#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
# pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2072
#define LARGE_STATE_COUNT 445
#define SYMBOL_COUNT 134
#define ALIAS_COUNT 1
#define TOKEN_COUNT 81
#define EXTERNAL_TOKEN_COUNT 14
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 57

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_BSLASH = 2,
  anon_sym_function = 3,
  anon_sym_EQ = 4,
  anon_sym_if = 5,
  anon_sym_for = 6,
  anon_sym_in = 7,
  anon_sym_while = 8,
  anon_sym_repeat = 9,
  anon_sym_QMARK = 10,
  anon_sym_TILDE = 11,
  anon_sym_BANG = 12,
  anon_sym_PLUS = 13,
  anon_sym_DASH = 14,
  anon_sym_LT_DASH = 15,
  anon_sym_LT_LT_DASH = 16,
  anon_sym_COLON_EQ = 17,
  anon_sym_DASH_GT = 18,
  anon_sym_DASH_GT_GT = 19,
  anon_sym_PIPE = 20,
  anon_sym_AMP = 21,
  anon_sym_PIPE_PIPE = 22,
  anon_sym_AMP_AMP = 23,
  anon_sym_LT = 24,
  anon_sym_LT_EQ = 25,
  anon_sym_GT = 26,
  anon_sym_GT_EQ = 27,
  anon_sym_EQ_EQ = 28,
  anon_sym_BANG_EQ = 29,
  anon_sym_STAR = 30,
  anon_sym_SLASH = 31,
  anon_sym_STAR_STAR = 32,
  anon_sym_CARET = 33,
  aux_sym_binary_operator_token1 = 34,
  anon_sym_PIPE_GT = 35,
  anon_sym_COLON = 36,
  anon_sym_DOLLAR = 37,
  anon_sym_AT = 38,
  anon_sym_COLON_COLON = 39,
  anon_sym_COLON_COLON_COLON = 40,
  anon_sym_L = 41,
  anon_sym_i = 42,
  sym__hex_literal = 43,
  sym__number_literal = 44,
  anon_sym_SQUOTE = 45,
  anon_sym_DQUOTE = 46,
  aux_sym__single_quoted_string_content_token1 = 47,
  aux_sym__double_quoted_string_content_token1 = 48,
  sym_escape_sequence = 49,
  sym_dots = 50,
  sym_dot_dot_i = 51,
  sym_return = 52,
  sym_next = 53,
  sym_break = 54,
  sym_true = 55,
  sym_false = 56,
  sym_null = 57,
  sym_inf = 58,
  sym_nan = 59,
  anon_sym_NA = 60,
  anon_sym_NA_integer_ = 61,
  anon_sym_NA_real_ = 62,
  anon_sym_NA_complex_ = 63,
  anon_sym_NA_character_ = 64,
  sym_comment = 65,
  sym_comma = 66,
  sym__start = 67,
  sym__newline = 68,
  sym__semicolon = 69,
  sym__raw_string_literal = 70,
  sym__external_else = 71,
  sym__external_open_parenthesis = 72,
  sym__external_close_parenthesis = 73,
  sym__external_open_brace = 74,
  sym__external_close_brace = 75,
  sym__external_open_bracket = 76,
  sym__external_close_bracket = 77,
  sym__external_open_bracket2 = 78,
  sym__external_close_bracket2 = 79,
  sym__error_sentinel = 80,
  sym_program = 81,
  sym_function_definition = 82,
  sym_parameters = 83,
  sym_parameter = 84,
  sym__parameter_with_default = 85,
  sym__parameter_without_default = 86,
  sym__parameter_name = 87,
  sym_if_statement = 88,
  sym_for_statement = 89,
  sym_while_statement = 90,
  sym_repeat_statement = 91,
  sym_braced_expression = 92,
  sym_parenthesized_expression = 93,
  sym_call = 94,
  sym_subset = 95,
  sym_subset2 = 96,
  sym_call_arguments = 97,
  sym_subset_arguments = 98,
  sym_subset2_arguments = 99,
  sym_argument = 100,
  sym__argument_named = 101,
  sym__argument_unnamed = 102,
  sym__argument_value = 103,
  sym_unary_operator = 104,
  sym_binary_operator = 105,
  sym_extract_operator = 106,
  sym_namespace_operator = 107,
  sym_integer = 108,
  sym_complex = 109,
  sym_float = 110,
  sym__float_literal = 111,
  sym_string = 112,
  sym__single_quoted_string = 113,
  sym__double_quoted_string = 114,
  aux_sym__single_quoted_string_content = 115,
  aux_sym__double_quoted_string_content = 116,
  sym__argument_name_string_or_identifier_or_null = 117,
  sym_na = 118,
  sym__expression = 119,
  sym__else = 120,
  sym__open_parenthesis = 121,
  sym__close_parenthesis = 122,
  sym__open_brace = 123,
  sym__close_brace = 124,
  sym__open_bracket = 125,
  sym__close_bracket = 126,
  sym__open_bracket2 = 127,
  sym__close_bracket2 = 128,
  aux_sym_program_repeat1 = 129,
  aux_sym_function_definition_repeat1 = 130,
  aux_sym_parameters_repeat1 = 131,
  aux_sym_braced_expression_repeat1 = 132,
  aux_sym_call_arguments_repeat1 = 133,
  alias_sym_string_content = 134,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_function] = "function",
  [anon_sym_EQ] = "=",
  [anon_sym_if] = "if",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_QMARK] = "\?",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_DASH_GT_GT] = "->>",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_CARET] = "^",
  [aux_sym_binary_operator_token1] = "special",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON_COLON] = ":::",
  [anon_sym_L] = "L",
  [anon_sym_i] = "i",
  [sym__hex_literal] = "_hex_literal",
  [sym__number_literal] = "_number_literal",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__single_quoted_string_content_token1] = "_single_quoted_string_content_token1",
  [aux_sym__double_quoted_string_content_token1] = "_double_quoted_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_dots] = "dots",
  [sym_dot_dot_i] = "dot_dot_i",
  [sym_return] = "return",
  [sym_next] = "next",
  [sym_break] = "break",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_inf] = "inf",
  [sym_nan] = "nan",
  [anon_sym_NA] = "NA",
  [anon_sym_NA_integer_] = "NA_integer_",
  [anon_sym_NA_real_] = "NA_real_",
  [anon_sym_NA_complex_] = "NA_complex_",
  [anon_sym_NA_character_] = "NA_character_",
  [sym_comment] = "comment",
  [sym_comma] = "comma",
  [sym__start] = "_start",
  [sym__newline] = "_newline",
  [sym__semicolon] = "_semicolon",
  [sym__raw_string_literal] = "_raw_string_literal",
  [sym__external_else] = "else",
  [sym__external_open_parenthesis] = "(",
  [sym__external_close_parenthesis] = ")",
  [sym__external_open_brace] = "{",
  [sym__external_close_brace] = "}",
  [sym__external_open_bracket] = "[",
  [sym__external_close_bracket] = "]",
  [sym__external_open_bracket2] = "[[",
  [sym__external_close_bracket2] = "]]",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_program] = "program",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym__parameter_with_default] = "_parameter_with_default",
  [sym__parameter_without_default] = "_parameter_without_default",
  [sym__parameter_name] = "_parameter_name",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_braced_expression] = "braced_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call] = "call",
  [sym_subset] = "subset",
  [sym_subset2] = "subset2",
  [sym_call_arguments] = "arguments",
  [sym_subset_arguments] = "arguments",
  [sym_subset2_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym__argument_named] = "_argument_named",
  [sym__argument_unnamed] = "_argument_unnamed",
  [sym__argument_value] = "_argument_value",
  [sym_unary_operator] = "unary_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_extract_operator] = "extract_operator",
  [sym_namespace_operator] = "namespace_operator",
  [sym_integer] = "integer",
  [sym_complex] = "complex",
  [sym_float] = "float",
  [sym__float_literal] = "_float_literal",
  [sym_string] = "string",
  [sym__single_quoted_string] = "_single_quoted_string",
  [sym__double_quoted_string] = "_double_quoted_string",
  [aux_sym__single_quoted_string_content] = "_single_quoted_string_content",
  [aux_sym__double_quoted_string_content] = "_double_quoted_string_content",
  [sym__argument_name_string_or_identifier_or_null] = "_argument_name_string_or_identifier_or_null",
  [sym_na] = "na",
  [sym__expression] = "_expression",
  [sym__else] = "_else",
  [sym__open_parenthesis] = "_open_parenthesis",
  [sym__close_parenthesis] = "_close_parenthesis",
  [sym__open_brace] = "_open_brace",
  [sym__close_brace] = "_close_brace",
  [sym__open_bracket] = "_open_bracket",
  [sym__close_bracket] = "_close_bracket",
  [sym__open_bracket2] = "_open_bracket2",
  [sym__close_bracket2] = "_close_bracket2",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_braced_expression_repeat1] = "braced_expression_repeat1",
  [aux_sym_call_arguments_repeat1] = "call_arguments_repeat1",
  [alias_sym_string_content] = "string_content",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_DASH_GT_GT] = anon_sym_DASH_GT_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_CARET] = anon_sym_CARET,
  [aux_sym_binary_operator_token1] = aux_sym_binary_operator_token1,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON_COLON] = anon_sym_COLON_COLON_COLON,
  [anon_sym_L] = anon_sym_L,
  [anon_sym_i] = anon_sym_i,
  [sym__hex_literal] = sym__hex_literal,
  [sym__number_literal] = sym__number_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__single_quoted_string_content_token1] = aux_sym__single_quoted_string_content_token1,
  [aux_sym__double_quoted_string_content_token1] = aux_sym__double_quoted_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_dots] = sym_dots,
  [sym_dot_dot_i] = sym_dot_dot_i,
  [sym_return] = sym_return,
  [sym_next] = sym_next,
  [sym_break] = sym_break,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_inf] = sym_inf,
  [sym_nan] = sym_nan,
  [anon_sym_NA] = anon_sym_NA,
  [anon_sym_NA_integer_] = anon_sym_NA_integer_,
  [anon_sym_NA_real_] = anon_sym_NA_real_,
  [anon_sym_NA_complex_] = anon_sym_NA_complex_,
  [anon_sym_NA_character_] = anon_sym_NA_character_,
  [sym_comment] = sym_comment,
  [sym_comma] = sym_comma,
  [sym__start] = sym__start,
  [sym__newline] = sym__newline,
  [sym__semicolon] = sym__semicolon,
  [sym__raw_string_literal] = sym__raw_string_literal,
  [sym__external_else] = sym__external_else,
  [sym__external_open_parenthesis] = sym__external_open_parenthesis,
  [sym__external_close_parenthesis] = sym__external_close_parenthesis,
  [sym__external_open_brace] = sym__external_open_brace,
  [sym__external_close_brace] = sym__external_close_brace,
  [sym__external_open_bracket] = sym__external_open_bracket,
  [sym__external_close_bracket] = sym__external_close_bracket,
  [sym__external_open_bracket2] = sym__external_open_bracket2,
  [sym__external_close_bracket2] = sym__external_close_bracket2,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_program] = sym_program,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym__parameter_with_default] = sym__parameter_with_default,
  [sym__parameter_without_default] = sym__parameter_without_default,
  [sym__parameter_name] = sym__parameter_name,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_braced_expression] = sym_braced_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call] = sym_call,
  [sym_subset] = sym_subset,
  [sym_subset2] = sym_subset2,
  [sym_call_arguments] = sym_call_arguments,
  [sym_subset_arguments] = sym_call_arguments,
  [sym_subset2_arguments] = sym_call_arguments,
  [sym_argument] = sym_argument,
  [sym__argument_named] = sym__argument_named,
  [sym__argument_unnamed] = sym__argument_unnamed,
  [sym__argument_value] = sym__argument_value,
  [sym_unary_operator] = sym_unary_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_extract_operator] = sym_extract_operator,
  [sym_namespace_operator] = sym_namespace_operator,
  [sym_integer] = sym_integer,
  [sym_complex] = sym_complex,
  [sym_float] = sym_float,
  [sym__float_literal] = sym__float_literal,
  [sym_string] = sym_string,
  [sym__single_quoted_string] = sym__single_quoted_string,
  [sym__double_quoted_string] = sym__double_quoted_string,
  [aux_sym__single_quoted_string_content] = aux_sym__single_quoted_string_content,
  [aux_sym__double_quoted_string_content] = aux_sym__double_quoted_string_content,
  [sym__argument_name_string_or_identifier_or_null] = sym__argument_name_string_or_identifier_or_null,
  [sym_na] = sym_na,
  [sym__expression] = sym__expression,
  [sym__else] = sym__else,
  [sym__open_parenthesis] = sym__open_parenthesis,
  [sym__close_parenthesis] = sym__close_parenthesis,
  [sym__open_brace] = sym__open_brace,
  [sym__close_brace] = sym__close_brace,
  [sym__open_bracket] = sym__open_bracket,
  [sym__close_bracket] = sym__close_bracket,
  [sym__open_bracket2] = sym__open_bracket2,
  [sym__close_bracket2] = sym__close_bracket2,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_braced_expression_repeat1] = aux_sym_braced_expression_repeat1,
  [aux_sym_call_arguments_repeat1] = aux_sym_call_arguments_repeat1,
  [alias_sym_string_content] = alias_sym_string_content,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__number_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__single_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_dots] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_dot_i] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_inf] = {
    .visible = true,
    .named = true,
  },
  [sym_nan] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_integer_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_real_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_complex_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_character_] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__start] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__external_else] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_with_default] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_without_default] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_braced_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_subset] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2] = {
    .visible = true,
    .named = true,
  },
  [sym_call_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_named] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_unnamed] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_value] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_extract_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym__float_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym__argument_name_string_or_identifier_or_null] = {
    .visible = false,
    .named = true,
  },
  [sym_na] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__else] = {
    .visible = false,
    .named = true,
  },
  [sym__open_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__close_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__open_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__close_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket2] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket2] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_braced_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_string_content] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_body = 4,
  field_close = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_default = 9,
  field_function = 10,
  field_lhs = 11,
  field_name = 12,
  field_open = 13,
  field_operator = 14,
  field_parameter = 15,
  field_parameters = 16,
  field_rhs = 17,
  field_sequence = 18,
  field_value = 19,
  field_variable = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close] = "close",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_default] = "default",
  [field_function] = "function",
  [field_lhs] = "lhs",
  [field_name] = "name",
  [field_open] = "open",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_rhs] = "rhs",
  [field_sequence] = "sequence",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 3},
  [2] = {.index = 3, .length = 1},
  [3] = {.index = 4, .length = 2},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 2},
  [6] = {.index = 10, .length = 2},
  [7] = {.index = 12, .length = 1},
  [8] = {.index = 13, .length = 3},
  [9] = {.index = 16, .length = 1},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 1},
  [12] = {.index = 20, .length = 1},
  [13] = {.index = 21, .length = 2},
  [14] = {.index = 23, .length = 3},
  [15] = {.index = 26, .length = 3},
  [16] = {.index = 29, .length = 2},
  [17] = {.index = 31, .length = 1},
  [18] = {.index = 32, .length = 1},
  [19] = {.index = 33, .length = 3},
  [20] = {.index = 36, .length = 3},
  [21] = {.index = 39, .length = 2},
  [22] = {.index = 41, .length = 3},
  [23] = {.index = 44, .length = 3},
  [24] = {.index = 47, .length = 3},
  [25] = {.index = 50, .length = 3},
  [26] = {.index = 53, .length = 1},
  [27] = {.index = 54, .length = 3},
  [28] = {.index = 57, .length = 3},
  [29] = {.index = 60, .length = 2},
  [30] = {.index = 62, .length = 1},
  [31] = {.index = 63, .length = 4},
  [32] = {.index = 67, .length = 2},
  [33] = {.index = 69, .length = 2},
  [34] = {.index = 71, .length = 3},
  [35] = {.index = 74, .length = 4},
  [36] = {.index = 78, .length = 4},
  [37] = {.index = 82, .length = 4},
  [38] = {.index = 86, .length = 2},
  [39] = {.index = 88, .length = 4},
  [40] = {.index = 92, .length = 4},
  [41] = {.index = 96, .length = 4},
  [42] = {.index = 100, .length = 4},
  [43] = {.index = 104, .length = 5},
  [44] = {.index = 109, .length = 4},
  [45] = {.index = 113, .length = 5},
  [46] = {.index = 118, .length = 4},
  [47] = {.index = 122, .length = 5},
  [48] = {.index = 127, .length = 5},
  [49] = {.index = 132, .length = 5},
  [50] = {.index = 137, .length = 5},
  [51] = {.index = 142, .length = 5},
  [52] = {.index = 147, .length = 5},
  [53] = {.index = 152, .length = 5},
  [54] = {.index = 157, .length = 5},
  [55] = {.index = 162, .length = 5},
  [56] = {.index = 167, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_close, 0, .inherited = true},
    {field_content, 0, .inherited = true},
    {field_open, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_operator, 0},
    {field_rhs, 1},
  [6] =
    {field_close, 1},
    {field_open, 0},
  [8] =
    {field_lhs, 0},
    {field_operator, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [16] =
    {field_name, 0},
  [17] =
    {field_default, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [19] =
    {field_name, 0, .inherited = true},
  [20] =
    {field_body, 2},
  [21] =
    {field_operator, 0},
    {field_rhs, 2},
  [23] =
    {field_close, 2},
    {field_content, 1},
    {field_open, 0},
  [26] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [29] =
    {field_name, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [31] =
    {field_value, 0, .inherited = true},
  [32] =
    {field_value, 0},
  [33] =
    {field_body, 1},
    {field_close, 2},
    {field_open, 0},
  [36] =
    {field_body, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [39] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [41] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [44] =
    {field_close, 2},
    {field_open, 0},
    {field_parameter, 1},
  [47] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2},
  [50] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 3},
  [53] =
    {field_argument, 1},
  [54] =
    {field_argument, 1},
    {field_close, 2},
    {field_open, 0},
  [57] =
    {field_argument, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [60] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [62] =
    {field_parameter, 1},
  [63] =
    {field_close, 3},
    {field_open, 0},
    {field_parameter, 1},
    {field_parameter, 2, .inherited = true},
  [67] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [69] =
    {field_default, 2},
    {field_name, 0, .inherited = true},
  [71] =
    {field_body, 4},
    {field_name, 0},
    {field_parameters, 2},
  [74] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [78] =
    {field_body, 4},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [82] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
    {field_close, 3},
    {field_open, 0},
  [86] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [88] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [92] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [96] =
    {field_body, 5},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [100] =
    {field_body, 5},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [104] =
    {field_alternative, 6},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [109] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [113] =
    {field_body, 6},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [118] =
    {field_body, 6},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [122] =
    {field_alternative, 7},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [127] =
    {field_alternative, 7},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [132] =
    {field_alternative, 7},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [137] =
    {field_body, 7},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [142] =
    {field_body, 7},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
  [147] =
    {field_alternative, 8},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [152] =
    {field_alternative, 8},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [157] =
    {field_alternative, 8},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [162] =
    {field_body, 8},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
  [167] =
    {field_alternative, 9},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [14] = {
    [1] = alias_sym_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__single_quoted_string_content, 2,
    aux_sym__single_quoted_string_content,
    alias_sym_string_content,
  aux_sym__double_quoted_string_content, 2,
    aux_sym__double_quoted_string_content,
    alias_sym_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 2,
  [7] = 5,
  [8] = 3,
  [9] = 4,
  [10] = 4,
  [11] = 2,
  [12] = 5,
  [13] = 3,
  [14] = 4,
  [15] = 2,
  [16] = 5,
  [17] = 3,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 18,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 19,
  [76] = 20,
  [77] = 21,
  [78] = 22,
  [79] = 23,
  [80] = 24,
  [81] = 25,
  [82] = 26,
  [83] = 27,
  [84] = 28,
  [85] = 29,
  [86] = 30,
  [87] = 31,
  [88] = 32,
  [89] = 33,
  [90] = 34,
  [91] = 35,
  [92] = 36,
  [93] = 37,
  [94] = 38,
  [95] = 39,
  [96] = 40,
  [97] = 41,
  [98] = 42,
  [99] = 43,
  [100] = 44,
  [101] = 45,
  [102] = 46,
  [103] = 47,
  [104] = 48,
  [105] = 49,
  [106] = 50,
  [107] = 51,
  [108] = 52,
  [109] = 53,
  [110] = 54,
  [111] = 55,
  [112] = 56,
  [113] = 57,
  [114] = 58,
  [115] = 59,
  [116] = 60,
  [117] = 61,
  [118] = 62,
  [119] = 66,
  [120] = 64,
  [121] = 65,
  [122] = 67,
  [123] = 68,
  [124] = 69,
  [125] = 70,
  [126] = 71,
  [127] = 72,
  [128] = 73,
  [129] = 74,
  [130] = 29,
  [131] = 71,
  [132] = 72,
  [133] = 73,
  [134] = 74,
  [135] = 19,
  [136] = 20,
  [137] = 21,
  [138] = 23,
  [139] = 24,
  [140] = 25,
  [141] = 26,
  [142] = 27,
  [143] = 28,
  [144] = 29,
  [145] = 30,
  [146] = 31,
  [147] = 32,
  [148] = 33,
  [149] = 34,
  [150] = 35,
  [151] = 36,
  [152] = 37,
  [153] = 38,
  [154] = 39,
  [155] = 40,
  [156] = 41,
  [157] = 42,
  [158] = 43,
  [159] = 44,
  [160] = 45,
  [161] = 46,
  [162] = 47,
  [163] = 48,
  [164] = 49,
  [165] = 165,
  [166] = 50,
  [167] = 51,
  [168] = 52,
  [169] = 53,
  [170] = 66,
  [171] = 54,
  [172] = 55,
  [173] = 56,
  [174] = 57,
  [175] = 58,
  [176] = 59,
  [177] = 60,
  [178] = 61,
  [179] = 62,
  [180] = 18,
  [181] = 64,
  [182] = 65,
  [183] = 67,
  [184] = 68,
  [185] = 69,
  [186] = 70,
  [187] = 187,
  [188] = 71,
  [189] = 72,
  [190] = 73,
  [191] = 74,
  [192] = 19,
  [193] = 20,
  [194] = 21,
  [195] = 22,
  [196] = 23,
  [197] = 24,
  [198] = 25,
  [199] = 26,
  [200] = 27,
  [201] = 28,
  [202] = 30,
  [203] = 31,
  [204] = 32,
  [205] = 33,
  [206] = 34,
  [207] = 35,
  [208] = 36,
  [209] = 37,
  [210] = 38,
  [211] = 39,
  [212] = 40,
  [213] = 41,
  [214] = 42,
  [215] = 43,
  [216] = 44,
  [217] = 45,
  [218] = 46,
  [219] = 47,
  [220] = 48,
  [221] = 49,
  [222] = 50,
  [223] = 51,
  [224] = 52,
  [225] = 53,
  [226] = 54,
  [227] = 55,
  [228] = 56,
  [229] = 57,
  [230] = 58,
  [231] = 59,
  [232] = 60,
  [233] = 61,
  [234] = 62,
  [235] = 18,
  [236] = 64,
  [237] = 65,
  [238] = 66,
  [239] = 67,
  [240] = 68,
  [241] = 69,
  [242] = 70,
  [243] = 22,
  [244] = 244,
  [245] = 244,
  [246] = 246,
  [247] = 246,
  [248] = 248,
  [249] = 249,
  [250] = 244,
  [251] = 244,
  [252] = 252,
  [253] = 253,
  [254] = 252,
  [255] = 248,
  [256] = 253,
  [257] = 249,
  [258] = 249,
  [259] = 246,
  [260] = 248,
  [261] = 253,
  [262] = 249,
  [263] = 246,
  [264] = 248,
  [265] = 249,
  [266] = 248,
  [267] = 253,
  [268] = 249,
  [269] = 248,
  [270] = 253,
  [271] = 249,
  [272] = 248,
  [273] = 253,
  [274] = 249,
  [275] = 248,
  [276] = 253,
  [277] = 249,
  [278] = 248,
  [279] = 253,
  [280] = 249,
  [281] = 248,
  [282] = 253,
  [283] = 253,
  [284] = 284,
  [285] = 284,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 286,
  [291] = 287,
  [292] = 288,
  [293] = 289,
  [294] = 294,
  [295] = 295,
  [296] = 294,
  [297] = 295,
  [298] = 298,
  [299] = 299,
  [300] = 252,
  [301] = 298,
  [302] = 299,
  [303] = 252,
  [304] = 287,
  [305] = 284,
  [306] = 295,
  [307] = 307,
  [308] = 288,
  [309] = 289,
  [310] = 310,
  [311] = 294,
  [312] = 310,
  [313] = 284,
  [314] = 286,
  [315] = 287,
  [316] = 288,
  [317] = 289,
  [318] = 307,
  [319] = 298,
  [320] = 299,
  [321] = 294,
  [322] = 295,
  [323] = 286,
  [324] = 310,
  [325] = 298,
  [326] = 299,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 307,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 332,
  [345] = 345,
  [346] = 335,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 333,
  [351] = 345,
  [352] = 352,
  [353] = 353,
  [354] = 307,
  [355] = 347,
  [356] = 336,
  [357] = 337,
  [358] = 339,
  [359] = 348,
  [360] = 338,
  [361] = 340,
  [362] = 362,
  [363] = 363,
  [364] = 349,
  [365] = 328,
  [366] = 329,
  [367] = 330,
  [368] = 331,
  [369] = 327,
  [370] = 352,
  [371] = 363,
  [372] = 353,
  [373] = 341,
  [374] = 342,
  [375] = 343,
  [376] = 362,
  [377] = 339,
  [378] = 362,
  [379] = 343,
  [380] = 332,
  [381] = 345,
  [382] = 335,
  [383] = 347,
  [384] = 352,
  [385] = 349,
  [386] = 386,
  [387] = 330,
  [388] = 333,
  [389] = 389,
  [390] = 386,
  [391] = 348,
  [392] = 349,
  [393] = 333,
  [394] = 338,
  [395] = 331,
  [396] = 327,
  [397] = 353,
  [398] = 386,
  [399] = 386,
  [400] = 386,
  [401] = 363,
  [402] = 389,
  [403] = 386,
  [404] = 345,
  [405] = 363,
  [406] = 340,
  [407] = 335,
  [408] = 338,
  [409] = 347,
  [410] = 336,
  [411] = 337,
  [412] = 342,
  [413] = 339,
  [414] = 389,
  [415] = 352,
  [416] = 353,
  [417] = 386,
  [418] = 389,
  [419] = 336,
  [420] = 341,
  [421] = 337,
  [422] = 389,
  [423] = 328,
  [424] = 329,
  [425] = 348,
  [426] = 389,
  [427] = 362,
  [428] = 340,
  [429] = 330,
  [430] = 389,
  [431] = 331,
  [432] = 327,
  [433] = 386,
  [434] = 389,
  [435] = 341,
  [436] = 342,
  [437] = 389,
  [438] = 343,
  [439] = 386,
  [440] = 332,
  [441] = 389,
  [442] = 328,
  [443] = 329,
  [444] = 386,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 449,
  [451] = 449,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 477,
  [485] = 480,
  [486] = 455,
  [487] = 487,
  [488] = 488,
  [489] = 456,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 487,
  [499] = 452,
  [500] = 500,
  [501] = 488,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 490,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 492,
  [510] = 510,
  [511] = 481,
  [512] = 482,
  [513] = 513,
  [514] = 514,
  [515] = 483,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 453,
  [525] = 454,
  [526] = 457,
  [527] = 458,
  [528] = 460,
  [529] = 463,
  [530] = 465,
  [531] = 467,
  [532] = 469,
  [533] = 475,
  [534] = 513,
  [535] = 455,
  [536] = 456,
  [537] = 459,
  [538] = 461,
  [539] = 462,
  [540] = 464,
  [541] = 466,
  [542] = 468,
  [543] = 470,
  [544] = 471,
  [545] = 472,
  [546] = 473,
  [547] = 474,
  [548] = 476,
  [549] = 478,
  [550] = 477,
  [551] = 480,
  [552] = 487,
  [553] = 488,
  [554] = 490,
  [555] = 492,
  [556] = 494,
  [557] = 495,
  [558] = 496,
  [559] = 497,
  [560] = 452,
  [561] = 500,
  [562] = 502,
  [563] = 503,
  [564] = 504,
  [565] = 506,
  [566] = 508,
  [567] = 510,
  [568] = 481,
  [569] = 482,
  [570] = 513,
  [571] = 514,
  [572] = 483,
  [573] = 516,
  [574] = 517,
  [575] = 518,
  [576] = 519,
  [577] = 520,
  [578] = 521,
  [579] = 522,
  [580] = 523,
  [581] = 453,
  [582] = 454,
  [583] = 457,
  [584] = 458,
  [585] = 460,
  [586] = 463,
  [587] = 465,
  [588] = 467,
  [589] = 469,
  [590] = 475,
  [591] = 516,
  [592] = 455,
  [593] = 456,
  [594] = 494,
  [595] = 459,
  [596] = 461,
  [597] = 462,
  [598] = 464,
  [599] = 466,
  [600] = 468,
  [601] = 470,
  [602] = 471,
  [603] = 472,
  [604] = 473,
  [605] = 474,
  [606] = 476,
  [607] = 478,
  [608] = 477,
  [609] = 480,
  [610] = 487,
  [611] = 488,
  [612] = 490,
  [613] = 492,
  [614] = 494,
  [615] = 495,
  [616] = 496,
  [617] = 497,
  [618] = 452,
  [619] = 500,
  [620] = 502,
  [621] = 503,
  [622] = 504,
  [623] = 506,
  [624] = 508,
  [625] = 514,
  [626] = 510,
  [627] = 481,
  [628] = 482,
  [629] = 513,
  [630] = 514,
  [631] = 495,
  [632] = 496,
  [633] = 497,
  [634] = 517,
  [635] = 483,
  [636] = 518,
  [637] = 516,
  [638] = 500,
  [639] = 517,
  [640] = 518,
  [641] = 519,
  [642] = 520,
  [643] = 502,
  [644] = 519,
  [645] = 503,
  [646] = 504,
  [647] = 521,
  [648] = 523,
  [649] = 453,
  [650] = 454,
  [651] = 457,
  [652] = 458,
  [653] = 460,
  [654] = 463,
  [655] = 465,
  [656] = 467,
  [657] = 469,
  [658] = 475,
  [659] = 459,
  [660] = 506,
  [661] = 520,
  [662] = 461,
  [663] = 508,
  [664] = 462,
  [665] = 455,
  [666] = 456,
  [667] = 510,
  [668] = 481,
  [669] = 482,
  [670] = 513,
  [671] = 514,
  [672] = 459,
  [673] = 461,
  [674] = 462,
  [675] = 464,
  [676] = 483,
  [677] = 466,
  [678] = 468,
  [679] = 516,
  [680] = 470,
  [681] = 471,
  [682] = 517,
  [683] = 472,
  [684] = 473,
  [685] = 518,
  [686] = 474,
  [687] = 476,
  [688] = 519,
  [689] = 478,
  [690] = 520,
  [691] = 521,
  [692] = 522,
  [693] = 477,
  [694] = 480,
  [695] = 523,
  [696] = 453,
  [697] = 454,
  [698] = 457,
  [699] = 458,
  [700] = 460,
  [701] = 463,
  [702] = 465,
  [703] = 467,
  [704] = 469,
  [705] = 475,
  [706] = 464,
  [707] = 455,
  [708] = 456,
  [709] = 487,
  [710] = 488,
  [711] = 490,
  [712] = 492,
  [713] = 494,
  [714] = 495,
  [715] = 496,
  [716] = 497,
  [717] = 452,
  [718] = 500,
  [719] = 459,
  [720] = 502,
  [721] = 461,
  [722] = 503,
  [723] = 504,
  [724] = 462,
  [725] = 506,
  [726] = 464,
  [727] = 508,
  [728] = 466,
  [729] = 510,
  [730] = 481,
  [731] = 482,
  [732] = 513,
  [733] = 514,
  [734] = 483,
  [735] = 516,
  [736] = 517,
  [737] = 518,
  [738] = 519,
  [739] = 520,
  [740] = 521,
  [741] = 523,
  [742] = 453,
  [743] = 454,
  [744] = 457,
  [745] = 458,
  [746] = 460,
  [747] = 463,
  [748] = 465,
  [749] = 467,
  [750] = 469,
  [751] = 475,
  [752] = 468,
  [753] = 455,
  [754] = 456,
  [755] = 459,
  [756] = 461,
  [757] = 462,
  [758] = 464,
  [759] = 466,
  [760] = 468,
  [761] = 470,
  [762] = 471,
  [763] = 472,
  [764] = 473,
  [765] = 474,
  [766] = 476,
  [767] = 478,
  [768] = 477,
  [769] = 480,
  [770] = 487,
  [771] = 488,
  [772] = 490,
  [773] = 492,
  [774] = 494,
  [775] = 495,
  [776] = 496,
  [777] = 497,
  [778] = 452,
  [779] = 500,
  [780] = 502,
  [781] = 503,
  [782] = 504,
  [783] = 506,
  [784] = 508,
  [785] = 510,
  [786] = 481,
  [787] = 482,
  [788] = 513,
  [789] = 514,
  [790] = 470,
  [791] = 471,
  [792] = 472,
  [793] = 483,
  [794] = 516,
  [795] = 473,
  [796] = 517,
  [797] = 518,
  [798] = 474,
  [799] = 519,
  [800] = 520,
  [801] = 476,
  [802] = 478,
  [803] = 521,
  [804] = 523,
  [805] = 453,
  [806] = 454,
  [807] = 457,
  [808] = 458,
  [809] = 460,
  [810] = 463,
  [811] = 465,
  [812] = 467,
  [813] = 469,
  [814] = 475,
  [815] = 455,
  [816] = 456,
  [817] = 459,
  [818] = 461,
  [819] = 477,
  [820] = 462,
  [821] = 480,
  [822] = 464,
  [823] = 466,
  [824] = 468,
  [825] = 470,
  [826] = 471,
  [827] = 472,
  [828] = 473,
  [829] = 474,
  [830] = 476,
  [831] = 478,
  [832] = 466,
  [833] = 477,
  [834] = 480,
  [835] = 487,
  [836] = 488,
  [837] = 490,
  [838] = 492,
  [839] = 487,
  [840] = 488,
  [841] = 494,
  [842] = 495,
  [843] = 490,
  [844] = 492,
  [845] = 496,
  [846] = 497,
  [847] = 494,
  [848] = 495,
  [849] = 496,
  [850] = 497,
  [851] = 452,
  [852] = 500,
  [853] = 452,
  [854] = 500,
  [855] = 502,
  [856] = 503,
  [857] = 504,
  [858] = 502,
  [859] = 506,
  [860] = 503,
  [861] = 504,
  [862] = 508,
  [863] = 510,
  [864] = 481,
  [865] = 482,
  [866] = 513,
  [867] = 514,
  [868] = 483,
  [869] = 516,
  [870] = 517,
  [871] = 518,
  [872] = 519,
  [873] = 520,
  [874] = 521,
  [875] = 523,
  [876] = 453,
  [877] = 454,
  [878] = 457,
  [879] = 458,
  [880] = 460,
  [881] = 463,
  [882] = 465,
  [883] = 467,
  [884] = 469,
  [885] = 475,
  [886] = 506,
  [887] = 455,
  [888] = 456,
  [889] = 459,
  [890] = 461,
  [891] = 462,
  [892] = 464,
  [893] = 466,
  [894] = 468,
  [895] = 470,
  [896] = 471,
  [897] = 472,
  [898] = 473,
  [899] = 474,
  [900] = 476,
  [901] = 478,
  [902] = 477,
  [903] = 480,
  [904] = 487,
  [905] = 488,
  [906] = 490,
  [907] = 492,
  [908] = 494,
  [909] = 495,
  [910] = 496,
  [911] = 497,
  [912] = 452,
  [913] = 500,
  [914] = 502,
  [915] = 503,
  [916] = 504,
  [917] = 506,
  [918] = 508,
  [919] = 510,
  [920] = 481,
  [921] = 482,
  [922] = 513,
  [923] = 514,
  [924] = 483,
  [925] = 516,
  [926] = 517,
  [927] = 518,
  [928] = 519,
  [929] = 520,
  [930] = 521,
  [931] = 523,
  [932] = 453,
  [933] = 454,
  [934] = 457,
  [935] = 458,
  [936] = 460,
  [937] = 463,
  [938] = 465,
  [939] = 467,
  [940] = 469,
  [941] = 475,
  [942] = 455,
  [943] = 456,
  [944] = 459,
  [945] = 461,
  [946] = 462,
  [947] = 464,
  [948] = 466,
  [949] = 468,
  [950] = 470,
  [951] = 471,
  [952] = 472,
  [953] = 473,
  [954] = 474,
  [955] = 476,
  [956] = 478,
  [957] = 477,
  [958] = 480,
  [959] = 487,
  [960] = 488,
  [961] = 490,
  [962] = 492,
  [963] = 494,
  [964] = 495,
  [965] = 496,
  [966] = 497,
  [967] = 452,
  [968] = 500,
  [969] = 502,
  [970] = 503,
  [971] = 504,
  [972] = 506,
  [973] = 508,
  [974] = 508,
  [975] = 479,
  [976] = 491,
  [977] = 493,
  [978] = 510,
  [979] = 481,
  [980] = 507,
  [981] = 482,
  [982] = 513,
  [983] = 514,
  [984] = 468,
  [985] = 470,
  [986] = 471,
  [987] = 483,
  [988] = 479,
  [989] = 491,
  [990] = 493,
  [991] = 507,
  [992] = 516,
  [993] = 472,
  [994] = 517,
  [995] = 479,
  [996] = 491,
  [997] = 493,
  [998] = 507,
  [999] = 518,
  [1000] = 473,
  [1001] = 519,
  [1002] = 479,
  [1003] = 491,
  [1004] = 493,
  [1005] = 507,
  [1006] = 510,
  [1007] = 520,
  [1008] = 474,
  [1009] = 521,
  [1010] = 479,
  [1011] = 491,
  [1012] = 493,
  [1013] = 507,
  [1014] = 476,
  [1015] = 522,
  [1016] = 478,
  [1017] = 521,
  [1018] = 479,
  [1019] = 491,
  [1020] = 493,
  [1021] = 507,
  [1022] = 522,
  [1023] = 523,
  [1024] = 453,
  [1025] = 454,
  [1026] = 479,
  [1027] = 491,
  [1028] = 493,
  [1029] = 507,
  [1030] = 457,
  [1031] = 458,
  [1032] = 460,
  [1033] = 463,
  [1034] = 479,
  [1035] = 491,
  [1036] = 493,
  [1037] = 507,
  [1038] = 465,
  [1039] = 467,
  [1040] = 469,
  [1041] = 475,
  [1042] = 479,
  [1043] = 491,
  [1044] = 493,
  [1045] = 507,
  [1046] = 523,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1047,
  [1055] = 1055,
  [1056] = 1051,
  [1057] = 1053,
  [1058] = 1050,
  [1059] = 1048,
  [1060] = 1053,
  [1061] = 1050,
  [1062] = 1048,
  [1063] = 1047,
  [1064] = 1051,
  [1065] = 1053,
  [1066] = 1050,
  [1067] = 1048,
  [1068] = 1047,
  [1069] = 1051,
  [1070] = 1053,
  [1071] = 1050,
  [1072] = 1048,
  [1073] = 1047,
  [1074] = 1051,
  [1075] = 1053,
  [1076] = 1050,
  [1077] = 1048,
  [1078] = 1047,
  [1079] = 1051,
  [1080] = 1053,
  [1081] = 1050,
  [1082] = 1048,
  [1083] = 1047,
  [1084] = 1051,
  [1085] = 1053,
  [1086] = 1050,
  [1087] = 1048,
  [1088] = 1047,
  [1089] = 1051,
  [1090] = 1053,
  [1091] = 1050,
  [1092] = 1048,
  [1093] = 1047,
  [1094] = 1051,
  [1095] = 1053,
  [1096] = 1050,
  [1097] = 1048,
  [1098] = 1047,
  [1099] = 1052,
  [1100] = 1049,
  [1101] = 1052,
  [1102] = 1049,
  [1103] = 1052,
  [1104] = 1049,
  [1105] = 1052,
  [1106] = 1049,
  [1107] = 1052,
  [1108] = 1049,
  [1109] = 1052,
  [1110] = 1049,
  [1111] = 1052,
  [1112] = 1049,
  [1113] = 1052,
  [1114] = 1049,
  [1115] = 1052,
  [1116] = 1049,
  [1117] = 1051,
  [1118] = 246,
  [1119] = 246,
  [1120] = 244,
  [1121] = 246,
  [1122] = 244,
  [1123] = 244,
  [1124] = 244,
  [1125] = 246,
  [1126] = 246,
  [1127] = 246,
  [1128] = 244,
  [1129] = 244,
  [1130] = 252,
  [1131] = 252,
  [1132] = 252,
  [1133] = 307,
  [1134] = 307,
  [1135] = 252,
  [1136] = 252,
  [1137] = 252,
  [1138] = 307,
  [1139] = 3,
  [1140] = 4,
  [1141] = 2,
  [1142] = 5,
  [1143] = 3,
  [1144] = 4,
  [1145] = 307,
  [1146] = 2,
  [1147] = 307,
  [1148] = 307,
  [1149] = 5,
  [1150] = 3,
  [1151] = 2,
  [1152] = 5,
  [1153] = 3,
  [1154] = 4,
  [1155] = 4,
  [1156] = 2,
  [1157] = 5,
  [1158] = 2,
  [1159] = 5,
  [1160] = 3,
  [1161] = 4,
  [1162] = 2,
  [1163] = 5,
  [1164] = 4,
  [1165] = 3,
  [1166] = 21,
  [1167] = 45,
  [1168] = 46,
  [1169] = 47,
  [1170] = 48,
  [1171] = 49,
  [1172] = 50,
  [1173] = 51,
  [1174] = 52,
  [1175] = 53,
  [1176] = 33,
  [1177] = 54,
  [1178] = 55,
  [1179] = 56,
  [1180] = 57,
  [1181] = 58,
  [1182] = 59,
  [1183] = 60,
  [1184] = 61,
  [1185] = 62,
  [1186] = 18,
  [1187] = 64,
  [1188] = 65,
  [1189] = 66,
  [1190] = 67,
  [1191] = 68,
  [1192] = 69,
  [1193] = 70,
  [1194] = 66,
  [1195] = 67,
  [1196] = 71,
  [1197] = 72,
  [1198] = 73,
  [1199] = 74,
  [1200] = 19,
  [1201] = 20,
  [1202] = 34,
  [1203] = 22,
  [1204] = 23,
  [1205] = 24,
  [1206] = 25,
  [1207] = 26,
  [1208] = 27,
  [1209] = 28,
  [1210] = 35,
  [1211] = 29,
  [1212] = 30,
  [1213] = 31,
  [1214] = 32,
  [1215] = 36,
  [1216] = 33,
  [1217] = 37,
  [1218] = 34,
  [1219] = 35,
  [1220] = 36,
  [1221] = 37,
  [1222] = 38,
  [1223] = 39,
  [1224] = 40,
  [1225] = 41,
  [1226] = 42,
  [1227] = 43,
  [1228] = 44,
  [1229] = 45,
  [1230] = 46,
  [1231] = 47,
  [1232] = 48,
  [1233] = 49,
  [1234] = 50,
  [1235] = 51,
  [1236] = 52,
  [1237] = 53,
  [1238] = 54,
  [1239] = 55,
  [1240] = 56,
  [1241] = 57,
  [1242] = 58,
  [1243] = 59,
  [1244] = 60,
  [1245] = 61,
  [1246] = 62,
  [1247] = 18,
  [1248] = 64,
  [1249] = 65,
  [1250] = 38,
  [1251] = 39,
  [1252] = 40,
  [1253] = 41,
  [1254] = 44,
  [1255] = 43,
  [1256] = 44,
  [1257] = 45,
  [1258] = 46,
  [1259] = 47,
  [1260] = 48,
  [1261] = 49,
  [1262] = 50,
  [1263] = 68,
  [1264] = 51,
  [1265] = 52,
  [1266] = 53,
  [1267] = 54,
  [1268] = 69,
  [1269] = 55,
  [1270] = 56,
  [1271] = 57,
  [1272] = 58,
  [1273] = 59,
  [1274] = 60,
  [1275] = 71,
  [1276] = 61,
  [1277] = 62,
  [1278] = 18,
  [1279] = 64,
  [1280] = 65,
  [1281] = 70,
  [1282] = 72,
  [1283] = 73,
  [1284] = 74,
  [1285] = 19,
  [1286] = 20,
  [1287] = 21,
  [1288] = 22,
  [1289] = 23,
  [1290] = 66,
  [1291] = 67,
  [1292] = 68,
  [1293] = 69,
  [1294] = 70,
  [1295] = 24,
  [1296] = 25,
  [1297] = 26,
  [1298] = 27,
  [1299] = 28,
  [1300] = 29,
  [1301] = 71,
  [1302] = 30,
  [1303] = 72,
  [1304] = 73,
  [1305] = 74,
  [1306] = 19,
  [1307] = 20,
  [1308] = 21,
  [1309] = 22,
  [1310] = 23,
  [1311] = 24,
  [1312] = 25,
  [1313] = 26,
  [1314] = 27,
  [1315] = 28,
  [1316] = 31,
  [1317] = 29,
  [1318] = 30,
  [1319] = 31,
  [1320] = 32,
  [1321] = 33,
  [1322] = 32,
  [1323] = 34,
  [1324] = 35,
  [1325] = 36,
  [1326] = 37,
  [1327] = 38,
  [1328] = 39,
  [1329] = 40,
  [1330] = 41,
  [1331] = 42,
  [1332] = 43,
  [1333] = 42,
  [1334] = 68,
  [1335] = 53,
  [1336] = 36,
  [1337] = 37,
  [1338] = 38,
  [1339] = 39,
  [1340] = 40,
  [1341] = 41,
  [1342] = 42,
  [1343] = 43,
  [1344] = 44,
  [1345] = 54,
  [1346] = 45,
  [1347] = 46,
  [1348] = 47,
  [1349] = 48,
  [1350] = 55,
  [1351] = 56,
  [1352] = 57,
  [1353] = 58,
  [1354] = 59,
  [1355] = 60,
  [1356] = 49,
  [1357] = 59,
  [1358] = 50,
  [1359] = 1359,
  [1360] = 52,
  [1361] = 1361,
  [1362] = 23,
  [1363] = 60,
  [1364] = 69,
  [1365] = 54,
  [1366] = 51,
  [1367] = 52,
  [1368] = 53,
  [1369] = 70,
  [1370] = 54,
  [1371] = 1371,
  [1372] = 61,
  [1373] = 55,
  [1374] = 56,
  [1375] = 24,
  [1376] = 62,
  [1377] = 18,
  [1378] = 57,
  [1379] = 58,
  [1380] = 59,
  [1381] = 60,
  [1382] = 61,
  [1383] = 62,
  [1384] = 18,
  [1385] = 64,
  [1386] = 25,
  [1387] = 65,
  [1388] = 55,
  [1389] = 64,
  [1390] = 65,
  [1391] = 56,
  [1392] = 71,
  [1393] = 72,
  [1394] = 73,
  [1395] = 26,
  [1396] = 74,
  [1397] = 19,
  [1398] = 20,
  [1399] = 1399,
  [1400] = 21,
  [1401] = 22,
  [1402] = 1402,
  [1403] = 23,
  [1404] = 24,
  [1405] = 25,
  [1406] = 26,
  [1407] = 27,
  [1408] = 28,
  [1409] = 29,
  [1410] = 61,
  [1411] = 30,
  [1412] = 62,
  [1413] = 57,
  [1414] = 31,
  [1415] = 1415,
  [1416] = 58,
  [1417] = 1417,
  [1418] = 32,
  [1419] = 33,
  [1420] = 27,
  [1421] = 71,
  [1422] = 28,
  [1423] = 29,
  [1424] = 72,
  [1425] = 30,
  [1426] = 73,
  [1427] = 74,
  [1428] = 19,
  [1429] = 31,
  [1430] = 20,
  [1431] = 32,
  [1432] = 21,
  [1433] = 33,
  [1434] = 66,
  [1435] = 22,
  [1436] = 23,
  [1437] = 67,
  [1438] = 66,
  [1439] = 34,
  [1440] = 24,
  [1441] = 35,
  [1442] = 25,
  [1443] = 68,
  [1444] = 26,
  [1445] = 1445,
  [1446] = 27,
  [1447] = 69,
  [1448] = 18,
  [1449] = 67,
  [1450] = 64,
  [1451] = 65,
  [1452] = 1359,
  [1453] = 1371,
  [1454] = 1402,
  [1455] = 36,
  [1456] = 37,
  [1457] = 1457,
  [1458] = 68,
  [1459] = 38,
  [1460] = 39,
  [1461] = 1399,
  [1462] = 40,
  [1463] = 69,
  [1464] = 41,
  [1465] = 42,
  [1466] = 35,
  [1467] = 28,
  [1468] = 43,
  [1469] = 70,
  [1470] = 44,
  [1471] = 1359,
  [1472] = 1371,
  [1473] = 1402,
  [1474] = 1457,
  [1475] = 1399,
  [1476] = 1359,
  [1477] = 1371,
  [1478] = 1402,
  [1479] = 45,
  [1480] = 1457,
  [1481] = 46,
  [1482] = 1399,
  [1483] = 47,
  [1484] = 48,
  [1485] = 1359,
  [1486] = 1371,
  [1487] = 1402,
  [1488] = 1457,
  [1489] = 1399,
  [1490] = 1359,
  [1491] = 1371,
  [1492] = 49,
  [1493] = 1402,
  [1494] = 1457,
  [1495] = 1399,
  [1496] = 50,
  [1497] = 1359,
  [1498] = 1371,
  [1499] = 1402,
  [1500] = 71,
  [1501] = 1457,
  [1502] = 1399,
  [1503] = 72,
  [1504] = 1359,
  [1505] = 1371,
  [1506] = 1402,
  [1507] = 73,
  [1508] = 74,
  [1509] = 1457,
  [1510] = 19,
  [1511] = 1399,
  [1512] = 20,
  [1513] = 1359,
  [1514] = 1371,
  [1515] = 1402,
  [1516] = 34,
  [1517] = 1457,
  [1518] = 1399,
  [1519] = 51,
  [1520] = 52,
  [1521] = 1359,
  [1522] = 1371,
  [1523] = 1402,
  [1524] = 1457,
  [1525] = 1399,
  [1526] = 29,
  [1527] = 35,
  [1528] = 1417,
  [1529] = 70,
  [1530] = 21,
  [1531] = 1415,
  [1532] = 30,
  [1533] = 53,
  [1534] = 22,
  [1535] = 66,
  [1536] = 1457,
  [1537] = 31,
  [1538] = 1417,
  [1539] = 36,
  [1540] = 1415,
  [1541] = 32,
  [1542] = 37,
  [1543] = 38,
  [1544] = 1417,
  [1545] = 33,
  [1546] = 1415,
  [1547] = 39,
  [1548] = 40,
  [1549] = 1417,
  [1550] = 41,
  [1551] = 1415,
  [1552] = 1361,
  [1553] = 42,
  [1554] = 43,
  [1555] = 1417,
  [1556] = 1415,
  [1557] = 44,
  [1558] = 45,
  [1559] = 46,
  [1560] = 1417,
  [1561] = 47,
  [1562] = 1415,
  [1563] = 48,
  [1564] = 1417,
  [1565] = 1415,
  [1566] = 1417,
  [1567] = 1415,
  [1568] = 1417,
  [1569] = 1415,
  [1570] = 49,
  [1571] = 50,
  [1572] = 67,
  [1573] = 34,
  [1574] = 51,
  [1575] = 1361,
  [1576] = 289,
  [1577] = 286,
  [1578] = 287,
  [1579] = 288,
  [1580] = 286,
  [1581] = 298,
  [1582] = 299,
  [1583] = 298,
  [1584] = 299,
  [1585] = 1585,
  [1586] = 294,
  [1587] = 295,
  [1588] = 294,
  [1589] = 295,
  [1590] = 284,
  [1591] = 284,
  [1592] = 286,
  [1593] = 287,
  [1594] = 288,
  [1595] = 289,
  [1596] = 294,
  [1597] = 295,
  [1598] = 299,
  [1599] = 287,
  [1600] = 298,
  [1601] = 284,
  [1602] = 288,
  [1603] = 289,
  [1604] = 288,
  [1605] = 294,
  [1606] = 295,
  [1607] = 286,
  [1608] = 286,
  [1609] = 307,
  [1610] = 287,
  [1611] = 289,
  [1612] = 298,
  [1613] = 298,
  [1614] = 299,
  [1615] = 299,
  [1616] = 284,
  [1617] = 298,
  [1618] = 299,
  [1619] = 286,
  [1620] = 287,
  [1621] = 284,
  [1622] = 294,
  [1623] = 295,
  [1624] = 288,
  [1625] = 289,
  [1626] = 287,
  [1627] = 1627,
  [1628] = 1627,
  [1629] = 288,
  [1630] = 1627,
  [1631] = 295,
  [1632] = 289,
  [1633] = 284,
  [1634] = 294,
  [1635] = 353,
  [1636] = 337,
  [1637] = 340,
  [1638] = 363,
  [1639] = 328,
  [1640] = 329,
  [1641] = 340,
  [1642] = 328,
  [1643] = 341,
  [1644] = 342,
  [1645] = 343,
  [1646] = 341,
  [1647] = 342,
  [1648] = 343,
  [1649] = 332,
  [1650] = 345,
  [1651] = 335,
  [1652] = 347,
  [1653] = 332,
  [1654] = 348,
  [1655] = 349,
  [1656] = 333,
  [1657] = 336,
  [1658] = 341,
  [1659] = 345,
  [1660] = 335,
  [1661] = 347,
  [1662] = 337,
  [1663] = 342,
  [1664] = 343,
  [1665] = 348,
  [1666] = 332,
  [1667] = 345,
  [1668] = 349,
  [1669] = 333,
  [1670] = 335,
  [1671] = 347,
  [1672] = 339,
  [1673] = 329,
  [1674] = 362,
  [1675] = 336,
  [1676] = 349,
  [1677] = 338,
  [1678] = 333,
  [1679] = 330,
  [1680] = 331,
  [1681] = 352,
  [1682] = 327,
  [1683] = 338,
  [1684] = 353,
  [1685] = 330,
  [1686] = 331,
  [1687] = 327,
  [1688] = 363,
  [1689] = 336,
  [1690] = 340,
  [1691] = 337,
  [1692] = 1692,
  [1693] = 339,
  [1694] = 1694,
  [1695] = 362,
  [1696] = 352,
  [1697] = 1697,
  [1698] = 339,
  [1699] = 362,
  [1700] = 352,
  [1701] = 353,
  [1702] = 338,
  [1703] = 363,
  [1704] = 328,
  [1705] = 329,
  [1706] = 330,
  [1707] = 331,
  [1708] = 327,
  [1709] = 348,
  [1710] = 353,
  [1711] = 362,
  [1712] = 341,
  [1713] = 328,
  [1714] = 329,
  [1715] = 340,
  [1716] = 338,
  [1717] = 336,
  [1718] = 362,
  [1719] = 337,
  [1720] = 363,
  [1721] = 329,
  [1722] = 341,
  [1723] = 342,
  [1724] = 343,
  [1725] = 332,
  [1726] = 352,
  [1727] = 345,
  [1728] = 335,
  [1729] = 347,
  [1730] = 353,
  [1731] = 363,
  [1732] = 352,
  [1733] = 330,
  [1734] = 330,
  [1735] = 339,
  [1736] = 353,
  [1737] = 362,
  [1738] = 352,
  [1739] = 331,
  [1740] = 331,
  [1741] = 348,
  [1742] = 338,
  [1743] = 348,
  [1744] = 327,
  [1745] = 349,
  [1746] = 327,
  [1747] = 337,
  [1748] = 345,
  [1749] = 333,
  [1750] = 338,
  [1751] = 328,
  [1752] = 1752,
  [1753] = 327,
  [1754] = 349,
  [1755] = 340,
  [1756] = 333,
  [1757] = 347,
  [1758] = 340,
  [1759] = 342,
  [1760] = 336,
  [1761] = 339,
  [1762] = 337,
  [1763] = 335,
  [1764] = 339,
  [1765] = 363,
  [1766] = 343,
  [1767] = 336,
  [1768] = 328,
  [1769] = 329,
  [1770] = 341,
  [1771] = 342,
  [1772] = 343,
  [1773] = 330,
  [1774] = 332,
  [1775] = 345,
  [1776] = 335,
  [1777] = 347,
  [1778] = 332,
  [1779] = 1752,
  [1780] = 331,
  [1781] = 348,
  [1782] = 349,
  [1783] = 333,
  [1784] = 1752,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1788,
  [1790] = 1787,
  [1791] = 1788,
  [1792] = 1787,
  [1793] = 1788,
  [1794] = 1787,
  [1795] = 1787,
  [1796] = 1788,
  [1797] = 1787,
  [1798] = 1787,
  [1799] = 1788,
  [1800] = 1788,
  [1801] = 1788,
  [1802] = 1787,
  [1803] = 1787,
  [1804] = 1787,
  [1805] = 1788,
  [1806] = 1788,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1811,
  [1813] = 1813,
  [1814] = 1813,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1808,
  [1821] = 1816,
  [1822] = 1807,
  [1823] = 1823,
  [1824] = 1818,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1817,
  [1828] = 1819,
  [1829] = 1825,
  [1830] = 1819,
  [1831] = 1808,
  [1832] = 1811,
  [1833] = 1813,
  [1834] = 1823,
  [1835] = 1816,
  [1836] = 1817,
  [1837] = 1818,
  [1838] = 1809,
  [1839] = 1807,
  [1840] = 1823,
  [1841] = 1811,
  [1842] = 1807,
  [1843] = 1823,
  [1844] = 1811,
  [1845] = 1826,
  [1846] = 1810,
  [1847] = 1826,
  [1848] = 1813,
  [1849] = 1808,
  [1850] = 1808,
  [1851] = 1811,
  [1852] = 1813,
  [1853] = 1810,
  [1854] = 1809,
  [1855] = 1816,
  [1856] = 1817,
  [1857] = 1808,
  [1858] = 1858,
  [1859] = 1818,
  [1860] = 1811,
  [1861] = 1807,
  [1862] = 1823,
  [1863] = 1813,
  [1864] = 1864,
  [1865] = 1826,
  [1866] = 1809,
  [1867] = 1819,
  [1868] = 1816,
  [1869] = 1811,
  [1870] = 1813,
  [1871] = 1810,
  [1872] = 1816,
  [1873] = 1816,
  [1874] = 1817,
  [1875] = 1817,
  [1876] = 1817,
  [1877] = 1877,
  [1878] = 1817,
  [1879] = 1823,
  [1880] = 1880,
  [1881] = 1826,
  [1882] = 1825,
  [1883] = 1813,
  [1884] = 1819,
  [1885] = 1885,
  [1886] = 1807,
  [1887] = 1823,
  [1888] = 1811,
  [1889] = 1818,
  [1890] = 1813,
  [1891] = 1891,
  [1892] = 1819,
  [1893] = 1818,
  [1894] = 1826,
  [1895] = 1807,
  [1896] = 1808,
  [1897] = 1816,
  [1898] = 1817,
  [1899] = 1810,
  [1900] = 1900,
  [1901] = 1810,
  [1902] = 1807,
  [1903] = 1818,
  [1904] = 1818,
  [1905] = 1825,
  [1906] = 1807,
  [1907] = 1825,
  [1908] = 1823,
  [1909] = 1810,
  [1910] = 1811,
  [1911] = 1813,
  [1912] = 1826,
  [1913] = 1913,
  [1914] = 1809,
  [1915] = 1810,
  [1916] = 1819,
  [1917] = 1809,
  [1918] = 1819,
  [1919] = 1808,
  [1920] = 1808,
  [1921] = 1823,
  [1922] = 1809,
  [1923] = 1810,
  [1924] = 1816,
  [1925] = 1819,
  [1926] = 1825,
  [1927] = 1825,
  [1928] = 1818,
  [1929] = 1825,
  [1930] = 1864,
  [1931] = 1825,
  [1932] = 1891,
  [1933] = 1826,
  [1934] = 1826,
  [1935] = 1809,
  [1936] = 1864,
  [1937] = 1810,
  [1938] = 1891,
  [1939] = 1819,
  [1940] = 1864,
  [1941] = 1807,
  [1942] = 1891,
  [1943] = 1808,
  [1944] = 1864,
  [1945] = 1823,
  [1946] = 1891,
  [1947] = 1947,
  [1948] = 1864,
  [1949] = 1891,
  [1950] = 1864,
  [1951] = 1826,
  [1952] = 1891,
  [1953] = 1809,
  [1954] = 1864,
  [1955] = 1818,
  [1956] = 1891,
  [1957] = 1864,
  [1958] = 1816,
  [1959] = 1891,
  [1960] = 1825,
  [1961] = 1864,
  [1962] = 1891,
  [1963] = 1913,
  [1964] = 1809,
  [1965] = 1900,
  [1966] = 1913,
  [1967] = 1900,
  [1968] = 1913,
  [1969] = 1900,
  [1970] = 1913,
  [1971] = 1900,
  [1972] = 1913,
  [1973] = 1900,
  [1974] = 1913,
  [1975] = 1900,
  [1976] = 1913,
  [1977] = 1900,
  [1978] = 1913,
  [1979] = 1900,
  [1980] = 1913,
  [1981] = 1815,
  [1982] = 1900,
  [1983] = 1858,
  [1984] = 1815,
  [1985] = 1858,
  [1986] = 1815,
  [1987] = 1858,
  [1988] = 1815,
  [1989] = 1858,
  [1990] = 1815,
  [1991] = 1858,
  [1992] = 1815,
  [1993] = 1858,
  [1994] = 1815,
  [1995] = 1858,
  [1996] = 1815,
  [1997] = 1858,
  [1998] = 1815,
  [1999] = 1858,
  [2000] = 1817,
  [2001] = 307,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2004,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2003,
  [2009] = 2009,
  [2010] = 2003,
  [2011] = 2009,
  [2012] = 2003,
  [2013] = 2009,
  [2014] = 2014,
  [2015] = 2003,
  [2016] = 2009,
  [2017] = 2004,
  [2018] = 2003,
  [2019] = 2009,
  [2020] = 2003,
  [2021] = 2009,
  [2022] = 2003,
  [2023] = 2009,
  [2024] = 2009,
  [2025] = 2003,
  [2026] = 2009,
  [2027] = 2003,
  [2028] = 2009,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 2031,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2037,
  [2039] = 2033,
  [2040] = 2032,
  [2041] = 2037,
  [2042] = 2033,
  [2043] = 2030,
  [2044] = 2044,
  [2045] = 2031,
  [2046] = 2032,
  [2047] = 2030,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2048,
  [2051] = 2049,
  [2052] = 2048,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2049,
  [2056] = 2049,
  [2057] = 2049,
  [2058] = 2048,
  [2059] = 2054,
  [2060] = 2048,
  [2061] = 2048,
  [2062] = 2049,
  [2063] = 2049,
  [2064] = 2048,
  [2065] = 2048,
  [2066] = 2049,
  [2067] = 2048,
  [2068] = 2049,
  [2069] = 2049,
  [2070] = 2048,
  [2071] = 2054,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'.', '.'}, {'A', 'Z'}, {'_', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'.', '.'}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe},
  {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152},
  {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d},
  {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22},
  {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47},
  {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b},
  {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c},
  {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
  {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(27);
      ADVANCE_MAP(
        '!', 32,
        '"', 73,
        '#', 97,
        '$', 58,
        '%', 5,
        '&', 41,
        '\'', 72,
        '*', 50,
        '+', 33,
        ',', 98,
        '-', 34,
        '.', 94,
        '/', 51,
        '0', 64,
        ':', 56,
        '<', 44,
        '=', 29,
        '>', 46,
        '?', 30,
        '@', 59,
        '\\', 28,
        '^', 53,
        '`', 9,
        '|', 40,
        '~', 31,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(65);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(96);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 7,
        '"', 73,
        '#', 97,
        '$', 58,
        '%', 5,
        '&', 41,
        '\'', 72,
        '*', 50,
        '+', 33,
        ',', 98,
        '-', 34,
        '.', 95,
        '/', 51,
        ':', 57,
        '<', 44,
        '=', 29,
        '>', 46,
        '?', 30,
        '@', 59,
        '^', 53,
        '`', 9,
        '|', 40,
        '~', 31,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(96);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 7,
        '#', 97,
        '$', 58,
        '%', 5,
        '&', 41,
        '*', 50,
        '+', 33,
        ',', 98,
        '-', 34,
        '/', 51,
        ':', 57,
        '<', 44,
        '=', 29,
        '>', 46,
        '?', 30,
        '@', 59,
        '^', 53,
        '`', 9,
        '|', 40,
        '~', 31,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(96);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0) ADVANCE(79);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(74);
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 5:
      if (lookahead == '%') ADVANCE(54);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\\') ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == '-') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 8:
      if (lookahead == 'U') ADVANCE(10);
      if (lookahead == 'u') ADVANCE(11);
      if (lookahead == 'x') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(82);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(80);
      END_STATE();
    case 9:
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '`') ADVANCE(92);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '{') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 11:
      if (lookahead == '{') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 12:
      if (lookahead == '}') ADVANCE(80);
      END_STATE();
    case 13:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 26:
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(48);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(38);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '>') ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DASH_GT_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(55);
      if (lookahead == '|') ADVANCE(42);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(43);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '<') ADVANCE(6);
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(52);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_binary_operator_token1);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(60);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == ':') ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_COLON);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym__hex_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(70);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(71);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(69);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(71);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(74);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(77);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_dots);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_dot_dot_i);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(91);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(91);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(69);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_comma);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'F', 1,
        'I', 2,
        'L', 3,
        'N', 4,
        'T', 5,
        'b', 6,
        'f', 7,
        'i', 8,
        'n', 9,
        'r', 10,
        'w', 11,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(14);
      if (lookahead == 'U') ADVANCE(15);
      if (lookahead == 'a') ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'R') ADVANCE(17);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == 'L') ADVANCE(26);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(27);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_NA);
      if (lookahead == '_') ADVANCE(28);
      END_STATE();
    case 15:
      if (lookahead == 'L') ADVANCE(29);
      END_STATE();
    case 16:
      if (lookahead == 'N') ADVANCE(30);
      END_STATE();
    case 17:
      if (lookahead == 'U') ADVANCE(31);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(34);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 23:
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 24:
      if (lookahead == 'p') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'S') ADVANCE(39);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_inf);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 'L') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nan);
      END_STATE();
    case 31:
      if (lookahead == 'E') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'E') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 45:
      if (lookahead == 'k') ADVANCE(56);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_next);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(62);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_break);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(67);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 62:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_return);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 70:
      if (lookahead == 'g') ADVANCE(75);
      END_STATE();
    case 71:
      if (lookahead == '_') ADVANCE(76);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_NA_real_);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 79:
      if (lookahead == 'x') ADVANCE(82);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 82:
      if (lookahead == '_') ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead == '_') ADVANCE(86);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_NA_complex_);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_NA_integer_);
      END_STATE();
    case 87:
      if (lookahead == '_') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_NA_character_);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 0, .external_lex_state = 3},
  [3] = {.lex_state = 0, .external_lex_state = 3},
  [4] = {.lex_state = 0, .external_lex_state = 3},
  [5] = {.lex_state = 0, .external_lex_state = 3},
  [6] = {.lex_state = 0, .external_lex_state = 4},
  [7] = {.lex_state = 0, .external_lex_state = 4},
  [8] = {.lex_state = 0, .external_lex_state = 4},
  [9] = {.lex_state = 0, .external_lex_state = 4},
  [10] = {.lex_state = 0, .external_lex_state = 4},
  [11] = {.lex_state = 0, .external_lex_state = 3},
  [12] = {.lex_state = 0, .external_lex_state = 3},
  [13] = {.lex_state = 0, .external_lex_state = 3},
  [14] = {.lex_state = 0, .external_lex_state = 3},
  [15] = {.lex_state = 0, .external_lex_state = 4},
  [16] = {.lex_state = 0, .external_lex_state = 4},
  [17] = {.lex_state = 0, .external_lex_state = 4},
  [18] = {.lex_state = 0, .external_lex_state = 4},
  [19] = {.lex_state = 0, .external_lex_state = 3},
  [20] = {.lex_state = 0, .external_lex_state = 3},
  [21] = {.lex_state = 0, .external_lex_state = 3},
  [22] = {.lex_state = 0, .external_lex_state = 3},
  [23] = {.lex_state = 0, .external_lex_state = 3},
  [24] = {.lex_state = 0, .external_lex_state = 3},
  [25] = {.lex_state = 0, .external_lex_state = 3},
  [26] = {.lex_state = 0, .external_lex_state = 3},
  [27] = {.lex_state = 0, .external_lex_state = 3},
  [28] = {.lex_state = 0, .external_lex_state = 3},
  [29] = {.lex_state = 0, .external_lex_state = 3},
  [30] = {.lex_state = 0, .external_lex_state = 3},
  [31] = {.lex_state = 0, .external_lex_state = 3},
  [32] = {.lex_state = 0, .external_lex_state = 3},
  [33] = {.lex_state = 0, .external_lex_state = 3},
  [34] = {.lex_state = 0, .external_lex_state = 3},
  [35] = {.lex_state = 0, .external_lex_state = 3},
  [36] = {.lex_state = 0, .external_lex_state = 3},
  [37] = {.lex_state = 0, .external_lex_state = 3},
  [38] = {.lex_state = 0, .external_lex_state = 3},
  [39] = {.lex_state = 0, .external_lex_state = 3},
  [40] = {.lex_state = 0, .external_lex_state = 3},
  [41] = {.lex_state = 0, .external_lex_state = 3},
  [42] = {.lex_state = 0, .external_lex_state = 3},
  [43] = {.lex_state = 0, .external_lex_state = 3},
  [44] = {.lex_state = 0, .external_lex_state = 3},
  [45] = {.lex_state = 0, .external_lex_state = 3},
  [46] = {.lex_state = 0, .external_lex_state = 3},
  [47] = {.lex_state = 0, .external_lex_state = 3},
  [48] = {.lex_state = 0, .external_lex_state = 3},
  [49] = {.lex_state = 0, .external_lex_state = 3},
  [50] = {.lex_state = 0, .external_lex_state = 3},
  [51] = {.lex_state = 0, .external_lex_state = 3},
  [52] = {.lex_state = 0, .external_lex_state = 3},
  [53] = {.lex_state = 0, .external_lex_state = 3},
  [54] = {.lex_state = 0, .external_lex_state = 3},
  [55] = {.lex_state = 0, .external_lex_state = 3},
  [56] = {.lex_state = 0, .external_lex_state = 3},
  [57] = {.lex_state = 0, .external_lex_state = 3},
  [58] = {.lex_state = 0, .external_lex_state = 3},
  [59] = {.lex_state = 0, .external_lex_state = 3},
  [60] = {.lex_state = 0, .external_lex_state = 3},
  [61] = {.lex_state = 0, .external_lex_state = 3},
  [62] = {.lex_state = 0, .external_lex_state = 3},
  [63] = {.lex_state = 0, .external_lex_state = 3},
  [64] = {.lex_state = 0, .external_lex_state = 3},
  [65] = {.lex_state = 0, .external_lex_state = 3},
  [66] = {.lex_state = 0, .external_lex_state = 4},
  [67] = {.lex_state = 0, .external_lex_state = 4},
  [68] = {.lex_state = 0, .external_lex_state = 4},
  [69] = {.lex_state = 0, .external_lex_state = 4},
  [70] = {.lex_state = 0, .external_lex_state = 4},
  [71] = {.lex_state = 0, .external_lex_state = 4},
  [72] = {.lex_state = 0, .external_lex_state = 4},
  [73] = {.lex_state = 0, .external_lex_state = 4},
  [74] = {.lex_state = 0, .external_lex_state = 3},
  [75] = {.lex_state = 0, .external_lex_state = 4},
  [76] = {.lex_state = 0, .external_lex_state = 4},
  [77] = {.lex_state = 0, .external_lex_state = 4},
  [78] = {.lex_state = 0, .external_lex_state = 4},
  [79] = {.lex_state = 0, .external_lex_state = 4},
  [80] = {.lex_state = 0, .external_lex_state = 4},
  [81] = {.lex_state = 0, .external_lex_state = 4},
  [82] = {.lex_state = 0, .external_lex_state = 4},
  [83] = {.lex_state = 0, .external_lex_state = 4},
  [84] = {.lex_state = 0, .external_lex_state = 4},
  [85] = {.lex_state = 0, .external_lex_state = 4},
  [86] = {.lex_state = 0, .external_lex_state = 4},
  [87] = {.lex_state = 0, .external_lex_state = 4},
  [88] = {.lex_state = 0, .external_lex_state = 4},
  [89] = {.lex_state = 0, .external_lex_state = 4},
  [90] = {.lex_state = 0, .external_lex_state = 4},
  [91] = {.lex_state = 0, .external_lex_state = 4},
  [92] = {.lex_state = 0, .external_lex_state = 4},
  [93] = {.lex_state = 0, .external_lex_state = 4},
  [94] = {.lex_state = 0, .external_lex_state = 4},
  [95] = {.lex_state = 0, .external_lex_state = 4},
  [96] = {.lex_state = 0, .external_lex_state = 4},
  [97] = {.lex_state = 0, .external_lex_state = 4},
  [98] = {.lex_state = 0, .external_lex_state = 4},
  [99] = {.lex_state = 0, .external_lex_state = 4},
  [100] = {.lex_state = 0, .external_lex_state = 4},
  [101] = {.lex_state = 0, .external_lex_state = 4},
  [102] = {.lex_state = 0, .external_lex_state = 4},
  [103] = {.lex_state = 0, .external_lex_state = 4},
  [104] = {.lex_state = 0, .external_lex_state = 4},
  [105] = {.lex_state = 0, .external_lex_state = 4},
  [106] = {.lex_state = 0, .external_lex_state = 4},
  [107] = {.lex_state = 0, .external_lex_state = 4},
  [108] = {.lex_state = 0, .external_lex_state = 4},
  [109] = {.lex_state = 0, .external_lex_state = 4},
  [110] = {.lex_state = 0, .external_lex_state = 4},
  [111] = {.lex_state = 0, .external_lex_state = 4},
  [112] = {.lex_state = 0, .external_lex_state = 4},
  [113] = {.lex_state = 0, .external_lex_state = 4},
  [114] = {.lex_state = 0, .external_lex_state = 4},
  [115] = {.lex_state = 0, .external_lex_state = 4},
  [116] = {.lex_state = 0, .external_lex_state = 4},
  [117] = {.lex_state = 0, .external_lex_state = 4},
  [118] = {.lex_state = 0, .external_lex_state = 4},
  [119] = {.lex_state = 0, .external_lex_state = 3},
  [120] = {.lex_state = 0, .external_lex_state = 4},
  [121] = {.lex_state = 0, .external_lex_state = 4},
  [122] = {.lex_state = 0, .external_lex_state = 3},
  [123] = {.lex_state = 0, .external_lex_state = 3},
  [124] = {.lex_state = 0, .external_lex_state = 3},
  [125] = {.lex_state = 0, .external_lex_state = 3},
  [126] = {.lex_state = 0, .external_lex_state = 3},
  [127] = {.lex_state = 0, .external_lex_state = 3},
  [128] = {.lex_state = 0, .external_lex_state = 3},
  [129] = {.lex_state = 0, .external_lex_state = 4},
  [130] = {.lex_state = 0, .external_lex_state = 5},
  [131] = {.lex_state = 0, .external_lex_state = 6},
  [132] = {.lex_state = 0, .external_lex_state = 6},
  [133] = {.lex_state = 0, .external_lex_state = 6},
  [134] = {.lex_state = 0, .external_lex_state = 6},
  [135] = {.lex_state = 0, .external_lex_state = 6},
  [136] = {.lex_state = 0, .external_lex_state = 6},
  [137] = {.lex_state = 0, .external_lex_state = 6},
  [138] = {.lex_state = 0, .external_lex_state = 6},
  [139] = {.lex_state = 0, .external_lex_state = 6},
  [140] = {.lex_state = 0, .external_lex_state = 6},
  [141] = {.lex_state = 0, .external_lex_state = 6},
  [142] = {.lex_state = 0, .external_lex_state = 6},
  [143] = {.lex_state = 0, .external_lex_state = 6},
  [144] = {.lex_state = 0, .external_lex_state = 6},
  [145] = {.lex_state = 0, .external_lex_state = 6},
  [146] = {.lex_state = 0, .external_lex_state = 6},
  [147] = {.lex_state = 0, .external_lex_state = 6},
  [148] = {.lex_state = 0, .external_lex_state = 6},
  [149] = {.lex_state = 0, .external_lex_state = 6},
  [150] = {.lex_state = 0, .external_lex_state = 6},
  [151] = {.lex_state = 0, .external_lex_state = 6},
  [152] = {.lex_state = 0, .external_lex_state = 6},
  [153] = {.lex_state = 0, .external_lex_state = 6},
  [154] = {.lex_state = 0, .external_lex_state = 6},
  [155] = {.lex_state = 0, .external_lex_state = 6},
  [156] = {.lex_state = 0, .external_lex_state = 6},
  [157] = {.lex_state = 0, .external_lex_state = 6},
  [158] = {.lex_state = 0, .external_lex_state = 6},
  [159] = {.lex_state = 0, .external_lex_state = 6},
  [160] = {.lex_state = 0, .external_lex_state = 6},
  [161] = {.lex_state = 0, .external_lex_state = 6},
  [162] = {.lex_state = 0, .external_lex_state = 6},
  [163] = {.lex_state = 0, .external_lex_state = 6},
  [164] = {.lex_state = 0, .external_lex_state = 6},
  [165] = {.lex_state = 0, .external_lex_state = 5},
  [166] = {.lex_state = 0, .external_lex_state = 6},
  [167] = {.lex_state = 0, .external_lex_state = 6},
  [168] = {.lex_state = 0, .external_lex_state = 6},
  [169] = {.lex_state = 0, .external_lex_state = 6},
  [170] = {.lex_state = 0, .external_lex_state = 5},
  [171] = {.lex_state = 0, .external_lex_state = 6},
  [172] = {.lex_state = 0, .external_lex_state = 6},
  [173] = {.lex_state = 0, .external_lex_state = 6},
  [174] = {.lex_state = 0, .external_lex_state = 6},
  [175] = {.lex_state = 0, .external_lex_state = 6},
  [176] = {.lex_state = 0, .external_lex_state = 6},
  [177] = {.lex_state = 0, .external_lex_state = 6},
  [178] = {.lex_state = 0, .external_lex_state = 6},
  [179] = {.lex_state = 0, .external_lex_state = 6},
  [180] = {.lex_state = 0, .external_lex_state = 6},
  [181] = {.lex_state = 0, .external_lex_state = 6},
  [182] = {.lex_state = 0, .external_lex_state = 6},
  [183] = {.lex_state = 0, .external_lex_state = 5},
  [184] = {.lex_state = 0, .external_lex_state = 5},
  [185] = {.lex_state = 0, .external_lex_state = 5},
  [186] = {.lex_state = 0, .external_lex_state = 5},
  [187] = {.lex_state = 0, .external_lex_state = 6},
  [188] = {.lex_state = 0, .external_lex_state = 5},
  [189] = {.lex_state = 0, .external_lex_state = 5},
  [190] = {.lex_state = 0, .external_lex_state = 5},
  [191] = {.lex_state = 0, .external_lex_state = 5},
  [192] = {.lex_state = 0, .external_lex_state = 5},
  [193] = {.lex_state = 0, .external_lex_state = 5},
  [194] = {.lex_state = 0, .external_lex_state = 5},
  [195] = {.lex_state = 0, .external_lex_state = 5},
  [196] = {.lex_state = 0, .external_lex_state = 5},
  [197] = {.lex_state = 0, .external_lex_state = 5},
  [198] = {.lex_state = 0, .external_lex_state = 5},
  [199] = {.lex_state = 0, .external_lex_state = 5},
  [200] = {.lex_state = 0, .external_lex_state = 5},
  [201] = {.lex_state = 0, .external_lex_state = 5},
  [202] = {.lex_state = 0, .external_lex_state = 5},
  [203] = {.lex_state = 0, .external_lex_state = 5},
  [204] = {.lex_state = 0, .external_lex_state = 5},
  [205] = {.lex_state = 0, .external_lex_state = 5},
  [206] = {.lex_state = 0, .external_lex_state = 5},
  [207] = {.lex_state = 0, .external_lex_state = 5},
  [208] = {.lex_state = 0, .external_lex_state = 5},
  [209] = {.lex_state = 0, .external_lex_state = 5},
  [210] = {.lex_state = 0, .external_lex_state = 5},
  [211] = {.lex_state = 0, .external_lex_state = 5},
  [212] = {.lex_state = 0, .external_lex_state = 5},
  [213] = {.lex_state = 0, .external_lex_state = 5},
  [214] = {.lex_state = 0, .external_lex_state = 5},
  [215] = {.lex_state = 0, .external_lex_state = 5},
  [216] = {.lex_state = 0, .external_lex_state = 5},
  [217] = {.lex_state = 0, .external_lex_state = 5},
  [218] = {.lex_state = 0, .external_lex_state = 5},
  [219] = {.lex_state = 0, .external_lex_state = 5},
  [220] = {.lex_state = 0, .external_lex_state = 5},
  [221] = {.lex_state = 0, .external_lex_state = 5},
  [222] = {.lex_state = 0, .external_lex_state = 5},
  [223] = {.lex_state = 0, .external_lex_state = 5},
  [224] = {.lex_state = 0, .external_lex_state = 5},
  [225] = {.lex_state = 0, .external_lex_state = 5},
  [226] = {.lex_state = 0, .external_lex_state = 5},
  [227] = {.lex_state = 0, .external_lex_state = 5},
  [228] = {.lex_state = 0, .external_lex_state = 5},
  [229] = {.lex_state = 0, .external_lex_state = 5},
  [230] = {.lex_state = 0, .external_lex_state = 5},
  [231] = {.lex_state = 0, .external_lex_state = 5},
  [232] = {.lex_state = 0, .external_lex_state = 5},
  [233] = {.lex_state = 0, .external_lex_state = 5},
  [234] = {.lex_state = 0, .external_lex_state = 5},
  [235] = {.lex_state = 0, .external_lex_state = 5},
  [236] = {.lex_state = 0, .external_lex_state = 5},
  [237] = {.lex_state = 0, .external_lex_state = 5},
  [238] = {.lex_state = 0, .external_lex_state = 6},
  [239] = {.lex_state = 0, .external_lex_state = 6},
  [240] = {.lex_state = 0, .external_lex_state = 6},
  [241] = {.lex_state = 0, .external_lex_state = 6},
  [242] = {.lex_state = 0, .external_lex_state = 6},
  [243] = {.lex_state = 0, .external_lex_state = 6},
  [244] = {.lex_state = 0, .external_lex_state = 3},
  [245] = {.lex_state = 0, .external_lex_state = 4},
  [246] = {.lex_state = 0, .external_lex_state = 4},
  [247] = {.lex_state = 0, .external_lex_state = 3},
  [248] = {.lex_state = 0, .external_lex_state = 7},
  [249] = {.lex_state = 0, .external_lex_state = 8},
  [250] = {.lex_state = 0, .external_lex_state = 6},
  [251] = {.lex_state = 0, .external_lex_state = 5},
  [252] = {.lex_state = 0, .external_lex_state = 4},
  [253] = {.lex_state = 0, .external_lex_state = 9},
  [254] = {.lex_state = 0, .external_lex_state = 3},
  [255] = {.lex_state = 0, .external_lex_state = 7},
  [256] = {.lex_state = 0, .external_lex_state = 9},
  [257] = {.lex_state = 0, .external_lex_state = 8},
  [258] = {.lex_state = 0, .external_lex_state = 8},
  [259] = {.lex_state = 0, .external_lex_state = 6},
  [260] = {.lex_state = 0, .external_lex_state = 7},
  [261] = {.lex_state = 0, .external_lex_state = 9},
  [262] = {.lex_state = 0, .external_lex_state = 8},
  [263] = {.lex_state = 0, .external_lex_state = 5},
  [264] = {.lex_state = 0, .external_lex_state = 7},
  [265] = {.lex_state = 0, .external_lex_state = 8},
  [266] = {.lex_state = 0, .external_lex_state = 7},
  [267] = {.lex_state = 0, .external_lex_state = 9},
  [268] = {.lex_state = 0, .external_lex_state = 8},
  [269] = {.lex_state = 0, .external_lex_state = 7},
  [270] = {.lex_state = 0, .external_lex_state = 9},
  [271] = {.lex_state = 0, .external_lex_state = 8},
  [272] = {.lex_state = 0, .external_lex_state = 7},
  [273] = {.lex_state = 0, .external_lex_state = 9},
  [274] = {.lex_state = 0, .external_lex_state = 8},
  [275] = {.lex_state = 0, .external_lex_state = 7},
  [276] = {.lex_state = 0, .external_lex_state = 9},
  [277] = {.lex_state = 0, .external_lex_state = 8},
  [278] = {.lex_state = 0, .external_lex_state = 7},
  [279] = {.lex_state = 0, .external_lex_state = 9},
  [280] = {.lex_state = 0, .external_lex_state = 8},
  [281] = {.lex_state = 0, .external_lex_state = 7},
  [282] = {.lex_state = 0, .external_lex_state = 9},
  [283] = {.lex_state = 0, .external_lex_state = 9},
  [284] = {.lex_state = 0, .external_lex_state = 4},
  [285] = {.lex_state = 0, .external_lex_state = 3},
  [286] = {.lex_state = 0, .external_lex_state = 3},
  [287] = {.lex_state = 0, .external_lex_state = 3},
  [288] = {.lex_state = 0, .external_lex_state = 3},
  [289] = {.lex_state = 0, .external_lex_state = 3},
  [290] = {.lex_state = 0, .external_lex_state = 4},
  [291] = {.lex_state = 0, .external_lex_state = 4},
  [292] = {.lex_state = 0, .external_lex_state = 4},
  [293] = {.lex_state = 0, .external_lex_state = 4},
  [294] = {.lex_state = 0, .external_lex_state = 4},
  [295] = {.lex_state = 0, .external_lex_state = 4},
  [296] = {.lex_state = 0, .external_lex_state = 3},
  [297] = {.lex_state = 0, .external_lex_state = 3},
  [298] = {.lex_state = 0, .external_lex_state = 4},
  [299] = {.lex_state = 0, .external_lex_state = 4},
  [300] = {.lex_state = 0, .external_lex_state = 5},
  [301] = {.lex_state = 0, .external_lex_state = 3},
  [302] = {.lex_state = 0, .external_lex_state = 3},
  [303] = {.lex_state = 0, .external_lex_state = 6},
  [304] = {.lex_state = 0, .external_lex_state = 5},
  [305] = {.lex_state = 0, .external_lex_state = 5},
  [306] = {.lex_state = 0, .external_lex_state = 5},
  [307] = {.lex_state = 0, .external_lex_state = 3},
  [308] = {.lex_state = 0, .external_lex_state = 5},
  [309] = {.lex_state = 0, .external_lex_state = 5},
  [310] = {.lex_state = 0, .external_lex_state = 7},
  [311] = {.lex_state = 0, .external_lex_state = 5},
  [312] = {.lex_state = 0, .external_lex_state = 9},
  [313] = {.lex_state = 0, .external_lex_state = 6},
  [314] = {.lex_state = 0, .external_lex_state = 6},
  [315] = {.lex_state = 0, .external_lex_state = 6},
  [316] = {.lex_state = 0, .external_lex_state = 6},
  [317] = {.lex_state = 0, .external_lex_state = 6},
  [318] = {.lex_state = 0, .external_lex_state = 4},
  [319] = {.lex_state = 0, .external_lex_state = 6},
  [320] = {.lex_state = 0, .external_lex_state = 6},
  [321] = {.lex_state = 0, .external_lex_state = 6},
  [322] = {.lex_state = 0, .external_lex_state = 6},
  [323] = {.lex_state = 0, .external_lex_state = 5},
  [324] = {.lex_state = 0, .external_lex_state = 8},
  [325] = {.lex_state = 0, .external_lex_state = 5},
  [326] = {.lex_state = 0, .external_lex_state = 5},
  [327] = {.lex_state = 0, .external_lex_state = 4},
  [328] = {.lex_state = 0, .external_lex_state = 4},
  [329] = {.lex_state = 0, .external_lex_state = 4},
  [330] = {.lex_state = 0, .external_lex_state = 4},
  [331] = {.lex_state = 0, .external_lex_state = 4},
  [332] = {.lex_state = 0, .external_lex_state = 3},
  [333] = {.lex_state = 0, .external_lex_state = 3},
  [334] = {.lex_state = 0, .external_lex_state = 6},
  [335] = {.lex_state = 0, .external_lex_state = 3},
  [336] = {.lex_state = 0, .external_lex_state = 4},
  [337] = {.lex_state = 0, .external_lex_state = 4},
  [338] = {.lex_state = 0, .external_lex_state = 4},
  [339] = {.lex_state = 0, .external_lex_state = 4},
  [340] = {.lex_state = 0, .external_lex_state = 3},
  [341] = {.lex_state = 0, .external_lex_state = 4},
  [342] = {.lex_state = 0, .external_lex_state = 4},
  [343] = {.lex_state = 0, .external_lex_state = 4},
  [344] = {.lex_state = 0, .external_lex_state = 4},
  [345] = {.lex_state = 0, .external_lex_state = 4},
  [346] = {.lex_state = 0, .external_lex_state = 4},
  [347] = {.lex_state = 0, .external_lex_state = 4},
  [348] = {.lex_state = 0, .external_lex_state = 4},
  [349] = {.lex_state = 0, .external_lex_state = 4},
  [350] = {.lex_state = 0, .external_lex_state = 4},
  [351] = {.lex_state = 0, .external_lex_state = 3},
  [352] = {.lex_state = 0, .external_lex_state = 4},
  [353] = {.lex_state = 0, .external_lex_state = 4},
  [354] = {.lex_state = 0, .external_lex_state = 5},
  [355] = {.lex_state = 0, .external_lex_state = 3},
  [356] = {.lex_state = 0, .external_lex_state = 3},
  [357] = {.lex_state = 0, .external_lex_state = 3},
  [358] = {.lex_state = 0, .external_lex_state = 3},
  [359] = {.lex_state = 0, .external_lex_state = 3},
  [360] = {.lex_state = 0, .external_lex_state = 3},
  [361] = {.lex_state = 0, .external_lex_state = 4},
  [362] = {.lex_state = 0, .external_lex_state = 3},
  [363] = {.lex_state = 0, .external_lex_state = 3},
  [364] = {.lex_state = 0, .external_lex_state = 3},
  [365] = {.lex_state = 0, .external_lex_state = 3},
  [366] = {.lex_state = 0, .external_lex_state = 3},
  [367] = {.lex_state = 0, .external_lex_state = 3},
  [368] = {.lex_state = 0, .external_lex_state = 3},
  [369] = {.lex_state = 0, .external_lex_state = 3},
  [370] = {.lex_state = 0, .external_lex_state = 3},
  [371] = {.lex_state = 0, .external_lex_state = 4},
  [372] = {.lex_state = 0, .external_lex_state = 3},
  [373] = {.lex_state = 0, .external_lex_state = 3},
  [374] = {.lex_state = 0, .external_lex_state = 3},
  [375] = {.lex_state = 0, .external_lex_state = 3},
  [376] = {.lex_state = 0, .external_lex_state = 4},
  [377] = {.lex_state = 0, .external_lex_state = 5},
  [378] = {.lex_state = 0, .external_lex_state = 5},
  [379] = {.lex_state = 0, .external_lex_state = 5},
  [380] = {.lex_state = 0, .external_lex_state = 5},
  [381] = {.lex_state = 0, .external_lex_state = 5},
  [382] = {.lex_state = 0, .external_lex_state = 5},
  [383] = {.lex_state = 0, .external_lex_state = 5},
  [384] = {.lex_state = 0, .external_lex_state = 5},
  [385] = {.lex_state = 0, .external_lex_state = 6},
  [386] = {.lex_state = 0, .external_lex_state = 10},
  [387] = {.lex_state = 0, .external_lex_state = 5},
  [388] = {.lex_state = 0, .external_lex_state = 6},
  [389] = {.lex_state = 0, .external_lex_state = 10},
  [390] = {.lex_state = 0, .external_lex_state = 10},
  [391] = {.lex_state = 0, .external_lex_state = 5},
  [392] = {.lex_state = 0, .external_lex_state = 5},
  [393] = {.lex_state = 0, .external_lex_state = 5},
  [394] = {.lex_state = 0, .external_lex_state = 6},
  [395] = {.lex_state = 0, .external_lex_state = 5},
  [396] = {.lex_state = 0, .external_lex_state = 5},
  [397] = {.lex_state = 0, .external_lex_state = 5},
  [398] = {.lex_state = 0, .external_lex_state = 10},
  [399] = {.lex_state = 0, .external_lex_state = 10},
  [400] = {.lex_state = 0, .external_lex_state = 10},
  [401] = {.lex_state = 0, .external_lex_state = 5},
  [402] = {.lex_state = 0, .external_lex_state = 10},
  [403] = {.lex_state = 0, .external_lex_state = 10},
  [404] = {.lex_state = 0, .external_lex_state = 6},
  [405] = {.lex_state = 0, .external_lex_state = 6},
  [406] = {.lex_state = 0, .external_lex_state = 6},
  [407] = {.lex_state = 0, .external_lex_state = 6},
  [408] = {.lex_state = 0, .external_lex_state = 5},
  [409] = {.lex_state = 0, .external_lex_state = 6},
  [410] = {.lex_state = 0, .external_lex_state = 6},
  [411] = {.lex_state = 0, .external_lex_state = 6},
  [412] = {.lex_state = 0, .external_lex_state = 5},
  [413] = {.lex_state = 0, .external_lex_state = 6},
  [414] = {.lex_state = 0, .external_lex_state = 10},
  [415] = {.lex_state = 0, .external_lex_state = 6},
  [416] = {.lex_state = 0, .external_lex_state = 6},
  [417] = {.lex_state = 0, .external_lex_state = 10},
  [418] = {.lex_state = 0, .external_lex_state = 10},
  [419] = {.lex_state = 0, .external_lex_state = 5},
  [420] = {.lex_state = 0, .external_lex_state = 5},
  [421] = {.lex_state = 0, .external_lex_state = 5},
  [422] = {.lex_state = 0, .external_lex_state = 10},
  [423] = {.lex_state = 0, .external_lex_state = 6},
  [424] = {.lex_state = 0, .external_lex_state = 6},
  [425] = {.lex_state = 0, .external_lex_state = 6},
  [426] = {.lex_state = 0, .external_lex_state = 10},
  [427] = {.lex_state = 0, .external_lex_state = 6},
  [428] = {.lex_state = 0, .external_lex_state = 5},
  [429] = {.lex_state = 0, .external_lex_state = 6},
  [430] = {.lex_state = 0, .external_lex_state = 10},
  [431] = {.lex_state = 0, .external_lex_state = 6},
  [432] = {.lex_state = 0, .external_lex_state = 6},
  [433] = {.lex_state = 0, .external_lex_state = 10},
  [434] = {.lex_state = 0, .external_lex_state = 10},
  [435] = {.lex_state = 0, .external_lex_state = 6},
  [436] = {.lex_state = 0, .external_lex_state = 6},
  [437] = {.lex_state = 0, .external_lex_state = 10},
  [438] = {.lex_state = 0, .external_lex_state = 6},
  [439] = {.lex_state = 0, .external_lex_state = 10},
  [440] = {.lex_state = 0, .external_lex_state = 6},
  [441] = {.lex_state = 0, .external_lex_state = 10},
  [442] = {.lex_state = 0, .external_lex_state = 5},
  [443] = {.lex_state = 0, .external_lex_state = 5},
  [444] = {.lex_state = 0, .external_lex_state = 10},
  [445] = {.lex_state = 0, .external_lex_state = 10},
  [446] = {.lex_state = 0, .external_lex_state = 11},
  [447] = {.lex_state = 0, .external_lex_state = 11},
  [448] = {.lex_state = 0, .external_lex_state = 11},
  [449] = {.lex_state = 0, .external_lex_state = 7},
  [450] = {.lex_state = 0, .external_lex_state = 9},
  [451] = {.lex_state = 0, .external_lex_state = 8},
  [452] = {.lex_state = 0, .external_lex_state = 12},
  [453] = {.lex_state = 0, .external_lex_state = 12},
  [454] = {.lex_state = 0, .external_lex_state = 12},
  [455] = {.lex_state = 0, .external_lex_state = 12},
  [456] = {.lex_state = 0, .external_lex_state = 12},
  [457] = {.lex_state = 0, .external_lex_state = 12},
  [458] = {.lex_state = 0, .external_lex_state = 12},
  [459] = {.lex_state = 0, .external_lex_state = 12},
  [460] = {.lex_state = 0, .external_lex_state = 12},
  [461] = {.lex_state = 0, .external_lex_state = 12},
  [462] = {.lex_state = 0, .external_lex_state = 12},
  [463] = {.lex_state = 0, .external_lex_state = 12},
  [464] = {.lex_state = 0, .external_lex_state = 12},
  [465] = {.lex_state = 0, .external_lex_state = 12},
  [466] = {.lex_state = 0, .external_lex_state = 12},
  [467] = {.lex_state = 0, .external_lex_state = 12},
  [468] = {.lex_state = 0, .external_lex_state = 12},
  [469] = {.lex_state = 0, .external_lex_state = 12},
  [470] = {.lex_state = 0, .external_lex_state = 12},
  [471] = {.lex_state = 0, .external_lex_state = 12},
  [472] = {.lex_state = 0, .external_lex_state = 12},
  [473] = {.lex_state = 0, .external_lex_state = 12},
  [474] = {.lex_state = 0, .external_lex_state = 12},
  [475] = {.lex_state = 0, .external_lex_state = 12},
  [476] = {.lex_state = 0, .external_lex_state = 12},
  [477] = {.lex_state = 0, .external_lex_state = 12},
  [478] = {.lex_state = 0, .external_lex_state = 12},
  [479] = {.lex_state = 0, .external_lex_state = 12},
  [480] = {.lex_state = 0, .external_lex_state = 12},
  [481] = {.lex_state = 0, .external_lex_state = 12},
  [482] = {.lex_state = 0, .external_lex_state = 12},
  [483] = {.lex_state = 0, .external_lex_state = 12},
  [484] = {.lex_state = 0, .external_lex_state = 12},
  [485] = {.lex_state = 0, .external_lex_state = 12},
  [486] = {.lex_state = 0, .external_lex_state = 12},
  [487] = {.lex_state = 0, .external_lex_state = 12},
  [488] = {.lex_state = 0, .external_lex_state = 12},
  [489] = {.lex_state = 0, .external_lex_state = 12},
  [490] = {.lex_state = 0, .external_lex_state = 12},
  [491] = {.lex_state = 0, .external_lex_state = 12},
  [492] = {.lex_state = 0, .external_lex_state = 12},
  [493] = {.lex_state = 0, .external_lex_state = 12},
  [494] = {.lex_state = 0, .external_lex_state = 12},
  [495] = {.lex_state = 0, .external_lex_state = 12},
  [496] = {.lex_state = 0, .external_lex_state = 12},
  [497] = {.lex_state = 0, .external_lex_state = 12},
  [498] = {.lex_state = 0, .external_lex_state = 12},
  [499] = {.lex_state = 0, .external_lex_state = 12},
  [500] = {.lex_state = 0, .external_lex_state = 12},
  [501] = {.lex_state = 0, .external_lex_state = 12},
  [502] = {.lex_state = 0, .external_lex_state = 12},
  [503] = {.lex_state = 0, .external_lex_state = 12},
  [504] = {.lex_state = 0, .external_lex_state = 12},
  [505] = {.lex_state = 0, .external_lex_state = 12},
  [506] = {.lex_state = 0, .external_lex_state = 12},
  [507] = {.lex_state = 0, .external_lex_state = 12},
  [508] = {.lex_state = 0, .external_lex_state = 12},
  [509] = {.lex_state = 0, .external_lex_state = 12},
  [510] = {.lex_state = 0, .external_lex_state = 12},
  [511] = {.lex_state = 0, .external_lex_state = 12},
  [512] = {.lex_state = 0, .external_lex_state = 12},
  [513] = {.lex_state = 0, .external_lex_state = 12},
  [514] = {.lex_state = 0, .external_lex_state = 12},
  [515] = {.lex_state = 0, .external_lex_state = 12},
  [516] = {.lex_state = 0, .external_lex_state = 12},
  [517] = {.lex_state = 0, .external_lex_state = 12},
  [518] = {.lex_state = 0, .external_lex_state = 12},
  [519] = {.lex_state = 0, .external_lex_state = 12},
  [520] = {.lex_state = 0, .external_lex_state = 12},
  [521] = {.lex_state = 0, .external_lex_state = 12},
  [522] = {.lex_state = 0, .external_lex_state = 12},
  [523] = {.lex_state = 0, .external_lex_state = 12},
  [524] = {.lex_state = 0, .external_lex_state = 12},
  [525] = {.lex_state = 0, .external_lex_state = 12},
  [526] = {.lex_state = 0, .external_lex_state = 12},
  [527] = {.lex_state = 0, .external_lex_state = 12},
  [528] = {.lex_state = 0, .external_lex_state = 12},
  [529] = {.lex_state = 0, .external_lex_state = 12},
  [530] = {.lex_state = 0, .external_lex_state = 12},
  [531] = {.lex_state = 0, .external_lex_state = 12},
  [532] = {.lex_state = 0, .external_lex_state = 12},
  [533] = {.lex_state = 0, .external_lex_state = 12},
  [534] = {.lex_state = 0, .external_lex_state = 12},
  [535] = {.lex_state = 0, .external_lex_state = 12},
  [536] = {.lex_state = 0, .external_lex_state = 12},
  [537] = {.lex_state = 0, .external_lex_state = 12},
  [538] = {.lex_state = 0, .external_lex_state = 12},
  [539] = {.lex_state = 0, .external_lex_state = 12},
  [540] = {.lex_state = 0, .external_lex_state = 12},
  [541] = {.lex_state = 0, .external_lex_state = 12},
  [542] = {.lex_state = 0, .external_lex_state = 12},
  [543] = {.lex_state = 0, .external_lex_state = 12},
  [544] = {.lex_state = 0, .external_lex_state = 12},
  [545] = {.lex_state = 0, .external_lex_state = 12},
  [546] = {.lex_state = 0, .external_lex_state = 12},
  [547] = {.lex_state = 0, .external_lex_state = 12},
  [548] = {.lex_state = 0, .external_lex_state = 12},
  [549] = {.lex_state = 0, .external_lex_state = 12},
  [550] = {.lex_state = 0, .external_lex_state = 12},
  [551] = {.lex_state = 0, .external_lex_state = 12},
  [552] = {.lex_state = 0, .external_lex_state = 12},
  [553] = {.lex_state = 0, .external_lex_state = 12},
  [554] = {.lex_state = 0, .external_lex_state = 12},
  [555] = {.lex_state = 0, .external_lex_state = 12},
  [556] = {.lex_state = 0, .external_lex_state = 12},
  [557] = {.lex_state = 0, .external_lex_state = 12},
  [558] = {.lex_state = 0, .external_lex_state = 12},
  [559] = {.lex_state = 0, .external_lex_state = 12},
  [560] = {.lex_state = 0, .external_lex_state = 12},
  [561] = {.lex_state = 0, .external_lex_state = 12},
  [562] = {.lex_state = 0, .external_lex_state = 12},
  [563] = {.lex_state = 0, .external_lex_state = 12},
  [564] = {.lex_state = 0, .external_lex_state = 12},
  [565] = {.lex_state = 0, .external_lex_state = 12},
  [566] = {.lex_state = 0, .external_lex_state = 12},
  [567] = {.lex_state = 0, .external_lex_state = 12},
  [568] = {.lex_state = 0, .external_lex_state = 12},
  [569] = {.lex_state = 0, .external_lex_state = 12},
  [570] = {.lex_state = 0, .external_lex_state = 12},
  [571] = {.lex_state = 0, .external_lex_state = 12},
  [572] = {.lex_state = 0, .external_lex_state = 12},
  [573] = {.lex_state = 0, .external_lex_state = 12},
  [574] = {.lex_state = 0, .external_lex_state = 12},
  [575] = {.lex_state = 0, .external_lex_state = 12},
  [576] = {.lex_state = 0, .external_lex_state = 12},
  [577] = {.lex_state = 0, .external_lex_state = 12},
  [578] = {.lex_state = 0, .external_lex_state = 12},
  [579] = {.lex_state = 0, .external_lex_state = 12},
  [580] = {.lex_state = 0, .external_lex_state = 12},
  [581] = {.lex_state = 0, .external_lex_state = 12},
  [582] = {.lex_state = 0, .external_lex_state = 12},
  [583] = {.lex_state = 0, .external_lex_state = 12},
  [584] = {.lex_state = 0, .external_lex_state = 12},
  [585] = {.lex_state = 0, .external_lex_state = 12},
  [586] = {.lex_state = 0, .external_lex_state = 12},
  [587] = {.lex_state = 0, .external_lex_state = 12},
  [588] = {.lex_state = 0, .external_lex_state = 12},
  [589] = {.lex_state = 0, .external_lex_state = 12},
  [590] = {.lex_state = 0, .external_lex_state = 12},
  [591] = {.lex_state = 0, .external_lex_state = 12},
  [592] = {.lex_state = 0, .external_lex_state = 12},
  [593] = {.lex_state = 0, .external_lex_state = 12},
  [594] = {.lex_state = 0, .external_lex_state = 12},
  [595] = {.lex_state = 0, .external_lex_state = 12},
  [596] = {.lex_state = 0, .external_lex_state = 12},
  [597] = {.lex_state = 0, .external_lex_state = 12},
  [598] = {.lex_state = 0, .external_lex_state = 12},
  [599] = {.lex_state = 0, .external_lex_state = 12},
  [600] = {.lex_state = 0, .external_lex_state = 12},
  [601] = {.lex_state = 0, .external_lex_state = 12},
  [602] = {.lex_state = 0, .external_lex_state = 12},
  [603] = {.lex_state = 0, .external_lex_state = 12},
  [604] = {.lex_state = 0, .external_lex_state = 12},
  [605] = {.lex_state = 0, .external_lex_state = 12},
  [606] = {.lex_state = 0, .external_lex_state = 12},
  [607] = {.lex_state = 0, .external_lex_state = 12},
  [608] = {.lex_state = 0, .external_lex_state = 12},
  [609] = {.lex_state = 0, .external_lex_state = 12},
  [610] = {.lex_state = 0, .external_lex_state = 12},
  [611] = {.lex_state = 0, .external_lex_state = 12},
  [612] = {.lex_state = 0, .external_lex_state = 12},
  [613] = {.lex_state = 0, .external_lex_state = 12},
  [614] = {.lex_state = 0, .external_lex_state = 12},
  [615] = {.lex_state = 0, .external_lex_state = 12},
  [616] = {.lex_state = 0, .external_lex_state = 12},
  [617] = {.lex_state = 0, .external_lex_state = 12},
  [618] = {.lex_state = 0, .external_lex_state = 12},
  [619] = {.lex_state = 0, .external_lex_state = 12},
  [620] = {.lex_state = 0, .external_lex_state = 12},
  [621] = {.lex_state = 0, .external_lex_state = 12},
  [622] = {.lex_state = 0, .external_lex_state = 12},
  [623] = {.lex_state = 0, .external_lex_state = 12},
  [624] = {.lex_state = 0, .external_lex_state = 12},
  [625] = {.lex_state = 0, .external_lex_state = 12},
  [626] = {.lex_state = 0, .external_lex_state = 12},
  [627] = {.lex_state = 0, .external_lex_state = 12},
  [628] = {.lex_state = 0, .external_lex_state = 12},
  [629] = {.lex_state = 0, .external_lex_state = 12},
  [630] = {.lex_state = 0, .external_lex_state = 12},
  [631] = {.lex_state = 0, .external_lex_state = 12},
  [632] = {.lex_state = 0, .external_lex_state = 12},
  [633] = {.lex_state = 0, .external_lex_state = 12},
  [634] = {.lex_state = 0, .external_lex_state = 12},
  [635] = {.lex_state = 0, .external_lex_state = 12},
  [636] = {.lex_state = 0, .external_lex_state = 12},
  [637] = {.lex_state = 0, .external_lex_state = 12},
  [638] = {.lex_state = 0, .external_lex_state = 12},
  [639] = {.lex_state = 0, .external_lex_state = 12},
  [640] = {.lex_state = 0, .external_lex_state = 12},
  [641] = {.lex_state = 0, .external_lex_state = 12},
  [642] = {.lex_state = 0, .external_lex_state = 12},
  [643] = {.lex_state = 0, .external_lex_state = 12},
  [644] = {.lex_state = 0, .external_lex_state = 12},
  [645] = {.lex_state = 0, .external_lex_state = 12},
  [646] = {.lex_state = 0, .external_lex_state = 12},
  [647] = {.lex_state = 0, .external_lex_state = 12},
  [648] = {.lex_state = 0, .external_lex_state = 12},
  [649] = {.lex_state = 0, .external_lex_state = 12},
  [650] = {.lex_state = 0, .external_lex_state = 12},
  [651] = {.lex_state = 0, .external_lex_state = 12},
  [652] = {.lex_state = 0, .external_lex_state = 12},
  [653] = {.lex_state = 0, .external_lex_state = 12},
  [654] = {.lex_state = 0, .external_lex_state = 12},
  [655] = {.lex_state = 0, .external_lex_state = 12},
  [656] = {.lex_state = 0, .external_lex_state = 12},
  [657] = {.lex_state = 0, .external_lex_state = 12},
  [658] = {.lex_state = 0, .external_lex_state = 12},
  [659] = {.lex_state = 0, .external_lex_state = 12},
  [660] = {.lex_state = 0, .external_lex_state = 12},
  [661] = {.lex_state = 0, .external_lex_state = 12},
  [662] = {.lex_state = 0, .external_lex_state = 12},
  [663] = {.lex_state = 0, .external_lex_state = 12},
  [664] = {.lex_state = 0, .external_lex_state = 12},
  [665] = {.lex_state = 0, .external_lex_state = 12},
  [666] = {.lex_state = 0, .external_lex_state = 12},
  [667] = {.lex_state = 0, .external_lex_state = 12},
  [668] = {.lex_state = 0, .external_lex_state = 12},
  [669] = {.lex_state = 0, .external_lex_state = 12},
  [670] = {.lex_state = 0, .external_lex_state = 12},
  [671] = {.lex_state = 0, .external_lex_state = 12},
  [672] = {.lex_state = 0, .external_lex_state = 12},
  [673] = {.lex_state = 0, .external_lex_state = 12},
  [674] = {.lex_state = 0, .external_lex_state = 12},
  [675] = {.lex_state = 0, .external_lex_state = 12},
  [676] = {.lex_state = 0, .external_lex_state = 12},
  [677] = {.lex_state = 0, .external_lex_state = 12},
  [678] = {.lex_state = 0, .external_lex_state = 12},
  [679] = {.lex_state = 0, .external_lex_state = 12},
  [680] = {.lex_state = 0, .external_lex_state = 12},
  [681] = {.lex_state = 0, .external_lex_state = 12},
  [682] = {.lex_state = 0, .external_lex_state = 12},
  [683] = {.lex_state = 0, .external_lex_state = 12},
  [684] = {.lex_state = 0, .external_lex_state = 12},
  [685] = {.lex_state = 0, .external_lex_state = 12},
  [686] = {.lex_state = 0, .external_lex_state = 12},
  [687] = {.lex_state = 0, .external_lex_state = 12},
  [688] = {.lex_state = 0, .external_lex_state = 12},
  [689] = {.lex_state = 0, .external_lex_state = 12},
  [690] = {.lex_state = 0, .external_lex_state = 12},
  [691] = {.lex_state = 0, .external_lex_state = 12},
  [692] = {.lex_state = 0, .external_lex_state = 12},
  [693] = {.lex_state = 0, .external_lex_state = 12},
  [694] = {.lex_state = 0, .external_lex_state = 12},
  [695] = {.lex_state = 0, .external_lex_state = 12},
  [696] = {.lex_state = 0, .external_lex_state = 12},
  [697] = {.lex_state = 0, .external_lex_state = 12},
  [698] = {.lex_state = 0, .external_lex_state = 12},
  [699] = {.lex_state = 0, .external_lex_state = 12},
  [700] = {.lex_state = 0, .external_lex_state = 12},
  [701] = {.lex_state = 0, .external_lex_state = 12},
  [702] = {.lex_state = 0, .external_lex_state = 12},
  [703] = {.lex_state = 0, .external_lex_state = 12},
  [704] = {.lex_state = 0, .external_lex_state = 12},
  [705] = {.lex_state = 0, .external_lex_state = 12},
  [706] = {.lex_state = 0, .external_lex_state = 12},
  [707] = {.lex_state = 0, .external_lex_state = 12},
  [708] = {.lex_state = 0, .external_lex_state = 12},
  [709] = {.lex_state = 0, .external_lex_state = 12},
  [710] = {.lex_state = 0, .external_lex_state = 12},
  [711] = {.lex_state = 0, .external_lex_state = 12},
  [712] = {.lex_state = 0, .external_lex_state = 12},
  [713] = {.lex_state = 0, .external_lex_state = 12},
  [714] = {.lex_state = 0, .external_lex_state = 12},
  [715] = {.lex_state = 0, .external_lex_state = 12},
  [716] = {.lex_state = 0, .external_lex_state = 12},
  [717] = {.lex_state = 0, .external_lex_state = 12},
  [718] = {.lex_state = 0, .external_lex_state = 12},
  [719] = {.lex_state = 0, .external_lex_state = 12},
  [720] = {.lex_state = 0, .external_lex_state = 12},
  [721] = {.lex_state = 0, .external_lex_state = 12},
  [722] = {.lex_state = 0, .external_lex_state = 12},
  [723] = {.lex_state = 0, .external_lex_state = 12},
  [724] = {.lex_state = 0, .external_lex_state = 12},
  [725] = {.lex_state = 0, .external_lex_state = 12},
  [726] = {.lex_state = 0, .external_lex_state = 12},
  [727] = {.lex_state = 0, .external_lex_state = 12},
  [728] = {.lex_state = 0, .external_lex_state = 12},
  [729] = {.lex_state = 0, .external_lex_state = 12},
  [730] = {.lex_state = 0, .external_lex_state = 12},
  [731] = {.lex_state = 0, .external_lex_state = 12},
  [732] = {.lex_state = 0, .external_lex_state = 12},
  [733] = {.lex_state = 0, .external_lex_state = 12},
  [734] = {.lex_state = 0, .external_lex_state = 12},
  [735] = {.lex_state = 0, .external_lex_state = 12},
  [736] = {.lex_state = 0, .external_lex_state = 12},
  [737] = {.lex_state = 0, .external_lex_state = 12},
  [738] = {.lex_state = 0, .external_lex_state = 12},
  [739] = {.lex_state = 0, .external_lex_state = 12},
  [740] = {.lex_state = 0, .external_lex_state = 12},
  [741] = {.lex_state = 0, .external_lex_state = 12},
  [742] = {.lex_state = 0, .external_lex_state = 12},
  [743] = {.lex_state = 0, .external_lex_state = 12},
  [744] = {.lex_state = 0, .external_lex_state = 12},
  [745] = {.lex_state = 0, .external_lex_state = 12},
  [746] = {.lex_state = 0, .external_lex_state = 12},
  [747] = {.lex_state = 0, .external_lex_state = 12},
  [748] = {.lex_state = 0, .external_lex_state = 12},
  [749] = {.lex_state = 0, .external_lex_state = 12},
  [750] = {.lex_state = 0, .external_lex_state = 12},
  [751] = {.lex_state = 0, .external_lex_state = 12},
  [752] = {.lex_state = 0, .external_lex_state = 12},
  [753] = {.lex_state = 0, .external_lex_state = 12},
  [754] = {.lex_state = 0, .external_lex_state = 12},
  [755] = {.lex_state = 0, .external_lex_state = 12},
  [756] = {.lex_state = 0, .external_lex_state = 12},
  [757] = {.lex_state = 0, .external_lex_state = 12},
  [758] = {.lex_state = 0, .external_lex_state = 12},
  [759] = {.lex_state = 0, .external_lex_state = 12},
  [760] = {.lex_state = 0, .external_lex_state = 12},
  [761] = {.lex_state = 0, .external_lex_state = 12},
  [762] = {.lex_state = 0, .external_lex_state = 12},
  [763] = {.lex_state = 0, .external_lex_state = 12},
  [764] = {.lex_state = 0, .external_lex_state = 12},
  [765] = {.lex_state = 0, .external_lex_state = 12},
  [766] = {.lex_state = 0, .external_lex_state = 12},
  [767] = {.lex_state = 0, .external_lex_state = 12},
  [768] = {.lex_state = 0, .external_lex_state = 12},
  [769] = {.lex_state = 0, .external_lex_state = 12},
  [770] = {.lex_state = 0, .external_lex_state = 12},
  [771] = {.lex_state = 0, .external_lex_state = 12},
  [772] = {.lex_state = 0, .external_lex_state = 12},
  [773] = {.lex_state = 0, .external_lex_state = 12},
  [774] = {.lex_state = 0, .external_lex_state = 12},
  [775] = {.lex_state = 0, .external_lex_state = 12},
  [776] = {.lex_state = 0, .external_lex_state = 12},
  [777] = {.lex_state = 0, .external_lex_state = 12},
  [778] = {.lex_state = 0, .external_lex_state = 12},
  [779] = {.lex_state = 0, .external_lex_state = 12},
  [780] = {.lex_state = 0, .external_lex_state = 12},
  [781] = {.lex_state = 0, .external_lex_state = 12},
  [782] = {.lex_state = 0, .external_lex_state = 12},
  [783] = {.lex_state = 0, .external_lex_state = 12},
  [784] = {.lex_state = 0, .external_lex_state = 12},
  [785] = {.lex_state = 0, .external_lex_state = 12},
  [786] = {.lex_state = 0, .external_lex_state = 12},
  [787] = {.lex_state = 0, .external_lex_state = 12},
  [788] = {.lex_state = 0, .external_lex_state = 12},
  [789] = {.lex_state = 0, .external_lex_state = 12},
  [790] = {.lex_state = 0, .external_lex_state = 12},
  [791] = {.lex_state = 0, .external_lex_state = 12},
  [792] = {.lex_state = 0, .external_lex_state = 12},
  [793] = {.lex_state = 0, .external_lex_state = 12},
  [794] = {.lex_state = 0, .external_lex_state = 12},
  [795] = {.lex_state = 0, .external_lex_state = 12},
  [796] = {.lex_state = 0, .external_lex_state = 12},
  [797] = {.lex_state = 0, .external_lex_state = 12},
  [798] = {.lex_state = 0, .external_lex_state = 12},
  [799] = {.lex_state = 0, .external_lex_state = 12},
  [800] = {.lex_state = 0, .external_lex_state = 12},
  [801] = {.lex_state = 0, .external_lex_state = 12},
  [802] = {.lex_state = 0, .external_lex_state = 12},
  [803] = {.lex_state = 0, .external_lex_state = 12},
  [804] = {.lex_state = 0, .external_lex_state = 12},
  [805] = {.lex_state = 0, .external_lex_state = 12},
  [806] = {.lex_state = 0, .external_lex_state = 12},
  [807] = {.lex_state = 0, .external_lex_state = 12},
  [808] = {.lex_state = 0, .external_lex_state = 12},
  [809] = {.lex_state = 0, .external_lex_state = 12},
  [810] = {.lex_state = 0, .external_lex_state = 12},
  [811] = {.lex_state = 0, .external_lex_state = 12},
  [812] = {.lex_state = 0, .external_lex_state = 12},
  [813] = {.lex_state = 0, .external_lex_state = 12},
  [814] = {.lex_state = 0, .external_lex_state = 12},
  [815] = {.lex_state = 0, .external_lex_state = 12},
  [816] = {.lex_state = 0, .external_lex_state = 12},
  [817] = {.lex_state = 0, .external_lex_state = 12},
  [818] = {.lex_state = 0, .external_lex_state = 12},
  [819] = {.lex_state = 0, .external_lex_state = 12},
  [820] = {.lex_state = 0, .external_lex_state = 12},
  [821] = {.lex_state = 0, .external_lex_state = 12},
  [822] = {.lex_state = 0, .external_lex_state = 12},
  [823] = {.lex_state = 0, .external_lex_state = 12},
  [824] = {.lex_state = 0, .external_lex_state = 12},
  [825] = {.lex_state = 0, .external_lex_state = 12},
  [826] = {.lex_state = 0, .external_lex_state = 12},
  [827] = {.lex_state = 0, .external_lex_state = 12},
  [828] = {.lex_state = 0, .external_lex_state = 12},
  [829] = {.lex_state = 0, .external_lex_state = 12},
  [830] = {.lex_state = 0, .external_lex_state = 12},
  [831] = {.lex_state = 0, .external_lex_state = 12},
  [832] = {.lex_state = 0, .external_lex_state = 12},
  [833] = {.lex_state = 0, .external_lex_state = 12},
  [834] = {.lex_state = 0, .external_lex_state = 12},
  [835] = {.lex_state = 0, .external_lex_state = 12},
  [836] = {.lex_state = 0, .external_lex_state = 12},
  [837] = {.lex_state = 0, .external_lex_state = 12},
  [838] = {.lex_state = 0, .external_lex_state = 12},
  [839] = {.lex_state = 0, .external_lex_state = 12},
  [840] = {.lex_state = 0, .external_lex_state = 12},
  [841] = {.lex_state = 0, .external_lex_state = 12},
  [842] = {.lex_state = 0, .external_lex_state = 12},
  [843] = {.lex_state = 0, .external_lex_state = 12},
  [844] = {.lex_state = 0, .external_lex_state = 12},
  [845] = {.lex_state = 0, .external_lex_state = 12},
  [846] = {.lex_state = 0, .external_lex_state = 12},
  [847] = {.lex_state = 0, .external_lex_state = 12},
  [848] = {.lex_state = 0, .external_lex_state = 12},
  [849] = {.lex_state = 0, .external_lex_state = 12},
  [850] = {.lex_state = 0, .external_lex_state = 12},
  [851] = {.lex_state = 0, .external_lex_state = 12},
  [852] = {.lex_state = 0, .external_lex_state = 12},
  [853] = {.lex_state = 0, .external_lex_state = 12},
  [854] = {.lex_state = 0, .external_lex_state = 12},
  [855] = {.lex_state = 0, .external_lex_state = 12},
  [856] = {.lex_state = 0, .external_lex_state = 12},
  [857] = {.lex_state = 0, .external_lex_state = 12},
  [858] = {.lex_state = 0, .external_lex_state = 12},
  [859] = {.lex_state = 0, .external_lex_state = 12},
  [860] = {.lex_state = 0, .external_lex_state = 12},
  [861] = {.lex_state = 0, .external_lex_state = 12},
  [862] = {.lex_state = 0, .external_lex_state = 12},
  [863] = {.lex_state = 0, .external_lex_state = 12},
  [864] = {.lex_state = 0, .external_lex_state = 12},
  [865] = {.lex_state = 0, .external_lex_state = 12},
  [866] = {.lex_state = 0, .external_lex_state = 12},
  [867] = {.lex_state = 0, .external_lex_state = 12},
  [868] = {.lex_state = 0, .external_lex_state = 12},
  [869] = {.lex_state = 0, .external_lex_state = 12},
  [870] = {.lex_state = 0, .external_lex_state = 12},
  [871] = {.lex_state = 0, .external_lex_state = 12},
  [872] = {.lex_state = 0, .external_lex_state = 12},
  [873] = {.lex_state = 0, .external_lex_state = 12},
  [874] = {.lex_state = 0, .external_lex_state = 12},
  [875] = {.lex_state = 0, .external_lex_state = 12},
  [876] = {.lex_state = 0, .external_lex_state = 12},
  [877] = {.lex_state = 0, .external_lex_state = 12},
  [878] = {.lex_state = 0, .external_lex_state = 12},
  [879] = {.lex_state = 0, .external_lex_state = 12},
  [880] = {.lex_state = 0, .external_lex_state = 12},
  [881] = {.lex_state = 0, .external_lex_state = 12},
  [882] = {.lex_state = 0, .external_lex_state = 12},
  [883] = {.lex_state = 0, .external_lex_state = 12},
  [884] = {.lex_state = 0, .external_lex_state = 12},
  [885] = {.lex_state = 0, .external_lex_state = 12},
  [886] = {.lex_state = 0, .external_lex_state = 12},
  [887] = {.lex_state = 0, .external_lex_state = 12},
  [888] = {.lex_state = 0, .external_lex_state = 12},
  [889] = {.lex_state = 0, .external_lex_state = 12},
  [890] = {.lex_state = 0, .external_lex_state = 12},
  [891] = {.lex_state = 0, .external_lex_state = 12},
  [892] = {.lex_state = 0, .external_lex_state = 12},
  [893] = {.lex_state = 0, .external_lex_state = 12},
  [894] = {.lex_state = 0, .external_lex_state = 12},
  [895] = {.lex_state = 0, .external_lex_state = 12},
  [896] = {.lex_state = 0, .external_lex_state = 12},
  [897] = {.lex_state = 0, .external_lex_state = 12},
  [898] = {.lex_state = 0, .external_lex_state = 12},
  [899] = {.lex_state = 0, .external_lex_state = 12},
  [900] = {.lex_state = 0, .external_lex_state = 12},
  [901] = {.lex_state = 0, .external_lex_state = 12},
  [902] = {.lex_state = 0, .external_lex_state = 12},
  [903] = {.lex_state = 0, .external_lex_state = 12},
  [904] = {.lex_state = 0, .external_lex_state = 12},
  [905] = {.lex_state = 0, .external_lex_state = 12},
  [906] = {.lex_state = 0, .external_lex_state = 12},
  [907] = {.lex_state = 0, .external_lex_state = 12},
  [908] = {.lex_state = 0, .external_lex_state = 12},
  [909] = {.lex_state = 0, .external_lex_state = 12},
  [910] = {.lex_state = 0, .external_lex_state = 12},
  [911] = {.lex_state = 0, .external_lex_state = 12},
  [912] = {.lex_state = 0, .external_lex_state = 12},
  [913] = {.lex_state = 0, .external_lex_state = 12},
  [914] = {.lex_state = 0, .external_lex_state = 12},
  [915] = {.lex_state = 0, .external_lex_state = 12},
  [916] = {.lex_state = 0, .external_lex_state = 12},
  [917] = {.lex_state = 0, .external_lex_state = 12},
  [918] = {.lex_state = 0, .external_lex_state = 12},
  [919] = {.lex_state = 0, .external_lex_state = 12},
  [920] = {.lex_state = 0, .external_lex_state = 12},
  [921] = {.lex_state = 0, .external_lex_state = 12},
  [922] = {.lex_state = 0, .external_lex_state = 12},
  [923] = {.lex_state = 0, .external_lex_state = 12},
  [924] = {.lex_state = 0, .external_lex_state = 12},
  [925] = {.lex_state = 0, .external_lex_state = 12},
  [926] = {.lex_state = 0, .external_lex_state = 12},
  [927] = {.lex_state = 0, .external_lex_state = 12},
  [928] = {.lex_state = 0, .external_lex_state = 12},
  [929] = {.lex_state = 0, .external_lex_state = 12},
  [930] = {.lex_state = 0, .external_lex_state = 12},
  [931] = {.lex_state = 0, .external_lex_state = 12},
  [932] = {.lex_state = 0, .external_lex_state = 12},
  [933] = {.lex_state = 0, .external_lex_state = 12},
  [934] = {.lex_state = 0, .external_lex_state = 12},
  [935] = {.lex_state = 0, .external_lex_state = 12},
  [936] = {.lex_state = 0, .external_lex_state = 12},
  [937] = {.lex_state = 0, .external_lex_state = 12},
  [938] = {.lex_state = 0, .external_lex_state = 12},
  [939] = {.lex_state = 0, .external_lex_state = 12},
  [940] = {.lex_state = 0, .external_lex_state = 12},
  [941] = {.lex_state = 0, .external_lex_state = 12},
  [942] = {.lex_state = 0, .external_lex_state = 12},
  [943] = {.lex_state = 0, .external_lex_state = 12},
  [944] = {.lex_state = 0, .external_lex_state = 12},
  [945] = {.lex_state = 0, .external_lex_state = 12},
  [946] = {.lex_state = 0, .external_lex_state = 12},
  [947] = {.lex_state = 0, .external_lex_state = 12},
  [948] = {.lex_state = 0, .external_lex_state = 12},
  [949] = {.lex_state = 0, .external_lex_state = 12},
  [950] = {.lex_state = 0, .external_lex_state = 12},
  [951] = {.lex_state = 0, .external_lex_state = 12},
  [952] = {.lex_state = 0, .external_lex_state = 12},
  [953] = {.lex_state = 0, .external_lex_state = 12},
  [954] = {.lex_state = 0, .external_lex_state = 12},
  [955] = {.lex_state = 0, .external_lex_state = 12},
  [956] = {.lex_state = 0, .external_lex_state = 12},
  [957] = {.lex_state = 0, .external_lex_state = 12},
  [958] = {.lex_state = 0, .external_lex_state = 12},
  [959] = {.lex_state = 0, .external_lex_state = 12},
  [960] = {.lex_state = 0, .external_lex_state = 12},
  [961] = {.lex_state = 0, .external_lex_state = 12},
  [962] = {.lex_state = 0, .external_lex_state = 12},
  [963] = {.lex_state = 0, .external_lex_state = 12},
  [964] = {.lex_state = 0, .external_lex_state = 12},
  [965] = {.lex_state = 0, .external_lex_state = 12},
  [966] = {.lex_state = 0, .external_lex_state = 12},
  [967] = {.lex_state = 0, .external_lex_state = 12},
  [968] = {.lex_state = 0, .external_lex_state = 12},
  [969] = {.lex_state = 0, .external_lex_state = 12},
  [970] = {.lex_state = 0, .external_lex_state = 12},
  [971] = {.lex_state = 0, .external_lex_state = 12},
  [972] = {.lex_state = 0, .external_lex_state = 12},
  [973] = {.lex_state = 0, .external_lex_state = 12},
  [974] = {.lex_state = 0, .external_lex_state = 12},
  [975] = {.lex_state = 0, .external_lex_state = 12},
  [976] = {.lex_state = 0, .external_lex_state = 12},
  [977] = {.lex_state = 0, .external_lex_state = 12},
  [978] = {.lex_state = 0, .external_lex_state = 12},
  [979] = {.lex_state = 0, .external_lex_state = 12},
  [980] = {.lex_state = 0, .external_lex_state = 12},
  [981] = {.lex_state = 0, .external_lex_state = 12},
  [982] = {.lex_state = 0, .external_lex_state = 12},
  [983] = {.lex_state = 0, .external_lex_state = 12},
  [984] = {.lex_state = 0, .external_lex_state = 12},
  [985] = {.lex_state = 0, .external_lex_state = 12},
  [986] = {.lex_state = 0, .external_lex_state = 12},
  [987] = {.lex_state = 0, .external_lex_state = 12},
  [988] = {.lex_state = 0, .external_lex_state = 12},
  [989] = {.lex_state = 0, .external_lex_state = 12},
  [990] = {.lex_state = 0, .external_lex_state = 12},
  [991] = {.lex_state = 0, .external_lex_state = 12},
  [992] = {.lex_state = 0, .external_lex_state = 12},
  [993] = {.lex_state = 0, .external_lex_state = 12},
  [994] = {.lex_state = 0, .external_lex_state = 12},
  [995] = {.lex_state = 0, .external_lex_state = 12},
  [996] = {.lex_state = 0, .external_lex_state = 12},
  [997] = {.lex_state = 0, .external_lex_state = 12},
  [998] = {.lex_state = 0, .external_lex_state = 12},
  [999] = {.lex_state = 0, .external_lex_state = 12},
  [1000] = {.lex_state = 0, .external_lex_state = 12},
  [1001] = {.lex_state = 0, .external_lex_state = 12},
  [1002] = {.lex_state = 0, .external_lex_state = 12},
  [1003] = {.lex_state = 0, .external_lex_state = 12},
  [1004] = {.lex_state = 0, .external_lex_state = 12},
  [1005] = {.lex_state = 0, .external_lex_state = 12},
  [1006] = {.lex_state = 0, .external_lex_state = 12},
  [1007] = {.lex_state = 0, .external_lex_state = 12},
  [1008] = {.lex_state = 0, .external_lex_state = 12},
  [1009] = {.lex_state = 0, .external_lex_state = 12},
  [1010] = {.lex_state = 0, .external_lex_state = 12},
  [1011] = {.lex_state = 0, .external_lex_state = 12},
  [1012] = {.lex_state = 0, .external_lex_state = 12},
  [1013] = {.lex_state = 0, .external_lex_state = 12},
  [1014] = {.lex_state = 0, .external_lex_state = 12},
  [1015] = {.lex_state = 0, .external_lex_state = 12},
  [1016] = {.lex_state = 0, .external_lex_state = 12},
  [1017] = {.lex_state = 0, .external_lex_state = 12},
  [1018] = {.lex_state = 0, .external_lex_state = 12},
  [1019] = {.lex_state = 0, .external_lex_state = 12},
  [1020] = {.lex_state = 0, .external_lex_state = 12},
  [1021] = {.lex_state = 0, .external_lex_state = 12},
  [1022] = {.lex_state = 0, .external_lex_state = 12},
  [1023] = {.lex_state = 0, .external_lex_state = 12},
  [1024] = {.lex_state = 0, .external_lex_state = 12},
  [1025] = {.lex_state = 0, .external_lex_state = 12},
  [1026] = {.lex_state = 0, .external_lex_state = 12},
  [1027] = {.lex_state = 0, .external_lex_state = 12},
  [1028] = {.lex_state = 0, .external_lex_state = 12},
  [1029] = {.lex_state = 0, .external_lex_state = 12},
  [1030] = {.lex_state = 0, .external_lex_state = 12},
  [1031] = {.lex_state = 0, .external_lex_state = 12},
  [1032] = {.lex_state = 0, .external_lex_state = 12},
  [1033] = {.lex_state = 0, .external_lex_state = 12},
  [1034] = {.lex_state = 0, .external_lex_state = 12},
  [1035] = {.lex_state = 0, .external_lex_state = 12},
  [1036] = {.lex_state = 0, .external_lex_state = 12},
  [1037] = {.lex_state = 0, .external_lex_state = 12},
  [1038] = {.lex_state = 0, .external_lex_state = 12},
  [1039] = {.lex_state = 0, .external_lex_state = 12},
  [1040] = {.lex_state = 0, .external_lex_state = 12},
  [1041] = {.lex_state = 0, .external_lex_state = 12},
  [1042] = {.lex_state = 0, .external_lex_state = 12},
  [1043] = {.lex_state = 0, .external_lex_state = 12},
  [1044] = {.lex_state = 0, .external_lex_state = 12},
  [1045] = {.lex_state = 0, .external_lex_state = 12},
  [1046] = {.lex_state = 0, .external_lex_state = 12},
  [1047] = {.lex_state = 0, .external_lex_state = 13},
  [1048] = {.lex_state = 0, .external_lex_state = 13},
  [1049] = {.lex_state = 0, .external_lex_state = 13},
  [1050] = {.lex_state = 0, .external_lex_state = 13},
  [1051] = {.lex_state = 0, .external_lex_state = 13},
  [1052] = {.lex_state = 0, .external_lex_state = 13},
  [1053] = {.lex_state = 0, .external_lex_state = 13},
  [1054] = {.lex_state = 0, .external_lex_state = 13},
  [1055] = {.lex_state = 0, .external_lex_state = 13},
  [1056] = {.lex_state = 0, .external_lex_state = 13},
  [1057] = {.lex_state = 0, .external_lex_state = 13},
  [1058] = {.lex_state = 0, .external_lex_state = 13},
  [1059] = {.lex_state = 0, .external_lex_state = 13},
  [1060] = {.lex_state = 0, .external_lex_state = 13},
  [1061] = {.lex_state = 0, .external_lex_state = 13},
  [1062] = {.lex_state = 0, .external_lex_state = 13},
  [1063] = {.lex_state = 0, .external_lex_state = 13},
  [1064] = {.lex_state = 0, .external_lex_state = 13},
  [1065] = {.lex_state = 0, .external_lex_state = 13},
  [1066] = {.lex_state = 0, .external_lex_state = 13},
  [1067] = {.lex_state = 0, .external_lex_state = 13},
  [1068] = {.lex_state = 0, .external_lex_state = 13},
  [1069] = {.lex_state = 0, .external_lex_state = 13},
  [1070] = {.lex_state = 0, .external_lex_state = 13},
  [1071] = {.lex_state = 0, .external_lex_state = 13},
  [1072] = {.lex_state = 0, .external_lex_state = 13},
  [1073] = {.lex_state = 0, .external_lex_state = 13},
  [1074] = {.lex_state = 0, .external_lex_state = 13},
  [1075] = {.lex_state = 0, .external_lex_state = 13},
  [1076] = {.lex_state = 0, .external_lex_state = 13},
  [1077] = {.lex_state = 0, .external_lex_state = 13},
  [1078] = {.lex_state = 0, .external_lex_state = 13},
  [1079] = {.lex_state = 0, .external_lex_state = 13},
  [1080] = {.lex_state = 0, .external_lex_state = 13},
  [1081] = {.lex_state = 0, .external_lex_state = 13},
  [1082] = {.lex_state = 0, .external_lex_state = 13},
  [1083] = {.lex_state = 0, .external_lex_state = 13},
  [1084] = {.lex_state = 0, .external_lex_state = 13},
  [1085] = {.lex_state = 0, .external_lex_state = 13},
  [1086] = {.lex_state = 0, .external_lex_state = 13},
  [1087] = {.lex_state = 0, .external_lex_state = 13},
  [1088] = {.lex_state = 0, .external_lex_state = 13},
  [1089] = {.lex_state = 0, .external_lex_state = 13},
  [1090] = {.lex_state = 0, .external_lex_state = 13},
  [1091] = {.lex_state = 0, .external_lex_state = 13},
  [1092] = {.lex_state = 0, .external_lex_state = 13},
  [1093] = {.lex_state = 0, .external_lex_state = 13},
  [1094] = {.lex_state = 0, .external_lex_state = 13},
  [1095] = {.lex_state = 0, .external_lex_state = 13},
  [1096] = {.lex_state = 0, .external_lex_state = 13},
  [1097] = {.lex_state = 0, .external_lex_state = 13},
  [1098] = {.lex_state = 0, .external_lex_state = 13},
  [1099] = {.lex_state = 0, .external_lex_state = 13},
  [1100] = {.lex_state = 0, .external_lex_state = 13},
  [1101] = {.lex_state = 0, .external_lex_state = 13},
  [1102] = {.lex_state = 0, .external_lex_state = 13},
  [1103] = {.lex_state = 0, .external_lex_state = 13},
  [1104] = {.lex_state = 0, .external_lex_state = 13},
  [1105] = {.lex_state = 0, .external_lex_state = 13},
  [1106] = {.lex_state = 0, .external_lex_state = 13},
  [1107] = {.lex_state = 0, .external_lex_state = 13},
  [1108] = {.lex_state = 0, .external_lex_state = 13},
  [1109] = {.lex_state = 0, .external_lex_state = 13},
  [1110] = {.lex_state = 0, .external_lex_state = 13},
  [1111] = {.lex_state = 0, .external_lex_state = 13},
  [1112] = {.lex_state = 0, .external_lex_state = 13},
  [1113] = {.lex_state = 0, .external_lex_state = 13},
  [1114] = {.lex_state = 0, .external_lex_state = 13},
  [1115] = {.lex_state = 0, .external_lex_state = 13},
  [1116] = {.lex_state = 0, .external_lex_state = 13},
  [1117] = {.lex_state = 0, .external_lex_state = 13},
  [1118] = {.lex_state = 1, .external_lex_state = 14},
  [1119] = {.lex_state = 1, .external_lex_state = 15},
  [1120] = {.lex_state = 1, .external_lex_state = 15},
  [1121] = {.lex_state = 1, .external_lex_state = 16},
  [1122] = {.lex_state = 1, .external_lex_state = 16},
  [1123] = {.lex_state = 1, .external_lex_state = 14},
  [1124] = {.lex_state = 1, .external_lex_state = 17},
  [1125] = {.lex_state = 1, .external_lex_state = 17},
  [1126] = {.lex_state = 1, .external_lex_state = 18},
  [1127] = {.lex_state = 1, .external_lex_state = 19},
  [1128] = {.lex_state = 1, .external_lex_state = 18},
  [1129] = {.lex_state = 1, .external_lex_state = 19},
  [1130] = {.lex_state = 1, .external_lex_state = 20},
  [1131] = {.lex_state = 1, .external_lex_state = 21},
  [1132] = {.lex_state = 1, .external_lex_state = 22},
  [1133] = {.lex_state = 1, .external_lex_state = 14},
  [1134] = {.lex_state = 1, .external_lex_state = 16},
  [1135] = {.lex_state = 1, .external_lex_state = 23},
  [1136] = {.lex_state = 1, .external_lex_state = 24},
  [1137] = {.lex_state = 1, .external_lex_state = 25},
  [1138] = {.lex_state = 1, .external_lex_state = 15},
  [1139] = {.lex_state = 0, .external_lex_state = 26},
  [1140] = {.lex_state = 0, .external_lex_state = 27},
  [1141] = {.lex_state = 0, .external_lex_state = 27},
  [1142] = {.lex_state = 0, .external_lex_state = 27},
  [1143] = {.lex_state = 0, .external_lex_state = 27},
  [1144] = {.lex_state = 0, .external_lex_state = 27},
  [1145] = {.lex_state = 1, .external_lex_state = 18},
  [1146] = {.lex_state = 0, .external_lex_state = 28},
  [1147] = {.lex_state = 1, .external_lex_state = 17},
  [1148] = {.lex_state = 1, .external_lex_state = 19},
  [1149] = {.lex_state = 0, .external_lex_state = 28},
  [1150] = {.lex_state = 0, .external_lex_state = 28},
  [1151] = {.lex_state = 0, .external_lex_state = 26},
  [1152] = {.lex_state = 0, .external_lex_state = 26},
  [1153] = {.lex_state = 0, .external_lex_state = 26},
  [1154] = {.lex_state = 0, .external_lex_state = 26},
  [1155] = {.lex_state = 0, .external_lex_state = 28},
  [1156] = {.lex_state = 0, .external_lex_state = 28},
  [1157] = {.lex_state = 0, .external_lex_state = 28},
  [1158] = {.lex_state = 0, .external_lex_state = 26},
  [1159] = {.lex_state = 0, .external_lex_state = 26},
  [1160] = {.lex_state = 0, .external_lex_state = 28},
  [1161] = {.lex_state = 0, .external_lex_state = 26},
  [1162] = {.lex_state = 0, .external_lex_state = 27},
  [1163] = {.lex_state = 0, .external_lex_state = 27},
  [1164] = {.lex_state = 0, .external_lex_state = 28},
  [1165] = {.lex_state = 0, .external_lex_state = 27},
  [1166] = {.lex_state = 0, .external_lex_state = 27},
  [1167] = {.lex_state = 0, .external_lex_state = 28},
  [1168] = {.lex_state = 0, .external_lex_state = 28},
  [1169] = {.lex_state = 0, .external_lex_state = 28},
  [1170] = {.lex_state = 0, .external_lex_state = 28},
  [1171] = {.lex_state = 0, .external_lex_state = 28},
  [1172] = {.lex_state = 0, .external_lex_state = 28},
  [1173] = {.lex_state = 0, .external_lex_state = 28},
  [1174] = {.lex_state = 0, .external_lex_state = 28},
  [1175] = {.lex_state = 0, .external_lex_state = 28},
  [1176] = {.lex_state = 0, .external_lex_state = 26},
  [1177] = {.lex_state = 0, .external_lex_state = 28},
  [1178] = {.lex_state = 0, .external_lex_state = 28},
  [1179] = {.lex_state = 0, .external_lex_state = 28},
  [1180] = {.lex_state = 0, .external_lex_state = 28},
  [1181] = {.lex_state = 0, .external_lex_state = 28},
  [1182] = {.lex_state = 0, .external_lex_state = 28},
  [1183] = {.lex_state = 0, .external_lex_state = 28},
  [1184] = {.lex_state = 0, .external_lex_state = 28},
  [1185] = {.lex_state = 0, .external_lex_state = 28},
  [1186] = {.lex_state = 0, .external_lex_state = 28},
  [1187] = {.lex_state = 0, .external_lex_state = 28},
  [1188] = {.lex_state = 0, .external_lex_state = 28},
  [1189] = {.lex_state = 0, .external_lex_state = 27},
  [1190] = {.lex_state = 0, .external_lex_state = 27},
  [1191] = {.lex_state = 0, .external_lex_state = 27},
  [1192] = {.lex_state = 0, .external_lex_state = 27},
  [1193] = {.lex_state = 0, .external_lex_state = 27},
  [1194] = {.lex_state = 0, .external_lex_state = 26},
  [1195] = {.lex_state = 0, .external_lex_state = 26},
  [1196] = {.lex_state = 0, .external_lex_state = 27},
  [1197] = {.lex_state = 0, .external_lex_state = 27},
  [1198] = {.lex_state = 0, .external_lex_state = 27},
  [1199] = {.lex_state = 0, .external_lex_state = 27},
  [1200] = {.lex_state = 0, .external_lex_state = 27},
  [1201] = {.lex_state = 0, .external_lex_state = 27},
  [1202] = {.lex_state = 0, .external_lex_state = 26},
  [1203] = {.lex_state = 0, .external_lex_state = 27},
  [1204] = {.lex_state = 0, .external_lex_state = 27},
  [1205] = {.lex_state = 0, .external_lex_state = 27},
  [1206] = {.lex_state = 0, .external_lex_state = 27},
  [1207] = {.lex_state = 0, .external_lex_state = 27},
  [1208] = {.lex_state = 0, .external_lex_state = 27},
  [1209] = {.lex_state = 0, .external_lex_state = 27},
  [1210] = {.lex_state = 0, .external_lex_state = 26},
  [1211] = {.lex_state = 0, .external_lex_state = 27},
  [1212] = {.lex_state = 0, .external_lex_state = 27},
  [1213] = {.lex_state = 0, .external_lex_state = 27},
  [1214] = {.lex_state = 0, .external_lex_state = 27},
  [1215] = {.lex_state = 0, .external_lex_state = 26},
  [1216] = {.lex_state = 0, .external_lex_state = 27},
  [1217] = {.lex_state = 0, .external_lex_state = 26},
  [1218] = {.lex_state = 0, .external_lex_state = 27},
  [1219] = {.lex_state = 0, .external_lex_state = 27},
  [1220] = {.lex_state = 0, .external_lex_state = 27},
  [1221] = {.lex_state = 0, .external_lex_state = 27},
  [1222] = {.lex_state = 0, .external_lex_state = 27},
  [1223] = {.lex_state = 0, .external_lex_state = 27},
  [1224] = {.lex_state = 0, .external_lex_state = 27},
  [1225] = {.lex_state = 0, .external_lex_state = 27},
  [1226] = {.lex_state = 0, .external_lex_state = 27},
  [1227] = {.lex_state = 0, .external_lex_state = 27},
  [1228] = {.lex_state = 0, .external_lex_state = 27},
  [1229] = {.lex_state = 0, .external_lex_state = 27},
  [1230] = {.lex_state = 0, .external_lex_state = 27},
  [1231] = {.lex_state = 0, .external_lex_state = 27},
  [1232] = {.lex_state = 0, .external_lex_state = 27},
  [1233] = {.lex_state = 0, .external_lex_state = 27},
  [1234] = {.lex_state = 0, .external_lex_state = 27},
  [1235] = {.lex_state = 0, .external_lex_state = 27},
  [1236] = {.lex_state = 0, .external_lex_state = 27},
  [1237] = {.lex_state = 0, .external_lex_state = 27},
  [1238] = {.lex_state = 0, .external_lex_state = 27},
  [1239] = {.lex_state = 0, .external_lex_state = 27},
  [1240] = {.lex_state = 0, .external_lex_state = 27},
  [1241] = {.lex_state = 0, .external_lex_state = 27},
  [1242] = {.lex_state = 0, .external_lex_state = 27},
  [1243] = {.lex_state = 0, .external_lex_state = 27},
  [1244] = {.lex_state = 0, .external_lex_state = 27},
  [1245] = {.lex_state = 0, .external_lex_state = 27},
  [1246] = {.lex_state = 0, .external_lex_state = 27},
  [1247] = {.lex_state = 0, .external_lex_state = 27},
  [1248] = {.lex_state = 0, .external_lex_state = 27},
  [1249] = {.lex_state = 0, .external_lex_state = 27},
  [1250] = {.lex_state = 0, .external_lex_state = 26},
  [1251] = {.lex_state = 0, .external_lex_state = 26},
  [1252] = {.lex_state = 0, .external_lex_state = 26},
  [1253] = {.lex_state = 0, .external_lex_state = 26},
  [1254] = {.lex_state = 0, .external_lex_state = 28},
  [1255] = {.lex_state = 0, .external_lex_state = 26},
  [1256] = {.lex_state = 0, .external_lex_state = 26},
  [1257] = {.lex_state = 0, .external_lex_state = 26},
  [1258] = {.lex_state = 0, .external_lex_state = 26},
  [1259] = {.lex_state = 0, .external_lex_state = 26},
  [1260] = {.lex_state = 0, .external_lex_state = 26},
  [1261] = {.lex_state = 0, .external_lex_state = 26},
  [1262] = {.lex_state = 0, .external_lex_state = 26},
  [1263] = {.lex_state = 0, .external_lex_state = 26},
  [1264] = {.lex_state = 0, .external_lex_state = 26},
  [1265] = {.lex_state = 0, .external_lex_state = 26},
  [1266] = {.lex_state = 0, .external_lex_state = 26},
  [1267] = {.lex_state = 0, .external_lex_state = 26},
  [1268] = {.lex_state = 0, .external_lex_state = 26},
  [1269] = {.lex_state = 0, .external_lex_state = 26},
  [1270] = {.lex_state = 0, .external_lex_state = 26},
  [1271] = {.lex_state = 0, .external_lex_state = 26},
  [1272] = {.lex_state = 0, .external_lex_state = 26},
  [1273] = {.lex_state = 0, .external_lex_state = 26},
  [1274] = {.lex_state = 0, .external_lex_state = 26},
  [1275] = {.lex_state = 0, .external_lex_state = 26},
  [1276] = {.lex_state = 0, .external_lex_state = 26},
  [1277] = {.lex_state = 0, .external_lex_state = 26},
  [1278] = {.lex_state = 0, .external_lex_state = 26},
  [1279] = {.lex_state = 0, .external_lex_state = 26},
  [1280] = {.lex_state = 0, .external_lex_state = 26},
  [1281] = {.lex_state = 0, .external_lex_state = 26},
  [1282] = {.lex_state = 0, .external_lex_state = 26},
  [1283] = {.lex_state = 0, .external_lex_state = 26},
  [1284] = {.lex_state = 0, .external_lex_state = 26},
  [1285] = {.lex_state = 0, .external_lex_state = 26},
  [1286] = {.lex_state = 0, .external_lex_state = 26},
  [1287] = {.lex_state = 0, .external_lex_state = 26},
  [1288] = {.lex_state = 0, .external_lex_state = 26},
  [1289] = {.lex_state = 0, .external_lex_state = 26},
  [1290] = {.lex_state = 0, .external_lex_state = 28},
  [1291] = {.lex_state = 0, .external_lex_state = 28},
  [1292] = {.lex_state = 0, .external_lex_state = 28},
  [1293] = {.lex_state = 0, .external_lex_state = 28},
  [1294] = {.lex_state = 0, .external_lex_state = 28},
  [1295] = {.lex_state = 0, .external_lex_state = 26},
  [1296] = {.lex_state = 0, .external_lex_state = 26},
  [1297] = {.lex_state = 0, .external_lex_state = 26},
  [1298] = {.lex_state = 0, .external_lex_state = 26},
  [1299] = {.lex_state = 0, .external_lex_state = 26},
  [1300] = {.lex_state = 0, .external_lex_state = 26},
  [1301] = {.lex_state = 0, .external_lex_state = 28},
  [1302] = {.lex_state = 0, .external_lex_state = 26},
  [1303] = {.lex_state = 0, .external_lex_state = 28},
  [1304] = {.lex_state = 0, .external_lex_state = 28},
  [1305] = {.lex_state = 0, .external_lex_state = 28},
  [1306] = {.lex_state = 0, .external_lex_state = 28},
  [1307] = {.lex_state = 0, .external_lex_state = 28},
  [1308] = {.lex_state = 0, .external_lex_state = 28},
  [1309] = {.lex_state = 0, .external_lex_state = 28},
  [1310] = {.lex_state = 0, .external_lex_state = 28},
  [1311] = {.lex_state = 0, .external_lex_state = 28},
  [1312] = {.lex_state = 0, .external_lex_state = 28},
  [1313] = {.lex_state = 0, .external_lex_state = 28},
  [1314] = {.lex_state = 0, .external_lex_state = 28},
  [1315] = {.lex_state = 0, .external_lex_state = 28},
  [1316] = {.lex_state = 0, .external_lex_state = 26},
  [1317] = {.lex_state = 0, .external_lex_state = 28},
  [1318] = {.lex_state = 0, .external_lex_state = 28},
  [1319] = {.lex_state = 0, .external_lex_state = 28},
  [1320] = {.lex_state = 0, .external_lex_state = 28},
  [1321] = {.lex_state = 0, .external_lex_state = 28},
  [1322] = {.lex_state = 0, .external_lex_state = 26},
  [1323] = {.lex_state = 0, .external_lex_state = 28},
  [1324] = {.lex_state = 0, .external_lex_state = 28},
  [1325] = {.lex_state = 0, .external_lex_state = 28},
  [1326] = {.lex_state = 0, .external_lex_state = 28},
  [1327] = {.lex_state = 0, .external_lex_state = 28},
  [1328] = {.lex_state = 0, .external_lex_state = 28},
  [1329] = {.lex_state = 0, .external_lex_state = 28},
  [1330] = {.lex_state = 0, .external_lex_state = 28},
  [1331] = {.lex_state = 0, .external_lex_state = 28},
  [1332] = {.lex_state = 0, .external_lex_state = 28},
  [1333] = {.lex_state = 0, .external_lex_state = 26},
  [1334] = {.lex_state = 0, .external_lex_state = 29},
  [1335] = {.lex_state = 0, .external_lex_state = 30},
  [1336] = {.lex_state = 0, .external_lex_state = 29},
  [1337] = {.lex_state = 0, .external_lex_state = 29},
  [1338] = {.lex_state = 0, .external_lex_state = 29},
  [1339] = {.lex_state = 0, .external_lex_state = 29},
  [1340] = {.lex_state = 0, .external_lex_state = 29},
  [1341] = {.lex_state = 0, .external_lex_state = 29},
  [1342] = {.lex_state = 0, .external_lex_state = 29},
  [1343] = {.lex_state = 0, .external_lex_state = 29},
  [1344] = {.lex_state = 0, .external_lex_state = 29},
  [1345] = {.lex_state = 0, .external_lex_state = 30},
  [1346] = {.lex_state = 0, .external_lex_state = 29},
  [1347] = {.lex_state = 0, .external_lex_state = 29},
  [1348] = {.lex_state = 0, .external_lex_state = 29},
  [1349] = {.lex_state = 0, .external_lex_state = 29},
  [1350] = {.lex_state = 0, .external_lex_state = 30},
  [1351] = {.lex_state = 0, .external_lex_state = 30},
  [1352] = {.lex_state = 0, .external_lex_state = 30},
  [1353] = {.lex_state = 0, .external_lex_state = 30},
  [1354] = {.lex_state = 0, .external_lex_state = 30},
  [1355] = {.lex_state = 0, .external_lex_state = 30},
  [1356] = {.lex_state = 0, .external_lex_state = 29},
  [1357] = {.lex_state = 0, .external_lex_state = 31},
  [1358] = {.lex_state = 0, .external_lex_state = 29},
  [1359] = {.lex_state = 0, .external_lex_state = 30},
  [1360] = {.lex_state = 0, .external_lex_state = 30},
  [1361] = {.lex_state = 0, .external_lex_state = 30},
  [1362] = {.lex_state = 0, .external_lex_state = 30},
  [1363] = {.lex_state = 0, .external_lex_state = 31},
  [1364] = {.lex_state = 0, .external_lex_state = 29},
  [1365] = {.lex_state = 0, .external_lex_state = 31},
  [1366] = {.lex_state = 0, .external_lex_state = 29},
  [1367] = {.lex_state = 0, .external_lex_state = 29},
  [1368] = {.lex_state = 0, .external_lex_state = 29},
  [1369] = {.lex_state = 0, .external_lex_state = 29},
  [1370] = {.lex_state = 0, .external_lex_state = 29},
  [1371] = {.lex_state = 0, .external_lex_state = 30},
  [1372] = {.lex_state = 0, .external_lex_state = 31},
  [1373] = {.lex_state = 0, .external_lex_state = 29},
  [1374] = {.lex_state = 0, .external_lex_state = 29},
  [1375] = {.lex_state = 0, .external_lex_state = 30},
  [1376] = {.lex_state = 0, .external_lex_state = 31},
  [1377] = {.lex_state = 0, .external_lex_state = 31},
  [1378] = {.lex_state = 0, .external_lex_state = 29},
  [1379] = {.lex_state = 0, .external_lex_state = 29},
  [1380] = {.lex_state = 0, .external_lex_state = 29},
  [1381] = {.lex_state = 0, .external_lex_state = 29},
  [1382] = {.lex_state = 0, .external_lex_state = 29},
  [1383] = {.lex_state = 0, .external_lex_state = 29},
  [1384] = {.lex_state = 0, .external_lex_state = 29},
  [1385] = {.lex_state = 0, .external_lex_state = 29},
  [1386] = {.lex_state = 0, .external_lex_state = 30},
  [1387] = {.lex_state = 0, .external_lex_state = 29},
  [1388] = {.lex_state = 0, .external_lex_state = 31},
  [1389] = {.lex_state = 0, .external_lex_state = 31},
  [1390] = {.lex_state = 0, .external_lex_state = 31},
  [1391] = {.lex_state = 0, .external_lex_state = 31},
  [1392] = {.lex_state = 0, .external_lex_state = 31},
  [1393] = {.lex_state = 0, .external_lex_state = 31},
  [1394] = {.lex_state = 0, .external_lex_state = 31},
  [1395] = {.lex_state = 0, .external_lex_state = 30},
  [1396] = {.lex_state = 0, .external_lex_state = 31},
  [1397] = {.lex_state = 0, .external_lex_state = 31},
  [1398] = {.lex_state = 0, .external_lex_state = 31},
  [1399] = {.lex_state = 0, .external_lex_state = 30},
  [1400] = {.lex_state = 0, .external_lex_state = 31},
  [1401] = {.lex_state = 0, .external_lex_state = 31},
  [1402] = {.lex_state = 0, .external_lex_state = 30},
  [1403] = {.lex_state = 0, .external_lex_state = 31},
  [1404] = {.lex_state = 0, .external_lex_state = 31},
  [1405] = {.lex_state = 0, .external_lex_state = 31},
  [1406] = {.lex_state = 0, .external_lex_state = 31},
  [1407] = {.lex_state = 0, .external_lex_state = 31},
  [1408] = {.lex_state = 0, .external_lex_state = 31},
  [1409] = {.lex_state = 0, .external_lex_state = 31},
  [1410] = {.lex_state = 0, .external_lex_state = 30},
  [1411] = {.lex_state = 0, .external_lex_state = 31},
  [1412] = {.lex_state = 0, .external_lex_state = 30},
  [1413] = {.lex_state = 0, .external_lex_state = 31},
  [1414] = {.lex_state = 0, .external_lex_state = 31},
  [1415] = {.lex_state = 0, .external_lex_state = 30},
  [1416] = {.lex_state = 0, .external_lex_state = 31},
  [1417] = {.lex_state = 0, .external_lex_state = 30},
  [1418] = {.lex_state = 0, .external_lex_state = 31},
  [1419] = {.lex_state = 0, .external_lex_state = 31},
  [1420] = {.lex_state = 0, .external_lex_state = 30},
  [1421] = {.lex_state = 0, .external_lex_state = 29},
  [1422] = {.lex_state = 0, .external_lex_state = 30},
  [1423] = {.lex_state = 0, .external_lex_state = 30},
  [1424] = {.lex_state = 0, .external_lex_state = 29},
  [1425] = {.lex_state = 0, .external_lex_state = 30},
  [1426] = {.lex_state = 0, .external_lex_state = 29},
  [1427] = {.lex_state = 0, .external_lex_state = 29},
  [1428] = {.lex_state = 0, .external_lex_state = 29},
  [1429] = {.lex_state = 0, .external_lex_state = 30},
  [1430] = {.lex_state = 0, .external_lex_state = 29},
  [1431] = {.lex_state = 0, .external_lex_state = 30},
  [1432] = {.lex_state = 0, .external_lex_state = 29},
  [1433] = {.lex_state = 0, .external_lex_state = 30},
  [1434] = {.lex_state = 0, .external_lex_state = 31},
  [1435] = {.lex_state = 0, .external_lex_state = 29},
  [1436] = {.lex_state = 0, .external_lex_state = 29},
  [1437] = {.lex_state = 0, .external_lex_state = 31},
  [1438] = {.lex_state = 0, .external_lex_state = 30},
  [1439] = {.lex_state = 0, .external_lex_state = 31},
  [1440] = {.lex_state = 0, .external_lex_state = 29},
  [1441] = {.lex_state = 0, .external_lex_state = 31},
  [1442] = {.lex_state = 0, .external_lex_state = 29},
  [1443] = {.lex_state = 0, .external_lex_state = 31},
  [1444] = {.lex_state = 0, .external_lex_state = 29},
  [1445] = {.lex_state = 0, .external_lex_state = 30},
  [1446] = {.lex_state = 0, .external_lex_state = 29},
  [1447] = {.lex_state = 0, .external_lex_state = 31},
  [1448] = {.lex_state = 0, .external_lex_state = 30},
  [1449] = {.lex_state = 0, .external_lex_state = 30},
  [1450] = {.lex_state = 0, .external_lex_state = 30},
  [1451] = {.lex_state = 0, .external_lex_state = 30},
  [1452] = {.lex_state = 0, .external_lex_state = 30},
  [1453] = {.lex_state = 0, .external_lex_state = 30},
  [1454] = {.lex_state = 0, .external_lex_state = 30},
  [1455] = {.lex_state = 0, .external_lex_state = 31},
  [1456] = {.lex_state = 0, .external_lex_state = 31},
  [1457] = {.lex_state = 0, .external_lex_state = 30},
  [1458] = {.lex_state = 0, .external_lex_state = 30},
  [1459] = {.lex_state = 0, .external_lex_state = 31},
  [1460] = {.lex_state = 0, .external_lex_state = 31},
  [1461] = {.lex_state = 0, .external_lex_state = 30},
  [1462] = {.lex_state = 0, .external_lex_state = 31},
  [1463] = {.lex_state = 0, .external_lex_state = 30},
  [1464] = {.lex_state = 0, .external_lex_state = 31},
  [1465] = {.lex_state = 0, .external_lex_state = 31},
  [1466] = {.lex_state = 0, .external_lex_state = 29},
  [1467] = {.lex_state = 0, .external_lex_state = 29},
  [1468] = {.lex_state = 0, .external_lex_state = 31},
  [1469] = {.lex_state = 0, .external_lex_state = 30},
  [1470] = {.lex_state = 0, .external_lex_state = 31},
  [1471] = {.lex_state = 0, .external_lex_state = 30},
  [1472] = {.lex_state = 0, .external_lex_state = 30},
  [1473] = {.lex_state = 0, .external_lex_state = 30},
  [1474] = {.lex_state = 0, .external_lex_state = 30},
  [1475] = {.lex_state = 0, .external_lex_state = 30},
  [1476] = {.lex_state = 0, .external_lex_state = 30},
  [1477] = {.lex_state = 0, .external_lex_state = 30},
  [1478] = {.lex_state = 0, .external_lex_state = 30},
  [1479] = {.lex_state = 0, .external_lex_state = 31},
  [1480] = {.lex_state = 0, .external_lex_state = 30},
  [1481] = {.lex_state = 0, .external_lex_state = 31},
  [1482] = {.lex_state = 0, .external_lex_state = 30},
  [1483] = {.lex_state = 0, .external_lex_state = 31},
  [1484] = {.lex_state = 0, .external_lex_state = 31},
  [1485] = {.lex_state = 0, .external_lex_state = 30},
  [1486] = {.lex_state = 0, .external_lex_state = 30},
  [1487] = {.lex_state = 0, .external_lex_state = 30},
  [1488] = {.lex_state = 0, .external_lex_state = 30},
  [1489] = {.lex_state = 0, .external_lex_state = 30},
  [1490] = {.lex_state = 0, .external_lex_state = 30},
  [1491] = {.lex_state = 0, .external_lex_state = 30},
  [1492] = {.lex_state = 0, .external_lex_state = 31},
  [1493] = {.lex_state = 0, .external_lex_state = 30},
  [1494] = {.lex_state = 0, .external_lex_state = 30},
  [1495] = {.lex_state = 0, .external_lex_state = 30},
  [1496] = {.lex_state = 0, .external_lex_state = 31},
  [1497] = {.lex_state = 0, .external_lex_state = 30},
  [1498] = {.lex_state = 0, .external_lex_state = 30},
  [1499] = {.lex_state = 0, .external_lex_state = 30},
  [1500] = {.lex_state = 0, .external_lex_state = 30},
  [1501] = {.lex_state = 0, .external_lex_state = 30},
  [1502] = {.lex_state = 0, .external_lex_state = 30},
  [1503] = {.lex_state = 0, .external_lex_state = 30},
  [1504] = {.lex_state = 0, .external_lex_state = 30},
  [1505] = {.lex_state = 0, .external_lex_state = 30},
  [1506] = {.lex_state = 0, .external_lex_state = 30},
  [1507] = {.lex_state = 0, .external_lex_state = 30},
  [1508] = {.lex_state = 0, .external_lex_state = 30},
  [1509] = {.lex_state = 0, .external_lex_state = 30},
  [1510] = {.lex_state = 0, .external_lex_state = 30},
  [1511] = {.lex_state = 0, .external_lex_state = 30},
  [1512] = {.lex_state = 0, .external_lex_state = 30},
  [1513] = {.lex_state = 0, .external_lex_state = 30},
  [1514] = {.lex_state = 0, .external_lex_state = 30},
  [1515] = {.lex_state = 0, .external_lex_state = 30},
  [1516] = {.lex_state = 0, .external_lex_state = 30},
  [1517] = {.lex_state = 0, .external_lex_state = 30},
  [1518] = {.lex_state = 0, .external_lex_state = 30},
  [1519] = {.lex_state = 0, .external_lex_state = 31},
  [1520] = {.lex_state = 0, .external_lex_state = 31},
  [1521] = {.lex_state = 0, .external_lex_state = 30},
  [1522] = {.lex_state = 0, .external_lex_state = 30},
  [1523] = {.lex_state = 0, .external_lex_state = 30},
  [1524] = {.lex_state = 0, .external_lex_state = 30},
  [1525] = {.lex_state = 0, .external_lex_state = 30},
  [1526] = {.lex_state = 0, .external_lex_state = 29},
  [1527] = {.lex_state = 0, .external_lex_state = 30},
  [1528] = {.lex_state = 0, .external_lex_state = 30},
  [1529] = {.lex_state = 0, .external_lex_state = 31},
  [1530] = {.lex_state = 0, .external_lex_state = 30},
  [1531] = {.lex_state = 0, .external_lex_state = 30},
  [1532] = {.lex_state = 0, .external_lex_state = 29},
  [1533] = {.lex_state = 0, .external_lex_state = 31},
  [1534] = {.lex_state = 0, .external_lex_state = 30},
  [1535] = {.lex_state = 0, .external_lex_state = 29},
  [1536] = {.lex_state = 0, .external_lex_state = 30},
  [1537] = {.lex_state = 0, .external_lex_state = 29},
  [1538] = {.lex_state = 0, .external_lex_state = 30},
  [1539] = {.lex_state = 0, .external_lex_state = 30},
  [1540] = {.lex_state = 0, .external_lex_state = 30},
  [1541] = {.lex_state = 0, .external_lex_state = 29},
  [1542] = {.lex_state = 0, .external_lex_state = 30},
  [1543] = {.lex_state = 0, .external_lex_state = 30},
  [1544] = {.lex_state = 0, .external_lex_state = 30},
  [1545] = {.lex_state = 0, .external_lex_state = 29},
  [1546] = {.lex_state = 0, .external_lex_state = 30},
  [1547] = {.lex_state = 0, .external_lex_state = 30},
  [1548] = {.lex_state = 0, .external_lex_state = 30},
  [1549] = {.lex_state = 0, .external_lex_state = 30},
  [1550] = {.lex_state = 0, .external_lex_state = 30},
  [1551] = {.lex_state = 0, .external_lex_state = 30},
  [1552] = {.lex_state = 0, .external_lex_state = 29},
  [1553] = {.lex_state = 0, .external_lex_state = 30},
  [1554] = {.lex_state = 0, .external_lex_state = 30},
  [1555] = {.lex_state = 0, .external_lex_state = 30},
  [1556] = {.lex_state = 0, .external_lex_state = 30},
  [1557] = {.lex_state = 0, .external_lex_state = 30},
  [1558] = {.lex_state = 0, .external_lex_state = 30},
  [1559] = {.lex_state = 0, .external_lex_state = 30},
  [1560] = {.lex_state = 0, .external_lex_state = 30},
  [1561] = {.lex_state = 0, .external_lex_state = 30},
  [1562] = {.lex_state = 0, .external_lex_state = 30},
  [1563] = {.lex_state = 0, .external_lex_state = 30},
  [1564] = {.lex_state = 0, .external_lex_state = 30},
  [1565] = {.lex_state = 0, .external_lex_state = 30},
  [1566] = {.lex_state = 0, .external_lex_state = 30},
  [1567] = {.lex_state = 0, .external_lex_state = 30},
  [1568] = {.lex_state = 0, .external_lex_state = 30},
  [1569] = {.lex_state = 0, .external_lex_state = 30},
  [1570] = {.lex_state = 0, .external_lex_state = 30},
  [1571] = {.lex_state = 0, .external_lex_state = 30},
  [1572] = {.lex_state = 0, .external_lex_state = 29},
  [1573] = {.lex_state = 0, .external_lex_state = 29},
  [1574] = {.lex_state = 0, .external_lex_state = 30},
  [1575] = {.lex_state = 0, .external_lex_state = 31},
  [1576] = {.lex_state = 0, .external_lex_state = 28},
  [1577] = {.lex_state = 0, .external_lex_state = 28},
  [1578] = {.lex_state = 2, .external_lex_state = 28},
  [1579] = {.lex_state = 0, .external_lex_state = 28},
  [1580] = {.lex_state = 0, .external_lex_state = 26},
  [1581] = {.lex_state = 0, .external_lex_state = 26},
  [1582] = {.lex_state = 0, .external_lex_state = 26},
  [1583] = {.lex_state = 0, .external_lex_state = 28},
  [1584] = {.lex_state = 0, .external_lex_state = 28},
  [1585] = {.lex_state = 0, .external_lex_state = 10},
  [1586] = {.lex_state = 0, .external_lex_state = 26},
  [1587] = {.lex_state = 0, .external_lex_state = 26},
  [1588] = {.lex_state = 0, .external_lex_state = 28},
  [1589] = {.lex_state = 0, .external_lex_state = 28},
  [1590] = {.lex_state = 0, .external_lex_state = 28},
  [1591] = {.lex_state = 0, .external_lex_state = 27},
  [1592] = {.lex_state = 0, .external_lex_state = 27},
  [1593] = {.lex_state = 2, .external_lex_state = 27},
  [1594] = {.lex_state = 0, .external_lex_state = 27},
  [1595] = {.lex_state = 0, .external_lex_state = 27},
  [1596] = {.lex_state = 0, .external_lex_state = 27},
  [1597] = {.lex_state = 0, .external_lex_state = 27},
  [1598] = {.lex_state = 0, .external_lex_state = 27},
  [1599] = {.lex_state = 2, .external_lex_state = 26},
  [1600] = {.lex_state = 0, .external_lex_state = 27},
  [1601] = {.lex_state = 0, .external_lex_state = 26},
  [1602] = {.lex_state = 0, .external_lex_state = 26},
  [1603] = {.lex_state = 0, .external_lex_state = 26},
  [1604] = {.lex_state = 0, .external_lex_state = 29},
  [1605] = {.lex_state = 0, .external_lex_state = 29},
  [1606] = {.lex_state = 0, .external_lex_state = 30},
  [1607] = {.lex_state = 0, .external_lex_state = 29},
  [1608] = {.lex_state = 0, .external_lex_state = 31},
  [1609] = {.lex_state = 0, .external_lex_state = 12},
  [1610] = {.lex_state = 2, .external_lex_state = 29},
  [1611] = {.lex_state = 0, .external_lex_state = 31},
  [1612] = {.lex_state = 0, .external_lex_state = 30},
  [1613] = {.lex_state = 0, .external_lex_state = 31},
  [1614] = {.lex_state = 0, .external_lex_state = 30},
  [1615] = {.lex_state = 0, .external_lex_state = 31},
  [1616] = {.lex_state = 0, .external_lex_state = 30},
  [1617] = {.lex_state = 0, .external_lex_state = 29},
  [1618] = {.lex_state = 0, .external_lex_state = 29},
  [1619] = {.lex_state = 0, .external_lex_state = 30},
  [1620] = {.lex_state = 2, .external_lex_state = 30},
  [1621] = {.lex_state = 0, .external_lex_state = 31},
  [1622] = {.lex_state = 0, .external_lex_state = 31},
  [1623] = {.lex_state = 0, .external_lex_state = 31},
  [1624] = {.lex_state = 0, .external_lex_state = 30},
  [1625] = {.lex_state = 0, .external_lex_state = 30},
  [1626] = {.lex_state = 2, .external_lex_state = 31},
  [1627] = {.lex_state = 0, .external_lex_state = 29},
  [1628] = {.lex_state = 0, .external_lex_state = 31},
  [1629] = {.lex_state = 0, .external_lex_state = 31},
  [1630] = {.lex_state = 0, .external_lex_state = 30},
  [1631] = {.lex_state = 0, .external_lex_state = 29},
  [1632] = {.lex_state = 0, .external_lex_state = 29},
  [1633] = {.lex_state = 0, .external_lex_state = 29},
  [1634] = {.lex_state = 0, .external_lex_state = 30},
  [1635] = {.lex_state = 0, .external_lex_state = 28},
  [1636] = {.lex_state = 0, .external_lex_state = 26},
  [1637] = {.lex_state = 0, .external_lex_state = 28},
  [1638] = {.lex_state = 0, .external_lex_state = 27},
  [1639] = {.lex_state = 0, .external_lex_state = 26},
  [1640] = {.lex_state = 0, .external_lex_state = 26},
  [1641] = {.lex_state = 0, .external_lex_state = 26},
  [1642] = {.lex_state = 0, .external_lex_state = 27},
  [1643] = {.lex_state = 0, .external_lex_state = 26},
  [1644] = {.lex_state = 0, .external_lex_state = 26},
  [1645] = {.lex_state = 0, .external_lex_state = 26},
  [1646] = {.lex_state = 0, .external_lex_state = 28},
  [1647] = {.lex_state = 0, .external_lex_state = 28},
  [1648] = {.lex_state = 0, .external_lex_state = 28},
  [1649] = {.lex_state = 0, .external_lex_state = 28},
  [1650] = {.lex_state = 0, .external_lex_state = 28},
  [1651] = {.lex_state = 0, .external_lex_state = 28},
  [1652] = {.lex_state = 0, .external_lex_state = 28},
  [1653] = {.lex_state = 0, .external_lex_state = 26},
  [1654] = {.lex_state = 0, .external_lex_state = 28},
  [1655] = {.lex_state = 0, .external_lex_state = 28},
  [1656] = {.lex_state = 0, .external_lex_state = 28},
  [1657] = {.lex_state = 0, .external_lex_state = 28},
  [1658] = {.lex_state = 0, .external_lex_state = 27},
  [1659] = {.lex_state = 0, .external_lex_state = 26},
  [1660] = {.lex_state = 0, .external_lex_state = 26},
  [1661] = {.lex_state = 0, .external_lex_state = 26},
  [1662] = {.lex_state = 0, .external_lex_state = 28},
  [1663] = {.lex_state = 0, .external_lex_state = 27},
  [1664] = {.lex_state = 0, .external_lex_state = 27},
  [1665] = {.lex_state = 0, .external_lex_state = 26},
  [1666] = {.lex_state = 0, .external_lex_state = 27},
  [1667] = {.lex_state = 0, .external_lex_state = 27},
  [1668] = {.lex_state = 0, .external_lex_state = 26},
  [1669] = {.lex_state = 0, .external_lex_state = 26},
  [1670] = {.lex_state = 0, .external_lex_state = 27},
  [1671] = {.lex_state = 0, .external_lex_state = 27},
  [1672] = {.lex_state = 0, .external_lex_state = 26},
  [1673] = {.lex_state = 0, .external_lex_state = 27},
  [1674] = {.lex_state = 0, .external_lex_state = 26},
  [1675] = {.lex_state = 0, .external_lex_state = 26},
  [1676] = {.lex_state = 0, .external_lex_state = 27},
  [1677] = {.lex_state = 0, .external_lex_state = 27},
  [1678] = {.lex_state = 0, .external_lex_state = 27},
  [1679] = {.lex_state = 0, .external_lex_state = 27},
  [1680] = {.lex_state = 0, .external_lex_state = 27},
  [1681] = {.lex_state = 0, .external_lex_state = 26},
  [1682] = {.lex_state = 0, .external_lex_state = 27},
  [1683] = {.lex_state = 0, .external_lex_state = 26},
  [1684] = {.lex_state = 0, .external_lex_state = 26},
  [1685] = {.lex_state = 0, .external_lex_state = 26},
  [1686] = {.lex_state = 0, .external_lex_state = 26},
  [1687] = {.lex_state = 0, .external_lex_state = 26},
  [1688] = {.lex_state = 0, .external_lex_state = 26},
  [1689] = {.lex_state = 0, .external_lex_state = 27},
  [1690] = {.lex_state = 0, .external_lex_state = 27},
  [1691] = {.lex_state = 0, .external_lex_state = 27},
  [1692] = {.lex_state = 0, .external_lex_state = 12},
  [1693] = {.lex_state = 0, .external_lex_state = 28},
  [1694] = {.lex_state = 0, .external_lex_state = 12},
  [1695] = {.lex_state = 0, .external_lex_state = 28},
  [1696] = {.lex_state = 0, .external_lex_state = 28},
  [1697] = {.lex_state = 0, .external_lex_state = 12},
  [1698] = {.lex_state = 0, .external_lex_state = 27},
  [1699] = {.lex_state = 0, .external_lex_state = 27},
  [1700] = {.lex_state = 0, .external_lex_state = 27},
  [1701] = {.lex_state = 0, .external_lex_state = 27},
  [1702] = {.lex_state = 0, .external_lex_state = 28},
  [1703] = {.lex_state = 0, .external_lex_state = 28},
  [1704] = {.lex_state = 0, .external_lex_state = 28},
  [1705] = {.lex_state = 0, .external_lex_state = 28},
  [1706] = {.lex_state = 0, .external_lex_state = 28},
  [1707] = {.lex_state = 0, .external_lex_state = 28},
  [1708] = {.lex_state = 0, .external_lex_state = 28},
  [1709] = {.lex_state = 0, .external_lex_state = 27},
  [1710] = {.lex_state = 0, .external_lex_state = 30},
  [1711] = {.lex_state = 0, .external_lex_state = 31},
  [1712] = {.lex_state = 0, .external_lex_state = 29},
  [1713] = {.lex_state = 0, .external_lex_state = 30},
  [1714] = {.lex_state = 0, .external_lex_state = 30},
  [1715] = {.lex_state = 0, .external_lex_state = 29},
  [1716] = {.lex_state = 0, .external_lex_state = 30},
  [1717] = {.lex_state = 0, .external_lex_state = 30},
  [1718] = {.lex_state = 0, .external_lex_state = 29},
  [1719] = {.lex_state = 0, .external_lex_state = 30},
  [1720] = {.lex_state = 0, .external_lex_state = 31},
  [1721] = {.lex_state = 0, .external_lex_state = 31},
  [1722] = {.lex_state = 0, .external_lex_state = 31},
  [1723] = {.lex_state = 0, .external_lex_state = 31},
  [1724] = {.lex_state = 0, .external_lex_state = 31},
  [1725] = {.lex_state = 0, .external_lex_state = 31},
  [1726] = {.lex_state = 0, .external_lex_state = 31},
  [1727] = {.lex_state = 0, .external_lex_state = 31},
  [1728] = {.lex_state = 0, .external_lex_state = 31},
  [1729] = {.lex_state = 0, .external_lex_state = 31},
  [1730] = {.lex_state = 0, .external_lex_state = 31},
  [1731] = {.lex_state = 0, .external_lex_state = 30},
  [1732] = {.lex_state = 0, .external_lex_state = 29},
  [1733] = {.lex_state = 0, .external_lex_state = 31},
  [1734] = {.lex_state = 0, .external_lex_state = 30},
  [1735] = {.lex_state = 0, .external_lex_state = 30},
  [1736] = {.lex_state = 0, .external_lex_state = 29},
  [1737] = {.lex_state = 0, .external_lex_state = 30},
  [1738] = {.lex_state = 0, .external_lex_state = 30},
  [1739] = {.lex_state = 0, .external_lex_state = 31},
  [1740] = {.lex_state = 0, .external_lex_state = 30},
  [1741] = {.lex_state = 0, .external_lex_state = 29},
  [1742] = {.lex_state = 0, .external_lex_state = 29},
  [1743] = {.lex_state = 0, .external_lex_state = 31},
  [1744] = {.lex_state = 0, .external_lex_state = 29},
  [1745] = {.lex_state = 0, .external_lex_state = 31},
  [1746] = {.lex_state = 0, .external_lex_state = 31},
  [1747] = {.lex_state = 0, .external_lex_state = 31},
  [1748] = {.lex_state = 0, .external_lex_state = 29},
  [1749] = {.lex_state = 0, .external_lex_state = 31},
  [1750] = {.lex_state = 0, .external_lex_state = 31},
  [1751] = {.lex_state = 0, .external_lex_state = 31},
  [1752] = {.lex_state = 0, .external_lex_state = 30},
  [1753] = {.lex_state = 0, .external_lex_state = 30},
  [1754] = {.lex_state = 0, .external_lex_state = 29},
  [1755] = {.lex_state = 0, .external_lex_state = 30},
  [1756] = {.lex_state = 0, .external_lex_state = 29},
  [1757] = {.lex_state = 0, .external_lex_state = 29},
  [1758] = {.lex_state = 0, .external_lex_state = 31},
  [1759] = {.lex_state = 0, .external_lex_state = 29},
  [1760] = {.lex_state = 0, .external_lex_state = 29},
  [1761] = {.lex_state = 0, .external_lex_state = 31},
  [1762] = {.lex_state = 0, .external_lex_state = 29},
  [1763] = {.lex_state = 0, .external_lex_state = 29},
  [1764] = {.lex_state = 0, .external_lex_state = 29},
  [1765] = {.lex_state = 0, .external_lex_state = 29},
  [1766] = {.lex_state = 0, .external_lex_state = 29},
  [1767] = {.lex_state = 0, .external_lex_state = 31},
  [1768] = {.lex_state = 0, .external_lex_state = 29},
  [1769] = {.lex_state = 0, .external_lex_state = 29},
  [1770] = {.lex_state = 0, .external_lex_state = 30},
  [1771] = {.lex_state = 0, .external_lex_state = 30},
  [1772] = {.lex_state = 0, .external_lex_state = 30},
  [1773] = {.lex_state = 0, .external_lex_state = 29},
  [1774] = {.lex_state = 0, .external_lex_state = 30},
  [1775] = {.lex_state = 0, .external_lex_state = 30},
  [1776] = {.lex_state = 0, .external_lex_state = 30},
  [1777] = {.lex_state = 0, .external_lex_state = 30},
  [1778] = {.lex_state = 0, .external_lex_state = 29},
  [1779] = {.lex_state = 0, .external_lex_state = 31},
  [1780] = {.lex_state = 0, .external_lex_state = 29},
  [1781] = {.lex_state = 0, .external_lex_state = 30},
  [1782] = {.lex_state = 0, .external_lex_state = 30},
  [1783] = {.lex_state = 0, .external_lex_state = 30},
  [1784] = {.lex_state = 0, .external_lex_state = 29},
  [1785] = {.lex_state = 1, .external_lex_state = 32},
  [1786] = {.lex_state = 1},
  [1787] = {.lex_state = 0, .external_lex_state = 33},
  [1788] = {.lex_state = 0, .external_lex_state = 33},
  [1789] = {.lex_state = 0, .external_lex_state = 33},
  [1790] = {.lex_state = 0, .external_lex_state = 33},
  [1791] = {.lex_state = 0, .external_lex_state = 33},
  [1792] = {.lex_state = 0, .external_lex_state = 33},
  [1793] = {.lex_state = 0, .external_lex_state = 33},
  [1794] = {.lex_state = 0, .external_lex_state = 33},
  [1795] = {.lex_state = 0, .external_lex_state = 33},
  [1796] = {.lex_state = 0, .external_lex_state = 33},
  [1797] = {.lex_state = 0, .external_lex_state = 33},
  [1798] = {.lex_state = 0, .external_lex_state = 33},
  [1799] = {.lex_state = 0, .external_lex_state = 33},
  [1800] = {.lex_state = 0, .external_lex_state = 33},
  [1801] = {.lex_state = 0, .external_lex_state = 33},
  [1802] = {.lex_state = 0, .external_lex_state = 33},
  [1803] = {.lex_state = 0, .external_lex_state = 33},
  [1804] = {.lex_state = 0, .external_lex_state = 33},
  [1805] = {.lex_state = 0, .external_lex_state = 33},
  [1806] = {.lex_state = 0, .external_lex_state = 33},
  [1807] = {.lex_state = 0, .external_lex_state = 32},
  [1808] = {.lex_state = 0, .external_lex_state = 34},
  [1809] = {.lex_state = 0, .external_lex_state = 35},
  [1810] = {.lex_state = 0, .external_lex_state = 35},
  [1811] = {.lex_state = 4},
  [1812] = {.lex_state = 4},
  [1813] = {.lex_state = 3},
  [1814] = {.lex_state = 3},
  [1815] = {.lex_state = 0, .external_lex_state = 33},
  [1816] = {.lex_state = 4},
  [1817] = {.lex_state = 3},
  [1818] = {.lex_state = 0, .external_lex_state = 35},
  [1819] = {.lex_state = 0, .external_lex_state = 34},
  [1820] = {.lex_state = 0, .external_lex_state = 34},
  [1821] = {.lex_state = 4},
  [1822] = {.lex_state = 0, .external_lex_state = 32},
  [1823] = {.lex_state = 0, .external_lex_state = 32},
  [1824] = {.lex_state = 0, .external_lex_state = 35},
  [1825] = {.lex_state = 0, .external_lex_state = 34},
  [1826] = {.lex_state = 0, .external_lex_state = 32},
  [1827] = {.lex_state = 3},
  [1828] = {.lex_state = 0, .external_lex_state = 34},
  [1829] = {.lex_state = 0, .external_lex_state = 34},
  [1830] = {.lex_state = 0, .external_lex_state = 34},
  [1831] = {.lex_state = 0, .external_lex_state = 34},
  [1832] = {.lex_state = 4},
  [1833] = {.lex_state = 3},
  [1834] = {.lex_state = 0, .external_lex_state = 32},
  [1835] = {.lex_state = 4},
  [1836] = {.lex_state = 3},
  [1837] = {.lex_state = 0, .external_lex_state = 35},
  [1838] = {.lex_state = 0, .external_lex_state = 35},
  [1839] = {.lex_state = 0, .external_lex_state = 32},
  [1840] = {.lex_state = 0, .external_lex_state = 32},
  [1841] = {.lex_state = 4},
  [1842] = {.lex_state = 0, .external_lex_state = 32},
  [1843] = {.lex_state = 0, .external_lex_state = 32},
  [1844] = {.lex_state = 4},
  [1845] = {.lex_state = 0, .external_lex_state = 32},
  [1846] = {.lex_state = 0, .external_lex_state = 35},
  [1847] = {.lex_state = 0, .external_lex_state = 32},
  [1848] = {.lex_state = 3},
  [1849] = {.lex_state = 0, .external_lex_state = 34},
  [1850] = {.lex_state = 0, .external_lex_state = 34},
  [1851] = {.lex_state = 4},
  [1852] = {.lex_state = 3},
  [1853] = {.lex_state = 0, .external_lex_state = 35},
  [1854] = {.lex_state = 0, .external_lex_state = 35},
  [1855] = {.lex_state = 4},
  [1856] = {.lex_state = 3},
  [1857] = {.lex_state = 0, .external_lex_state = 34},
  [1858] = {.lex_state = 0, .external_lex_state = 33},
  [1859] = {.lex_state = 0, .external_lex_state = 35},
  [1860] = {.lex_state = 4},
  [1861] = {.lex_state = 0, .external_lex_state = 32},
  [1862] = {.lex_state = 0, .external_lex_state = 32},
  [1863] = {.lex_state = 3},
  [1864] = {.lex_state = 0, .external_lex_state = 33},
  [1865] = {.lex_state = 0, .external_lex_state = 32},
  [1866] = {.lex_state = 0, .external_lex_state = 35},
  [1867] = {.lex_state = 0, .external_lex_state = 34},
  [1868] = {.lex_state = 4},
  [1869] = {.lex_state = 4},
  [1870] = {.lex_state = 3},
  [1871] = {.lex_state = 0, .external_lex_state = 35},
  [1872] = {.lex_state = 4},
  [1873] = {.lex_state = 4},
  [1874] = {.lex_state = 3},
  [1875] = {.lex_state = 3},
  [1876] = {.lex_state = 3},
  [1877] = {.lex_state = 0, .external_lex_state = 32},
  [1878] = {.lex_state = 3},
  [1879] = {.lex_state = 0, .external_lex_state = 32},
  [1880] = {.lex_state = 4},
  [1881] = {.lex_state = 0, .external_lex_state = 32},
  [1882] = {.lex_state = 0, .external_lex_state = 34},
  [1883] = {.lex_state = 3},
  [1884] = {.lex_state = 0, .external_lex_state = 34},
  [1885] = {.lex_state = 3},
  [1886] = {.lex_state = 0, .external_lex_state = 32},
  [1887] = {.lex_state = 0, .external_lex_state = 32},
  [1888] = {.lex_state = 4},
  [1889] = {.lex_state = 0, .external_lex_state = 35},
  [1890] = {.lex_state = 3},
  [1891] = {.lex_state = 0, .external_lex_state = 33},
  [1892] = {.lex_state = 0, .external_lex_state = 34},
  [1893] = {.lex_state = 0, .external_lex_state = 35},
  [1894] = {.lex_state = 0, .external_lex_state = 32},
  [1895] = {.lex_state = 0, .external_lex_state = 32},
  [1896] = {.lex_state = 0, .external_lex_state = 34},
  [1897] = {.lex_state = 4},
  [1898] = {.lex_state = 3},
  [1899] = {.lex_state = 0, .external_lex_state = 35},
  [1900] = {.lex_state = 0, .external_lex_state = 33},
  [1901] = {.lex_state = 0, .external_lex_state = 35},
  [1902] = {.lex_state = 0, .external_lex_state = 32},
  [1903] = {.lex_state = 0, .external_lex_state = 35},
  [1904] = {.lex_state = 0, .external_lex_state = 35},
  [1905] = {.lex_state = 0, .external_lex_state = 34},
  [1906] = {.lex_state = 0, .external_lex_state = 32},
  [1907] = {.lex_state = 0, .external_lex_state = 34},
  [1908] = {.lex_state = 0, .external_lex_state = 32},
  [1909] = {.lex_state = 0, .external_lex_state = 35},
  [1910] = {.lex_state = 4},
  [1911] = {.lex_state = 3},
  [1912] = {.lex_state = 0, .external_lex_state = 32},
  [1913] = {.lex_state = 0, .external_lex_state = 33},
  [1914] = {.lex_state = 0, .external_lex_state = 35},
  [1915] = {.lex_state = 0, .external_lex_state = 35},
  [1916] = {.lex_state = 0, .external_lex_state = 34},
  [1917] = {.lex_state = 0, .external_lex_state = 35},
  [1918] = {.lex_state = 0, .external_lex_state = 34},
  [1919] = {.lex_state = 0, .external_lex_state = 34},
  [1920] = {.lex_state = 0, .external_lex_state = 34},
  [1921] = {.lex_state = 0, .external_lex_state = 32},
  [1922] = {.lex_state = 0, .external_lex_state = 35},
  [1923] = {.lex_state = 0, .external_lex_state = 35},
  [1924] = {.lex_state = 4},
  [1925] = {.lex_state = 0, .external_lex_state = 34},
  [1926] = {.lex_state = 0, .external_lex_state = 34},
  [1927] = {.lex_state = 0, .external_lex_state = 34},
  [1928] = {.lex_state = 0, .external_lex_state = 35},
  [1929] = {.lex_state = 0, .external_lex_state = 34},
  [1930] = {.lex_state = 0, .external_lex_state = 33},
  [1931] = {.lex_state = 0, .external_lex_state = 34},
  [1932] = {.lex_state = 0, .external_lex_state = 33},
  [1933] = {.lex_state = 0, .external_lex_state = 32},
  [1934] = {.lex_state = 0, .external_lex_state = 32},
  [1935] = {.lex_state = 0, .external_lex_state = 35},
  [1936] = {.lex_state = 0, .external_lex_state = 33},
  [1937] = {.lex_state = 0, .external_lex_state = 35},
  [1938] = {.lex_state = 0, .external_lex_state = 33},
  [1939] = {.lex_state = 0, .external_lex_state = 34},
  [1940] = {.lex_state = 0, .external_lex_state = 33},
  [1941] = {.lex_state = 0, .external_lex_state = 32},
  [1942] = {.lex_state = 0, .external_lex_state = 33},
  [1943] = {.lex_state = 0, .external_lex_state = 34},
  [1944] = {.lex_state = 0, .external_lex_state = 33},
  [1945] = {.lex_state = 0, .external_lex_state = 32},
  [1946] = {.lex_state = 0, .external_lex_state = 33},
  [1947] = {.lex_state = 0, .external_lex_state = 32},
  [1948] = {.lex_state = 0, .external_lex_state = 33},
  [1949] = {.lex_state = 0, .external_lex_state = 33},
  [1950] = {.lex_state = 0, .external_lex_state = 33},
  [1951] = {.lex_state = 0, .external_lex_state = 32},
  [1952] = {.lex_state = 0, .external_lex_state = 33},
  [1953] = {.lex_state = 0, .external_lex_state = 35},
  [1954] = {.lex_state = 0, .external_lex_state = 33},
  [1955] = {.lex_state = 0, .external_lex_state = 35},
  [1956] = {.lex_state = 0, .external_lex_state = 33},
  [1957] = {.lex_state = 0, .external_lex_state = 33},
  [1958] = {.lex_state = 4},
  [1959] = {.lex_state = 0, .external_lex_state = 33},
  [1960] = {.lex_state = 0, .external_lex_state = 34},
  [1961] = {.lex_state = 0, .external_lex_state = 33},
  [1962] = {.lex_state = 0, .external_lex_state = 33},
  [1963] = {.lex_state = 0, .external_lex_state = 33},
  [1964] = {.lex_state = 0, .external_lex_state = 35},
  [1965] = {.lex_state = 0, .external_lex_state = 33},
  [1966] = {.lex_state = 0, .external_lex_state = 33},
  [1967] = {.lex_state = 0, .external_lex_state = 33},
  [1968] = {.lex_state = 0, .external_lex_state = 33},
  [1969] = {.lex_state = 0, .external_lex_state = 33},
  [1970] = {.lex_state = 0, .external_lex_state = 33},
  [1971] = {.lex_state = 0, .external_lex_state = 33},
  [1972] = {.lex_state = 0, .external_lex_state = 33},
  [1973] = {.lex_state = 0, .external_lex_state = 33},
  [1974] = {.lex_state = 0, .external_lex_state = 33},
  [1975] = {.lex_state = 0, .external_lex_state = 33},
  [1976] = {.lex_state = 0, .external_lex_state = 33},
  [1977] = {.lex_state = 0, .external_lex_state = 33},
  [1978] = {.lex_state = 0, .external_lex_state = 33},
  [1979] = {.lex_state = 0, .external_lex_state = 33},
  [1980] = {.lex_state = 0, .external_lex_state = 33},
  [1981] = {.lex_state = 0, .external_lex_state = 33},
  [1982] = {.lex_state = 0, .external_lex_state = 33},
  [1983] = {.lex_state = 0, .external_lex_state = 33},
  [1984] = {.lex_state = 0, .external_lex_state = 33},
  [1985] = {.lex_state = 0, .external_lex_state = 33},
  [1986] = {.lex_state = 0, .external_lex_state = 33},
  [1987] = {.lex_state = 0, .external_lex_state = 33},
  [1988] = {.lex_state = 0, .external_lex_state = 33},
  [1989] = {.lex_state = 0, .external_lex_state = 33},
  [1990] = {.lex_state = 0, .external_lex_state = 33},
  [1991] = {.lex_state = 0, .external_lex_state = 33},
  [1992] = {.lex_state = 0, .external_lex_state = 33},
  [1993] = {.lex_state = 0, .external_lex_state = 33},
  [1994] = {.lex_state = 0, .external_lex_state = 33},
  [1995] = {.lex_state = 0, .external_lex_state = 33},
  [1996] = {.lex_state = 0, .external_lex_state = 33},
  [1997] = {.lex_state = 0, .external_lex_state = 33},
  [1998] = {.lex_state = 0, .external_lex_state = 33},
  [1999] = {.lex_state = 0, .external_lex_state = 33},
  [2000] = {.lex_state = 3},
  [2001] = {.lex_state = 0, .external_lex_state = 33},
  [2002] = {.lex_state = 0, .external_lex_state = 32},
  [2003] = {.lex_state = 1},
  [2004] = {.lex_state = 0, .external_lex_state = 32},
  [2005] = {.lex_state = 0, .external_lex_state = 34},
  [2006] = {.lex_state = 0, .external_lex_state = 32},
  [2007] = {.lex_state = 3},
  [2008] = {.lex_state = 1},
  [2009] = {.lex_state = 1},
  [2010] = {.lex_state = 1},
  [2011] = {.lex_state = 1},
  [2012] = {.lex_state = 1},
  [2013] = {.lex_state = 1},
  [2014] = {.lex_state = 4},
  [2015] = {.lex_state = 1},
  [2016] = {.lex_state = 1},
  [2017] = {.lex_state = 0, .external_lex_state = 35},
  [2018] = {.lex_state = 1},
  [2019] = {.lex_state = 1},
  [2020] = {.lex_state = 1},
  [2021] = {.lex_state = 1},
  [2022] = {.lex_state = 1},
  [2023] = {.lex_state = 1},
  [2024] = {.lex_state = 1},
  [2025] = {.lex_state = 1},
  [2026] = {.lex_state = 1},
  [2027] = {.lex_state = 1},
  [2028] = {.lex_state = 1},
  [2029] = {.lex_state = 0, .external_lex_state = 32},
  [2030] = {.lex_state = 0, .external_lex_state = 32},
  [2031] = {.lex_state = 0, .external_lex_state = 32},
  [2032] = {.lex_state = 0, .external_lex_state = 35},
  [2033] = {.lex_state = 0, .external_lex_state = 34},
  [2034] = {.lex_state = 0, .external_lex_state = 32},
  [2035] = {.lex_state = 0, .external_lex_state = 34},
  [2036] = {.lex_state = 0, .external_lex_state = 32},
  [2037] = {.lex_state = 0, .external_lex_state = 32},
  [2038] = {.lex_state = 0, .external_lex_state = 34},
  [2039] = {.lex_state = 0, .external_lex_state = 32},
  [2040] = {.lex_state = 0, .external_lex_state = 34},
  [2041] = {.lex_state = 0, .external_lex_state = 35},
  [2042] = {.lex_state = 0, .external_lex_state = 35},
  [2043] = {.lex_state = 0, .external_lex_state = 35},
  [2044] = {.lex_state = 0, .external_lex_state = 32},
  [2045] = {.lex_state = 0, .external_lex_state = 35},
  [2046] = {.lex_state = 0, .external_lex_state = 32},
  [2047] = {.lex_state = 0, .external_lex_state = 34},
  [2048] = {.lex_state = 2},
  [2049] = {.lex_state = 2},
  [2050] = {.lex_state = 2},
  [2051] = {.lex_state = 2},
  [2052] = {.lex_state = 2},
  [2053] = {.lex_state = 0},
  [2054] = {.lex_state = 0},
  [2055] = {.lex_state = 2},
  [2056] = {.lex_state = 2},
  [2057] = {.lex_state = 2},
  [2058] = {.lex_state = 2},
  [2059] = {.lex_state = 0},
  [2060] = {.lex_state = 2},
  [2061] = {.lex_state = 2},
  [2062] = {.lex_state = 2},
  [2063] = {.lex_state = 2},
  [2064] = {.lex_state = 2},
  [2065] = {.lex_state = 2},
  [2066] = {.lex_state = 2},
  [2067] = {.lex_state = 2},
  [2068] = {.lex_state = 2},
  [2069] = {.lex_state = 2},
  [2070] = {.lex_state = 2},
  [2071] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_DASH_GT_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [aux_sym_binary_operator_token1] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [sym__number_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_dots] = ACTIONS(1),
    [sym_dot_dot_i] = ACTIONS(1),
    [sym_return] = ACTIONS(1),
    [sym_next] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_inf] = ACTIONS(1),
    [sym_nan] = ACTIONS(1),
    [anon_sym_NA] = ACTIONS(1),
    [anon_sym_NA_integer_] = ACTIONS(1),
    [anon_sym_NA_real_] = ACTIONS(1),
    [anon_sym_NA_complex_] = ACTIONS(1),
    [anon_sym_NA_character_] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym__start] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
    [sym__raw_string_literal] = ACTIONS(1),
    [sym__external_else] = ACTIONS(1),
    [sym__external_open_parenthesis] = ACTIONS(1),
    [sym__external_close_parenthesis] = ACTIONS(1),
    [sym__external_open_brace] = ACTIONS(1),
    [sym__external_close_brace] = ACTIONS(1),
    [sym__external_open_bracket] = ACTIONS(1),
    [sym__external_close_bracket] = ACTIONS(1),
    [sym__external_open_bracket2] = ACTIONS(1),
    [sym__external_close_bracket2] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2053),
    [sym_comment] = ACTIONS(3),
    [sym__start] = ACTIONS(5),
  },
  [2] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(505),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(9),
    [anon_sym_while] = ACTIONS(9),
    [anon_sym_repeat] = ACTIONS(9),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(7),
    [sym__number_literal] = ACTIONS(9),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_dots] = ACTIONS(9),
    [sym_dot_dot_i] = ACTIONS(9),
    [sym_return] = ACTIONS(9),
    [sym_next] = ACTIONS(9),
    [sym_break] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_inf] = ACTIONS(9),
    [sym_nan] = ACTIONS(9),
    [anon_sym_NA] = ACTIONS(9),
    [anon_sym_NA_integer_] = ACTIONS(9),
    [anon_sym_NA_real_] = ACTIONS(9),
    [anon_sym_NA_complex_] = ACTIONS(9),
    [anon_sym_NA_character_] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7),
    [sym__semicolon] = ACTIONS(7),
    [sym__raw_string_literal] = ACTIONS(7),
    [sym__external_else] = ACTIONS(49),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(7),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [3] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(633),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(57),
    [anon_sym_function] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(59),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_QMARK] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(57),
    [sym__number_literal] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_dots] = ACTIONS(59),
    [sym_dot_dot_i] = ACTIONS(59),
    [sym_return] = ACTIONS(59),
    [sym_next] = ACTIONS(59),
    [sym_break] = ACTIONS(59),
    [sym_true] = ACTIONS(59),
    [sym_false] = ACTIONS(59),
    [sym_null] = ACTIONS(59),
    [sym_inf] = ACTIONS(59),
    [sym_nan] = ACTIONS(59),
    [anon_sym_NA] = ACTIONS(59),
    [anon_sym_NA_integer_] = ACTIONS(59),
    [anon_sym_NA_real_] = ACTIONS(59),
    [anon_sym_NA_complex_] = ACTIONS(59),
    [anon_sym_NA_character_] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(57),
    [sym__semicolon] = ACTIONS(57),
    [sym__raw_string_literal] = ACTIONS(57),
    [sym__external_else] = ACTIONS(61),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(57),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [4] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(646),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_identifier] = ACTIONS(65),
    [anon_sym_BSLASH] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(63),
    [sym__number_literal] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [sym_dots] = ACTIONS(65),
    [sym_dot_dot_i] = ACTIONS(65),
    [sym_return] = ACTIONS(65),
    [sym_next] = ACTIONS(65),
    [sym_break] = ACTIONS(65),
    [sym_true] = ACTIONS(65),
    [sym_false] = ACTIONS(65),
    [sym_null] = ACTIONS(65),
    [sym_inf] = ACTIONS(65),
    [sym_nan] = ACTIONS(65),
    [anon_sym_NA] = ACTIONS(65),
    [anon_sym_NA_integer_] = ACTIONS(65),
    [anon_sym_NA_real_] = ACTIONS(65),
    [anon_sym_NA_complex_] = ACTIONS(65),
    [anon_sym_NA_character_] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(63),
    [sym__semicolon] = ACTIONS(63),
    [sym__raw_string_literal] = ACTIONS(63),
    [sym__external_else] = ACTIONS(67),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(63),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [5] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(632),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(69),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_BSLASH] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_repeat] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(69),
    [sym__number_literal] = ACTIONS(71),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_dots] = ACTIONS(71),
    [sym_dot_dot_i] = ACTIONS(71),
    [sym_return] = ACTIONS(71),
    [sym_next] = ACTIONS(71),
    [sym_break] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_null] = ACTIONS(71),
    [sym_inf] = ACTIONS(71),
    [sym_nan] = ACTIONS(71),
    [anon_sym_NA] = ACTIONS(71),
    [anon_sym_NA_integer_] = ACTIONS(71),
    [anon_sym_NA_real_] = ACTIONS(71),
    [anon_sym_NA_complex_] = ACTIONS(71),
    [anon_sym_NA_character_] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(69),
    [sym__semicolon] = ACTIONS(69),
    [sym__raw_string_literal] = ACTIONS(69),
    [sym__external_else] = ACTIONS(73),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(69),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [6] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(490),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(9),
    [anon_sym_while] = ACTIONS(9),
    [anon_sym_repeat] = ACTIONS(9),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(7),
    [sym__number_literal] = ACTIONS(9),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_dots] = ACTIONS(9),
    [sym_dot_dot_i] = ACTIONS(9),
    [sym_return] = ACTIONS(9),
    [sym_next] = ACTIONS(9),
    [sym_break] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_inf] = ACTIONS(9),
    [sym_nan] = ACTIONS(9),
    [anon_sym_NA] = ACTIONS(9),
    [anon_sym_NA_integer_] = ACTIONS(9),
    [anon_sym_NA_real_] = ACTIONS(9),
    [anon_sym_NA_complex_] = ACTIONS(9),
    [anon_sym_NA_character_] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7),
    [sym__semicolon] = ACTIONS(7),
    [sym__raw_string_literal] = ACTIONS(7),
    [sym__external_else] = ACTIONS(113),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(7),
    [sym__external_close_brace] = ACTIONS(7),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [7] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(496),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_BSLASH] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_repeat] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(69),
    [sym__number_literal] = ACTIONS(71),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_dots] = ACTIONS(71),
    [sym_dot_dot_i] = ACTIONS(71),
    [sym_return] = ACTIONS(71),
    [sym_next] = ACTIONS(71),
    [sym_break] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_null] = ACTIONS(71),
    [sym_inf] = ACTIONS(71),
    [sym_nan] = ACTIONS(71),
    [anon_sym_NA] = ACTIONS(71),
    [anon_sym_NA_integer_] = ACTIONS(71),
    [anon_sym_NA_real_] = ACTIONS(71),
    [anon_sym_NA_complex_] = ACTIONS(71),
    [anon_sym_NA_character_] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(69),
    [sym__semicolon] = ACTIONS(69),
    [sym__raw_string_literal] = ACTIONS(69),
    [sym__external_else] = ACTIONS(121),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(69),
    [sym__external_close_brace] = ACTIONS(69),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [8] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(497),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(57),
    [anon_sym_function] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(59),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_QMARK] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(57),
    [sym__number_literal] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_dots] = ACTIONS(59),
    [sym_dot_dot_i] = ACTIONS(59),
    [sym_return] = ACTIONS(59),
    [sym_next] = ACTIONS(59),
    [sym_break] = ACTIONS(59),
    [sym_true] = ACTIONS(59),
    [sym_false] = ACTIONS(59),
    [sym_null] = ACTIONS(59),
    [sym_inf] = ACTIONS(59),
    [sym_nan] = ACTIONS(59),
    [anon_sym_NA] = ACTIONS(59),
    [anon_sym_NA_integer_] = ACTIONS(59),
    [anon_sym_NA_real_] = ACTIONS(59),
    [anon_sym_NA_complex_] = ACTIONS(59),
    [anon_sym_NA_character_] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(57),
    [sym__semicolon] = ACTIONS(57),
    [sym__raw_string_literal] = ACTIONS(57),
    [sym__external_else] = ACTIONS(123),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(57),
    [sym__external_close_brace] = ACTIONS(57),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [9] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(504),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(65),
    [anon_sym_BSLASH] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(63),
    [sym__number_literal] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [sym_dots] = ACTIONS(65),
    [sym_dot_dot_i] = ACTIONS(65),
    [sym_return] = ACTIONS(65),
    [sym_next] = ACTIONS(65),
    [sym_break] = ACTIONS(65),
    [sym_true] = ACTIONS(65),
    [sym_false] = ACTIONS(65),
    [sym_null] = ACTIONS(65),
    [sym_inf] = ACTIONS(65),
    [sym_nan] = ACTIONS(65),
    [anon_sym_NA] = ACTIONS(65),
    [anon_sym_NA_integer_] = ACTIONS(65),
    [anon_sym_NA_real_] = ACTIONS(65),
    [anon_sym_NA_complex_] = ACTIONS(65),
    [anon_sym_NA_character_] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(63),
    [sym__semicolon] = ACTIONS(63),
    [sym__raw_string_literal] = ACTIONS(63),
    [sym__external_else] = ACTIONS(125),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(63),
    [sym__external_close_brace] = ACTIONS(63),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [10] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(857),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(65),
    [anon_sym_BSLASH] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(63),
    [sym__number_literal] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [sym_dots] = ACTIONS(65),
    [sym_dot_dot_i] = ACTIONS(65),
    [sym_return] = ACTIONS(65),
    [sym_next] = ACTIONS(65),
    [sym_break] = ACTIONS(65),
    [sym_true] = ACTIONS(65),
    [sym_false] = ACTIONS(65),
    [sym_null] = ACTIONS(65),
    [sym_inf] = ACTIONS(65),
    [sym_nan] = ACTIONS(65),
    [anon_sym_NA] = ACTIONS(65),
    [anon_sym_NA_integer_] = ACTIONS(65),
    [anon_sym_NA_real_] = ACTIONS(65),
    [anon_sym_NA_complex_] = ACTIONS(65),
    [anon_sym_NA_character_] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(63),
    [sym__semicolon] = ACTIONS(63),
    [sym__raw_string_literal] = ACTIONS(63),
    [sym__external_else] = ACTIONS(127),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(63),
    [sym__external_close_brace] = ACTIONS(63),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [11] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(711),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(9),
    [anon_sym_while] = ACTIONS(9),
    [anon_sym_repeat] = ACTIONS(9),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(7),
    [sym__number_literal] = ACTIONS(9),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_dots] = ACTIONS(9),
    [sym_dot_dot_i] = ACTIONS(9),
    [sym_return] = ACTIONS(9),
    [sym_next] = ACTIONS(9),
    [sym_break] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_inf] = ACTIONS(9),
    [sym_nan] = ACTIONS(9),
    [anon_sym_NA] = ACTIONS(9),
    [anon_sym_NA_integer_] = ACTIONS(9),
    [anon_sym_NA_real_] = ACTIONS(9),
    [anon_sym_NA_complex_] = ACTIONS(9),
    [anon_sym_NA_character_] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7),
    [sym__semicolon] = ACTIONS(7),
    [sym__raw_string_literal] = ACTIONS(7),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(7),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [12] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(715),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(69),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_BSLASH] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_repeat] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(69),
    [sym__number_literal] = ACTIONS(71),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_dots] = ACTIONS(71),
    [sym_dot_dot_i] = ACTIONS(71),
    [sym_return] = ACTIONS(71),
    [sym_next] = ACTIONS(71),
    [sym_break] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_null] = ACTIONS(71),
    [sym_inf] = ACTIONS(71),
    [sym_nan] = ACTIONS(71),
    [anon_sym_NA] = ACTIONS(71),
    [anon_sym_NA_integer_] = ACTIONS(71),
    [anon_sym_NA_real_] = ACTIONS(71),
    [anon_sym_NA_complex_] = ACTIONS(71),
    [anon_sym_NA_character_] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(69),
    [sym__semicolon] = ACTIONS(69),
    [sym__raw_string_literal] = ACTIONS(69),
    [sym__external_else] = ACTIONS(131),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(69),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [13] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(716),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(57),
    [anon_sym_function] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(59),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_QMARK] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(57),
    [sym__number_literal] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_dots] = ACTIONS(59),
    [sym_dot_dot_i] = ACTIONS(59),
    [sym_return] = ACTIONS(59),
    [sym_next] = ACTIONS(59),
    [sym_break] = ACTIONS(59),
    [sym_true] = ACTIONS(59),
    [sym_false] = ACTIONS(59),
    [sym_null] = ACTIONS(59),
    [sym_inf] = ACTIONS(59),
    [sym_nan] = ACTIONS(59),
    [anon_sym_NA] = ACTIONS(59),
    [anon_sym_NA_integer_] = ACTIONS(59),
    [anon_sym_NA_real_] = ACTIONS(59),
    [anon_sym_NA_complex_] = ACTIONS(59),
    [anon_sym_NA_character_] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(57),
    [sym__semicolon] = ACTIONS(57),
    [sym__raw_string_literal] = ACTIONS(57),
    [sym__external_else] = ACTIONS(133),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(57),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [14] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__else] = STATE(723),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_identifier] = ACTIONS(65),
    [anon_sym_BSLASH] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(63),
    [sym__number_literal] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [sym_dots] = ACTIONS(65),
    [sym_dot_dot_i] = ACTIONS(65),
    [sym_return] = ACTIONS(65),
    [sym_next] = ACTIONS(65),
    [sym_break] = ACTIONS(65),
    [sym_true] = ACTIONS(65),
    [sym_false] = ACTIONS(65),
    [sym_null] = ACTIONS(65),
    [sym_inf] = ACTIONS(65),
    [sym_nan] = ACTIONS(65),
    [anon_sym_NA] = ACTIONS(65),
    [anon_sym_NA_integer_] = ACTIONS(65),
    [anon_sym_NA_real_] = ACTIONS(65),
    [anon_sym_NA_complex_] = ACTIONS(65),
    [anon_sym_NA_character_] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(63),
    [sym__semicolon] = ACTIONS(63),
    [sym__raw_string_literal] = ACTIONS(63),
    [sym__external_else] = ACTIONS(135),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(63),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [15] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(843),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(9),
    [anon_sym_while] = ACTIONS(9),
    [anon_sym_repeat] = ACTIONS(9),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(7),
    [sym__number_literal] = ACTIONS(9),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_dots] = ACTIONS(9),
    [sym_dot_dot_i] = ACTIONS(9),
    [sym_return] = ACTIONS(9),
    [sym_next] = ACTIONS(9),
    [sym_break] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_inf] = ACTIONS(9),
    [sym_nan] = ACTIONS(9),
    [anon_sym_NA] = ACTIONS(9),
    [anon_sym_NA_integer_] = ACTIONS(9),
    [anon_sym_NA_real_] = ACTIONS(9),
    [anon_sym_NA_complex_] = ACTIONS(9),
    [anon_sym_NA_character_] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7),
    [sym__semicolon] = ACTIONS(7),
    [sym__raw_string_literal] = ACTIONS(7),
    [sym__external_else] = ACTIONS(137),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(7),
    [sym__external_close_brace] = ACTIONS(7),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [16] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(849),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_BSLASH] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_repeat] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(69),
    [sym__number_literal] = ACTIONS(71),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_dots] = ACTIONS(71),
    [sym_dot_dot_i] = ACTIONS(71),
    [sym_return] = ACTIONS(71),
    [sym_next] = ACTIONS(71),
    [sym_break] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_null] = ACTIONS(71),
    [sym_inf] = ACTIONS(71),
    [sym_nan] = ACTIONS(71),
    [anon_sym_NA] = ACTIONS(71),
    [anon_sym_NA_integer_] = ACTIONS(71),
    [anon_sym_NA_real_] = ACTIONS(71),
    [anon_sym_NA_complex_] = ACTIONS(71),
    [anon_sym_NA_character_] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(69),
    [sym__semicolon] = ACTIONS(69),
    [sym__raw_string_literal] = ACTIONS(69),
    [sym__external_else] = ACTIONS(139),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(69),
    [sym__external_close_brace] = ACTIONS(69),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [17] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__else] = STATE(850),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(57),
    [anon_sym_function] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(59),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_QMARK] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(57),
    [sym__number_literal] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_dots] = ACTIONS(59),
    [sym_dot_dot_i] = ACTIONS(59),
    [sym_return] = ACTIONS(59),
    [sym_next] = ACTIONS(59),
    [sym_break] = ACTIONS(59),
    [sym_true] = ACTIONS(59),
    [sym_false] = ACTIONS(59),
    [sym_null] = ACTIONS(59),
    [sym_inf] = ACTIONS(59),
    [sym_nan] = ACTIONS(59),
    [anon_sym_NA] = ACTIONS(59),
    [anon_sym_NA_integer_] = ACTIONS(59),
    [anon_sym_NA_real_] = ACTIONS(59),
    [anon_sym_NA_complex_] = ACTIONS(59),
    [anon_sym_NA_character_] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(57),
    [sym__semicolon] = ACTIONS(57),
    [sym__raw_string_literal] = ACTIONS(57),
    [sym__external_else] = ACTIONS(141),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(57),
    [sym__external_close_brace] = ACTIONS(57),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [18] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_BSLASH] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(143),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(143),
    [anon_sym_repeat] = ACTIONS(143),
    [anon_sym_QMARK] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(145),
    [sym__number_literal] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_dots] = ACTIONS(143),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_return] = ACTIONS(143),
    [sym_next] = ACTIONS(143),
    [sym_break] = ACTIONS(143),
    [sym_true] = ACTIONS(143),
    [sym_false] = ACTIONS(143),
    [sym_null] = ACTIONS(143),
    [sym_inf] = ACTIONS(143),
    [sym_nan] = ACTIONS(143),
    [anon_sym_NA] = ACTIONS(143),
    [anon_sym_NA_integer_] = ACTIONS(143),
    [anon_sym_NA_real_] = ACTIONS(143),
    [anon_sym_NA_complex_] = ACTIONS(143),
    [anon_sym_NA_character_] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(145),
    [sym__raw_string_literal] = ACTIONS(145),
    [sym__external_else] = ACTIONS(145),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(145),
    [sym__external_close_brace] = ACTIONS(145),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [19] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [20] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(147),
    [anon_sym_PIPE_GT] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [21] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [22] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [23] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [24] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [25] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [26] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [27] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [28] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [29] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [30] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [31] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [32] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [33] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [34] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_BSLASH] = ACTIONS(155),
    [anon_sym_function] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_repeat] = ACTIONS(157),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(155),
    [sym__number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [sym_dots] = ACTIONS(157),
    [sym_dot_dot_i] = ACTIONS(157),
    [sym_return] = ACTIONS(157),
    [sym_next] = ACTIONS(157),
    [sym_break] = ACTIONS(157),
    [sym_true] = ACTIONS(157),
    [sym_false] = ACTIONS(157),
    [sym_null] = ACTIONS(157),
    [sym_inf] = ACTIONS(157),
    [sym_nan] = ACTIONS(157),
    [anon_sym_NA] = ACTIONS(157),
    [anon_sym_NA_integer_] = ACTIONS(157),
    [anon_sym_NA_real_] = ACTIONS(157),
    [anon_sym_NA_complex_] = ACTIONS(157),
    [anon_sym_NA_character_] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(155),
    [sym__semicolon] = ACTIONS(155),
    [sym__raw_string_literal] = ACTIONS(155),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(155),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [35] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(159),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(161),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_repeat] = ACTIONS(161),
    [anon_sym_QMARK] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(159),
    [sym__number_literal] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(159),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [sym_dots] = ACTIONS(161),
    [sym_dot_dot_i] = ACTIONS(161),
    [sym_return] = ACTIONS(161),
    [sym_next] = ACTIONS(161),
    [sym_break] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_null] = ACTIONS(161),
    [sym_inf] = ACTIONS(161),
    [sym_nan] = ACTIONS(161),
    [anon_sym_NA] = ACTIONS(161),
    [anon_sym_NA_integer_] = ACTIONS(161),
    [anon_sym_NA_real_] = ACTIONS(161),
    [anon_sym_NA_complex_] = ACTIONS(161),
    [anon_sym_NA_character_] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(159),
    [sym__semicolon] = ACTIONS(159),
    [sym__raw_string_literal] = ACTIONS(159),
    [sym__external_else] = ACTIONS(159),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(159),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [36] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [37] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [38] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [39] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [40] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [41] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [42] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [43] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [44] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [45] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [46] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [47] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [48] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [49] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_BSLASH] = ACTIONS(167),
    [anon_sym_function] = ACTIONS(169),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_repeat] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(167),
    [sym__number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [sym_dots] = ACTIONS(169),
    [sym_dot_dot_i] = ACTIONS(169),
    [sym_return] = ACTIONS(169),
    [sym_next] = ACTIONS(169),
    [sym_break] = ACTIONS(169),
    [sym_true] = ACTIONS(169),
    [sym_false] = ACTIONS(169),
    [sym_null] = ACTIONS(169),
    [sym_inf] = ACTIONS(169),
    [sym_nan] = ACTIONS(169),
    [anon_sym_NA] = ACTIONS(169),
    [anon_sym_NA_integer_] = ACTIONS(169),
    [anon_sym_NA_real_] = ACTIONS(169),
    [anon_sym_NA_complex_] = ACTIONS(169),
    [anon_sym_NA_character_] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(167),
    [sym__semicolon] = ACTIONS(167),
    [sym__raw_string_literal] = ACTIONS(167),
    [sym__external_else] = ACTIONS(167),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(167),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [50] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_BSLASH] = ACTIONS(171),
    [anon_sym_function] = ACTIONS(173),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(171),
    [sym__number_literal] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_dots] = ACTIONS(173),
    [sym_dot_dot_i] = ACTIONS(173),
    [sym_return] = ACTIONS(173),
    [sym_next] = ACTIONS(173),
    [sym_break] = ACTIONS(173),
    [sym_true] = ACTIONS(173),
    [sym_false] = ACTIONS(173),
    [sym_null] = ACTIONS(173),
    [sym_inf] = ACTIONS(173),
    [sym_nan] = ACTIONS(173),
    [anon_sym_NA] = ACTIONS(173),
    [anon_sym_NA_integer_] = ACTIONS(173),
    [anon_sym_NA_real_] = ACTIONS(173),
    [anon_sym_NA_complex_] = ACTIONS(173),
    [anon_sym_NA_character_] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(171),
    [sym__semicolon] = ACTIONS(171),
    [sym__raw_string_literal] = ACTIONS(171),
    [sym__external_else] = ACTIONS(171),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(171),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [51] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(175),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(175),
    [anon_sym_function] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_repeat] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(175),
    [sym__number_literal] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [sym_dots] = ACTIONS(177),
    [sym_dot_dot_i] = ACTIONS(177),
    [sym_return] = ACTIONS(177),
    [sym_next] = ACTIONS(177),
    [sym_break] = ACTIONS(177),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [sym_null] = ACTIONS(177),
    [sym_inf] = ACTIONS(177),
    [sym_nan] = ACTIONS(177),
    [anon_sym_NA] = ACTIONS(177),
    [anon_sym_NA_integer_] = ACTIONS(177),
    [anon_sym_NA_real_] = ACTIONS(177),
    [anon_sym_NA_complex_] = ACTIONS(177),
    [anon_sym_NA_character_] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(175),
    [sym__semicolon] = ACTIONS(175),
    [sym__raw_string_literal] = ACTIONS(175),
    [sym__external_else] = ACTIONS(175),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(175),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [52] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_repeat] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(179),
    [sym__number_literal] = ACTIONS(181),
    [anon_sym_SQUOTE] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_dots] = ACTIONS(181),
    [sym_dot_dot_i] = ACTIONS(181),
    [sym_return] = ACTIONS(181),
    [sym_next] = ACTIONS(181),
    [sym_break] = ACTIONS(181),
    [sym_true] = ACTIONS(181),
    [sym_false] = ACTIONS(181),
    [sym_null] = ACTIONS(181),
    [sym_inf] = ACTIONS(181),
    [sym_nan] = ACTIONS(181),
    [anon_sym_NA] = ACTIONS(181),
    [anon_sym_NA_integer_] = ACTIONS(181),
    [anon_sym_NA_real_] = ACTIONS(181),
    [anon_sym_NA_complex_] = ACTIONS(181),
    [anon_sym_NA_character_] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(179),
    [sym__semicolon] = ACTIONS(179),
    [sym__raw_string_literal] = ACTIONS(179),
    [sym__external_else] = ACTIONS(179),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(179),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [53] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(183),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(185),
    [anon_sym_repeat] = ACTIONS(185),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(185),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(183),
    [sym__number_literal] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE] = ACTIONS(183),
    [sym_dots] = ACTIONS(185),
    [sym_dot_dot_i] = ACTIONS(185),
    [sym_return] = ACTIONS(185),
    [sym_next] = ACTIONS(185),
    [sym_break] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_inf] = ACTIONS(185),
    [sym_nan] = ACTIONS(185),
    [anon_sym_NA] = ACTIONS(185),
    [anon_sym_NA_integer_] = ACTIONS(185),
    [anon_sym_NA_real_] = ACTIONS(185),
    [anon_sym_NA_complex_] = ACTIONS(185),
    [anon_sym_NA_character_] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(183),
    [sym__semicolon] = ACTIONS(183),
    [sym__raw_string_literal] = ACTIONS(183),
    [sym__external_else] = ACTIONS(183),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(183),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [54] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_repeat] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(187),
    [sym__number_literal] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_dots] = ACTIONS(189),
    [sym_dot_dot_i] = ACTIONS(189),
    [sym_return] = ACTIONS(189),
    [sym_next] = ACTIONS(189),
    [sym_break] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_inf] = ACTIONS(189),
    [sym_nan] = ACTIONS(189),
    [anon_sym_NA] = ACTIONS(189),
    [anon_sym_NA_integer_] = ACTIONS(189),
    [anon_sym_NA_real_] = ACTIONS(189),
    [anon_sym_NA_complex_] = ACTIONS(189),
    [anon_sym_NA_character_] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(187),
    [sym__semicolon] = ACTIONS(187),
    [sym__raw_string_literal] = ACTIONS(187),
    [sym__external_else] = ACTIONS(187),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(187),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [55] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(191),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(193),
    [anon_sym_repeat] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(193),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(191),
    [sym__number_literal] = ACTIONS(193),
    [anon_sym_SQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(193),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(193),
    [anon_sym_NA_integer_] = ACTIONS(193),
    [anon_sym_NA_real_] = ACTIONS(193),
    [anon_sym_NA_complex_] = ACTIONS(193),
    [anon_sym_NA_character_] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(191),
    [sym__semicolon] = ACTIONS(191),
    [sym__raw_string_literal] = ACTIONS(191),
    [sym__external_else] = ACTIONS(191),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(191),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [56] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(195),
    [sym_identifier] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(195),
    [anon_sym_function] = ACTIONS(197),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(197),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(197),
    [anon_sym_repeat] = ACTIONS(197),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(195),
    [sym__number_literal] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(195),
    [sym_dots] = ACTIONS(197),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_return] = ACTIONS(197),
    [sym_next] = ACTIONS(197),
    [sym_break] = ACTIONS(197),
    [sym_true] = ACTIONS(197),
    [sym_false] = ACTIONS(197),
    [sym_null] = ACTIONS(197),
    [sym_inf] = ACTIONS(197),
    [sym_nan] = ACTIONS(197),
    [anon_sym_NA] = ACTIONS(197),
    [anon_sym_NA_integer_] = ACTIONS(197),
    [anon_sym_NA_real_] = ACTIONS(197),
    [anon_sym_NA_complex_] = ACTIONS(197),
    [anon_sym_NA_character_] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(195),
    [sym__semicolon] = ACTIONS(195),
    [sym__raw_string_literal] = ACTIONS(195),
    [sym__external_else] = ACTIONS(195),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(195),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [57] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(199),
    [sym_identifier] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(199),
    [anon_sym_function] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_while] = ACTIONS(201),
    [anon_sym_repeat] = ACTIONS(201),
    [anon_sym_QMARK] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(199),
    [sym__number_literal] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_dots] = ACTIONS(201),
    [sym_dot_dot_i] = ACTIONS(201),
    [sym_return] = ACTIONS(201),
    [sym_next] = ACTIONS(201),
    [sym_break] = ACTIONS(201),
    [sym_true] = ACTIONS(201),
    [sym_false] = ACTIONS(201),
    [sym_null] = ACTIONS(201),
    [sym_inf] = ACTIONS(201),
    [sym_nan] = ACTIONS(201),
    [anon_sym_NA] = ACTIONS(201),
    [anon_sym_NA_integer_] = ACTIONS(201),
    [anon_sym_NA_real_] = ACTIONS(201),
    [anon_sym_NA_complex_] = ACTIONS(201),
    [anon_sym_NA_character_] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(199),
    [sym__raw_string_literal] = ACTIONS(199),
    [sym__external_else] = ACTIONS(199),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(199),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [58] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(203),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(203),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(205),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(203),
    [sym__semicolon] = ACTIONS(203),
    [sym__raw_string_literal] = ACTIONS(203),
    [sym__external_else] = ACTIONS(203),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(203),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [59] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_repeat] = ACTIONS(209),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_dots] = ACTIONS(209),
    [sym_dot_dot_i] = ACTIONS(209),
    [sym_return] = ACTIONS(209),
    [sym_next] = ACTIONS(209),
    [sym_break] = ACTIONS(209),
    [sym_true] = ACTIONS(209),
    [sym_false] = ACTIONS(209),
    [sym_null] = ACTIONS(209),
    [sym_inf] = ACTIONS(209),
    [sym_nan] = ACTIONS(209),
    [anon_sym_NA] = ACTIONS(209),
    [anon_sym_NA_integer_] = ACTIONS(209),
    [anon_sym_NA_real_] = ACTIONS(209),
    [anon_sym_NA_complex_] = ACTIONS(209),
    [anon_sym_NA_character_] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(207),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [60] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(211),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_repeat] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(211),
    [sym__number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_dots] = ACTIONS(213),
    [sym_dot_dot_i] = ACTIONS(213),
    [sym_return] = ACTIONS(213),
    [sym_next] = ACTIONS(213),
    [sym_break] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_inf] = ACTIONS(213),
    [sym_nan] = ACTIONS(213),
    [anon_sym_NA] = ACTIONS(213),
    [anon_sym_NA_integer_] = ACTIONS(213),
    [anon_sym_NA_real_] = ACTIONS(213),
    [anon_sym_NA_complex_] = ACTIONS(213),
    [anon_sym_NA_character_] = ACTIONS(213),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(211),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(211),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [61] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(215),
    [sym_identifier] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(215),
    [anon_sym_function] = ACTIONS(217),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(217),
    [anon_sym_for] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(217),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(215),
    [sym__number_literal] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [sym_dots] = ACTIONS(217),
    [sym_dot_dot_i] = ACTIONS(217),
    [sym_return] = ACTIONS(217),
    [sym_next] = ACTIONS(217),
    [sym_break] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_inf] = ACTIONS(217),
    [sym_nan] = ACTIONS(217),
    [anon_sym_NA] = ACTIONS(217),
    [anon_sym_NA_integer_] = ACTIONS(217),
    [anon_sym_NA_real_] = ACTIONS(217),
    [anon_sym_NA_complex_] = ACTIONS(217),
    [anon_sym_NA_character_] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(215),
    [sym__semicolon] = ACTIONS(215),
    [sym__raw_string_literal] = ACTIONS(215),
    [sym__external_else] = ACTIONS(215),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(215),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [62] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(219),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(219),
    [anon_sym_function] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(221),
    [anon_sym_while] = ACTIONS(221),
    [anon_sym_repeat] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(219),
    [sym__number_literal] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(221),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(221),
    [anon_sym_NA_integer_] = ACTIONS(221),
    [anon_sym_NA_real_] = ACTIONS(221),
    [anon_sym_NA_complex_] = ACTIONS(221),
    [anon_sym_NA_character_] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(219),
    [sym__semicolon] = ACTIONS(219),
    [sym__raw_string_literal] = ACTIONS(219),
    [sym__external_else] = ACTIONS(219),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(219),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [63] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(145),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_BSLASH] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(143),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(143),
    [anon_sym_repeat] = ACTIONS(143),
    [anon_sym_QMARK] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(145),
    [sym__number_literal] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_dots] = ACTIONS(143),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_return] = ACTIONS(143),
    [sym_next] = ACTIONS(143),
    [sym_break] = ACTIONS(143),
    [sym_true] = ACTIONS(143),
    [sym_false] = ACTIONS(143),
    [sym_null] = ACTIONS(143),
    [sym_inf] = ACTIONS(143),
    [sym_nan] = ACTIONS(143),
    [anon_sym_NA] = ACTIONS(143),
    [anon_sym_NA_integer_] = ACTIONS(143),
    [anon_sym_NA_real_] = ACTIONS(143),
    [anon_sym_NA_complex_] = ACTIONS(143),
    [anon_sym_NA_character_] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(145),
    [sym__raw_string_literal] = ACTIONS(145),
    [sym__external_else] = ACTIONS(145),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(145),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [64] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_repeat] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(223),
    [sym__number_literal] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_dots] = ACTIONS(225),
    [sym_dot_dot_i] = ACTIONS(225),
    [sym_return] = ACTIONS(225),
    [sym_next] = ACTIONS(225),
    [sym_break] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_null] = ACTIONS(225),
    [sym_inf] = ACTIONS(225),
    [sym_nan] = ACTIONS(225),
    [anon_sym_NA] = ACTIONS(225),
    [anon_sym_NA_integer_] = ACTIONS(225),
    [anon_sym_NA_real_] = ACTIONS(225),
    [anon_sym_NA_complex_] = ACTIONS(225),
    [anon_sym_NA_character_] = ACTIONS(225),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(223),
    [sym__semicolon] = ACTIONS(223),
    [sym__raw_string_literal] = ACTIONS(223),
    [sym__external_else] = ACTIONS(223),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(223),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [65] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_repeat] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(227),
    [sym__number_literal] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [sym_dots] = ACTIONS(229),
    [sym_dot_dot_i] = ACTIONS(229),
    [sym_return] = ACTIONS(229),
    [sym_next] = ACTIONS(229),
    [sym_break] = ACTIONS(229),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [sym_null] = ACTIONS(229),
    [sym_inf] = ACTIONS(229),
    [sym_nan] = ACTIONS(229),
    [anon_sym_NA] = ACTIONS(229),
    [anon_sym_NA_integer_] = ACTIONS(229),
    [anon_sym_NA_real_] = ACTIONS(229),
    [anon_sym_NA_complex_] = ACTIONS(229),
    [anon_sym_NA_character_] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(227),
    [sym__semicolon] = ACTIONS(227),
    [sym__raw_string_literal] = ACTIONS(227),
    [sym__external_else] = ACTIONS(227),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(227),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [66] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BSLASH] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(231),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_repeat] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(233),
    [sym__number_literal] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_dots] = ACTIONS(231),
    [sym_dot_dot_i] = ACTIONS(231),
    [sym_return] = ACTIONS(231),
    [sym_next] = ACTIONS(231),
    [sym_break] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_inf] = ACTIONS(231),
    [sym_nan] = ACTIONS(231),
    [anon_sym_NA] = ACTIONS(231),
    [anon_sym_NA_integer_] = ACTIONS(231),
    [anon_sym_NA_real_] = ACTIONS(231),
    [anon_sym_NA_complex_] = ACTIONS(231),
    [anon_sym_NA_character_] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(233),
    [sym__semicolon] = ACTIONS(233),
    [sym__raw_string_literal] = ACTIONS(233),
    [sym__external_else] = ACTIONS(233),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(233),
    [sym__external_close_brace] = ACTIONS(233),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [67] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [68] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [69] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [70] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(237),
    [anon_sym_PIPE_GT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [71] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_BSLASH] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_repeat] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(241),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(241),
    [sym__number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(241),
    [sym_dots] = ACTIONS(239),
    [sym_dot_dot_i] = ACTIONS(239),
    [sym_return] = ACTIONS(239),
    [sym_next] = ACTIONS(239),
    [sym_break] = ACTIONS(239),
    [sym_true] = ACTIONS(239),
    [sym_false] = ACTIONS(239),
    [sym_null] = ACTIONS(239),
    [sym_inf] = ACTIONS(239),
    [sym_nan] = ACTIONS(239),
    [anon_sym_NA] = ACTIONS(239),
    [anon_sym_NA_integer_] = ACTIONS(239),
    [anon_sym_NA_real_] = ACTIONS(239),
    [anon_sym_NA_complex_] = ACTIONS(239),
    [anon_sym_NA_character_] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(241),
    [sym__semicolon] = ACTIONS(241),
    [sym__raw_string_literal] = ACTIONS(241),
    [sym__external_else] = ACTIONS(241),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(241),
    [sym__external_close_brace] = ACTIONS(241),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [72] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BSLASH] = ACTIONS(245),
    [anon_sym_function] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(243),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_repeat] = ACTIONS(243),
    [anon_sym_QMARK] = ACTIONS(245),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(245),
    [sym__number_literal] = ACTIONS(243),
    [anon_sym_SQUOTE] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_dots] = ACTIONS(243),
    [sym_dot_dot_i] = ACTIONS(243),
    [sym_return] = ACTIONS(243),
    [sym_next] = ACTIONS(243),
    [sym_break] = ACTIONS(243),
    [sym_true] = ACTIONS(243),
    [sym_false] = ACTIONS(243),
    [sym_null] = ACTIONS(243),
    [sym_inf] = ACTIONS(243),
    [sym_nan] = ACTIONS(243),
    [anon_sym_NA] = ACTIONS(243),
    [anon_sym_NA_integer_] = ACTIONS(243),
    [anon_sym_NA_real_] = ACTIONS(243),
    [anon_sym_NA_complex_] = ACTIONS(243),
    [anon_sym_NA_character_] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(245),
    [sym__semicolon] = ACTIONS(245),
    [sym__raw_string_literal] = ACTIONS(245),
    [sym__external_else] = ACTIONS(245),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(245),
    [sym__external_close_brace] = ACTIONS(245),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [73] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [74] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [75] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [76] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(147),
    [anon_sym_PIPE_GT] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [77] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [78] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [79] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [80] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [81] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [82] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [83] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [84] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [85] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [86] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [87] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [88] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [89] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [90] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_BSLASH] = ACTIONS(155),
    [anon_sym_function] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_repeat] = ACTIONS(157),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(155),
    [sym__number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [sym_dots] = ACTIONS(157),
    [sym_dot_dot_i] = ACTIONS(157),
    [sym_return] = ACTIONS(157),
    [sym_next] = ACTIONS(157),
    [sym_break] = ACTIONS(157),
    [sym_true] = ACTIONS(157),
    [sym_false] = ACTIONS(157),
    [sym_null] = ACTIONS(157),
    [sym_inf] = ACTIONS(157),
    [sym_nan] = ACTIONS(157),
    [anon_sym_NA] = ACTIONS(157),
    [anon_sym_NA_integer_] = ACTIONS(157),
    [anon_sym_NA_real_] = ACTIONS(157),
    [anon_sym_NA_complex_] = ACTIONS(157),
    [anon_sym_NA_character_] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(155),
    [sym__semicolon] = ACTIONS(155),
    [sym__raw_string_literal] = ACTIONS(155),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(155),
    [sym__external_close_brace] = ACTIONS(155),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [91] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(161),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_repeat] = ACTIONS(161),
    [anon_sym_QMARK] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(159),
    [sym__number_literal] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(159),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [sym_dots] = ACTIONS(161),
    [sym_dot_dot_i] = ACTIONS(161),
    [sym_return] = ACTIONS(161),
    [sym_next] = ACTIONS(161),
    [sym_break] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_null] = ACTIONS(161),
    [sym_inf] = ACTIONS(161),
    [sym_nan] = ACTIONS(161),
    [anon_sym_NA] = ACTIONS(161),
    [anon_sym_NA_integer_] = ACTIONS(161),
    [anon_sym_NA_real_] = ACTIONS(161),
    [anon_sym_NA_complex_] = ACTIONS(161),
    [anon_sym_NA_character_] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(159),
    [sym__semicolon] = ACTIONS(159),
    [sym__raw_string_literal] = ACTIONS(159),
    [sym__external_else] = ACTIONS(159),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(159),
    [sym__external_close_brace] = ACTIONS(159),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [92] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [93] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [94] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [95] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [96] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [97] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [98] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [99] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [100] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [101] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [102] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [103] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [104] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_else] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [105] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_BSLASH] = ACTIONS(167),
    [anon_sym_function] = ACTIONS(169),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_repeat] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(167),
    [sym__number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [sym_dots] = ACTIONS(169),
    [sym_dot_dot_i] = ACTIONS(169),
    [sym_return] = ACTIONS(169),
    [sym_next] = ACTIONS(169),
    [sym_break] = ACTIONS(169),
    [sym_true] = ACTIONS(169),
    [sym_false] = ACTIONS(169),
    [sym_null] = ACTIONS(169),
    [sym_inf] = ACTIONS(169),
    [sym_nan] = ACTIONS(169),
    [anon_sym_NA] = ACTIONS(169),
    [anon_sym_NA_integer_] = ACTIONS(169),
    [anon_sym_NA_real_] = ACTIONS(169),
    [anon_sym_NA_complex_] = ACTIONS(169),
    [anon_sym_NA_character_] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(167),
    [sym__semicolon] = ACTIONS(167),
    [sym__raw_string_literal] = ACTIONS(167),
    [sym__external_else] = ACTIONS(167),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(167),
    [sym__external_close_brace] = ACTIONS(167),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [106] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_BSLASH] = ACTIONS(171),
    [anon_sym_function] = ACTIONS(173),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(171),
    [sym__number_literal] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_dots] = ACTIONS(173),
    [sym_dot_dot_i] = ACTIONS(173),
    [sym_return] = ACTIONS(173),
    [sym_next] = ACTIONS(173),
    [sym_break] = ACTIONS(173),
    [sym_true] = ACTIONS(173),
    [sym_false] = ACTIONS(173),
    [sym_null] = ACTIONS(173),
    [sym_inf] = ACTIONS(173),
    [sym_nan] = ACTIONS(173),
    [anon_sym_NA] = ACTIONS(173),
    [anon_sym_NA_integer_] = ACTIONS(173),
    [anon_sym_NA_real_] = ACTIONS(173),
    [anon_sym_NA_complex_] = ACTIONS(173),
    [anon_sym_NA_character_] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(171),
    [sym__semicolon] = ACTIONS(171),
    [sym__raw_string_literal] = ACTIONS(171),
    [sym__external_else] = ACTIONS(171),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(171),
    [sym__external_close_brace] = ACTIONS(171),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [107] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(175),
    [anon_sym_function] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_repeat] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(175),
    [sym__number_literal] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [sym_dots] = ACTIONS(177),
    [sym_dot_dot_i] = ACTIONS(177),
    [sym_return] = ACTIONS(177),
    [sym_next] = ACTIONS(177),
    [sym_break] = ACTIONS(177),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [sym_null] = ACTIONS(177),
    [sym_inf] = ACTIONS(177),
    [sym_nan] = ACTIONS(177),
    [anon_sym_NA] = ACTIONS(177),
    [anon_sym_NA_integer_] = ACTIONS(177),
    [anon_sym_NA_real_] = ACTIONS(177),
    [anon_sym_NA_complex_] = ACTIONS(177),
    [anon_sym_NA_character_] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(175),
    [sym__semicolon] = ACTIONS(175),
    [sym__raw_string_literal] = ACTIONS(175),
    [sym__external_else] = ACTIONS(175),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(175),
    [sym__external_close_brace] = ACTIONS(175),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [108] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_repeat] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(179),
    [sym__number_literal] = ACTIONS(181),
    [anon_sym_SQUOTE] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_dots] = ACTIONS(181),
    [sym_dot_dot_i] = ACTIONS(181),
    [sym_return] = ACTIONS(181),
    [sym_next] = ACTIONS(181),
    [sym_break] = ACTIONS(181),
    [sym_true] = ACTIONS(181),
    [sym_false] = ACTIONS(181),
    [sym_null] = ACTIONS(181),
    [sym_inf] = ACTIONS(181),
    [sym_nan] = ACTIONS(181),
    [anon_sym_NA] = ACTIONS(181),
    [anon_sym_NA_integer_] = ACTIONS(181),
    [anon_sym_NA_real_] = ACTIONS(181),
    [anon_sym_NA_complex_] = ACTIONS(181),
    [anon_sym_NA_character_] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(179),
    [sym__semicolon] = ACTIONS(179),
    [sym__raw_string_literal] = ACTIONS(179),
    [sym__external_else] = ACTIONS(179),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(179),
    [sym__external_close_brace] = ACTIONS(179),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [109] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(185),
    [anon_sym_repeat] = ACTIONS(185),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(185),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(183),
    [sym__number_literal] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE] = ACTIONS(183),
    [sym_dots] = ACTIONS(185),
    [sym_dot_dot_i] = ACTIONS(185),
    [sym_return] = ACTIONS(185),
    [sym_next] = ACTIONS(185),
    [sym_break] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_inf] = ACTIONS(185),
    [sym_nan] = ACTIONS(185),
    [anon_sym_NA] = ACTIONS(185),
    [anon_sym_NA_integer_] = ACTIONS(185),
    [anon_sym_NA_real_] = ACTIONS(185),
    [anon_sym_NA_complex_] = ACTIONS(185),
    [anon_sym_NA_character_] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(183),
    [sym__semicolon] = ACTIONS(183),
    [sym__raw_string_literal] = ACTIONS(183),
    [sym__external_else] = ACTIONS(183),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(183),
    [sym__external_close_brace] = ACTIONS(183),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [110] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_repeat] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(187),
    [sym__number_literal] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_dots] = ACTIONS(189),
    [sym_dot_dot_i] = ACTIONS(189),
    [sym_return] = ACTIONS(189),
    [sym_next] = ACTIONS(189),
    [sym_break] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_inf] = ACTIONS(189),
    [sym_nan] = ACTIONS(189),
    [anon_sym_NA] = ACTIONS(189),
    [anon_sym_NA_integer_] = ACTIONS(189),
    [anon_sym_NA_real_] = ACTIONS(189),
    [anon_sym_NA_complex_] = ACTIONS(189),
    [anon_sym_NA_character_] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(187),
    [sym__semicolon] = ACTIONS(187),
    [sym__raw_string_literal] = ACTIONS(187),
    [sym__external_else] = ACTIONS(187),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(187),
    [sym__external_close_brace] = ACTIONS(187),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [111] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(193),
    [anon_sym_repeat] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(193),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(191),
    [sym__number_literal] = ACTIONS(193),
    [anon_sym_SQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(193),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(193),
    [anon_sym_NA_integer_] = ACTIONS(193),
    [anon_sym_NA_real_] = ACTIONS(193),
    [anon_sym_NA_complex_] = ACTIONS(193),
    [anon_sym_NA_character_] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(191),
    [sym__semicolon] = ACTIONS(191),
    [sym__raw_string_literal] = ACTIONS(191),
    [sym__external_else] = ACTIONS(191),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(191),
    [sym__external_close_brace] = ACTIONS(191),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [112] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(195),
    [anon_sym_function] = ACTIONS(197),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(197),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(197),
    [anon_sym_repeat] = ACTIONS(197),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(195),
    [sym__number_literal] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(195),
    [sym_dots] = ACTIONS(197),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_return] = ACTIONS(197),
    [sym_next] = ACTIONS(197),
    [sym_break] = ACTIONS(197),
    [sym_true] = ACTIONS(197),
    [sym_false] = ACTIONS(197),
    [sym_null] = ACTIONS(197),
    [sym_inf] = ACTIONS(197),
    [sym_nan] = ACTIONS(197),
    [anon_sym_NA] = ACTIONS(197),
    [anon_sym_NA_integer_] = ACTIONS(197),
    [anon_sym_NA_real_] = ACTIONS(197),
    [anon_sym_NA_complex_] = ACTIONS(197),
    [anon_sym_NA_character_] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(195),
    [sym__semicolon] = ACTIONS(195),
    [sym__raw_string_literal] = ACTIONS(195),
    [sym__external_else] = ACTIONS(195),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(195),
    [sym__external_close_brace] = ACTIONS(195),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [113] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(199),
    [anon_sym_function] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_while] = ACTIONS(201),
    [anon_sym_repeat] = ACTIONS(201),
    [anon_sym_QMARK] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(199),
    [sym__number_literal] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_dots] = ACTIONS(201),
    [sym_dot_dot_i] = ACTIONS(201),
    [sym_return] = ACTIONS(201),
    [sym_next] = ACTIONS(201),
    [sym_break] = ACTIONS(201),
    [sym_true] = ACTIONS(201),
    [sym_false] = ACTIONS(201),
    [sym_null] = ACTIONS(201),
    [sym_inf] = ACTIONS(201),
    [sym_nan] = ACTIONS(201),
    [anon_sym_NA] = ACTIONS(201),
    [anon_sym_NA_integer_] = ACTIONS(201),
    [anon_sym_NA_real_] = ACTIONS(201),
    [anon_sym_NA_complex_] = ACTIONS(201),
    [anon_sym_NA_character_] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(199),
    [sym__raw_string_literal] = ACTIONS(199),
    [sym__external_else] = ACTIONS(199),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(199),
    [sym__external_close_brace] = ACTIONS(199),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [114] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(203),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(203),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(205),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(203),
    [sym__semicolon] = ACTIONS(203),
    [sym__raw_string_literal] = ACTIONS(203),
    [sym__external_else] = ACTIONS(203),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(203),
    [sym__external_close_brace] = ACTIONS(203),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [115] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_repeat] = ACTIONS(209),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_dots] = ACTIONS(209),
    [sym_dot_dot_i] = ACTIONS(209),
    [sym_return] = ACTIONS(209),
    [sym_next] = ACTIONS(209),
    [sym_break] = ACTIONS(209),
    [sym_true] = ACTIONS(209),
    [sym_false] = ACTIONS(209),
    [sym_null] = ACTIONS(209),
    [sym_inf] = ACTIONS(209),
    [sym_nan] = ACTIONS(209),
    [anon_sym_NA] = ACTIONS(209),
    [anon_sym_NA_integer_] = ACTIONS(209),
    [anon_sym_NA_real_] = ACTIONS(209),
    [anon_sym_NA_complex_] = ACTIONS(209),
    [anon_sym_NA_character_] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(207),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [116] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(211),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_repeat] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(211),
    [sym__number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_dots] = ACTIONS(213),
    [sym_dot_dot_i] = ACTIONS(213),
    [sym_return] = ACTIONS(213),
    [sym_next] = ACTIONS(213),
    [sym_break] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_inf] = ACTIONS(213),
    [sym_nan] = ACTIONS(213),
    [anon_sym_NA] = ACTIONS(213),
    [anon_sym_NA_integer_] = ACTIONS(213),
    [anon_sym_NA_real_] = ACTIONS(213),
    [anon_sym_NA_complex_] = ACTIONS(213),
    [anon_sym_NA_character_] = ACTIONS(213),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(211),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(211),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(211),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [117] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(215),
    [anon_sym_function] = ACTIONS(217),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(217),
    [anon_sym_for] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(217),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(215),
    [sym__number_literal] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [sym_dots] = ACTIONS(217),
    [sym_dot_dot_i] = ACTIONS(217),
    [sym_return] = ACTIONS(217),
    [sym_next] = ACTIONS(217),
    [sym_break] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_inf] = ACTIONS(217),
    [sym_nan] = ACTIONS(217),
    [anon_sym_NA] = ACTIONS(217),
    [anon_sym_NA_integer_] = ACTIONS(217),
    [anon_sym_NA_real_] = ACTIONS(217),
    [anon_sym_NA_complex_] = ACTIONS(217),
    [anon_sym_NA_character_] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(215),
    [sym__semicolon] = ACTIONS(215),
    [sym__raw_string_literal] = ACTIONS(215),
    [sym__external_else] = ACTIONS(215),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(215),
    [sym__external_close_brace] = ACTIONS(215),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [118] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(219),
    [anon_sym_function] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(221),
    [anon_sym_while] = ACTIONS(221),
    [anon_sym_repeat] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(219),
    [sym__number_literal] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(221),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(221),
    [anon_sym_NA_integer_] = ACTIONS(221),
    [anon_sym_NA_real_] = ACTIONS(221),
    [anon_sym_NA_complex_] = ACTIONS(221),
    [anon_sym_NA_character_] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(219),
    [sym__semicolon] = ACTIONS(219),
    [sym__raw_string_literal] = ACTIONS(219),
    [sym__external_else] = ACTIONS(219),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(219),
    [sym__external_close_brace] = ACTIONS(219),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [119] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(233),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BSLASH] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(231),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_repeat] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(233),
    [sym__number_literal] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_dots] = ACTIONS(231),
    [sym_dot_dot_i] = ACTIONS(231),
    [sym_return] = ACTIONS(231),
    [sym_next] = ACTIONS(231),
    [sym_break] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_inf] = ACTIONS(231),
    [sym_nan] = ACTIONS(231),
    [anon_sym_NA] = ACTIONS(231),
    [anon_sym_NA_integer_] = ACTIONS(231),
    [anon_sym_NA_real_] = ACTIONS(231),
    [anon_sym_NA_complex_] = ACTIONS(231),
    [anon_sym_NA_character_] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(233),
    [sym__semicolon] = ACTIONS(233),
    [sym__raw_string_literal] = ACTIONS(233),
    [sym__external_else] = ACTIONS(233),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(233),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [120] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_repeat] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(223),
    [sym__number_literal] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_dots] = ACTIONS(225),
    [sym_dot_dot_i] = ACTIONS(225),
    [sym_return] = ACTIONS(225),
    [sym_next] = ACTIONS(225),
    [sym_break] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_null] = ACTIONS(225),
    [sym_inf] = ACTIONS(225),
    [sym_nan] = ACTIONS(225),
    [anon_sym_NA] = ACTIONS(225),
    [anon_sym_NA_integer_] = ACTIONS(225),
    [anon_sym_NA_real_] = ACTIONS(225),
    [anon_sym_NA_complex_] = ACTIONS(225),
    [anon_sym_NA_character_] = ACTIONS(225),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(223),
    [sym__semicolon] = ACTIONS(223),
    [sym__raw_string_literal] = ACTIONS(223),
    [sym__external_else] = ACTIONS(223),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(223),
    [sym__external_close_brace] = ACTIONS(223),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [121] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_repeat] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(83),
    [anon_sym_LT_LT_DASH] = ACTIONS(83),
    [anon_sym_COLON_EQ] = ACTIONS(83),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_GT] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(227),
    [sym__number_literal] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [sym_dots] = ACTIONS(229),
    [sym_dot_dot_i] = ACTIONS(229),
    [sym_return] = ACTIONS(229),
    [sym_next] = ACTIONS(229),
    [sym_break] = ACTIONS(229),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [sym_null] = ACTIONS(229),
    [sym_inf] = ACTIONS(229),
    [sym_nan] = ACTIONS(229),
    [anon_sym_NA] = ACTIONS(229),
    [anon_sym_NA_integer_] = ACTIONS(229),
    [anon_sym_NA_real_] = ACTIONS(229),
    [anon_sym_NA_complex_] = ACTIONS(229),
    [anon_sym_NA_character_] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(227),
    [sym__semicolon] = ACTIONS(227),
    [sym__raw_string_literal] = ACTIONS(227),
    [sym__external_else] = ACTIONS(227),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(227),
    [sym__external_close_brace] = ACTIONS(227),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [122] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [123] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [124] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [125] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(237),
    [anon_sym_PIPE_GT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_else] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [126] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(241),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_BSLASH] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_repeat] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(241),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(241),
    [sym__number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(241),
    [sym_dots] = ACTIONS(239),
    [sym_dot_dot_i] = ACTIONS(239),
    [sym_return] = ACTIONS(239),
    [sym_next] = ACTIONS(239),
    [sym_break] = ACTIONS(239),
    [sym_true] = ACTIONS(239),
    [sym_false] = ACTIONS(239),
    [sym_null] = ACTIONS(239),
    [sym_inf] = ACTIONS(239),
    [sym_nan] = ACTIONS(239),
    [anon_sym_NA] = ACTIONS(239),
    [anon_sym_NA_integer_] = ACTIONS(239),
    [anon_sym_NA_real_] = ACTIONS(239),
    [anon_sym_NA_complex_] = ACTIONS(239),
    [anon_sym_NA_character_] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(241),
    [sym__semicolon] = ACTIONS(241),
    [sym__raw_string_literal] = ACTIONS(241),
    [sym__external_else] = ACTIONS(241),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(241),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [127] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(245),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BSLASH] = ACTIONS(245),
    [anon_sym_function] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(243),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_repeat] = ACTIONS(243),
    [anon_sym_QMARK] = ACTIONS(245),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(245),
    [sym__number_literal] = ACTIONS(243),
    [anon_sym_SQUOTE] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_dots] = ACTIONS(243),
    [sym_dot_dot_i] = ACTIONS(243),
    [sym_return] = ACTIONS(243),
    [sym_next] = ACTIONS(243),
    [sym_break] = ACTIONS(243),
    [sym_true] = ACTIONS(243),
    [sym_false] = ACTIONS(243),
    [sym_null] = ACTIONS(243),
    [sym_inf] = ACTIONS(243),
    [sym_nan] = ACTIONS(243),
    [anon_sym_NA] = ACTIONS(243),
    [anon_sym_NA_integer_] = ACTIONS(243),
    [anon_sym_NA_real_] = ACTIONS(243),
    [anon_sym_NA_complex_] = ACTIONS(243),
    [anon_sym_NA_character_] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(245),
    [sym__semicolon] = ACTIONS(245),
    [sym__raw_string_literal] = ACTIONS(245),
    [sym__external_else] = ACTIONS(245),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(245),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [128] = {
    [sym_call_arguments] = STATE(358),
    [sym_subset_arguments] = STATE(362),
    [sym_subset2_arguments] = STATE(370),
    [sym__open_parenthesis] = STATE(269),
    [sym__open_bracket] = STATE(270),
    [sym__open_bracket2] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LT_DASH] = ACTIONS(19),
    [anon_sym_LT_LT_DASH] = ACTIONS(19),
    [anon_sym_COLON_EQ] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(21),
    [anon_sym_DASH_GT_GT] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_PIPE_PIPE] = ACTIONS(29),
    [anon_sym_AMP_AMP] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(35),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(35),
    [anon_sym_EQ_EQ] = ACTIONS(35),
    [anon_sym_BANG_EQ] = ACTIONS(35),
    [anon_sym_STAR] = ACTIONS(37),
    [anon_sym_SLASH] = ACTIONS(39),
    [anon_sym_STAR_STAR] = ACTIONS(41),
    [anon_sym_CARET] = ACTIONS(41),
    [aux_sym_binary_operator_token1] = ACTIONS(43),
    [anon_sym_PIPE_GT] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(47),
    [anon_sym_AT] = ACTIONS(47),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(55),
  },
  [129] = {
    [sym_call_arguments] = STATE(339),
    [sym_subset_arguments] = STATE(376),
    [sym_subset2_arguments] = STATE(352),
    [sym__open_parenthesis] = STATE(275),
    [sym__open_bracket] = STATE(276),
    [sym__open_bracket2] = STATE(277),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(81),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_PIPE_PIPE] = ACTIONS(93),
    [anon_sym_AMP_AMP] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(99),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(99),
    [anon_sym_BANG_EQ] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_CARET] = ACTIONS(105),
    [aux_sym_binary_operator_token1] = ACTIONS(107),
    [anon_sym_PIPE_GT] = ACTIONS(107),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(115),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(117),
    [sym__external_open_bracket2] = ACTIONS(119),
  },
  [130] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [131] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_BSLASH] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_repeat] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(241),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(241),
    [sym__number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(241),
    [sym_dots] = ACTIONS(239),
    [sym_dot_dot_i] = ACTIONS(239),
    [sym_return] = ACTIONS(239),
    [sym_next] = ACTIONS(239),
    [sym_break] = ACTIONS(239),
    [sym_true] = ACTIONS(239),
    [sym_false] = ACTIONS(239),
    [sym_null] = ACTIONS(239),
    [sym_inf] = ACTIONS(239),
    [sym_nan] = ACTIONS(239),
    [anon_sym_NA] = ACTIONS(239),
    [anon_sym_NA_integer_] = ACTIONS(239),
    [anon_sym_NA_real_] = ACTIONS(239),
    [anon_sym_NA_complex_] = ACTIONS(239),
    [anon_sym_NA_character_] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(241),
    [sym__semicolon] = ACTIONS(241),
    [sym__raw_string_literal] = ACTIONS(241),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(241),
    [sym__external_close_brace] = ACTIONS(241),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [132] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BSLASH] = ACTIONS(245),
    [anon_sym_function] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(243),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_repeat] = ACTIONS(243),
    [anon_sym_QMARK] = ACTIONS(245),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(245),
    [sym__number_literal] = ACTIONS(243),
    [anon_sym_SQUOTE] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_dots] = ACTIONS(243),
    [sym_dot_dot_i] = ACTIONS(243),
    [sym_return] = ACTIONS(243),
    [sym_next] = ACTIONS(243),
    [sym_break] = ACTIONS(243),
    [sym_true] = ACTIONS(243),
    [sym_false] = ACTIONS(243),
    [sym_null] = ACTIONS(243),
    [sym_inf] = ACTIONS(243),
    [sym_nan] = ACTIONS(243),
    [anon_sym_NA] = ACTIONS(243),
    [anon_sym_NA_integer_] = ACTIONS(243),
    [anon_sym_NA_real_] = ACTIONS(243),
    [anon_sym_NA_complex_] = ACTIONS(243),
    [anon_sym_NA_character_] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(245),
    [sym__semicolon] = ACTIONS(245),
    [sym__raw_string_literal] = ACTIONS(245),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(245),
    [sym__external_close_brace] = ACTIONS(245),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [133] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [134] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [135] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [136] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(147),
    [anon_sym_PIPE_GT] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_close_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [137] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [138] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [139] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [140] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [141] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [142] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [143] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [144] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [145] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [146] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [147] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [148] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [149] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_BSLASH] = ACTIONS(155),
    [anon_sym_function] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_repeat] = ACTIONS(157),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(155),
    [sym__number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [sym_dots] = ACTIONS(157),
    [sym_dot_dot_i] = ACTIONS(157),
    [sym_return] = ACTIONS(157),
    [sym_next] = ACTIONS(157),
    [sym_break] = ACTIONS(157),
    [sym_true] = ACTIONS(157),
    [sym_false] = ACTIONS(157),
    [sym_null] = ACTIONS(157),
    [sym_inf] = ACTIONS(157),
    [sym_nan] = ACTIONS(157),
    [anon_sym_NA] = ACTIONS(157),
    [anon_sym_NA_integer_] = ACTIONS(157),
    [anon_sym_NA_real_] = ACTIONS(157),
    [anon_sym_NA_complex_] = ACTIONS(157),
    [anon_sym_NA_character_] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(155),
    [sym__semicolon] = ACTIONS(155),
    [sym__raw_string_literal] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(155),
    [sym__external_close_brace] = ACTIONS(155),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [150] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(161),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_repeat] = ACTIONS(161),
    [anon_sym_QMARK] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(159),
    [sym__number_literal] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(159),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [sym_dots] = ACTIONS(161),
    [sym_dot_dot_i] = ACTIONS(161),
    [sym_return] = ACTIONS(161),
    [sym_next] = ACTIONS(161),
    [sym_break] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_null] = ACTIONS(161),
    [sym_inf] = ACTIONS(161),
    [sym_nan] = ACTIONS(161),
    [anon_sym_NA] = ACTIONS(161),
    [anon_sym_NA_integer_] = ACTIONS(161),
    [anon_sym_NA_real_] = ACTIONS(161),
    [anon_sym_NA_complex_] = ACTIONS(161),
    [anon_sym_NA_character_] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(159),
    [sym__semicolon] = ACTIONS(159),
    [sym__raw_string_literal] = ACTIONS(159),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(159),
    [sym__external_close_brace] = ACTIONS(159),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [151] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [152] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [153] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [154] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [155] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [156] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [157] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [158] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [159] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [160] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [161] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [162] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [163] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_close_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [164] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_BSLASH] = ACTIONS(167),
    [anon_sym_function] = ACTIONS(169),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_repeat] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(167),
    [sym__number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [sym_dots] = ACTIONS(169),
    [sym_dot_dot_i] = ACTIONS(169),
    [sym_return] = ACTIONS(169),
    [sym_next] = ACTIONS(169),
    [sym_break] = ACTIONS(169),
    [sym_true] = ACTIONS(169),
    [sym_false] = ACTIONS(169),
    [sym_null] = ACTIONS(169),
    [sym_inf] = ACTIONS(169),
    [sym_nan] = ACTIONS(169),
    [anon_sym_NA] = ACTIONS(169),
    [anon_sym_NA_integer_] = ACTIONS(169),
    [anon_sym_NA_real_] = ACTIONS(169),
    [anon_sym_NA_complex_] = ACTIONS(169),
    [anon_sym_NA_character_] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(167),
    [sym__semicolon] = ACTIONS(167),
    [sym__raw_string_literal] = ACTIONS(167),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(167),
    [sym__external_close_brace] = ACTIONS(167),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [165] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym_identifier] = ACTIONS(315),
    [anon_sym_BSLASH] = ACTIONS(313),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(315),
    [anon_sym_for] = ACTIONS(315),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_repeat] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(313),
    [sym__number_literal] = ACTIONS(315),
    [anon_sym_SQUOTE] = ACTIONS(313),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_dots] = ACTIONS(315),
    [sym_dot_dot_i] = ACTIONS(315),
    [sym_return] = ACTIONS(315),
    [sym_next] = ACTIONS(315),
    [sym_break] = ACTIONS(315),
    [sym_true] = ACTIONS(315),
    [sym_false] = ACTIONS(315),
    [sym_null] = ACTIONS(315),
    [sym_inf] = ACTIONS(315),
    [sym_nan] = ACTIONS(315),
    [anon_sym_NA] = ACTIONS(315),
    [anon_sym_NA_integer_] = ACTIONS(315),
    [anon_sym_NA_real_] = ACTIONS(315),
    [anon_sym_NA_complex_] = ACTIONS(315),
    [anon_sym_NA_character_] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(313),
    [sym__semicolon] = ACTIONS(313),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(313),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [166] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_BSLASH] = ACTIONS(171),
    [anon_sym_function] = ACTIONS(173),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(171),
    [sym__number_literal] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_dots] = ACTIONS(173),
    [sym_dot_dot_i] = ACTIONS(173),
    [sym_return] = ACTIONS(173),
    [sym_next] = ACTIONS(173),
    [sym_break] = ACTIONS(173),
    [sym_true] = ACTIONS(173),
    [sym_false] = ACTIONS(173),
    [sym_null] = ACTIONS(173),
    [sym_inf] = ACTIONS(173),
    [sym_nan] = ACTIONS(173),
    [anon_sym_NA] = ACTIONS(173),
    [anon_sym_NA_integer_] = ACTIONS(173),
    [anon_sym_NA_real_] = ACTIONS(173),
    [anon_sym_NA_complex_] = ACTIONS(173),
    [anon_sym_NA_character_] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(171),
    [sym__semicolon] = ACTIONS(171),
    [sym__raw_string_literal] = ACTIONS(171),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(171),
    [sym__external_close_brace] = ACTIONS(171),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [167] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(175),
    [anon_sym_function] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_repeat] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(175),
    [sym__number_literal] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [sym_dots] = ACTIONS(177),
    [sym_dot_dot_i] = ACTIONS(177),
    [sym_return] = ACTIONS(177),
    [sym_next] = ACTIONS(177),
    [sym_break] = ACTIONS(177),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [sym_null] = ACTIONS(177),
    [sym_inf] = ACTIONS(177),
    [sym_nan] = ACTIONS(177),
    [anon_sym_NA] = ACTIONS(177),
    [anon_sym_NA_integer_] = ACTIONS(177),
    [anon_sym_NA_real_] = ACTIONS(177),
    [anon_sym_NA_complex_] = ACTIONS(177),
    [anon_sym_NA_character_] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(175),
    [sym__semicolon] = ACTIONS(175),
    [sym__raw_string_literal] = ACTIONS(175),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(175),
    [sym__external_close_brace] = ACTIONS(175),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [168] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_repeat] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(179),
    [sym__number_literal] = ACTIONS(181),
    [anon_sym_SQUOTE] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_dots] = ACTIONS(181),
    [sym_dot_dot_i] = ACTIONS(181),
    [sym_return] = ACTIONS(181),
    [sym_next] = ACTIONS(181),
    [sym_break] = ACTIONS(181),
    [sym_true] = ACTIONS(181),
    [sym_false] = ACTIONS(181),
    [sym_null] = ACTIONS(181),
    [sym_inf] = ACTIONS(181),
    [sym_nan] = ACTIONS(181),
    [anon_sym_NA] = ACTIONS(181),
    [anon_sym_NA_integer_] = ACTIONS(181),
    [anon_sym_NA_real_] = ACTIONS(181),
    [anon_sym_NA_complex_] = ACTIONS(181),
    [anon_sym_NA_character_] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(179),
    [sym__semicolon] = ACTIONS(179),
    [sym__raw_string_literal] = ACTIONS(179),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(179),
    [sym__external_close_brace] = ACTIONS(179),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [169] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(185),
    [anon_sym_repeat] = ACTIONS(185),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(185),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(183),
    [sym__number_literal] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE] = ACTIONS(183),
    [sym_dots] = ACTIONS(185),
    [sym_dot_dot_i] = ACTIONS(185),
    [sym_return] = ACTIONS(185),
    [sym_next] = ACTIONS(185),
    [sym_break] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_inf] = ACTIONS(185),
    [sym_nan] = ACTIONS(185),
    [anon_sym_NA] = ACTIONS(185),
    [anon_sym_NA_integer_] = ACTIONS(185),
    [anon_sym_NA_real_] = ACTIONS(185),
    [anon_sym_NA_complex_] = ACTIONS(185),
    [anon_sym_NA_character_] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(183),
    [sym__semicolon] = ACTIONS(183),
    [sym__raw_string_literal] = ACTIONS(183),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(183),
    [sym__external_close_brace] = ACTIONS(183),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [170] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(233),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BSLASH] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(231),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_repeat] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(233),
    [sym__number_literal] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_dots] = ACTIONS(231),
    [sym_dot_dot_i] = ACTIONS(231),
    [sym_return] = ACTIONS(231),
    [sym_next] = ACTIONS(231),
    [sym_break] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_inf] = ACTIONS(231),
    [sym_nan] = ACTIONS(231),
    [anon_sym_NA] = ACTIONS(231),
    [anon_sym_NA_integer_] = ACTIONS(231),
    [anon_sym_NA_real_] = ACTIONS(231),
    [anon_sym_NA_complex_] = ACTIONS(231),
    [anon_sym_NA_character_] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(233),
    [sym__semicolon] = ACTIONS(233),
    [sym__raw_string_literal] = ACTIONS(233),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(233),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [171] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_repeat] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(187),
    [sym__number_literal] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_dots] = ACTIONS(189),
    [sym_dot_dot_i] = ACTIONS(189),
    [sym_return] = ACTIONS(189),
    [sym_next] = ACTIONS(189),
    [sym_break] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_inf] = ACTIONS(189),
    [sym_nan] = ACTIONS(189),
    [anon_sym_NA] = ACTIONS(189),
    [anon_sym_NA_integer_] = ACTIONS(189),
    [anon_sym_NA_real_] = ACTIONS(189),
    [anon_sym_NA_complex_] = ACTIONS(189),
    [anon_sym_NA_character_] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(187),
    [sym__semicolon] = ACTIONS(187),
    [sym__raw_string_literal] = ACTIONS(187),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(187),
    [sym__external_close_brace] = ACTIONS(187),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [172] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(193),
    [anon_sym_repeat] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(193),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(191),
    [sym__number_literal] = ACTIONS(193),
    [anon_sym_SQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(193),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(193),
    [anon_sym_NA_integer_] = ACTIONS(193),
    [anon_sym_NA_real_] = ACTIONS(193),
    [anon_sym_NA_complex_] = ACTIONS(193),
    [anon_sym_NA_character_] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(191),
    [sym__semicolon] = ACTIONS(191),
    [sym__raw_string_literal] = ACTIONS(191),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(191),
    [sym__external_close_brace] = ACTIONS(191),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [173] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(195),
    [anon_sym_function] = ACTIONS(197),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(197),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(197),
    [anon_sym_repeat] = ACTIONS(197),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(195),
    [sym__number_literal] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(195),
    [sym_dots] = ACTIONS(197),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_return] = ACTIONS(197),
    [sym_next] = ACTIONS(197),
    [sym_break] = ACTIONS(197),
    [sym_true] = ACTIONS(197),
    [sym_false] = ACTIONS(197),
    [sym_null] = ACTIONS(197),
    [sym_inf] = ACTIONS(197),
    [sym_nan] = ACTIONS(197),
    [anon_sym_NA] = ACTIONS(197),
    [anon_sym_NA_integer_] = ACTIONS(197),
    [anon_sym_NA_real_] = ACTIONS(197),
    [anon_sym_NA_complex_] = ACTIONS(197),
    [anon_sym_NA_character_] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(195),
    [sym__semicolon] = ACTIONS(195),
    [sym__raw_string_literal] = ACTIONS(195),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(195),
    [sym__external_close_brace] = ACTIONS(195),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [174] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(199),
    [anon_sym_function] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_while] = ACTIONS(201),
    [anon_sym_repeat] = ACTIONS(201),
    [anon_sym_QMARK] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(199),
    [sym__number_literal] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_dots] = ACTIONS(201),
    [sym_dot_dot_i] = ACTIONS(201),
    [sym_return] = ACTIONS(201),
    [sym_next] = ACTIONS(201),
    [sym_break] = ACTIONS(201),
    [sym_true] = ACTIONS(201),
    [sym_false] = ACTIONS(201),
    [sym_null] = ACTIONS(201),
    [sym_inf] = ACTIONS(201),
    [sym_nan] = ACTIONS(201),
    [anon_sym_NA] = ACTIONS(201),
    [anon_sym_NA_integer_] = ACTIONS(201),
    [anon_sym_NA_real_] = ACTIONS(201),
    [anon_sym_NA_complex_] = ACTIONS(201),
    [anon_sym_NA_character_] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(199),
    [sym__raw_string_literal] = ACTIONS(199),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(199),
    [sym__external_close_brace] = ACTIONS(199),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [175] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(203),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(203),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(205),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(203),
    [sym__semicolon] = ACTIONS(203),
    [sym__raw_string_literal] = ACTIONS(203),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(203),
    [sym__external_close_brace] = ACTIONS(203),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [176] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_repeat] = ACTIONS(209),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_dots] = ACTIONS(209),
    [sym_dot_dot_i] = ACTIONS(209),
    [sym_return] = ACTIONS(209),
    [sym_next] = ACTIONS(209),
    [sym_break] = ACTIONS(209),
    [sym_true] = ACTIONS(209),
    [sym_false] = ACTIONS(209),
    [sym_null] = ACTIONS(209),
    [sym_inf] = ACTIONS(209),
    [sym_nan] = ACTIONS(209),
    [anon_sym_NA] = ACTIONS(209),
    [anon_sym_NA_integer_] = ACTIONS(209),
    [anon_sym_NA_real_] = ACTIONS(209),
    [anon_sym_NA_complex_] = ACTIONS(209),
    [anon_sym_NA_character_] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [177] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(211),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_repeat] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(211),
    [sym__number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_dots] = ACTIONS(213),
    [sym_dot_dot_i] = ACTIONS(213),
    [sym_return] = ACTIONS(213),
    [sym_next] = ACTIONS(213),
    [sym_break] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_inf] = ACTIONS(213),
    [sym_nan] = ACTIONS(213),
    [anon_sym_NA] = ACTIONS(213),
    [anon_sym_NA_integer_] = ACTIONS(213),
    [anon_sym_NA_real_] = ACTIONS(213),
    [anon_sym_NA_complex_] = ACTIONS(213),
    [anon_sym_NA_character_] = ACTIONS(213),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(211),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(211),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [178] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(215),
    [anon_sym_function] = ACTIONS(217),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(217),
    [anon_sym_for] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(217),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(215),
    [sym__number_literal] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [sym_dots] = ACTIONS(217),
    [sym_dot_dot_i] = ACTIONS(217),
    [sym_return] = ACTIONS(217),
    [sym_next] = ACTIONS(217),
    [sym_break] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_inf] = ACTIONS(217),
    [sym_nan] = ACTIONS(217),
    [anon_sym_NA] = ACTIONS(217),
    [anon_sym_NA_integer_] = ACTIONS(217),
    [anon_sym_NA_real_] = ACTIONS(217),
    [anon_sym_NA_complex_] = ACTIONS(217),
    [anon_sym_NA_character_] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(215),
    [sym__semicolon] = ACTIONS(215),
    [sym__raw_string_literal] = ACTIONS(215),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(215),
    [sym__external_close_brace] = ACTIONS(215),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [179] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(219),
    [anon_sym_function] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(221),
    [anon_sym_while] = ACTIONS(221),
    [anon_sym_repeat] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(219),
    [sym__number_literal] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(221),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(221),
    [anon_sym_NA_integer_] = ACTIONS(221),
    [anon_sym_NA_real_] = ACTIONS(221),
    [anon_sym_NA_complex_] = ACTIONS(221),
    [anon_sym_NA_character_] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(219),
    [sym__semicolon] = ACTIONS(219),
    [sym__raw_string_literal] = ACTIONS(219),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(219),
    [sym__external_close_brace] = ACTIONS(219),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [180] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_BSLASH] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(143),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(143),
    [anon_sym_repeat] = ACTIONS(143),
    [anon_sym_QMARK] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(145),
    [sym__number_literal] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_dots] = ACTIONS(143),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_return] = ACTIONS(143),
    [sym_next] = ACTIONS(143),
    [sym_break] = ACTIONS(143),
    [sym_true] = ACTIONS(143),
    [sym_false] = ACTIONS(143),
    [sym_null] = ACTIONS(143),
    [sym_inf] = ACTIONS(143),
    [sym_nan] = ACTIONS(143),
    [anon_sym_NA] = ACTIONS(143),
    [anon_sym_NA_integer_] = ACTIONS(143),
    [anon_sym_NA_real_] = ACTIONS(143),
    [anon_sym_NA_complex_] = ACTIONS(143),
    [anon_sym_NA_character_] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(145),
    [sym__raw_string_literal] = ACTIONS(145),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(145),
    [sym__external_close_brace] = ACTIONS(145),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [181] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_repeat] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(223),
    [sym__number_literal] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_dots] = ACTIONS(225),
    [sym_dot_dot_i] = ACTIONS(225),
    [sym_return] = ACTIONS(225),
    [sym_next] = ACTIONS(225),
    [sym_break] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_null] = ACTIONS(225),
    [sym_inf] = ACTIONS(225),
    [sym_nan] = ACTIONS(225),
    [anon_sym_NA] = ACTIONS(225),
    [anon_sym_NA_integer_] = ACTIONS(225),
    [anon_sym_NA_real_] = ACTIONS(225),
    [anon_sym_NA_complex_] = ACTIONS(225),
    [anon_sym_NA_character_] = ACTIONS(225),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(223),
    [sym__semicolon] = ACTIONS(223),
    [sym__raw_string_literal] = ACTIONS(223),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(223),
    [sym__external_close_brace] = ACTIONS(223),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [182] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_repeat] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(227),
    [sym__number_literal] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [sym_dots] = ACTIONS(229),
    [sym_dot_dot_i] = ACTIONS(229),
    [sym_return] = ACTIONS(229),
    [sym_next] = ACTIONS(229),
    [sym_break] = ACTIONS(229),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [sym_null] = ACTIONS(229),
    [sym_inf] = ACTIONS(229),
    [sym_nan] = ACTIONS(229),
    [anon_sym_NA] = ACTIONS(229),
    [anon_sym_NA_integer_] = ACTIONS(229),
    [anon_sym_NA_real_] = ACTIONS(229),
    [anon_sym_NA_complex_] = ACTIONS(229),
    [anon_sym_NA_character_] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(227),
    [sym__semicolon] = ACTIONS(227),
    [sym__raw_string_literal] = ACTIONS(227),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(227),
    [sym__external_close_brace] = ACTIONS(227),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [183] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [184] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [185] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [186] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(237),
    [anon_sym_PIPE_GT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [187] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_BSLASH] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_for] = ACTIONS(341),
    [anon_sym_while] = ACTIONS(341),
    [anon_sym_repeat] = ACTIONS(341),
    [anon_sym_QMARK] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(341),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(343),
    [sym__number_literal] = ACTIONS(341),
    [anon_sym_SQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym_dots] = ACTIONS(341),
    [sym_dot_dot_i] = ACTIONS(341),
    [sym_return] = ACTIONS(341),
    [sym_next] = ACTIONS(341),
    [sym_break] = ACTIONS(341),
    [sym_true] = ACTIONS(341),
    [sym_false] = ACTIONS(341),
    [sym_null] = ACTIONS(341),
    [sym_inf] = ACTIONS(341),
    [sym_nan] = ACTIONS(341),
    [anon_sym_NA] = ACTIONS(341),
    [anon_sym_NA_integer_] = ACTIONS(341),
    [anon_sym_NA_real_] = ACTIONS(341),
    [anon_sym_NA_complex_] = ACTIONS(341),
    [anon_sym_NA_character_] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__semicolon] = ACTIONS(343),
    [sym__raw_string_literal] = ACTIONS(343),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(343),
    [sym__external_close_brace] = ACTIONS(343),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [188] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(241),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_BSLASH] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_repeat] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(241),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(241),
    [sym__number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(241),
    [sym_dots] = ACTIONS(239),
    [sym_dot_dot_i] = ACTIONS(239),
    [sym_return] = ACTIONS(239),
    [sym_next] = ACTIONS(239),
    [sym_break] = ACTIONS(239),
    [sym_true] = ACTIONS(239),
    [sym_false] = ACTIONS(239),
    [sym_null] = ACTIONS(239),
    [sym_inf] = ACTIONS(239),
    [sym_nan] = ACTIONS(239),
    [anon_sym_NA] = ACTIONS(239),
    [anon_sym_NA_integer_] = ACTIONS(239),
    [anon_sym_NA_real_] = ACTIONS(239),
    [anon_sym_NA_complex_] = ACTIONS(239),
    [anon_sym_NA_character_] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(241),
    [sym__semicolon] = ACTIONS(241),
    [sym__raw_string_literal] = ACTIONS(241),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(241),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [189] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(245),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BSLASH] = ACTIONS(245),
    [anon_sym_function] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(243),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_repeat] = ACTIONS(243),
    [anon_sym_QMARK] = ACTIONS(245),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(245),
    [sym__number_literal] = ACTIONS(243),
    [anon_sym_SQUOTE] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_dots] = ACTIONS(243),
    [sym_dot_dot_i] = ACTIONS(243),
    [sym_return] = ACTIONS(243),
    [sym_next] = ACTIONS(243),
    [sym_break] = ACTIONS(243),
    [sym_true] = ACTIONS(243),
    [sym_false] = ACTIONS(243),
    [sym_null] = ACTIONS(243),
    [sym_inf] = ACTIONS(243),
    [sym_nan] = ACTIONS(243),
    [anon_sym_NA] = ACTIONS(243),
    [anon_sym_NA_integer_] = ACTIONS(243),
    [anon_sym_NA_real_] = ACTIONS(243),
    [anon_sym_NA_complex_] = ACTIONS(243),
    [anon_sym_NA_character_] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(245),
    [sym__semicolon] = ACTIONS(245),
    [sym__raw_string_literal] = ACTIONS(245),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(245),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [190] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [191] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [192] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [193] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BSLASH] = ACTIONS(147),
    [anon_sym_function] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_repeat] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LT_DASH] = ACTIONS(147),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_COLON_EQ] = ACTIONS(147),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [anon_sym_DASH_GT_GT] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(147),
    [anon_sym_PIPE_GT] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(147),
    [sym__number_literal] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_dots] = ACTIONS(149),
    [sym_dot_dot_i] = ACTIONS(149),
    [sym_return] = ACTIONS(149),
    [sym_next] = ACTIONS(149),
    [sym_break] = ACTIONS(149),
    [sym_true] = ACTIONS(149),
    [sym_false] = ACTIONS(149),
    [sym_null] = ACTIONS(149),
    [sym_inf] = ACTIONS(149),
    [sym_nan] = ACTIONS(149),
    [anon_sym_NA] = ACTIONS(149),
    [anon_sym_NA_integer_] = ACTIONS(149),
    [anon_sym_NA_real_] = ACTIONS(149),
    [anon_sym_NA_complex_] = ACTIONS(149),
    [anon_sym_NA_character_] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(147),
    [sym__semicolon] = ACTIONS(147),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(147),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [194] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [195] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [196] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [197] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [198] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [199] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [200] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [201] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [202] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [203] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [204] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [205] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_LT_DASH] = ACTIONS(151),
    [anon_sym_LT_LT_DASH] = ACTIONS(151),
    [anon_sym_COLON_EQ] = ACTIONS(151),
    [anon_sym_DASH_GT] = ACTIONS(153),
    [anon_sym_DASH_GT_GT] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(151),
    [anon_sym_PIPE_GT] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [206] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_BSLASH] = ACTIONS(155),
    [anon_sym_function] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_repeat] = ACTIONS(157),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(155),
    [sym__number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [sym_dots] = ACTIONS(157),
    [sym_dot_dot_i] = ACTIONS(157),
    [sym_return] = ACTIONS(157),
    [sym_next] = ACTIONS(157),
    [sym_break] = ACTIONS(157),
    [sym_true] = ACTIONS(157),
    [sym_false] = ACTIONS(157),
    [sym_null] = ACTIONS(157),
    [sym_inf] = ACTIONS(157),
    [sym_nan] = ACTIONS(157),
    [anon_sym_NA] = ACTIONS(157),
    [anon_sym_NA_integer_] = ACTIONS(157),
    [anon_sym_NA_real_] = ACTIONS(157),
    [anon_sym_NA_complex_] = ACTIONS(157),
    [anon_sym_NA_character_] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(155),
    [sym__semicolon] = ACTIONS(155),
    [sym__raw_string_literal] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(155),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [207] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(159),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(161),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_repeat] = ACTIONS(161),
    [anon_sym_QMARK] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(159),
    [sym__number_literal] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(159),
    [anon_sym_DQUOTE] = ACTIONS(159),
    [sym_dots] = ACTIONS(161),
    [sym_dot_dot_i] = ACTIONS(161),
    [sym_return] = ACTIONS(161),
    [sym_next] = ACTIONS(161),
    [sym_break] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_null] = ACTIONS(161),
    [sym_inf] = ACTIONS(161),
    [sym_nan] = ACTIONS(161),
    [anon_sym_NA] = ACTIONS(161),
    [anon_sym_NA_integer_] = ACTIONS(161),
    [anon_sym_NA_real_] = ACTIONS(161),
    [anon_sym_NA_complex_] = ACTIONS(161),
    [anon_sym_NA_character_] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(159),
    [sym__semicolon] = ACTIONS(159),
    [sym__raw_string_literal] = ACTIONS(159),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(159),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [208] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [209] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [210] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [211] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [212] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [213] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [214] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [215] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [216] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [217] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [218] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [219] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [220] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_LT_DASH] = ACTIONS(163),
    [anon_sym_LT_LT_DASH] = ACTIONS(163),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_DASH_GT_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(163),
    [anon_sym_PIPE_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(163),
    [sym__number_literal] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_dots] = ACTIONS(165),
    [sym_dot_dot_i] = ACTIONS(165),
    [sym_return] = ACTIONS(165),
    [sym_next] = ACTIONS(165),
    [sym_break] = ACTIONS(165),
    [sym_true] = ACTIONS(165),
    [sym_false] = ACTIONS(165),
    [sym_null] = ACTIONS(165),
    [sym_inf] = ACTIONS(165),
    [sym_nan] = ACTIONS(165),
    [anon_sym_NA] = ACTIONS(165),
    [anon_sym_NA_integer_] = ACTIONS(165),
    [anon_sym_NA_real_] = ACTIONS(165),
    [anon_sym_NA_complex_] = ACTIONS(165),
    [anon_sym_NA_character_] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__semicolon] = ACTIONS(163),
    [sym__raw_string_literal] = ACTIONS(163),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(163),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [221] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_BSLASH] = ACTIONS(167),
    [anon_sym_function] = ACTIONS(169),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_repeat] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(167),
    [sym__number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [sym_dots] = ACTIONS(169),
    [sym_dot_dot_i] = ACTIONS(169),
    [sym_return] = ACTIONS(169),
    [sym_next] = ACTIONS(169),
    [sym_break] = ACTIONS(169),
    [sym_true] = ACTIONS(169),
    [sym_false] = ACTIONS(169),
    [sym_null] = ACTIONS(169),
    [sym_inf] = ACTIONS(169),
    [sym_nan] = ACTIONS(169),
    [anon_sym_NA] = ACTIONS(169),
    [anon_sym_NA_integer_] = ACTIONS(169),
    [anon_sym_NA_real_] = ACTIONS(169),
    [anon_sym_NA_complex_] = ACTIONS(169),
    [anon_sym_NA_character_] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(167),
    [sym__semicolon] = ACTIONS(167),
    [sym__raw_string_literal] = ACTIONS(167),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(167),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [222] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_BSLASH] = ACTIONS(171),
    [anon_sym_function] = ACTIONS(173),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(171),
    [sym__number_literal] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_dots] = ACTIONS(173),
    [sym_dot_dot_i] = ACTIONS(173),
    [sym_return] = ACTIONS(173),
    [sym_next] = ACTIONS(173),
    [sym_break] = ACTIONS(173),
    [sym_true] = ACTIONS(173),
    [sym_false] = ACTIONS(173),
    [sym_null] = ACTIONS(173),
    [sym_inf] = ACTIONS(173),
    [sym_nan] = ACTIONS(173),
    [anon_sym_NA] = ACTIONS(173),
    [anon_sym_NA_integer_] = ACTIONS(173),
    [anon_sym_NA_real_] = ACTIONS(173),
    [anon_sym_NA_complex_] = ACTIONS(173),
    [anon_sym_NA_character_] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(171),
    [sym__semicolon] = ACTIONS(171),
    [sym__raw_string_literal] = ACTIONS(171),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(171),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [223] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(175),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(175),
    [anon_sym_function] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_repeat] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(175),
    [sym__number_literal] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [sym_dots] = ACTIONS(177),
    [sym_dot_dot_i] = ACTIONS(177),
    [sym_return] = ACTIONS(177),
    [sym_next] = ACTIONS(177),
    [sym_break] = ACTIONS(177),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [sym_null] = ACTIONS(177),
    [sym_inf] = ACTIONS(177),
    [sym_nan] = ACTIONS(177),
    [anon_sym_NA] = ACTIONS(177),
    [anon_sym_NA_integer_] = ACTIONS(177),
    [anon_sym_NA_real_] = ACTIONS(177),
    [anon_sym_NA_complex_] = ACTIONS(177),
    [anon_sym_NA_character_] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(175),
    [sym__semicolon] = ACTIONS(175),
    [sym__raw_string_literal] = ACTIONS(175),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(175),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [224] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_repeat] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(179),
    [sym__number_literal] = ACTIONS(181),
    [anon_sym_SQUOTE] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_dots] = ACTIONS(181),
    [sym_dot_dot_i] = ACTIONS(181),
    [sym_return] = ACTIONS(181),
    [sym_next] = ACTIONS(181),
    [sym_break] = ACTIONS(181),
    [sym_true] = ACTIONS(181),
    [sym_false] = ACTIONS(181),
    [sym_null] = ACTIONS(181),
    [sym_inf] = ACTIONS(181),
    [sym_nan] = ACTIONS(181),
    [anon_sym_NA] = ACTIONS(181),
    [anon_sym_NA_integer_] = ACTIONS(181),
    [anon_sym_NA_real_] = ACTIONS(181),
    [anon_sym_NA_complex_] = ACTIONS(181),
    [anon_sym_NA_character_] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(179),
    [sym__semicolon] = ACTIONS(179),
    [sym__raw_string_literal] = ACTIONS(179),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(179),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [225] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(183),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(185),
    [anon_sym_repeat] = ACTIONS(185),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(185),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(183),
    [sym__number_literal] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE] = ACTIONS(183),
    [sym_dots] = ACTIONS(185),
    [sym_dot_dot_i] = ACTIONS(185),
    [sym_return] = ACTIONS(185),
    [sym_next] = ACTIONS(185),
    [sym_break] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_inf] = ACTIONS(185),
    [sym_nan] = ACTIONS(185),
    [anon_sym_NA] = ACTIONS(185),
    [anon_sym_NA_integer_] = ACTIONS(185),
    [anon_sym_NA_real_] = ACTIONS(185),
    [anon_sym_NA_complex_] = ACTIONS(185),
    [anon_sym_NA_character_] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(183),
    [sym__semicolon] = ACTIONS(183),
    [sym__raw_string_literal] = ACTIONS(183),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(183),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [226] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_repeat] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(187),
    [sym__number_literal] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_dots] = ACTIONS(189),
    [sym_dot_dot_i] = ACTIONS(189),
    [sym_return] = ACTIONS(189),
    [sym_next] = ACTIONS(189),
    [sym_break] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_inf] = ACTIONS(189),
    [sym_nan] = ACTIONS(189),
    [anon_sym_NA] = ACTIONS(189),
    [anon_sym_NA_integer_] = ACTIONS(189),
    [anon_sym_NA_real_] = ACTIONS(189),
    [anon_sym_NA_complex_] = ACTIONS(189),
    [anon_sym_NA_character_] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(187),
    [sym__semicolon] = ACTIONS(187),
    [sym__raw_string_literal] = ACTIONS(187),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(187),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [227] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(191),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(193),
    [anon_sym_repeat] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(193),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(191),
    [sym__number_literal] = ACTIONS(193),
    [anon_sym_SQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(193),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(193),
    [anon_sym_NA_integer_] = ACTIONS(193),
    [anon_sym_NA_real_] = ACTIONS(193),
    [anon_sym_NA_complex_] = ACTIONS(193),
    [anon_sym_NA_character_] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(191),
    [sym__semicolon] = ACTIONS(191),
    [sym__raw_string_literal] = ACTIONS(191),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(191),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [228] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(195),
    [sym_identifier] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(195),
    [anon_sym_function] = ACTIONS(197),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(197),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(197),
    [anon_sym_repeat] = ACTIONS(197),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(195),
    [sym__number_literal] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(195),
    [sym_dots] = ACTIONS(197),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_return] = ACTIONS(197),
    [sym_next] = ACTIONS(197),
    [sym_break] = ACTIONS(197),
    [sym_true] = ACTIONS(197),
    [sym_false] = ACTIONS(197),
    [sym_null] = ACTIONS(197),
    [sym_inf] = ACTIONS(197),
    [sym_nan] = ACTIONS(197),
    [anon_sym_NA] = ACTIONS(197),
    [anon_sym_NA_integer_] = ACTIONS(197),
    [anon_sym_NA_real_] = ACTIONS(197),
    [anon_sym_NA_complex_] = ACTIONS(197),
    [anon_sym_NA_character_] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(195),
    [sym__semicolon] = ACTIONS(195),
    [sym__raw_string_literal] = ACTIONS(195),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(195),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [229] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(199),
    [sym_identifier] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(199),
    [anon_sym_function] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_while] = ACTIONS(201),
    [anon_sym_repeat] = ACTIONS(201),
    [anon_sym_QMARK] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(199),
    [sym__number_literal] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_dots] = ACTIONS(201),
    [sym_dot_dot_i] = ACTIONS(201),
    [sym_return] = ACTIONS(201),
    [sym_next] = ACTIONS(201),
    [sym_break] = ACTIONS(201),
    [sym_true] = ACTIONS(201),
    [sym_false] = ACTIONS(201),
    [sym_null] = ACTIONS(201),
    [sym_inf] = ACTIONS(201),
    [sym_nan] = ACTIONS(201),
    [anon_sym_NA] = ACTIONS(201),
    [anon_sym_NA_integer_] = ACTIONS(201),
    [anon_sym_NA_real_] = ACTIONS(201),
    [anon_sym_NA_complex_] = ACTIONS(201),
    [anon_sym_NA_character_] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(199),
    [sym__raw_string_literal] = ACTIONS(199),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(199),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [230] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(203),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(203),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(205),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(203),
    [sym__semicolon] = ACTIONS(203),
    [sym__raw_string_literal] = ACTIONS(203),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(203),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [231] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_repeat] = ACTIONS(209),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_dots] = ACTIONS(209),
    [sym_dot_dot_i] = ACTIONS(209),
    [sym_return] = ACTIONS(209),
    [sym_next] = ACTIONS(209),
    [sym_break] = ACTIONS(209),
    [sym_true] = ACTIONS(209),
    [sym_false] = ACTIONS(209),
    [sym_null] = ACTIONS(209),
    [sym_inf] = ACTIONS(209),
    [sym_nan] = ACTIONS(209),
    [anon_sym_NA] = ACTIONS(209),
    [anon_sym_NA_integer_] = ACTIONS(209),
    [anon_sym_NA_real_] = ACTIONS(209),
    [anon_sym_NA_complex_] = ACTIONS(209),
    [anon_sym_NA_character_] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [232] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(211),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_repeat] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(211),
    [sym__number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_dots] = ACTIONS(213),
    [sym_dot_dot_i] = ACTIONS(213),
    [sym_return] = ACTIONS(213),
    [sym_next] = ACTIONS(213),
    [sym_break] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_inf] = ACTIONS(213),
    [sym_nan] = ACTIONS(213),
    [anon_sym_NA] = ACTIONS(213),
    [anon_sym_NA_integer_] = ACTIONS(213),
    [anon_sym_NA_real_] = ACTIONS(213),
    [anon_sym_NA_complex_] = ACTIONS(213),
    [anon_sym_NA_character_] = ACTIONS(213),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(211),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [233] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(215),
    [sym_identifier] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(215),
    [anon_sym_function] = ACTIONS(217),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(217),
    [anon_sym_for] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(217),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(215),
    [sym__number_literal] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [sym_dots] = ACTIONS(217),
    [sym_dot_dot_i] = ACTIONS(217),
    [sym_return] = ACTIONS(217),
    [sym_next] = ACTIONS(217),
    [sym_break] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_inf] = ACTIONS(217),
    [sym_nan] = ACTIONS(217),
    [anon_sym_NA] = ACTIONS(217),
    [anon_sym_NA_integer_] = ACTIONS(217),
    [anon_sym_NA_real_] = ACTIONS(217),
    [anon_sym_NA_complex_] = ACTIONS(217),
    [anon_sym_NA_character_] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(215),
    [sym__semicolon] = ACTIONS(215),
    [sym__raw_string_literal] = ACTIONS(215),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(215),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [234] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(219),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(219),
    [anon_sym_function] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(221),
    [anon_sym_while] = ACTIONS(221),
    [anon_sym_repeat] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(219),
    [sym__number_literal] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(221),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(221),
    [anon_sym_NA_integer_] = ACTIONS(221),
    [anon_sym_NA_real_] = ACTIONS(221),
    [anon_sym_NA_complex_] = ACTIONS(221),
    [anon_sym_NA_character_] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(219),
    [sym__semicolon] = ACTIONS(219),
    [sym__raw_string_literal] = ACTIONS(219),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(219),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [235] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(145),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_BSLASH] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(143),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(143),
    [anon_sym_repeat] = ACTIONS(143),
    [anon_sym_QMARK] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(145),
    [sym__number_literal] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_dots] = ACTIONS(143),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_return] = ACTIONS(143),
    [sym_next] = ACTIONS(143),
    [sym_break] = ACTIONS(143),
    [sym_true] = ACTIONS(143),
    [sym_false] = ACTIONS(143),
    [sym_null] = ACTIONS(143),
    [sym_inf] = ACTIONS(143),
    [sym_nan] = ACTIONS(143),
    [anon_sym_NA] = ACTIONS(143),
    [anon_sym_NA_integer_] = ACTIONS(143),
    [anon_sym_NA_real_] = ACTIONS(143),
    [anon_sym_NA_complex_] = ACTIONS(143),
    [anon_sym_NA_character_] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(145),
    [sym__raw_string_literal] = ACTIONS(145),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(145),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [236] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_repeat] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(223),
    [sym__number_literal] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_dots] = ACTIONS(225),
    [sym_dot_dot_i] = ACTIONS(225),
    [sym_return] = ACTIONS(225),
    [sym_next] = ACTIONS(225),
    [sym_break] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_null] = ACTIONS(225),
    [sym_inf] = ACTIONS(225),
    [sym_nan] = ACTIONS(225),
    [anon_sym_NA] = ACTIONS(225),
    [anon_sym_NA_integer_] = ACTIONS(225),
    [anon_sym_NA_real_] = ACTIONS(225),
    [anon_sym_NA_complex_] = ACTIONS(225),
    [anon_sym_NA_character_] = ACTIONS(225),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(223),
    [sym__semicolon] = ACTIONS(223),
    [sym__raw_string_literal] = ACTIONS(223),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(223),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [237] = {
    [sym_call_arguments] = STATE(377),
    [sym_subset_arguments] = STATE(378),
    [sym_subset2_arguments] = STATE(384),
    [sym__open_parenthesis] = STATE(264),
    [sym__open_bracket] = STATE(253),
    [sym__open_bracket2] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_repeat] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_COLON_EQ] = ACTIONS(323),
    [anon_sym_DASH_GT] = ACTIONS(325),
    [anon_sym_DASH_GT_GT] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LT_EQ] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_GT_EQ] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_STAR_STAR] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(255),
    [aux_sym_binary_operator_token1] = ACTIONS(257),
    [anon_sym_PIPE_GT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [sym__hex_literal] = ACTIONS(227),
    [sym__number_literal] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [sym_dots] = ACTIONS(229),
    [sym_dot_dot_i] = ACTIONS(229),
    [sym_return] = ACTIONS(229),
    [sym_next] = ACTIONS(229),
    [sym_break] = ACTIONS(229),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [sym_null] = ACTIONS(229),
    [sym_inf] = ACTIONS(229),
    [sym_nan] = ACTIONS(229),
    [anon_sym_NA] = ACTIONS(229),
    [anon_sym_NA_integer_] = ACTIONS(229),
    [anon_sym_NA_real_] = ACTIONS(229),
    [anon_sym_NA_complex_] = ACTIONS(229),
    [anon_sym_NA_character_] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(227),
    [sym__semicolon] = ACTIONS(227),
    [sym__raw_string_literal] = ACTIONS(227),
    [sym__external_open_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(227),
    [sym__external_open_bracket] = ACTIONS(265),
    [sym__external_open_bracket2] = ACTIONS(267),
  },
  [238] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BSLASH] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(231),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_repeat] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(233),
    [sym__number_literal] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_dots] = ACTIONS(231),
    [sym_dot_dot_i] = ACTIONS(231),
    [sym_return] = ACTIONS(231),
    [sym_next] = ACTIONS(231),
    [sym_break] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_inf] = ACTIONS(231),
    [sym_nan] = ACTIONS(231),
    [anon_sym_NA] = ACTIONS(231),
    [anon_sym_NA_integer_] = ACTIONS(231),
    [anon_sym_NA_real_] = ACTIONS(231),
    [anon_sym_NA_complex_] = ACTIONS(231),
    [anon_sym_NA_character_] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(233),
    [sym__semicolon] = ACTIONS(233),
    [sym__raw_string_literal] = ACTIONS(233),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(233),
    [sym__external_close_brace] = ACTIONS(233),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [239] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [240] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [241] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [242] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_BSLASH] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_repeat] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_LT_LT_DASH] = ACTIONS(237),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_DASH_GT_GT] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(237),
    [anon_sym_PIPE_GT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(237),
    [sym__number_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_dots] = ACTIONS(235),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_return] = ACTIONS(235),
    [sym_next] = ACTIONS(235),
    [sym_break] = ACTIONS(235),
    [sym_true] = ACTIONS(235),
    [sym_false] = ACTIONS(235),
    [sym_null] = ACTIONS(235),
    [sym_inf] = ACTIONS(235),
    [sym_nan] = ACTIONS(235),
    [anon_sym_NA] = ACTIONS(235),
    [anon_sym_NA_integer_] = ACTIONS(235),
    [anon_sym_NA_real_] = ACTIONS(235),
    [anon_sym_NA_complex_] = ACTIONS(235),
    [anon_sym_NA_character_] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(237),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(237),
    [sym__external_close_brace] = ACTIONS(237),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [243] = {
    [sym_call_arguments] = STATE(413),
    [sym_subset_arguments] = STATE(427),
    [sym_subset2_arguments] = STATE(415),
    [sym__open_parenthesis] = STATE(260),
    [sym__open_bracket] = STATE(261),
    [sym__open_bracket2] = STATE(262),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(279),
    [anon_sym_DASH_GT_GT] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_SLASH] = ACTIONS(297),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [aux_sym_binary_operator_token1] = ACTIONS(301),
    [anon_sym_PIPE_GT] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(305),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(153),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_open_parenthesis] = ACTIONS(307),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(309),
    [sym__external_open_bracket2] = ACTIONS(311),
  },
  [244] = {
    [sym_string] = STATE(373),
    [sym__single_quoted_string] = STATE(288),
    [sym__double_quoted_string] = STATE(289),
    [aux_sym_function_definition_repeat1] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(347),
    [sym_identifier] = ACTIONS(349),
    [anon_sym_BSLASH] = ACTIONS(347),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(351),
    [anon_sym_for] = ACTIONS(351),
    [anon_sym_while] = ACTIONS(351),
    [anon_sym_repeat] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_LT_DASH] = ACTIONS(347),
    [anon_sym_LT_LT_DASH] = ACTIONS(347),
    [anon_sym_COLON_EQ] = ACTIONS(347),
    [anon_sym_DASH_GT] = ACTIONS(351),
    [anon_sym_DASH_GT_GT] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(347),
    [anon_sym_AMP_AMP] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_LT_EQ] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_EQ] = ACTIONS(347),
    [anon_sym_EQ_EQ] = ACTIONS(347),
    [anon_sym_BANG_EQ] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [aux_sym_binary_operator_token1] = ACTIONS(347),
    [anon_sym_PIPE_GT] = ACTIONS(347),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_DOLLAR] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [sym__hex_literal] = ACTIONS(347),
    [sym__number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [sym_dots] = ACTIONS(349),
    [sym_dot_dot_i] = ACTIONS(349),
    [sym_return] = ACTIONS(351),
    [sym_next] = ACTIONS(351),
    [sym_break] = ACTIONS(351),
    [sym_true] = ACTIONS(351),
    [sym_false] = ACTIONS(351),
    [sym_null] = ACTIONS(351),
    [sym_inf] = ACTIONS(351),
    [sym_nan] = ACTIONS(351),
    [anon_sym_NA] = ACTIONS(351),
    [anon_sym_NA_integer_] = ACTIONS(351),
    [anon_sym_NA_real_] = ACTIONS(351),
    [anon_sym_NA_complex_] = ACTIONS(351),
    [anon_sym_NA_character_] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__semicolon] = ACTIONS(347),
    [sym__raw_string_literal] = ACTIONS(357),
    [sym__external_else] = ACTIONS(347),
    [sym__external_open_parenthesis] = ACTIONS(347),
    [sym__external_open_brace] = ACTIONS(347),
    [sym__external_open_bracket] = ACTIONS(347),
    [sym__external_open_bracket2] = ACTIONS(347),
  },
  [245] = {
    [sym_string] = STATE(341),
    [sym__single_quoted_string] = STATE(292),
    [sym__double_quoted_string] = STATE(293),
    [aux_sym_function_definition_repeat1] = STATE(318),
    [sym_identifier] = ACTIONS(359),
    [anon_sym_BSLASH] = ACTIONS(347),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(351),
    [anon_sym_for] = ACTIONS(351),
    [anon_sym_while] = ACTIONS(351),
    [anon_sym_repeat] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_LT_DASH] = ACTIONS(347),
    [anon_sym_LT_LT_DASH] = ACTIONS(347),
    [anon_sym_COLON_EQ] = ACTIONS(347),
    [anon_sym_DASH_GT] = ACTIONS(351),
    [anon_sym_DASH_GT_GT] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(347),
    [anon_sym_AMP_AMP] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_LT_EQ] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_EQ] = ACTIONS(347),
    [anon_sym_EQ_EQ] = ACTIONS(347),
    [anon_sym_BANG_EQ] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [aux_sym_binary_operator_token1] = ACTIONS(347),
    [anon_sym_PIPE_GT] = ACTIONS(347),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_DOLLAR] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [sym__hex_literal] = ACTIONS(347),
    [sym__number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [sym_dots] = ACTIONS(359),
    [sym_dot_dot_i] = ACTIONS(359),
    [sym_return] = ACTIONS(351),
    [sym_next] = ACTIONS(351),
    [sym_break] = ACTIONS(351),
    [sym_true] = ACTIONS(351),
    [sym_false] = ACTIONS(351),
    [sym_null] = ACTIONS(351),
    [sym_inf] = ACTIONS(351),
    [sym_nan] = ACTIONS(351),
    [anon_sym_NA] = ACTIONS(351),
    [anon_sym_NA_integer_] = ACTIONS(351),
    [anon_sym_NA_real_] = ACTIONS(351),
    [anon_sym_NA_complex_] = ACTIONS(351),
    [anon_sym_NA_character_] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__semicolon] = ACTIONS(347),
    [sym__raw_string_literal] = ACTIONS(365),
    [sym__external_else] = ACTIONS(347),
    [sym__external_open_parenthesis] = ACTIONS(347),
    [sym__external_open_brace] = ACTIONS(347),
    [sym__external_close_brace] = ACTIONS(347),
    [sym__external_open_bracket] = ACTIONS(347),
    [sym__external_open_bracket2] = ACTIONS(347),
  },
  [246] = {
    [sym_string] = STATE(371),
    [sym__single_quoted_string] = STATE(292),
    [sym__double_quoted_string] = STATE(293),
    [aux_sym_function_definition_repeat1] = STATE(245),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_repeat] = ACTIONS(371),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(369),
    [anon_sym_BANG] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(369),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(367),
    [sym_return] = ACTIONS(371),
    [sym_next] = ACTIONS(371),
    [sym_break] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_inf] = ACTIONS(371),
    [sym_nan] = ACTIONS(371),
    [anon_sym_NA] = ACTIONS(371),
    [anon_sym_NA_integer_] = ACTIONS(371),
    [anon_sym_NA_real_] = ACTIONS(371),
    [anon_sym_NA_complex_] = ACTIONS(371),
    [anon_sym_NA_character_] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(373),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(365),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [247] = {
    [sym_string] = STATE(363),
    [sym__single_quoted_string] = STATE(288),
    [sym__double_quoted_string] = STATE(289),
    [aux_sym_function_definition_repeat1] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_repeat] = ACTIONS(371),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(369),
    [anon_sym_BANG] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(369),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [sym_dots] = ACTIONS(375),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_return] = ACTIONS(371),
    [sym_next] = ACTIONS(371),
    [sym_break] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_inf] = ACTIONS(371),
    [sym_nan] = ACTIONS(371),
    [anon_sym_NA] = ACTIONS(371),
    [anon_sym_NA_integer_] = ACTIONS(371),
    [anon_sym_NA_real_] = ACTIONS(371),
    [anon_sym_NA_complex_] = ACTIONS(371),
    [anon_sym_NA_character_] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(377),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(357),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [248] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1839),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1751),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1840),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(421),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [249] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1939),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1679),
    [aux_sym_call_arguments_repeat1] = STATE(1850),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(469),
  },
  [250] = {
    [sym_string] = STATE(435),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [aux_sym_function_definition_repeat1] = STATE(334),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_BSLASH] = ACTIONS(347),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(351),
    [anon_sym_for] = ACTIONS(351),
    [anon_sym_while] = ACTIONS(351),
    [anon_sym_repeat] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_LT_DASH] = ACTIONS(347),
    [anon_sym_LT_LT_DASH] = ACTIONS(347),
    [anon_sym_COLON_EQ] = ACTIONS(347),
    [anon_sym_DASH_GT] = ACTIONS(351),
    [anon_sym_DASH_GT_GT] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(347),
    [anon_sym_AMP_AMP] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_LT_EQ] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_EQ] = ACTIONS(347),
    [anon_sym_EQ_EQ] = ACTIONS(347),
    [anon_sym_BANG_EQ] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [aux_sym_binary_operator_token1] = ACTIONS(347),
    [anon_sym_PIPE_GT] = ACTIONS(347),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_DOLLAR] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [sym__hex_literal] = ACTIONS(347),
    [sym__number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(471),
    [sym_dot_dot_i] = ACTIONS(471),
    [sym_return] = ACTIONS(351),
    [sym_next] = ACTIONS(351),
    [sym_break] = ACTIONS(351),
    [sym_true] = ACTIONS(351),
    [sym_false] = ACTIONS(351),
    [sym_null] = ACTIONS(351),
    [sym_inf] = ACTIONS(351),
    [sym_nan] = ACTIONS(351),
    [anon_sym_NA] = ACTIONS(351),
    [anon_sym_NA_integer_] = ACTIONS(351),
    [anon_sym_NA_real_] = ACTIONS(351),
    [anon_sym_NA_complex_] = ACTIONS(351),
    [anon_sym_NA_character_] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__semicolon] = ACTIONS(347),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(347),
    [sym__external_open_brace] = ACTIONS(347),
    [sym__external_close_brace] = ACTIONS(347),
    [sym__external_open_bracket] = ACTIONS(347),
    [sym__external_open_bracket2] = ACTIONS(347),
  },
  [251] = {
    [sym_string] = STATE(420),
    [sym__single_quoted_string] = STATE(308),
    [sym__double_quoted_string] = STATE(309),
    [aux_sym_function_definition_repeat1] = STATE(354),
    [ts_builtin_sym_end] = ACTIONS(347),
    [sym_identifier] = ACTIONS(479),
    [anon_sym_BSLASH] = ACTIONS(347),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(351),
    [anon_sym_for] = ACTIONS(351),
    [anon_sym_while] = ACTIONS(351),
    [anon_sym_repeat] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_LT_DASH] = ACTIONS(347),
    [anon_sym_LT_LT_DASH] = ACTIONS(347),
    [anon_sym_COLON_EQ] = ACTIONS(347),
    [anon_sym_DASH_GT] = ACTIONS(351),
    [anon_sym_DASH_GT_GT] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(347),
    [anon_sym_AMP_AMP] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_LT_EQ] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_EQ] = ACTIONS(347),
    [anon_sym_EQ_EQ] = ACTIONS(347),
    [anon_sym_BANG_EQ] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [aux_sym_binary_operator_token1] = ACTIONS(347),
    [anon_sym_PIPE_GT] = ACTIONS(347),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_DOLLAR] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [sym__hex_literal] = ACTIONS(347),
    [sym__number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(481),
    [anon_sym_DQUOTE] = ACTIONS(483),
    [sym_dots] = ACTIONS(479),
    [sym_dot_dot_i] = ACTIONS(479),
    [sym_return] = ACTIONS(351),
    [sym_next] = ACTIONS(351),
    [sym_break] = ACTIONS(351),
    [sym_true] = ACTIONS(351),
    [sym_false] = ACTIONS(351),
    [sym_null] = ACTIONS(351),
    [sym_inf] = ACTIONS(351),
    [sym_nan] = ACTIONS(351),
    [anon_sym_NA] = ACTIONS(351),
    [anon_sym_NA_integer_] = ACTIONS(351),
    [anon_sym_NA_real_] = ACTIONS(351),
    [anon_sym_NA_complex_] = ACTIONS(351),
    [anon_sym_NA_character_] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__semicolon] = ACTIONS(347),
    [sym__raw_string_literal] = ACTIONS(485),
    [sym__external_open_parenthesis] = ACTIONS(347),
    [sym__external_open_brace] = ACTIONS(347),
    [sym__external_open_bracket] = ACTIONS(347),
    [sym__external_open_bracket2] = ACTIONS(347),
  },
  [252] = {
    [sym_string] = STATE(361),
    [sym__single_quoted_string] = STATE(292),
    [sym__double_quoted_string] = STATE(293),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(491),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_LT_DASH] = ACTIONS(489),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_COLON_EQ] = ACTIONS(489),
    [anon_sym_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_GT] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(489),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_GT_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_STAR_STAR] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(489),
    [aux_sym_binary_operator_token1] = ACTIONS(489),
    [anon_sym_PIPE_GT] = ACTIONS(489),
    [anon_sym_COLON] = ACTIONS(491),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(489),
    [sym__number_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [sym_dots] = ACTIONS(487),
    [sym_dot_dot_i] = ACTIONS(487),
    [sym_return] = ACTIONS(491),
    [sym_next] = ACTIONS(491),
    [sym_break] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_null] = ACTIONS(491),
    [sym_inf] = ACTIONS(491),
    [sym_nan] = ACTIONS(491),
    [anon_sym_NA] = ACTIONS(491),
    [anon_sym_NA_integer_] = ACTIONS(491),
    [anon_sym_NA_real_] = ACTIONS(491),
    [anon_sym_NA_complex_] = ACTIONS(491),
    [anon_sym_NA_character_] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(489),
    [sym__semicolon] = ACTIONS(489),
    [sym__raw_string_literal] = ACTIONS(365),
    [sym__external_else] = ACTIONS(489),
    [sym__external_open_parenthesis] = ACTIONS(489),
    [sym__external_open_brace] = ACTIONS(489),
    [sym__external_close_brace] = ACTIONS(489),
    [sym__external_open_bracket] = ACTIONS(489),
    [sym__external_open_bracket2] = ACTIONS(489),
  },
  [253] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1846),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(443),
    [aux_sym_call_arguments_repeat1] = STATE(1964),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(537),
  },
  [254] = {
    [sym_string] = STATE(340),
    [sym__single_quoted_string] = STATE(288),
    [sym__double_quoted_string] = STATE(289),
    [ts_builtin_sym_end] = ACTIONS(489),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(491),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_LT_DASH] = ACTIONS(489),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_COLON_EQ] = ACTIONS(489),
    [anon_sym_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_GT] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(489),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_GT_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_STAR_STAR] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(489),
    [aux_sym_binary_operator_token1] = ACTIONS(489),
    [anon_sym_PIPE_GT] = ACTIONS(489),
    [anon_sym_COLON] = ACTIONS(491),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(489),
    [sym__number_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [sym_dots] = ACTIONS(539),
    [sym_dot_dot_i] = ACTIONS(539),
    [sym_return] = ACTIONS(491),
    [sym_next] = ACTIONS(491),
    [sym_break] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_null] = ACTIONS(491),
    [sym_inf] = ACTIONS(491),
    [sym_nan] = ACTIONS(491),
    [anon_sym_NA] = ACTIONS(491),
    [anon_sym_NA_integer_] = ACTIONS(491),
    [anon_sym_NA_real_] = ACTIONS(491),
    [anon_sym_NA_complex_] = ACTIONS(491),
    [anon_sym_NA_character_] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(489),
    [sym__semicolon] = ACTIONS(489),
    [sym__raw_string_literal] = ACTIONS(357),
    [sym__external_else] = ACTIONS(489),
    [sym__external_open_parenthesis] = ACTIONS(489),
    [sym__external_open_brace] = ACTIONS(489),
    [sym__external_open_bracket] = ACTIONS(489),
    [sym__external_open_bracket2] = ACTIONS(489),
  },
  [255] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1902),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1713),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1908),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(541),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [256] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1810),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1714),
    [aux_sym_call_arguments_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(543),
  },
  [257] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1830),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1734),
    [aux_sym_call_arguments_repeat1] = STATE(1808),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [258] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1819),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(387),
    [aux_sym_call_arguments_repeat1] = STATE(1857),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(547),
  },
  [259] = {
    [sym_string] = STATE(405),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [aux_sym_function_definition_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_repeat] = ACTIONS(371),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(369),
    [anon_sym_BANG] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(369),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(549),
    [sym_dot_dot_i] = ACTIONS(549),
    [sym_return] = ACTIONS(371),
    [sym_next] = ACTIONS(371),
    [sym_break] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_inf] = ACTIONS(371),
    [sym_nan] = ACTIONS(371),
    [anon_sym_NA] = ACTIONS(371),
    [anon_sym_NA_integer_] = ACTIONS(371),
    [anon_sym_NA_real_] = ACTIONS(371),
    [anon_sym_NA_complex_] = ACTIONS(371),
    [anon_sym_NA_character_] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(551),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [260] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1906),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(423),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1921),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(553),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [261] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1899),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(424),
    [aux_sym_call_arguments_repeat1] = STATE(1866),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(555),
  },
  [262] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1867),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(429),
    [aux_sym_call_arguments_repeat1] = STATE(1896),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(557),
  },
  [263] = {
    [sym_string] = STATE(401),
    [sym__single_quoted_string] = STATE(308),
    [sym__double_quoted_string] = STATE(309),
    [aux_sym_function_definition_repeat1] = STATE(251),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(559),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_repeat] = ACTIONS(371),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(369),
    [anon_sym_BANG] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(369),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(481),
    [anon_sym_DQUOTE] = ACTIONS(483),
    [sym_dots] = ACTIONS(559),
    [sym_dot_dot_i] = ACTIONS(559),
    [sym_return] = ACTIONS(371),
    [sym_next] = ACTIONS(371),
    [sym_break] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_inf] = ACTIONS(371),
    [sym_nan] = ACTIONS(371),
    [anon_sym_NA] = ACTIONS(371),
    [anon_sym_NA_integer_] = ACTIONS(371),
    [anon_sym_NA_real_] = ACTIONS(371),
    [anon_sym_NA_complex_] = ACTIONS(371),
    [anon_sym_NA_character_] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(561),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(485),
    [sym__external_open_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [264] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1895),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(442),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1834),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(563),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [265] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1892),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1733),
    [aux_sym_call_arguments_repeat1] = STATE(1820),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(565),
  },
  [266] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1886),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1768),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1887),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(567),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [267] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1909),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1769),
    [aux_sym_call_arguments_repeat1] = STATE(1922),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(569),
  },
  [268] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1925),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1773),
    [aux_sym_call_arguments_repeat1] = STATE(1943),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(571),
  },
  [269] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1941),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(365),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1945),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(573),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [270] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(366),
    [aux_sym_call_arguments_repeat1] = STATE(1953),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(575),
  },
  [271] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1828),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(367),
    [aux_sym_call_arguments_repeat1] = STATE(1831),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(577),
  },
  [272] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1822),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1639),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1823),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(579),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [273] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1871),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1640),
    [aux_sym_call_arguments_repeat1] = STATE(1809),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(581),
  },
  [274] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1884),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1685),
    [aux_sym_call_arguments_repeat1] = STATE(1849),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(583),
  },
  [275] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1842),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(328),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1843),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [276] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1915),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(329),
    [aux_sym_call_arguments_repeat1] = STATE(1917),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(587),
  },
  [277] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1918),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(330),
    [aux_sym_call_arguments_repeat1] = STATE(1920),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(589),
  },
  [278] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1861),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1704),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1862),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [279] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1901),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1705),
    [aux_sym_call_arguments_repeat1] = STATE(1914),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(593),
  },
  [280] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym__close_bracket2] = STATE(1706),
    [aux_sym_call_arguments_repeat1] = STATE(1919),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(595),
  },
  [281] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(1807),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__close_parenthesis] = STATE(1642),
    [sym__open_brace] = STATE(402),
    [aux_sym_call_arguments_repeat1] = STATE(1879),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(597),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [282] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1923),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1673),
    [aux_sym_call_arguments_repeat1] = STATE(1935),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(599),
  },
  [283] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(1853),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym__close_bracket] = STATE(1721),
    [aux_sym_call_arguments_repeat1] = STATE(1854),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(601),
  },
  [284] = {
    [sym_identifier] = ACTIONS(603),
    [anon_sym_BSLASH] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_if] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(603),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_LT_DASH] = ACTIONS(605),
    [anon_sym_LT_LT_DASH] = ACTIONS(605),
    [anon_sym_COLON_EQ] = ACTIONS(605),
    [anon_sym_DASH_GT] = ACTIONS(603),
    [anon_sym_DASH_GT_GT] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_AMP] = ACTIONS(603),
    [anon_sym_PIPE_PIPE] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(603),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_EQ] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_STAR_STAR] = ACTIONS(605),
    [anon_sym_CARET] = ACTIONS(605),
    [aux_sym_binary_operator_token1] = ACTIONS(605),
    [anon_sym_PIPE_GT] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(605),
    [sym__hex_literal] = ACTIONS(605),
    [sym__number_literal] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [sym_dots] = ACTIONS(603),
    [sym_dot_dot_i] = ACTIONS(603),
    [sym_return] = ACTIONS(603),
    [sym_next] = ACTIONS(603),
    [sym_break] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(603),
    [sym_inf] = ACTIONS(603),
    [sym_nan] = ACTIONS(603),
    [anon_sym_NA] = ACTIONS(603),
    [anon_sym_NA_integer_] = ACTIONS(603),
    [anon_sym_NA_real_] = ACTIONS(603),
    [anon_sym_NA_complex_] = ACTIONS(603),
    [anon_sym_NA_character_] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(605),
    [sym__semicolon] = ACTIONS(605),
    [sym__raw_string_literal] = ACTIONS(605),
    [sym__external_else] = ACTIONS(605),
    [sym__external_open_parenthesis] = ACTIONS(605),
    [sym__external_open_brace] = ACTIONS(605),
    [sym__external_close_brace] = ACTIONS(605),
    [sym__external_open_bracket] = ACTIONS(605),
    [sym__external_open_bracket2] = ACTIONS(605),
  },
  [285] = {
    [ts_builtin_sym_end] = ACTIONS(605),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_BSLASH] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_if] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(603),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_LT_DASH] = ACTIONS(605),
    [anon_sym_LT_LT_DASH] = ACTIONS(605),
    [anon_sym_COLON_EQ] = ACTIONS(605),
    [anon_sym_DASH_GT] = ACTIONS(603),
    [anon_sym_DASH_GT_GT] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_AMP] = ACTIONS(603),
    [anon_sym_PIPE_PIPE] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(603),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_EQ] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_STAR_STAR] = ACTIONS(605),
    [anon_sym_CARET] = ACTIONS(605),
    [aux_sym_binary_operator_token1] = ACTIONS(605),
    [anon_sym_PIPE_GT] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(605),
    [sym__hex_literal] = ACTIONS(605),
    [sym__number_literal] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [sym_dots] = ACTIONS(603),
    [sym_dot_dot_i] = ACTIONS(603),
    [sym_return] = ACTIONS(603),
    [sym_next] = ACTIONS(603),
    [sym_break] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(603),
    [sym_inf] = ACTIONS(603),
    [sym_nan] = ACTIONS(603),
    [anon_sym_NA] = ACTIONS(603),
    [anon_sym_NA_integer_] = ACTIONS(603),
    [anon_sym_NA_real_] = ACTIONS(603),
    [anon_sym_NA_complex_] = ACTIONS(603),
    [anon_sym_NA_character_] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(605),
    [sym__semicolon] = ACTIONS(605),
    [sym__raw_string_literal] = ACTIONS(605),
    [sym__external_else] = ACTIONS(605),
    [sym__external_open_parenthesis] = ACTIONS(605),
    [sym__external_open_brace] = ACTIONS(605),
    [sym__external_open_bracket] = ACTIONS(605),
    [sym__external_open_bracket2] = ACTIONS(605),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_identifier] = ACTIONS(609),
    [anon_sym_BSLASH] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_while] = ACTIONS(609),
    [anon_sym_repeat] = ACTIONS(609),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_LT_DASH] = ACTIONS(607),
    [anon_sym_LT_LT_DASH] = ACTIONS(607),
    [anon_sym_COLON_EQ] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(609),
    [anon_sym_DASH_GT_GT] = ACTIONS(607),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(607),
    [anon_sym_AMP_AMP] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(607),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(607),
    [anon_sym_EQ_EQ] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(609),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_CARET] = ACTIONS(607),
    [aux_sym_binary_operator_token1] = ACTIONS(607),
    [anon_sym_PIPE_GT] = ACTIONS(607),
    [anon_sym_COLON] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_COLON_COLON] = ACTIONS(611),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(613),
    [sym__hex_literal] = ACTIONS(607),
    [sym__number_literal] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [sym_dots] = ACTIONS(609),
    [sym_dot_dot_i] = ACTIONS(609),
    [sym_return] = ACTIONS(609),
    [sym_next] = ACTIONS(609),
    [sym_break] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_inf] = ACTIONS(609),
    [sym_nan] = ACTIONS(609),
    [anon_sym_NA] = ACTIONS(609),
    [anon_sym_NA_integer_] = ACTIONS(609),
    [anon_sym_NA_real_] = ACTIONS(609),
    [anon_sym_NA_complex_] = ACTIONS(609),
    [anon_sym_NA_character_] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(607),
    [sym__semicolon] = ACTIONS(607),
    [sym__raw_string_literal] = ACTIONS(607),
    [sym__external_else] = ACTIONS(607),
    [sym__external_open_parenthesis] = ACTIONS(607),
    [sym__external_open_brace] = ACTIONS(607),
    [sym__external_open_bracket] = ACTIONS(607),
    [sym__external_open_bracket2] = ACTIONS(607),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_identifier] = ACTIONS(617),
    [anon_sym_BSLASH] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_while] = ACTIONS(617),
    [anon_sym_repeat] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_LT_DASH] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(615),
    [anon_sym_COLON_EQ] = ACTIONS(615),
    [anon_sym_DASH_GT] = ACTIONS(617),
    [anon_sym_DASH_GT_GT] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [anon_sym_STAR] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_STAR_STAR] = ACTIONS(615),
    [anon_sym_CARET] = ACTIONS(615),
    [aux_sym_binary_operator_token1] = ACTIONS(615),
    [anon_sym_PIPE_GT] = ACTIONS(615),
    [anon_sym_COLON] = ACTIONS(617),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(615),
    [anon_sym_L] = ACTIONS(619),
    [anon_sym_i] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(615),
    [sym__number_literal] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [sym_dots] = ACTIONS(617),
    [sym_dot_dot_i] = ACTIONS(617),
    [sym_return] = ACTIONS(617),
    [sym_next] = ACTIONS(617),
    [sym_break] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_null] = ACTIONS(617),
    [sym_inf] = ACTIONS(617),
    [sym_nan] = ACTIONS(617),
    [anon_sym_NA] = ACTIONS(617),
    [anon_sym_NA_integer_] = ACTIONS(617),
    [anon_sym_NA_real_] = ACTIONS(617),
    [anon_sym_NA_complex_] = ACTIONS(617),
    [anon_sym_NA_character_] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(615),
    [sym__semicolon] = ACTIONS(615),
    [sym__raw_string_literal] = ACTIONS(615),
    [sym__external_else] = ACTIONS(615),
    [sym__external_open_parenthesis] = ACTIONS(615),
    [sym__external_open_brace] = ACTIONS(615),
    [sym__external_open_bracket] = ACTIONS(615),
    [sym__external_open_bracket2] = ACTIONS(615),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_else] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_else] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [290] = {
    [sym_identifier] = ACTIONS(609),
    [anon_sym_BSLASH] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_while] = ACTIONS(609),
    [anon_sym_repeat] = ACTIONS(609),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_LT_DASH] = ACTIONS(607),
    [anon_sym_LT_LT_DASH] = ACTIONS(607),
    [anon_sym_COLON_EQ] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(609),
    [anon_sym_DASH_GT_GT] = ACTIONS(607),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(607),
    [anon_sym_AMP_AMP] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(607),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(607),
    [anon_sym_EQ_EQ] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(609),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_CARET] = ACTIONS(607),
    [aux_sym_binary_operator_token1] = ACTIONS(607),
    [anon_sym_PIPE_GT] = ACTIONS(607),
    [anon_sym_COLON] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(629),
    [sym__hex_literal] = ACTIONS(607),
    [sym__number_literal] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [sym_dots] = ACTIONS(609),
    [sym_dot_dot_i] = ACTIONS(609),
    [sym_return] = ACTIONS(609),
    [sym_next] = ACTIONS(609),
    [sym_break] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_inf] = ACTIONS(609),
    [sym_nan] = ACTIONS(609),
    [anon_sym_NA] = ACTIONS(609),
    [anon_sym_NA_integer_] = ACTIONS(609),
    [anon_sym_NA_real_] = ACTIONS(609),
    [anon_sym_NA_complex_] = ACTIONS(609),
    [anon_sym_NA_character_] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(607),
    [sym__semicolon] = ACTIONS(607),
    [sym__raw_string_literal] = ACTIONS(607),
    [sym__external_else] = ACTIONS(607),
    [sym__external_open_parenthesis] = ACTIONS(607),
    [sym__external_open_brace] = ACTIONS(607),
    [sym__external_close_brace] = ACTIONS(607),
    [sym__external_open_bracket] = ACTIONS(607),
    [sym__external_open_bracket2] = ACTIONS(607),
  },
  [291] = {
    [sym_identifier] = ACTIONS(617),
    [anon_sym_BSLASH] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_while] = ACTIONS(617),
    [anon_sym_repeat] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_LT_DASH] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(615),
    [anon_sym_COLON_EQ] = ACTIONS(615),
    [anon_sym_DASH_GT] = ACTIONS(617),
    [anon_sym_DASH_GT_GT] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [anon_sym_STAR] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_STAR_STAR] = ACTIONS(615),
    [anon_sym_CARET] = ACTIONS(615),
    [aux_sym_binary_operator_token1] = ACTIONS(615),
    [anon_sym_PIPE_GT] = ACTIONS(615),
    [anon_sym_COLON] = ACTIONS(617),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(615),
    [anon_sym_L] = ACTIONS(631),
    [anon_sym_i] = ACTIONS(633),
    [sym__hex_literal] = ACTIONS(615),
    [sym__number_literal] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [sym_dots] = ACTIONS(617),
    [sym_dot_dot_i] = ACTIONS(617),
    [sym_return] = ACTIONS(617),
    [sym_next] = ACTIONS(617),
    [sym_break] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_null] = ACTIONS(617),
    [sym_inf] = ACTIONS(617),
    [sym_nan] = ACTIONS(617),
    [anon_sym_NA] = ACTIONS(617),
    [anon_sym_NA_integer_] = ACTIONS(617),
    [anon_sym_NA_real_] = ACTIONS(617),
    [anon_sym_NA_complex_] = ACTIONS(617),
    [anon_sym_NA_character_] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(615),
    [sym__semicolon] = ACTIONS(615),
    [sym__raw_string_literal] = ACTIONS(615),
    [sym__external_else] = ACTIONS(615),
    [sym__external_open_parenthesis] = ACTIONS(615),
    [sym__external_open_brace] = ACTIONS(615),
    [sym__external_close_brace] = ACTIONS(615),
    [sym__external_open_bracket] = ACTIONS(615),
    [sym__external_open_bracket2] = ACTIONS(615),
  },
  [292] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_else] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_close_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [293] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_else] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_close_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [294] = {
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(635),
    [anon_sym_while] = ACTIONS(635),
    [anon_sym_repeat] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_LT_DASH] = ACTIONS(637),
    [anon_sym_LT_LT_DASH] = ACTIONS(637),
    [anon_sym_COLON_EQ] = ACTIONS(637),
    [anon_sym_DASH_GT] = ACTIONS(635),
    [anon_sym_DASH_GT_GT] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(637),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_STAR_STAR] = ACTIONS(637),
    [anon_sym_CARET] = ACTIONS(637),
    [aux_sym_binary_operator_token1] = ACTIONS(637),
    [anon_sym_PIPE_GT] = ACTIONS(637),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_COLON_COLON] = ACTIONS(635),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(637),
    [sym__hex_literal] = ACTIONS(637),
    [sym__number_literal] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_dots] = ACTIONS(635),
    [sym_dot_dot_i] = ACTIONS(635),
    [sym_return] = ACTIONS(635),
    [sym_next] = ACTIONS(635),
    [sym_break] = ACTIONS(635),
    [sym_true] = ACTIONS(635),
    [sym_false] = ACTIONS(635),
    [sym_null] = ACTIONS(635),
    [sym_inf] = ACTIONS(635),
    [sym_nan] = ACTIONS(635),
    [anon_sym_NA] = ACTIONS(635),
    [anon_sym_NA_integer_] = ACTIONS(635),
    [anon_sym_NA_real_] = ACTIONS(635),
    [anon_sym_NA_complex_] = ACTIONS(635),
    [anon_sym_NA_character_] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(637),
    [sym__semicolon] = ACTIONS(637),
    [sym__raw_string_literal] = ACTIONS(637),
    [sym__external_else] = ACTIONS(637),
    [sym__external_open_parenthesis] = ACTIONS(637),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_brace] = ACTIONS(637),
    [sym__external_open_bracket] = ACTIONS(637),
    [sym__external_open_bracket2] = ACTIONS(637),
  },
  [295] = {
    [sym_identifier] = ACTIONS(639),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_if] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(639),
    [anon_sym_while] = ACTIONS(639),
    [anon_sym_repeat] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(639),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(639),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_STAR_STAR] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [aux_sym_binary_operator_token1] = ACTIONS(641),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_COLON] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(641),
    [sym__hex_literal] = ACTIONS(641),
    [sym__number_literal] = ACTIONS(639),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [sym_dots] = ACTIONS(639),
    [sym_dot_dot_i] = ACTIONS(639),
    [sym_return] = ACTIONS(639),
    [sym_next] = ACTIONS(639),
    [sym_break] = ACTIONS(639),
    [sym_true] = ACTIONS(639),
    [sym_false] = ACTIONS(639),
    [sym_null] = ACTIONS(639),
    [sym_inf] = ACTIONS(639),
    [sym_nan] = ACTIONS(639),
    [anon_sym_NA] = ACTIONS(639),
    [anon_sym_NA_integer_] = ACTIONS(639),
    [anon_sym_NA_real_] = ACTIONS(639),
    [anon_sym_NA_complex_] = ACTIONS(639),
    [anon_sym_NA_character_] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(641),
    [sym__semicolon] = ACTIONS(641),
    [sym__raw_string_literal] = ACTIONS(641),
    [sym__external_else] = ACTIONS(641),
    [sym__external_open_parenthesis] = ACTIONS(641),
    [sym__external_open_brace] = ACTIONS(641),
    [sym__external_close_brace] = ACTIONS(641),
    [sym__external_open_bracket] = ACTIONS(641),
    [sym__external_open_bracket2] = ACTIONS(641),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(635),
    [anon_sym_while] = ACTIONS(635),
    [anon_sym_repeat] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_LT_DASH] = ACTIONS(637),
    [anon_sym_LT_LT_DASH] = ACTIONS(637),
    [anon_sym_COLON_EQ] = ACTIONS(637),
    [anon_sym_DASH_GT] = ACTIONS(635),
    [anon_sym_DASH_GT_GT] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(637),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_STAR_STAR] = ACTIONS(637),
    [anon_sym_CARET] = ACTIONS(637),
    [aux_sym_binary_operator_token1] = ACTIONS(637),
    [anon_sym_PIPE_GT] = ACTIONS(637),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_COLON_COLON] = ACTIONS(635),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(637),
    [sym__hex_literal] = ACTIONS(637),
    [sym__number_literal] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_dots] = ACTIONS(635),
    [sym_dot_dot_i] = ACTIONS(635),
    [sym_return] = ACTIONS(635),
    [sym_next] = ACTIONS(635),
    [sym_break] = ACTIONS(635),
    [sym_true] = ACTIONS(635),
    [sym_false] = ACTIONS(635),
    [sym_null] = ACTIONS(635),
    [sym_inf] = ACTIONS(635),
    [sym_nan] = ACTIONS(635),
    [anon_sym_NA] = ACTIONS(635),
    [anon_sym_NA_integer_] = ACTIONS(635),
    [anon_sym_NA_real_] = ACTIONS(635),
    [anon_sym_NA_complex_] = ACTIONS(635),
    [anon_sym_NA_character_] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(637),
    [sym__semicolon] = ACTIONS(637),
    [sym__raw_string_literal] = ACTIONS(637),
    [sym__external_else] = ACTIONS(637),
    [sym__external_open_parenthesis] = ACTIONS(637),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_open_bracket] = ACTIONS(637),
    [sym__external_open_bracket2] = ACTIONS(637),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [sym_identifier] = ACTIONS(639),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_if] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(639),
    [anon_sym_while] = ACTIONS(639),
    [anon_sym_repeat] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(639),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(639),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_STAR_STAR] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [aux_sym_binary_operator_token1] = ACTIONS(641),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_COLON] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(641),
    [sym__hex_literal] = ACTIONS(641),
    [sym__number_literal] = ACTIONS(639),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [sym_dots] = ACTIONS(639),
    [sym_dot_dot_i] = ACTIONS(639),
    [sym_return] = ACTIONS(639),
    [sym_next] = ACTIONS(639),
    [sym_break] = ACTIONS(639),
    [sym_true] = ACTIONS(639),
    [sym_false] = ACTIONS(639),
    [sym_null] = ACTIONS(639),
    [sym_inf] = ACTIONS(639),
    [sym_nan] = ACTIONS(639),
    [anon_sym_NA] = ACTIONS(639),
    [anon_sym_NA_integer_] = ACTIONS(639),
    [anon_sym_NA_real_] = ACTIONS(639),
    [anon_sym_NA_complex_] = ACTIONS(639),
    [anon_sym_NA_character_] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(641),
    [sym__semicolon] = ACTIONS(641),
    [sym__raw_string_literal] = ACTIONS(641),
    [sym__external_else] = ACTIONS(641),
    [sym__external_open_parenthesis] = ACTIONS(641),
    [sym__external_open_brace] = ACTIONS(641),
    [sym__external_open_bracket] = ACTIONS(641),
    [sym__external_open_bracket2] = ACTIONS(641),
  },
  [298] = {
    [sym_identifier] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(645),
    [anon_sym_COLON_EQ] = ACTIONS(645),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_CARET] = ACTIONS(645),
    [aux_sym_binary_operator_token1] = ACTIONS(645),
    [anon_sym_PIPE_GT] = ACTIONS(645),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(645),
    [sym__hex_literal] = ACTIONS(645),
    [sym__number_literal] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [sym_dots] = ACTIONS(643),
    [sym_dot_dot_i] = ACTIONS(643),
    [sym_return] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(645),
    [sym__semicolon] = ACTIONS(645),
    [sym__raw_string_literal] = ACTIONS(645),
    [sym__external_else] = ACTIONS(645),
    [sym__external_open_parenthesis] = ACTIONS(645),
    [sym__external_open_brace] = ACTIONS(645),
    [sym__external_close_brace] = ACTIONS(645),
    [sym__external_open_bracket] = ACTIONS(645),
    [sym__external_open_bracket2] = ACTIONS(645),
  },
  [299] = {
    [sym_identifier] = ACTIONS(647),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(647),
    [anon_sym_while] = ACTIONS(647),
    [anon_sym_repeat] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(647),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [aux_sym_binary_operator_token1] = ACTIONS(649),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_COLON] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym__hex_literal] = ACTIONS(649),
    [sym__number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [sym_dots] = ACTIONS(647),
    [sym_dot_dot_i] = ACTIONS(647),
    [sym_return] = ACTIONS(647),
    [sym_next] = ACTIONS(647),
    [sym_break] = ACTIONS(647),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_null] = ACTIONS(647),
    [sym_inf] = ACTIONS(647),
    [sym_nan] = ACTIONS(647),
    [anon_sym_NA] = ACTIONS(647),
    [anon_sym_NA_integer_] = ACTIONS(647),
    [anon_sym_NA_real_] = ACTIONS(647),
    [anon_sym_NA_complex_] = ACTIONS(647),
    [anon_sym_NA_character_] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(649),
    [sym__semicolon] = ACTIONS(649),
    [sym__raw_string_literal] = ACTIONS(649),
    [sym__external_else] = ACTIONS(649),
    [sym__external_open_parenthesis] = ACTIONS(649),
    [sym__external_open_brace] = ACTIONS(649),
    [sym__external_close_brace] = ACTIONS(649),
    [sym__external_open_bracket] = ACTIONS(649),
    [sym__external_open_bracket2] = ACTIONS(649),
  },
  [300] = {
    [sym_string] = STATE(428),
    [sym__single_quoted_string] = STATE(308),
    [sym__double_quoted_string] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(489),
    [sym_identifier] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(491),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_LT_DASH] = ACTIONS(489),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_COLON_EQ] = ACTIONS(489),
    [anon_sym_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_GT] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(489),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_GT_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_STAR_STAR] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(489),
    [aux_sym_binary_operator_token1] = ACTIONS(489),
    [anon_sym_PIPE_GT] = ACTIONS(489),
    [anon_sym_COLON] = ACTIONS(491),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(489),
    [sym__number_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(481),
    [anon_sym_DQUOTE] = ACTIONS(483),
    [sym_dots] = ACTIONS(651),
    [sym_dot_dot_i] = ACTIONS(651),
    [sym_return] = ACTIONS(491),
    [sym_next] = ACTIONS(491),
    [sym_break] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_null] = ACTIONS(491),
    [sym_inf] = ACTIONS(491),
    [sym_nan] = ACTIONS(491),
    [anon_sym_NA] = ACTIONS(491),
    [anon_sym_NA_integer_] = ACTIONS(491),
    [anon_sym_NA_real_] = ACTIONS(491),
    [anon_sym_NA_complex_] = ACTIONS(491),
    [anon_sym_NA_character_] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(489),
    [sym__semicolon] = ACTIONS(489),
    [sym__raw_string_literal] = ACTIONS(485),
    [sym__external_open_parenthesis] = ACTIONS(489),
    [sym__external_open_brace] = ACTIONS(489),
    [sym__external_open_bracket] = ACTIONS(489),
    [sym__external_open_bracket2] = ACTIONS(489),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(645),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(645),
    [anon_sym_COLON_EQ] = ACTIONS(645),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_CARET] = ACTIONS(645),
    [aux_sym_binary_operator_token1] = ACTIONS(645),
    [anon_sym_PIPE_GT] = ACTIONS(645),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(645),
    [sym__hex_literal] = ACTIONS(645),
    [sym__number_literal] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [sym_dots] = ACTIONS(643),
    [sym_dot_dot_i] = ACTIONS(643),
    [sym_return] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(645),
    [sym__semicolon] = ACTIONS(645),
    [sym__raw_string_literal] = ACTIONS(645),
    [sym__external_else] = ACTIONS(645),
    [sym__external_open_parenthesis] = ACTIONS(645),
    [sym__external_open_brace] = ACTIONS(645),
    [sym__external_open_bracket] = ACTIONS(645),
    [sym__external_open_bracket2] = ACTIONS(645),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(647),
    [anon_sym_while] = ACTIONS(647),
    [anon_sym_repeat] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(647),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [aux_sym_binary_operator_token1] = ACTIONS(649),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_COLON] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym__hex_literal] = ACTIONS(649),
    [sym__number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [sym_dots] = ACTIONS(647),
    [sym_dot_dot_i] = ACTIONS(647),
    [sym_return] = ACTIONS(647),
    [sym_next] = ACTIONS(647),
    [sym_break] = ACTIONS(647),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_null] = ACTIONS(647),
    [sym_inf] = ACTIONS(647),
    [sym_nan] = ACTIONS(647),
    [anon_sym_NA] = ACTIONS(647),
    [anon_sym_NA_integer_] = ACTIONS(647),
    [anon_sym_NA_real_] = ACTIONS(647),
    [anon_sym_NA_complex_] = ACTIONS(647),
    [anon_sym_NA_character_] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(649),
    [sym__semicolon] = ACTIONS(649),
    [sym__raw_string_literal] = ACTIONS(649),
    [sym__external_else] = ACTIONS(649),
    [sym__external_open_parenthesis] = ACTIONS(649),
    [sym__external_open_brace] = ACTIONS(649),
    [sym__external_open_bracket] = ACTIONS(649),
    [sym__external_open_bracket2] = ACTIONS(649),
  },
  [303] = {
    [sym_string] = STATE(406),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_BSLASH] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(491),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_LT_DASH] = ACTIONS(489),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_COLON_EQ] = ACTIONS(489),
    [anon_sym_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_GT] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(489),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_GT_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_STAR_STAR] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(489),
    [aux_sym_binary_operator_token1] = ACTIONS(489),
    [anon_sym_PIPE_GT] = ACTIONS(489),
    [anon_sym_COLON] = ACTIONS(491),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(489),
    [sym__number_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(653),
    [sym_dot_dot_i] = ACTIONS(653),
    [sym_return] = ACTIONS(491),
    [sym_next] = ACTIONS(491),
    [sym_break] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_null] = ACTIONS(491),
    [sym_inf] = ACTIONS(491),
    [sym_nan] = ACTIONS(491),
    [anon_sym_NA] = ACTIONS(491),
    [anon_sym_NA_integer_] = ACTIONS(491),
    [anon_sym_NA_real_] = ACTIONS(491),
    [anon_sym_NA_complex_] = ACTIONS(491),
    [anon_sym_NA_character_] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(489),
    [sym__semicolon] = ACTIONS(489),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(489),
    [sym__external_open_brace] = ACTIONS(489),
    [sym__external_close_brace] = ACTIONS(489),
    [sym__external_open_bracket] = ACTIONS(489),
    [sym__external_open_bracket2] = ACTIONS(489),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_identifier] = ACTIONS(617),
    [anon_sym_BSLASH] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_while] = ACTIONS(617),
    [anon_sym_repeat] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_LT_DASH] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(615),
    [anon_sym_COLON_EQ] = ACTIONS(615),
    [anon_sym_DASH_GT] = ACTIONS(617),
    [anon_sym_DASH_GT_GT] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [anon_sym_STAR] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_STAR_STAR] = ACTIONS(615),
    [anon_sym_CARET] = ACTIONS(615),
    [aux_sym_binary_operator_token1] = ACTIONS(615),
    [anon_sym_PIPE_GT] = ACTIONS(615),
    [anon_sym_COLON] = ACTIONS(617),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(615),
    [anon_sym_L] = ACTIONS(655),
    [anon_sym_i] = ACTIONS(657),
    [sym__hex_literal] = ACTIONS(615),
    [sym__number_literal] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [sym_dots] = ACTIONS(617),
    [sym_dot_dot_i] = ACTIONS(617),
    [sym_return] = ACTIONS(617),
    [sym_next] = ACTIONS(617),
    [sym_break] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_null] = ACTIONS(617),
    [sym_inf] = ACTIONS(617),
    [sym_nan] = ACTIONS(617),
    [anon_sym_NA] = ACTIONS(617),
    [anon_sym_NA_integer_] = ACTIONS(617),
    [anon_sym_NA_real_] = ACTIONS(617),
    [anon_sym_NA_complex_] = ACTIONS(617),
    [anon_sym_NA_character_] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(615),
    [sym__semicolon] = ACTIONS(615),
    [sym__raw_string_literal] = ACTIONS(615),
    [sym__external_open_parenthesis] = ACTIONS(615),
    [sym__external_open_brace] = ACTIONS(615),
    [sym__external_open_bracket] = ACTIONS(615),
    [sym__external_open_bracket2] = ACTIONS(615),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(605),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_BSLASH] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_if] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(603),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_LT_DASH] = ACTIONS(605),
    [anon_sym_LT_LT_DASH] = ACTIONS(605),
    [anon_sym_COLON_EQ] = ACTIONS(605),
    [anon_sym_DASH_GT] = ACTIONS(603),
    [anon_sym_DASH_GT_GT] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_AMP] = ACTIONS(603),
    [anon_sym_PIPE_PIPE] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(603),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_EQ] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_STAR_STAR] = ACTIONS(605),
    [anon_sym_CARET] = ACTIONS(605),
    [aux_sym_binary_operator_token1] = ACTIONS(605),
    [anon_sym_PIPE_GT] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(605),
    [sym__hex_literal] = ACTIONS(605),
    [sym__number_literal] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [sym_dots] = ACTIONS(603),
    [sym_dot_dot_i] = ACTIONS(603),
    [sym_return] = ACTIONS(603),
    [sym_next] = ACTIONS(603),
    [sym_break] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(603),
    [sym_inf] = ACTIONS(603),
    [sym_nan] = ACTIONS(603),
    [anon_sym_NA] = ACTIONS(603),
    [anon_sym_NA_integer_] = ACTIONS(603),
    [anon_sym_NA_real_] = ACTIONS(603),
    [anon_sym_NA_complex_] = ACTIONS(603),
    [anon_sym_NA_character_] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(605),
    [sym__semicolon] = ACTIONS(605),
    [sym__raw_string_literal] = ACTIONS(605),
    [sym__external_open_parenthesis] = ACTIONS(605),
    [sym__external_open_brace] = ACTIONS(605),
    [sym__external_open_bracket] = ACTIONS(605),
    [sym__external_open_bracket2] = ACTIONS(605),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [sym_identifier] = ACTIONS(639),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_if] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(639),
    [anon_sym_while] = ACTIONS(639),
    [anon_sym_repeat] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(639),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(639),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_STAR_STAR] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [aux_sym_binary_operator_token1] = ACTIONS(641),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_COLON] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(641),
    [sym__hex_literal] = ACTIONS(641),
    [sym__number_literal] = ACTIONS(639),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [sym_dots] = ACTIONS(639),
    [sym_dot_dot_i] = ACTIONS(639),
    [sym_return] = ACTIONS(639),
    [sym_next] = ACTIONS(639),
    [sym_break] = ACTIONS(639),
    [sym_true] = ACTIONS(639),
    [sym_false] = ACTIONS(639),
    [sym_null] = ACTIONS(639),
    [sym_inf] = ACTIONS(639),
    [sym_nan] = ACTIONS(639),
    [anon_sym_NA] = ACTIONS(639),
    [anon_sym_NA_integer_] = ACTIONS(639),
    [anon_sym_NA_real_] = ACTIONS(639),
    [anon_sym_NA_complex_] = ACTIONS(639),
    [anon_sym_NA_character_] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(641),
    [sym__semicolon] = ACTIONS(641),
    [sym__raw_string_literal] = ACTIONS(641),
    [sym__external_open_parenthesis] = ACTIONS(641),
    [sym__external_open_brace] = ACTIONS(641),
    [sym__external_open_bracket] = ACTIONS(641),
    [sym__external_open_bracket2] = ACTIONS(641),
  },
  [307] = {
    [aux_sym_function_definition_repeat1] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_repeat] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(661),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [aux_sym_binary_operator_token1] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [sym__hex_literal] = ACTIONS(659),
    [sym__number_literal] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [sym_dots] = ACTIONS(661),
    [sym_dot_dot_i] = ACTIONS(661),
    [sym_return] = ACTIONS(661),
    [sym_next] = ACTIONS(661),
    [sym_break] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_inf] = ACTIONS(661),
    [sym_nan] = ACTIONS(661),
    [anon_sym_NA] = ACTIONS(661),
    [anon_sym_NA_integer_] = ACTIONS(661),
    [anon_sym_NA_real_] = ACTIONS(661),
    [anon_sym_NA_complex_] = ACTIONS(661),
    [anon_sym_NA_character_] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(663),
    [sym__semicolon] = ACTIONS(659),
    [sym__raw_string_literal] = ACTIONS(659),
    [sym__external_else] = ACTIONS(659),
    [sym__external_open_parenthesis] = ACTIONS(659),
    [sym__external_open_brace] = ACTIONS(659),
    [sym__external_open_bracket] = ACTIONS(659),
    [sym__external_open_bracket2] = ACTIONS(659),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [310] = {
    [sym_function_definition] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_repeat_statement] = STATE(1361),
    [sym_braced_expression] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_call] = STATE(1361),
    [sym_subset] = STATE(1361),
    [sym_subset2] = STATE(1361),
    [sym_argument] = STATE(2037),
    [sym__argument_named] = STATE(2046),
    [sym__argument_unnamed] = STATE(2031),
    [sym__argument_value] = STATE(2030),
    [sym_unary_operator] = STATE(1361),
    [sym_binary_operator] = STATE(1361),
    [sym_extract_operator] = STATE(1361),
    [sym_namespace_operator] = STATE(1361),
    [sym_integer] = STATE(1361),
    [sym_complex] = STATE(1361),
    [sym_float] = STATE(1361),
    [sym__float_literal] = STATE(1620),
    [sym_string] = STATE(1630),
    [sym__single_quoted_string] = STATE(1624),
    [sym__double_quoted_string] = STATE(1625),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2059),
    [sym_na] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym__open_parenthesis] = STATE(1056),
    [sym__open_brace] = STATE(402),
    [sym_identifier] = ACTIONS(379),
    [anon_sym_BSLASH] = ACTIONS(381),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [sym__hex_literal] = ACTIONS(401),
    [sym__number_literal] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_dots] = ACTIONS(379),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(411),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(666),
    [sym__raw_string_literal] = ACTIONS(417),
    [sym__external_open_parenthesis] = ACTIONS(419),
    [sym__external_close_parenthesis] = ACTIONS(666),
    [sym__external_open_brace] = ACTIONS(423),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(635),
    [anon_sym_while] = ACTIONS(635),
    [anon_sym_repeat] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_LT_DASH] = ACTIONS(637),
    [anon_sym_LT_LT_DASH] = ACTIONS(637),
    [anon_sym_COLON_EQ] = ACTIONS(637),
    [anon_sym_DASH_GT] = ACTIONS(635),
    [anon_sym_DASH_GT_GT] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(637),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_STAR_STAR] = ACTIONS(637),
    [anon_sym_CARET] = ACTIONS(637),
    [aux_sym_binary_operator_token1] = ACTIONS(637),
    [anon_sym_PIPE_GT] = ACTIONS(637),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_COLON_COLON] = ACTIONS(635),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(637),
    [sym__hex_literal] = ACTIONS(637),
    [sym__number_literal] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_dots] = ACTIONS(635),
    [sym_dot_dot_i] = ACTIONS(635),
    [sym_return] = ACTIONS(635),
    [sym_next] = ACTIONS(635),
    [sym_break] = ACTIONS(635),
    [sym_true] = ACTIONS(635),
    [sym_false] = ACTIONS(635),
    [sym_null] = ACTIONS(635),
    [sym_inf] = ACTIONS(635),
    [sym_nan] = ACTIONS(635),
    [anon_sym_NA] = ACTIONS(635),
    [anon_sym_NA_integer_] = ACTIONS(635),
    [anon_sym_NA_real_] = ACTIONS(635),
    [anon_sym_NA_complex_] = ACTIONS(635),
    [anon_sym_NA_character_] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(637),
    [sym__semicolon] = ACTIONS(637),
    [sym__raw_string_literal] = ACTIONS(637),
    [sym__external_open_parenthesis] = ACTIONS(637),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_open_bracket] = ACTIONS(637),
    [sym__external_open_bracket2] = ACTIONS(637),
  },
  [312] = {
    [sym_function_definition] = STATE(1575),
    [sym_if_statement] = STATE(1575),
    [sym_for_statement] = STATE(1575),
    [sym_while_statement] = STATE(1575),
    [sym_repeat_statement] = STATE(1575),
    [sym_braced_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_subset] = STATE(1575),
    [sym_subset2] = STATE(1575),
    [sym_argument] = STATE(2041),
    [sym__argument_named] = STATE(2032),
    [sym__argument_unnamed] = STATE(2045),
    [sym__argument_value] = STATE(2043),
    [sym_unary_operator] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_extract_operator] = STATE(1575),
    [sym_namespace_operator] = STATE(1575),
    [sym_integer] = STATE(1575),
    [sym_complex] = STATE(1575),
    [sym_float] = STATE(1575),
    [sym__float_literal] = STATE(1626),
    [sym_string] = STATE(1628),
    [sym__single_quoted_string] = STATE(1629),
    [sym__double_quoted_string] = STATE(1611),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2071),
    [sym_na] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym__open_parenthesis] = STATE(1064),
    [sym__open_brace] = STATE(418),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_BSLASH] = ACTIONS(495),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_repeat] = ACTIONS(505),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [sym__hex_literal] = ACTIONS(515),
    [sym__number_literal] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_dots] = ACTIONS(493),
    [sym_dot_dot_i] = ACTIONS(493),
    [sym_return] = ACTIONS(523),
    [sym_next] = ACTIONS(523),
    [sym_break] = ACTIONS(523),
    [sym_true] = ACTIONS(523),
    [sym_false] = ACTIONS(523),
    [sym_null] = ACTIONS(525),
    [sym_inf] = ACTIONS(523),
    [sym_nan] = ACTIONS(523),
    [anon_sym_NA] = ACTIONS(527),
    [anon_sym_NA_integer_] = ACTIONS(527),
    [anon_sym_NA_real_] = ACTIONS(527),
    [anon_sym_NA_complex_] = ACTIONS(527),
    [anon_sym_NA_character_] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(666),
    [sym__raw_string_literal] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(533),
    [sym__external_open_brace] = ACTIONS(535),
    [sym__external_close_bracket] = ACTIONS(666),
  },
  [313] = {
    [sym_identifier] = ACTIONS(603),
    [anon_sym_BSLASH] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_if] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(603),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_LT_DASH] = ACTIONS(605),
    [anon_sym_LT_LT_DASH] = ACTIONS(605),
    [anon_sym_COLON_EQ] = ACTIONS(605),
    [anon_sym_DASH_GT] = ACTIONS(603),
    [anon_sym_DASH_GT_GT] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_AMP] = ACTIONS(603),
    [anon_sym_PIPE_PIPE] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(603),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_EQ] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_STAR_STAR] = ACTIONS(605),
    [anon_sym_CARET] = ACTIONS(605),
    [aux_sym_binary_operator_token1] = ACTIONS(605),
    [anon_sym_PIPE_GT] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(605),
    [sym__hex_literal] = ACTIONS(605),
    [sym__number_literal] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [sym_dots] = ACTIONS(603),
    [sym_dot_dot_i] = ACTIONS(603),
    [sym_return] = ACTIONS(603),
    [sym_next] = ACTIONS(603),
    [sym_break] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(603),
    [sym_inf] = ACTIONS(603),
    [sym_nan] = ACTIONS(603),
    [anon_sym_NA] = ACTIONS(603),
    [anon_sym_NA_integer_] = ACTIONS(603),
    [anon_sym_NA_real_] = ACTIONS(603),
    [anon_sym_NA_complex_] = ACTIONS(603),
    [anon_sym_NA_character_] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(605),
    [sym__semicolon] = ACTIONS(605),
    [sym__raw_string_literal] = ACTIONS(605),
    [sym__external_open_parenthesis] = ACTIONS(605),
    [sym__external_open_brace] = ACTIONS(605),
    [sym__external_close_brace] = ACTIONS(605),
    [sym__external_open_bracket] = ACTIONS(605),
    [sym__external_open_bracket2] = ACTIONS(605),
  },
  [314] = {
    [sym_identifier] = ACTIONS(609),
    [anon_sym_BSLASH] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_while] = ACTIONS(609),
    [anon_sym_repeat] = ACTIONS(609),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_LT_DASH] = ACTIONS(607),
    [anon_sym_LT_LT_DASH] = ACTIONS(607),
    [anon_sym_COLON_EQ] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(609),
    [anon_sym_DASH_GT_GT] = ACTIONS(607),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(607),
    [anon_sym_AMP_AMP] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(607),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(607),
    [anon_sym_EQ_EQ] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(609),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_CARET] = ACTIONS(607),
    [aux_sym_binary_operator_token1] = ACTIONS(607),
    [anon_sym_PIPE_GT] = ACTIONS(607),
    [anon_sym_COLON] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(670),
    [sym__hex_literal] = ACTIONS(607),
    [sym__number_literal] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [sym_dots] = ACTIONS(609),
    [sym_dot_dot_i] = ACTIONS(609),
    [sym_return] = ACTIONS(609),
    [sym_next] = ACTIONS(609),
    [sym_break] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_inf] = ACTIONS(609),
    [sym_nan] = ACTIONS(609),
    [anon_sym_NA] = ACTIONS(609),
    [anon_sym_NA_integer_] = ACTIONS(609),
    [anon_sym_NA_real_] = ACTIONS(609),
    [anon_sym_NA_complex_] = ACTIONS(609),
    [anon_sym_NA_character_] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(607),
    [sym__semicolon] = ACTIONS(607),
    [sym__raw_string_literal] = ACTIONS(607),
    [sym__external_open_parenthesis] = ACTIONS(607),
    [sym__external_open_brace] = ACTIONS(607),
    [sym__external_close_brace] = ACTIONS(607),
    [sym__external_open_bracket] = ACTIONS(607),
    [sym__external_open_bracket2] = ACTIONS(607),
  },
  [315] = {
    [sym_identifier] = ACTIONS(617),
    [anon_sym_BSLASH] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_while] = ACTIONS(617),
    [anon_sym_repeat] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_LT_DASH] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(615),
    [anon_sym_COLON_EQ] = ACTIONS(615),
    [anon_sym_DASH_GT] = ACTIONS(617),
    [anon_sym_DASH_GT_GT] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [anon_sym_STAR] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_STAR_STAR] = ACTIONS(615),
    [anon_sym_CARET] = ACTIONS(615),
    [aux_sym_binary_operator_token1] = ACTIONS(615),
    [anon_sym_PIPE_GT] = ACTIONS(615),
    [anon_sym_COLON] = ACTIONS(617),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(615),
    [anon_sym_L] = ACTIONS(672),
    [anon_sym_i] = ACTIONS(674),
    [sym__hex_literal] = ACTIONS(615),
    [sym__number_literal] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [sym_dots] = ACTIONS(617),
    [sym_dot_dot_i] = ACTIONS(617),
    [sym_return] = ACTIONS(617),
    [sym_next] = ACTIONS(617),
    [sym_break] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_null] = ACTIONS(617),
    [sym_inf] = ACTIONS(617),
    [sym_nan] = ACTIONS(617),
    [anon_sym_NA] = ACTIONS(617),
    [anon_sym_NA_integer_] = ACTIONS(617),
    [anon_sym_NA_real_] = ACTIONS(617),
    [anon_sym_NA_complex_] = ACTIONS(617),
    [anon_sym_NA_character_] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(615),
    [sym__semicolon] = ACTIONS(615),
    [sym__raw_string_literal] = ACTIONS(615),
    [sym__external_open_parenthesis] = ACTIONS(615),
    [sym__external_open_brace] = ACTIONS(615),
    [sym__external_close_brace] = ACTIONS(615),
    [sym__external_open_bracket] = ACTIONS(615),
    [sym__external_open_bracket2] = ACTIONS(615),
  },
  [316] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_close_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [317] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(625),
    [anon_sym_repeat] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LT_DASH] = ACTIONS(623),
    [anon_sym_LT_LT_DASH] = ACTIONS(623),
    [anon_sym_COLON_EQ] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_DASH_GT_GT] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_STAR_STAR] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(623),
    [aux_sym_binary_operator_token1] = ACTIONS(623),
    [anon_sym_PIPE_GT] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(623),
    [sym__hex_literal] = ACTIONS(623),
    [sym__number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(625),
    [sym_return] = ACTIONS(625),
    [sym_next] = ACTIONS(625),
    [sym_break] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_inf] = ACTIONS(625),
    [sym_nan] = ACTIONS(625),
    [anon_sym_NA] = ACTIONS(625),
    [anon_sym_NA_integer_] = ACTIONS(625),
    [anon_sym_NA_real_] = ACTIONS(625),
    [anon_sym_NA_complex_] = ACTIONS(625),
    [anon_sym_NA_character_] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(623),
    [sym__semicolon] = ACTIONS(623),
    [sym__raw_string_literal] = ACTIONS(623),
    [sym__external_open_parenthesis] = ACTIONS(623),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_close_brace] = ACTIONS(623),
    [sym__external_open_bracket] = ACTIONS(623),
    [sym__external_open_bracket2] = ACTIONS(623),
  },
  [318] = {
    [aux_sym_function_definition_repeat1] = STATE(318),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_repeat] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(661),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [aux_sym_binary_operator_token1] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [sym__hex_literal] = ACTIONS(659),
    [sym__number_literal] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [sym_dots] = ACTIONS(661),
    [sym_dot_dot_i] = ACTIONS(661),
    [sym_return] = ACTIONS(661),
    [sym_next] = ACTIONS(661),
    [sym_break] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_inf] = ACTIONS(661),
    [sym_nan] = ACTIONS(661),
    [anon_sym_NA] = ACTIONS(661),
    [anon_sym_NA_integer_] = ACTIONS(661),
    [anon_sym_NA_real_] = ACTIONS(661),
    [anon_sym_NA_complex_] = ACTIONS(661),
    [anon_sym_NA_character_] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(676),
    [sym__semicolon] = ACTIONS(659),
    [sym__raw_string_literal] = ACTIONS(659),
    [sym__external_else] = ACTIONS(659),
    [sym__external_open_parenthesis] = ACTIONS(659),
    [sym__external_open_brace] = ACTIONS(659),
    [sym__external_close_brace] = ACTIONS(659),
    [sym__external_open_bracket] = ACTIONS(659),
    [sym__external_open_bracket2] = ACTIONS(659),
  },
  [319] = {
    [sym_identifier] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(645),
    [anon_sym_COLON_EQ] = ACTIONS(645),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_CARET] = ACTIONS(645),
    [aux_sym_binary_operator_token1] = ACTIONS(645),
    [anon_sym_PIPE_GT] = ACTIONS(645),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(645),
    [sym__hex_literal] = ACTIONS(645),
    [sym__number_literal] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [sym_dots] = ACTIONS(643),
    [sym_dot_dot_i] = ACTIONS(643),
    [sym_return] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(645),
    [sym__semicolon] = ACTIONS(645),
    [sym__raw_string_literal] = ACTIONS(645),
    [sym__external_open_parenthesis] = ACTIONS(645),
    [sym__external_open_brace] = ACTIONS(645),
    [sym__external_close_brace] = ACTIONS(645),
    [sym__external_open_bracket] = ACTIONS(645),
    [sym__external_open_bracket2] = ACTIONS(645),
  },
  [320] = {
    [sym_identifier] = ACTIONS(647),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(647),
    [anon_sym_while] = ACTIONS(647),
    [anon_sym_repeat] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(647),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [aux_sym_binary_operator_token1] = ACTIONS(649),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_COLON] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym__hex_literal] = ACTIONS(649),
    [sym__number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [sym_dots] = ACTIONS(647),
    [sym_dot_dot_i] = ACTIONS(647),
    [sym_return] = ACTIONS(647),
    [sym_next] = ACTIONS(647),
    [sym_break] = ACTIONS(647),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_null] = ACTIONS(647),
    [sym_inf] = ACTIONS(647),
    [sym_nan] = ACTIONS(647),
    [anon_sym_NA] = ACTIONS(647),
    [anon_sym_NA_integer_] = ACTIONS(647),
    [anon_sym_NA_real_] = ACTIONS(647),
    [anon_sym_NA_complex_] = ACTIONS(647),
    [anon_sym_NA_character_] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(649),
    [sym__semicolon] = ACTIONS(649),
    [sym__raw_string_literal] = ACTIONS(649),
    [sym__external_open_parenthesis] = ACTIONS(649),
    [sym__external_open_brace] = ACTIONS(649),
    [sym__external_close_brace] = ACTIONS(649),
    [sym__external_open_bracket] = ACTIONS(649),
    [sym__external_open_bracket2] = ACTIONS(649),
  },
  [321] = {
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(635),
    [anon_sym_while] = ACTIONS(635),
    [anon_sym_repeat] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_LT_DASH] = ACTIONS(637),
    [anon_sym_LT_LT_DASH] = ACTIONS(637),
    [anon_sym_COLON_EQ] = ACTIONS(637),
    [anon_sym_DASH_GT] = ACTIONS(635),
    [anon_sym_DASH_GT_GT] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(637),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_STAR_STAR] = ACTIONS(637),
    [anon_sym_CARET] = ACTIONS(637),
    [aux_sym_binary_operator_token1] = ACTIONS(637),
    [anon_sym_PIPE_GT] = ACTIONS(637),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_COLON_COLON] = ACTIONS(635),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(637),
    [sym__hex_literal] = ACTIONS(637),
    [sym__number_literal] = ACTIONS(635),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_dots] = ACTIONS(635),
    [sym_dot_dot_i] = ACTIONS(635),
    [sym_return] = ACTIONS(635),
    [sym_next] = ACTIONS(635),
    [sym_break] = ACTIONS(635),
    [sym_true] = ACTIONS(635),
    [sym_false] = ACTIONS(635),
    [sym_null] = ACTIONS(635),
    [sym_inf] = ACTIONS(635),
    [sym_nan] = ACTIONS(635),
    [anon_sym_NA] = ACTIONS(635),
    [anon_sym_NA_integer_] = ACTIONS(635),
    [anon_sym_NA_real_] = ACTIONS(635),
    [anon_sym_NA_complex_] = ACTIONS(635),
    [anon_sym_NA_character_] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(637),
    [sym__semicolon] = ACTIONS(637),
    [sym__raw_string_literal] = ACTIONS(637),
    [sym__external_open_parenthesis] = ACTIONS(637),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_brace] = ACTIONS(637),
    [sym__external_open_bracket] = ACTIONS(637),
    [sym__external_open_bracket2] = ACTIONS(637),
  },
  [322] = {
    [sym_identifier] = ACTIONS(639),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_if] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(639),
    [anon_sym_while] = ACTIONS(639),
    [anon_sym_repeat] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(639),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(639),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_STAR_STAR] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [aux_sym_binary_operator_token1] = ACTIONS(641),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_COLON] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(641),
    [sym__hex_literal] = ACTIONS(641),
    [sym__number_literal] = ACTIONS(639),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [sym_dots] = ACTIONS(639),
    [sym_dot_dot_i] = ACTIONS(639),
    [sym_return] = ACTIONS(639),
    [sym_next] = ACTIONS(639),
    [sym_break] = ACTIONS(639),
    [sym_true] = ACTIONS(639),
    [sym_false] = ACTIONS(639),
    [sym_null] = ACTIONS(639),
    [sym_inf] = ACTIONS(639),
    [sym_nan] = ACTIONS(639),
    [anon_sym_NA] = ACTIONS(639),
    [anon_sym_NA_integer_] = ACTIONS(639),
    [anon_sym_NA_real_] = ACTIONS(639),
    [anon_sym_NA_complex_] = ACTIONS(639),
    [anon_sym_NA_character_] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(641),
    [sym__semicolon] = ACTIONS(641),
    [sym__raw_string_literal] = ACTIONS(641),
    [sym__external_open_parenthesis] = ACTIONS(641),
    [sym__external_open_brace] = ACTIONS(641),
    [sym__external_close_brace] = ACTIONS(641),
    [sym__external_open_bracket] = ACTIONS(641),
    [sym__external_open_bracket2] = ACTIONS(641),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_identifier] = ACTIONS(609),
    [anon_sym_BSLASH] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_while] = ACTIONS(609),
    [anon_sym_repeat] = ACTIONS(609),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_LT_DASH] = ACTIONS(607),
    [anon_sym_LT_LT_DASH] = ACTIONS(607),
    [anon_sym_COLON_EQ] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(609),
    [anon_sym_DASH_GT_GT] = ACTIONS(607),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(607),
    [anon_sym_AMP_AMP] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(607),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(607),
    [anon_sym_EQ_EQ] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(609),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_CARET] = ACTIONS(607),
    [aux_sym_binary_operator_token1] = ACTIONS(607),
    [anon_sym_PIPE_GT] = ACTIONS(607),
    [anon_sym_COLON] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_COLON_COLON] = ACTIONS(679),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(681),
    [sym__hex_literal] = ACTIONS(607),
    [sym__number_literal] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [sym_dots] = ACTIONS(609),
    [sym_dot_dot_i] = ACTIONS(609),
    [sym_return] = ACTIONS(609),
    [sym_next] = ACTIONS(609),
    [sym_break] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_inf] = ACTIONS(609),
    [sym_nan] = ACTIONS(609),
    [anon_sym_NA] = ACTIONS(609),
    [anon_sym_NA_integer_] = ACTIONS(609),
    [anon_sym_NA_real_] = ACTIONS(609),
    [anon_sym_NA_complex_] = ACTIONS(609),
    [anon_sym_NA_character_] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(607),
    [sym__semicolon] = ACTIONS(607),
    [sym__raw_string_literal] = ACTIONS(607),
    [sym__external_open_parenthesis] = ACTIONS(607),
    [sym__external_open_brace] = ACTIONS(607),
    [sym__external_open_bracket] = ACTIONS(607),
    [sym__external_open_bracket2] = ACTIONS(607),
  },
  [324] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_argument] = STATE(2038),
    [sym__argument_named] = STATE(2040),
    [sym__argument_unnamed] = STATE(2035),
    [sym__argument_value] = STATE(2047),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__float_literal] = STATE(1610),
    [sym_string] = STATE(1627),
    [sym__single_quoted_string] = STATE(1604),
    [sym__double_quoted_string] = STATE(1632),
    [sym__argument_name_string_or_identifier_or_null] = STATE(2054),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__open_parenthesis] = STATE(1069),
    [sym__open_brace] = STATE(422),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(425),
    [sym_return] = ACTIONS(455),
    [sym_next] = ACTIONS(455),
    [sym_break] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(455),
    [sym_nan] = ACTIONS(455),
    [anon_sym_NA] = ACTIONS(459),
    [anon_sym_NA_integer_] = ACTIONS(459),
    [anon_sym_NA_real_] = ACTIONS(459),
    [anon_sym_NA_complex_] = ACTIONS(459),
    [anon_sym_NA_character_] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(666),
    [sym__raw_string_literal] = ACTIONS(463),
    [sym__external_open_parenthesis] = ACTIONS(465),
    [sym__external_open_brace] = ACTIONS(467),
    [sym__external_close_bracket2] = ACTIONS(666),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(645),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(645),
    [anon_sym_COLON_EQ] = ACTIONS(645),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_CARET] = ACTIONS(645),
    [aux_sym_binary_operator_token1] = ACTIONS(645),
    [anon_sym_PIPE_GT] = ACTIONS(645),
    [anon_sym_COLON] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(645),
    [sym__hex_literal] = ACTIONS(645),
    [sym__number_literal] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [sym_dots] = ACTIONS(643),
    [sym_dot_dot_i] = ACTIONS(643),
    [sym_return] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(645),
    [sym__semicolon] = ACTIONS(645),
    [sym__raw_string_literal] = ACTIONS(645),
    [sym__external_open_parenthesis] = ACTIONS(645),
    [sym__external_open_brace] = ACTIONS(645),
    [sym__external_open_bracket] = ACTIONS(645),
    [sym__external_open_bracket2] = ACTIONS(645),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(647),
    [anon_sym_while] = ACTIONS(647),
    [anon_sym_repeat] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(647),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [aux_sym_binary_operator_token1] = ACTIONS(649),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_COLON] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym__hex_literal] = ACTIONS(649),
    [sym__number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [sym_dots] = ACTIONS(647),
    [sym_dot_dot_i] = ACTIONS(647),
    [sym_return] = ACTIONS(647),
    [sym_next] = ACTIONS(647),
    [sym_break] = ACTIONS(647),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_null] = ACTIONS(647),
    [sym_inf] = ACTIONS(647),
    [sym_nan] = ACTIONS(647),
    [anon_sym_NA] = ACTIONS(647),
    [anon_sym_NA_integer_] = ACTIONS(647),
    [anon_sym_NA_real_] = ACTIONS(647),
    [anon_sym_NA_complex_] = ACTIONS(647),
    [anon_sym_NA_character_] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(649),
    [sym__semicolon] = ACTIONS(649),
    [sym__raw_string_literal] = ACTIONS(649),
    [sym__external_open_parenthesis] = ACTIONS(649),
    [sym__external_open_brace] = ACTIONS(649),
    [sym__external_open_bracket] = ACTIONS(649),
    [sym__external_open_bracket2] = ACTIONS(649),
  },
  [327] = {
    [sym_identifier] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_repeat] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_LT_DASH] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(685),
    [anon_sym_COLON_EQ] = ACTIONS(685),
    [anon_sym_DASH_GT] = ACTIONS(683),
    [anon_sym_DASH_GT_GT] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(683),
    [anon_sym_PIPE_PIPE] = ACTIONS(685),
    [anon_sym_AMP_AMP] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_STAR_STAR] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [aux_sym_binary_operator_token1] = ACTIONS(685),
    [anon_sym_PIPE_GT] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [sym__hex_literal] = ACTIONS(685),
    [sym__number_literal] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [sym_dots] = ACTIONS(683),
    [sym_dot_dot_i] = ACTIONS(683),
    [sym_return] = ACTIONS(683),
    [sym_next] = ACTIONS(683),
    [sym_break] = ACTIONS(683),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [sym_inf] = ACTIONS(683),
    [sym_nan] = ACTIONS(683),
    [anon_sym_NA] = ACTIONS(683),
    [anon_sym_NA_integer_] = ACTIONS(683),
    [anon_sym_NA_real_] = ACTIONS(683),
    [anon_sym_NA_complex_] = ACTIONS(683),
    [anon_sym_NA_character_] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(685),
    [sym__semicolon] = ACTIONS(685),
    [sym__raw_string_literal] = ACTIONS(685),
    [sym__external_else] = ACTIONS(685),
    [sym__external_open_parenthesis] = ACTIONS(685),
    [sym__external_open_brace] = ACTIONS(685),
    [sym__external_close_brace] = ACTIONS(685),
    [sym__external_open_bracket] = ACTIONS(685),
    [sym__external_open_bracket2] = ACTIONS(685),
  },
  [328] = {
    [sym_identifier] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(687),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_repeat] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_LT_DASH] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(689),
    [anon_sym_COLON_EQ] = ACTIONS(689),
    [anon_sym_DASH_GT] = ACTIONS(687),
    [anon_sym_DASH_GT_GT] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_STAR_STAR] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(689),
    [aux_sym_binary_operator_token1] = ACTIONS(689),
    [anon_sym_PIPE_GT] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [sym__hex_literal] = ACTIONS(689),
    [sym__number_literal] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_dots] = ACTIONS(687),
    [sym_dot_dot_i] = ACTIONS(687),
    [sym_return] = ACTIONS(687),
    [sym_next] = ACTIONS(687),
    [sym_break] = ACTIONS(687),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_inf] = ACTIONS(687),
    [sym_nan] = ACTIONS(687),
    [anon_sym_NA] = ACTIONS(687),
    [anon_sym_NA_integer_] = ACTIONS(687),
    [anon_sym_NA_real_] = ACTIONS(687),
    [anon_sym_NA_complex_] = ACTIONS(687),
    [anon_sym_NA_character_] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(689),
    [sym__semicolon] = ACTIONS(689),
    [sym__raw_string_literal] = ACTIONS(689),
    [sym__external_else] = ACTIONS(689),
    [sym__external_open_parenthesis] = ACTIONS(689),
    [sym__external_open_brace] = ACTIONS(689),
    [sym__external_close_brace] = ACTIONS(689),
    [sym__external_open_bracket] = ACTIONS(689),
    [sym__external_open_bracket2] = ACTIONS(689),
  },
  [329] = {
    [sym_identifier] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_while] = ACTIONS(691),
    [anon_sym_repeat] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_COLON_EQ] = ACTIONS(693),
    [anon_sym_DASH_GT] = ACTIONS(691),
    [anon_sym_DASH_GT_GT] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(691),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_LT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_EQ] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_CARET] = ACTIONS(693),
    [aux_sym_binary_operator_token1] = ACTIONS(693),
    [anon_sym_PIPE_GT] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [sym__hex_literal] = ACTIONS(693),
    [sym__number_literal] = ACTIONS(691),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [sym_dots] = ACTIONS(691),
    [sym_dot_dot_i] = ACTIONS(691),
    [sym_return] = ACTIONS(691),
    [sym_next] = ACTIONS(691),
    [sym_break] = ACTIONS(691),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_null] = ACTIONS(691),
    [sym_inf] = ACTIONS(691),
    [sym_nan] = ACTIONS(691),
    [anon_sym_NA] = ACTIONS(691),
    [anon_sym_NA_integer_] = ACTIONS(691),
    [anon_sym_NA_real_] = ACTIONS(691),
    [anon_sym_NA_complex_] = ACTIONS(691),
    [anon_sym_NA_character_] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(693),
    [sym__semicolon] = ACTIONS(693),
    [sym__raw_string_literal] = ACTIONS(693),
    [sym__external_else] = ACTIONS(693),
    [sym__external_open_parenthesis] = ACTIONS(693),
    [sym__external_open_brace] = ACTIONS(693),
    [sym__external_close_brace] = ACTIONS(693),
    [sym__external_open_bracket] = ACTIONS(693),
    [sym__external_open_bracket2] = ACTIONS(693),
  },
  [330] = {
    [sym_identifier] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_if] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_repeat] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(697),
    [anon_sym_TILDE] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(695),
    [anon_sym_DASH_GT_GT] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_EQ] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_STAR_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(697),
    [aux_sym_binary_operator_token1] = ACTIONS(697),
    [anon_sym_PIPE_GT] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(697),
    [sym__hex_literal] = ACTIONS(697),
    [sym__number_literal] = ACTIONS(695),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [sym_dots] = ACTIONS(695),
    [sym_dot_dot_i] = ACTIONS(695),
    [sym_return] = ACTIONS(695),
    [sym_next] = ACTIONS(695),
    [sym_break] = ACTIONS(695),
    [sym_true] = ACTIONS(695),
    [sym_false] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [sym_inf] = ACTIONS(695),
    [sym_nan] = ACTIONS(695),
    [anon_sym_NA] = ACTIONS(695),
    [anon_sym_NA_integer_] = ACTIONS(695),
    [anon_sym_NA_real_] = ACTIONS(695),
    [anon_sym_NA_complex_] = ACTIONS(695),
    [anon_sym_NA_character_] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(697),
    [sym__semicolon] = ACTIONS(697),
    [sym__raw_string_literal] = ACTIONS(697),
    [sym__external_else] = ACTIONS(697),
    [sym__external_open_parenthesis] = ACTIONS(697),
    [sym__external_open_brace] = ACTIONS(697),
    [sym__external_close_brace] = ACTIONS(697),
    [sym__external_open_bracket] = ACTIONS(697),
    [sym__external_open_bracket2] = ACTIONS(697),
  },
  [331] = {
    [sym_identifier] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(699),
    [anon_sym_while] = ACTIONS(699),
    [anon_sym_repeat] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(701),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [aux_sym_binary_operator_token1] = ACTIONS(701),
    [anon_sym_PIPE_GT] = ACTIONS(701),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [sym__hex_literal] = ACTIONS(701),
    [sym__number_literal] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [sym_dots] = ACTIONS(699),
    [sym_dot_dot_i] = ACTIONS(699),
    [sym_return] = ACTIONS(699),
    [sym_next] = ACTIONS(699),
    [sym_break] = ACTIONS(699),
    [sym_true] = ACTIONS(699),
    [sym_false] = ACTIONS(699),
    [sym_null] = ACTIONS(699),
    [sym_inf] = ACTIONS(699),
    [sym_nan] = ACTIONS(699),
    [anon_sym_NA] = ACTIONS(699),
    [anon_sym_NA_integer_] = ACTIONS(699),
    [anon_sym_NA_real_] = ACTIONS(699),
    [anon_sym_NA_complex_] = ACTIONS(699),
    [anon_sym_NA_character_] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(701),
    [sym__semicolon] = ACTIONS(701),
    [sym__raw_string_literal] = ACTIONS(701),
    [sym__external_else] = ACTIONS(701),
    [sym__external_open_parenthesis] = ACTIONS(701),
    [sym__external_open_brace] = ACTIONS(701),
    [sym__external_close_brace] = ACTIONS(701),
    [sym__external_open_bracket] = ACTIONS(701),
    [sym__external_open_bracket2] = ACTIONS(701),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(703),
    [sym_identifier] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_repeat] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_LT_DASH] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(703),
    [anon_sym_COLON_EQ] = ACTIONS(703),
    [anon_sym_DASH_GT] = ACTIONS(705),
    [anon_sym_DASH_GT_GT] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_CARET] = ACTIONS(703),
    [aux_sym_binary_operator_token1] = ACTIONS(703),
    [anon_sym_PIPE_GT] = ACTIONS(703),
    [anon_sym_COLON] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(703),
    [sym__hex_literal] = ACTIONS(703),
    [sym__number_literal] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(703),
    [sym_dots] = ACTIONS(705),
    [sym_dot_dot_i] = ACTIONS(705),
    [sym_return] = ACTIONS(705),
    [sym_next] = ACTIONS(705),
    [sym_break] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [sym_inf] = ACTIONS(705),
    [sym_nan] = ACTIONS(705),
    [anon_sym_NA] = ACTIONS(705),
    [anon_sym_NA_integer_] = ACTIONS(705),
    [anon_sym_NA_real_] = ACTIONS(705),
    [anon_sym_NA_complex_] = ACTIONS(705),
    [anon_sym_NA_character_] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(703),
    [sym__semicolon] = ACTIONS(703),
    [sym__raw_string_literal] = ACTIONS(703),
    [sym__external_else] = ACTIONS(703),
    [sym__external_open_parenthesis] = ACTIONS(703),
    [sym__external_open_brace] = ACTIONS(703),
    [sym__external_open_bracket] = ACTIONS(703),
    [sym__external_open_bracket2] = ACTIONS(703),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(707),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_COLON_EQ] = ACTIONS(707),
    [anon_sym_DASH_GT] = ACTIONS(709),
    [anon_sym_DASH_GT_GT] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(707),
    [anon_sym_EQ_EQ] = ACTIONS(707),
    [anon_sym_BANG_EQ] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_CARET] = ACTIONS(707),
    [aux_sym_binary_operator_token1] = ACTIONS(707),
    [anon_sym_PIPE_GT] = ACTIONS(707),
    [anon_sym_COLON] = ACTIONS(709),
    [anon_sym_DOLLAR] = ACTIONS(707),
    [anon_sym_AT] = ACTIONS(707),
    [sym__hex_literal] = ACTIONS(707),
    [sym__number_literal] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [sym_dots] = ACTIONS(709),
    [sym_dot_dot_i] = ACTIONS(709),
    [sym_return] = ACTIONS(709),
    [sym_next] = ACTIONS(709),
    [sym_break] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_inf] = ACTIONS(709),
    [sym_nan] = ACTIONS(709),
    [anon_sym_NA] = ACTIONS(709),
    [anon_sym_NA_integer_] = ACTIONS(709),
    [anon_sym_NA_real_] = ACTIONS(709),
    [anon_sym_NA_complex_] = ACTIONS(709),
    [anon_sym_NA_character_] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(707),
    [sym__semicolon] = ACTIONS(707),
    [sym__raw_string_literal] = ACTIONS(707),
    [sym__external_else] = ACTIONS(707),
    [sym__external_open_parenthesis] = ACTIONS(707),
    [sym__external_open_brace] = ACTIONS(707),
    [sym__external_open_bracket] = ACTIONS(707),
    [sym__external_open_bracket2] = ACTIONS(707),
  },
  [334] = {
    [aux_sym_function_definition_repeat1] = STATE(334),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_repeat] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(661),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [aux_sym_binary_operator_token1] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [sym__hex_literal] = ACTIONS(659),
    [sym__number_literal] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [sym_dots] = ACTIONS(661),
    [sym_dot_dot_i] = ACTIONS(661),
    [sym_return] = ACTIONS(661),
    [sym_next] = ACTIONS(661),
    [sym_break] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_inf] = ACTIONS(661),
    [sym_nan] = ACTIONS(661),
    [anon_sym_NA] = ACTIONS(661),
    [anon_sym_NA_integer_] = ACTIONS(661),
    [anon_sym_NA_real_] = ACTIONS(661),
    [anon_sym_NA_complex_] = ACTIONS(661),
    [anon_sym_NA_character_] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(711),
    [sym__semicolon] = ACTIONS(659),
    [sym__raw_string_literal] = ACTIONS(659),
    [sym__external_open_parenthesis] = ACTIONS(659),
    [sym__external_open_brace] = ACTIONS(659),
    [sym__external_close_brace] = ACTIONS(659),
    [sym__external_open_bracket] = ACTIONS(659),
    [sym__external_open_bracket2] = ACTIONS(659),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(714),
    [sym_identifier] = ACTIONS(716),
    [anon_sym_BSLASH] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_LT_DASH] = ACTIONS(714),
    [anon_sym_LT_LT_DASH] = ACTIONS(714),
    [anon_sym_COLON_EQ] = ACTIONS(714),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_DASH_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(716),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(716),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [aux_sym_binary_operator_token1] = ACTIONS(714),
    [anon_sym_PIPE_GT] = ACTIONS(714),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [sym__hex_literal] = ACTIONS(714),
    [sym__number_literal] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [sym_dots] = ACTIONS(716),
    [sym_dot_dot_i] = ACTIONS(716),
    [sym_return] = ACTIONS(716),
    [sym_next] = ACTIONS(716),
    [sym_break] = ACTIONS(716),
    [sym_true] = ACTIONS(716),
    [sym_false] = ACTIONS(716),
    [sym_null] = ACTIONS(716),
    [sym_inf] = ACTIONS(716),
    [sym_nan] = ACTIONS(716),
    [anon_sym_NA] = ACTIONS(716),
    [anon_sym_NA_integer_] = ACTIONS(716),
    [anon_sym_NA_real_] = ACTIONS(716),
    [anon_sym_NA_complex_] = ACTIONS(716),
    [anon_sym_NA_character_] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(714),
    [sym__semicolon] = ACTIONS(714),
    [sym__raw_string_literal] = ACTIONS(714),
    [sym__external_else] = ACTIONS(714),
    [sym__external_open_parenthesis] = ACTIONS(714),
    [sym__external_open_brace] = ACTIONS(714),
    [sym__external_open_bracket] = ACTIONS(714),
    [sym__external_open_bracket2] = ACTIONS(714),
  },
  [336] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_BSLASH] = ACTIONS(720),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_repeat] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_DASH] = ACTIONS(720),
    [anon_sym_LT_LT_DASH] = ACTIONS(720),
    [anon_sym_COLON_EQ] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(718),
    [anon_sym_DASH_GT_GT] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_STAR_STAR] = ACTIONS(720),
    [anon_sym_CARET] = ACTIONS(720),
    [aux_sym_binary_operator_token1] = ACTIONS(720),
    [anon_sym_PIPE_GT] = ACTIONS(720),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [sym__hex_literal] = ACTIONS(720),
    [sym__number_literal] = ACTIONS(718),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(720),
    [sym_dots] = ACTIONS(718),
    [sym_dot_dot_i] = ACTIONS(718),
    [sym_return] = ACTIONS(718),
    [sym_next] = ACTIONS(718),
    [sym_break] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_inf] = ACTIONS(718),
    [sym_nan] = ACTIONS(718),
    [anon_sym_NA] = ACTIONS(718),
    [anon_sym_NA_integer_] = ACTIONS(718),
    [anon_sym_NA_real_] = ACTIONS(718),
    [anon_sym_NA_complex_] = ACTIONS(718),
    [anon_sym_NA_character_] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(720),
    [sym__semicolon] = ACTIONS(720),
    [sym__raw_string_literal] = ACTIONS(720),
    [sym__external_else] = ACTIONS(720),
    [sym__external_open_parenthesis] = ACTIONS(720),
    [sym__external_open_brace] = ACTIONS(720),
    [sym__external_close_brace] = ACTIONS(720),
    [sym__external_open_bracket] = ACTIONS(720),
    [sym__external_open_bracket2] = ACTIONS(720),
  },
  [337] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_BSLASH] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_repeat] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_DASH] = ACTIONS(724),
    [anon_sym_LT_LT_DASH] = ACTIONS(724),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_DASH_GT_GT] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(724),
    [anon_sym_BANG_EQ] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_STAR_STAR] = ACTIONS(724),
    [anon_sym_CARET] = ACTIONS(724),
    [aux_sym_binary_operator_token1] = ACTIONS(724),
    [anon_sym_PIPE_GT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(724),
    [sym__hex_literal] = ACTIONS(724),
    [sym__number_literal] = ACTIONS(722),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_dots] = ACTIONS(722),
    [sym_dot_dot_i] = ACTIONS(722),
    [sym_return] = ACTIONS(722),
    [sym_next] = ACTIONS(722),
    [sym_break] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_null] = ACTIONS(722),
    [sym_inf] = ACTIONS(722),
    [sym_nan] = ACTIONS(722),
    [anon_sym_NA] = ACTIONS(722),
    [anon_sym_NA_integer_] = ACTIONS(722),
    [anon_sym_NA_real_] = ACTIONS(722),
    [anon_sym_NA_complex_] = ACTIONS(722),
    [anon_sym_NA_character_] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(724),
    [sym__semicolon] = ACTIONS(724),
    [sym__raw_string_literal] = ACTIONS(724),
    [sym__external_else] = ACTIONS(724),
    [sym__external_open_parenthesis] = ACTIONS(724),
    [sym__external_open_brace] = ACTIONS(724),
    [sym__external_close_brace] = ACTIONS(724),
    [sym__external_open_bracket] = ACTIONS(724),
    [sym__external_open_bracket2] = ACTIONS(724),
  },
  [338] = {
    [sym_identifier] = ACTIONS(726),
    [anon_sym_BSLASH] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_repeat] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_COLON_EQ] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(726),
    [anon_sym_DASH_GT_GT] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [anon_sym_STAR_STAR] = ACTIONS(728),
    [anon_sym_CARET] = ACTIONS(728),
    [aux_sym_binary_operator_token1] = ACTIONS(728),
    [anon_sym_PIPE_GT] = ACTIONS(728),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [anon_sym_AT] = ACTIONS(728),
    [sym__hex_literal] = ACTIONS(728),
    [sym__number_literal] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_dots] = ACTIONS(726),
    [sym_dot_dot_i] = ACTIONS(726),
    [sym_return] = ACTIONS(726),
    [sym_next] = ACTIONS(726),
    [sym_break] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_inf] = ACTIONS(726),
    [sym_nan] = ACTIONS(726),
    [anon_sym_NA] = ACTIONS(726),
    [anon_sym_NA_integer_] = ACTIONS(726),
    [anon_sym_NA_real_] = ACTIONS(726),
    [anon_sym_NA_complex_] = ACTIONS(726),
    [anon_sym_NA_character_] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(728),
    [sym__semicolon] = ACTIONS(728),
    [sym__raw_string_literal] = ACTIONS(728),
    [sym__external_else] = ACTIONS(728),
    [sym__external_open_parenthesis] = ACTIONS(728),
    [sym__external_open_brace] = ACTIONS(728),
    [sym__external_close_brace] = ACTIONS(728),
    [sym__external_open_bracket] = ACTIONS(728),
    [sym__external_open_bracket2] = ACTIONS(728),
  },
  [339] = {
    [sym_identifier] = ACTIONS(730),
    [anon_sym_BSLASH] = ACTIONS(732),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_repeat] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_COLON_EQ] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_DASH_GT_GT] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_BANG_EQ] = ACTIONS(732),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_STAR_STAR] = ACTIONS(732),
    [anon_sym_CARET] = ACTIONS(732),
    [aux_sym_binary_operator_token1] = ACTIONS(732),
    [anon_sym_PIPE_GT] = ACTIONS(732),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [sym__hex_literal] = ACTIONS(732),
    [sym__number_literal] = ACTIONS(730),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [sym_dots] = ACTIONS(730),
    [sym_dot_dot_i] = ACTIONS(730),
    [sym_return] = ACTIONS(730),
    [sym_next] = ACTIONS(730),
    [sym_break] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_inf] = ACTIONS(730),
    [sym_nan] = ACTIONS(730),
    [anon_sym_NA] = ACTIONS(730),
    [anon_sym_NA_integer_] = ACTIONS(730),
    [anon_sym_NA_real_] = ACTIONS(730),
    [anon_sym_NA_complex_] = ACTIONS(730),
    [anon_sym_NA_character_] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(732),
    [sym__semicolon] = ACTIONS(732),
    [sym__raw_string_literal] = ACTIONS(732),
    [sym__external_else] = ACTIONS(732),
    [sym__external_open_parenthesis] = ACTIONS(732),
    [sym__external_open_brace] = ACTIONS(732),
    [sym__external_close_brace] = ACTIONS(732),
    [sym__external_open_bracket] = ACTIONS(732),
    [sym__external_open_bracket2] = ACTIONS(732),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(734),
    [sym_identifier] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_COLON_EQ] = ACTIONS(734),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_DASH_GT_GT] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [aux_sym_binary_operator_token1] = ACTIONS(734),
    [anon_sym_PIPE_GT] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [sym__hex_literal] = ACTIONS(734),
    [sym__number_literal] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [sym_dots] = ACTIONS(736),
    [sym_dot_dot_i] = ACTIONS(736),
    [sym_return] = ACTIONS(736),
    [sym_next] = ACTIONS(736),
    [sym_break] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_null] = ACTIONS(736),
    [sym_inf] = ACTIONS(736),
    [sym_nan] = ACTIONS(736),
    [anon_sym_NA] = ACTIONS(736),
    [anon_sym_NA_integer_] = ACTIONS(736),
    [anon_sym_NA_real_] = ACTIONS(736),
    [anon_sym_NA_complex_] = ACTIONS(736),
    [anon_sym_NA_character_] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(734),
    [sym__semicolon] = ACTIONS(734),
    [sym__raw_string_literal] = ACTIONS(734),
    [sym__external_else] = ACTIONS(734),
    [sym__external_open_parenthesis] = ACTIONS(734),
    [sym__external_open_brace] = ACTIONS(734),
    [sym__external_open_bracket] = ACTIONS(734),
    [sym__external_open_bracket2] = ACTIONS(734),
  },
  [341] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(740),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_repeat] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_LT_DASH] = ACTIONS(740),
    [anon_sym_LT_LT_DASH] = ACTIONS(740),
    [anon_sym_COLON_EQ] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(738),
    [anon_sym_DASH_GT_GT] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [aux_sym_binary_operator_token1] = ACTIONS(740),
    [anon_sym_PIPE_GT] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [sym__hex_literal] = ACTIONS(740),
    [sym__number_literal] = ACTIONS(738),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_dots] = ACTIONS(738),
    [sym_dot_dot_i] = ACTIONS(738),
    [sym_return] = ACTIONS(738),
    [sym_next] = ACTIONS(738),
    [sym_break] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_null] = ACTIONS(738),
    [sym_inf] = ACTIONS(738),
    [sym_nan] = ACTIONS(738),
    [anon_sym_NA] = ACTIONS(738),
    [anon_sym_NA_integer_] = ACTIONS(738),
    [anon_sym_NA_real_] = ACTIONS(738),
    [anon_sym_NA_complex_] = ACTIONS(738),
    [anon_sym_NA_character_] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(740),
    [sym__semicolon] = ACTIONS(740),
    [sym__raw_string_literal] = ACTIONS(740),
    [sym__external_else] = ACTIONS(740),
    [sym__external_open_parenthesis] = ACTIONS(740),
    [sym__external_open_brace] = ACTIONS(740),
    [sym__external_close_brace] = ACTIONS(740),
    [sym__external_open_bracket] = ACTIONS(740),
    [sym__external_open_bracket2] = ACTIONS(740),
  },
  [342] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_repeat] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_DASH] = ACTIONS(744),
    [anon_sym_LT_LT_DASH] = ACTIONS(744),
    [anon_sym_COLON_EQ] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(742),
    [anon_sym_DASH_GT_GT] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(744),
    [anon_sym_AMP_AMP] = ACTIONS(744),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(744),
    [anon_sym_STAR_STAR] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(744),
    [aux_sym_binary_operator_token1] = ACTIONS(744),
    [anon_sym_PIPE_GT] = ACTIONS(744),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(744),
    [sym__hex_literal] = ACTIONS(744),
    [sym__number_literal] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(744),
    [sym_dots] = ACTIONS(742),
    [sym_dot_dot_i] = ACTIONS(742),
    [sym_return] = ACTIONS(742),
    [sym_next] = ACTIONS(742),
    [sym_break] = ACTIONS(742),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_inf] = ACTIONS(742),
    [sym_nan] = ACTIONS(742),
    [anon_sym_NA] = ACTIONS(742),
    [anon_sym_NA_integer_] = ACTIONS(742),
    [anon_sym_NA_real_] = ACTIONS(742),
    [anon_sym_NA_complex_] = ACTIONS(742),
    [anon_sym_NA_character_] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(744),
    [sym__semicolon] = ACTIONS(744),
    [sym__raw_string_literal] = ACTIONS(744),
    [sym__external_else] = ACTIONS(744),
    [sym__external_open_parenthesis] = ACTIONS(744),
    [sym__external_open_brace] = ACTIONS(744),
    [sym__external_close_brace] = ACTIONS(744),
    [sym__external_open_bracket] = ACTIONS(744),
    [sym__external_open_bracket2] = ACTIONS(744),
  },
  [343] = {
    [sym_identifier] = ACTIONS(746),
    [anon_sym_BSLASH] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_while] = ACTIONS(746),
    [anon_sym_repeat] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_LT_DASH] = ACTIONS(748),
    [anon_sym_LT_LT_DASH] = ACTIONS(748),
    [anon_sym_COLON_EQ] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(746),
    [anon_sym_DASH_GT_GT] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(748),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_STAR_STAR] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(748),
    [aux_sym_binary_operator_token1] = ACTIONS(748),
    [anon_sym_PIPE_GT] = ACTIONS(748),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [sym__hex_literal] = ACTIONS(748),
    [sym__number_literal] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [sym_dots] = ACTIONS(746),
    [sym_dot_dot_i] = ACTIONS(746),
    [sym_return] = ACTIONS(746),
    [sym_next] = ACTIONS(746),
    [sym_break] = ACTIONS(746),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_null] = ACTIONS(746),
    [sym_inf] = ACTIONS(746),
    [sym_nan] = ACTIONS(746),
    [anon_sym_NA] = ACTIONS(746),
    [anon_sym_NA_integer_] = ACTIONS(746),
    [anon_sym_NA_real_] = ACTIONS(746),
    [anon_sym_NA_complex_] = ACTIONS(746),
    [anon_sym_NA_character_] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(748),
    [sym__semicolon] = ACTIONS(748),
    [sym__raw_string_literal] = ACTIONS(748),
    [sym__external_else] = ACTIONS(748),
    [sym__external_open_parenthesis] = ACTIONS(748),
    [sym__external_open_brace] = ACTIONS(748),
    [sym__external_close_brace] = ACTIONS(748),
    [sym__external_open_bracket] = ACTIONS(748),
    [sym__external_open_bracket2] = ACTIONS(748),
  },
  [344] = {
    [sym_identifier] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_repeat] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_LT_DASH] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(703),
    [anon_sym_COLON_EQ] = ACTIONS(703),
    [anon_sym_DASH_GT] = ACTIONS(705),
    [anon_sym_DASH_GT_GT] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_CARET] = ACTIONS(703),
    [aux_sym_binary_operator_token1] = ACTIONS(703),
    [anon_sym_PIPE_GT] = ACTIONS(703),
    [anon_sym_COLON] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(703),
    [sym__hex_literal] = ACTIONS(703),
    [sym__number_literal] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(703),
    [sym_dots] = ACTIONS(705),
    [sym_dot_dot_i] = ACTIONS(705),
    [sym_return] = ACTIONS(705),
    [sym_next] = ACTIONS(705),
    [sym_break] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [sym_inf] = ACTIONS(705),
    [sym_nan] = ACTIONS(705),
    [anon_sym_NA] = ACTIONS(705),
    [anon_sym_NA_integer_] = ACTIONS(705),
    [anon_sym_NA_real_] = ACTIONS(705),
    [anon_sym_NA_complex_] = ACTIONS(705),
    [anon_sym_NA_character_] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(703),
    [sym__semicolon] = ACTIONS(703),
    [sym__raw_string_literal] = ACTIONS(703),
    [sym__external_else] = ACTIONS(703),
    [sym__external_open_parenthesis] = ACTIONS(703),
    [sym__external_open_brace] = ACTIONS(703),
    [sym__external_close_brace] = ACTIONS(703),
    [sym__external_open_bracket] = ACTIONS(703),
    [sym__external_open_bracket2] = ACTIONS(703),
  },
  [345] = {
    [sym_identifier] = ACTIONS(750),
    [anon_sym_BSLASH] = ACTIONS(752),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(750),
    [anon_sym_while] = ACTIONS(750),
    [anon_sym_repeat] = ACTIONS(750),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_LT_DASH] = ACTIONS(752),
    [anon_sym_LT_LT_DASH] = ACTIONS(752),
    [anon_sym_COLON_EQ] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(750),
    [anon_sym_DASH_GT_GT] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(750),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_PIPE_PIPE] = ACTIONS(752),
    [anon_sym_AMP_AMP] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [aux_sym_binary_operator_token1] = ACTIONS(752),
    [anon_sym_PIPE_GT] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(750),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [sym__hex_literal] = ACTIONS(752),
    [sym__number_literal] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_dots] = ACTIONS(750),
    [sym_dot_dot_i] = ACTIONS(750),
    [sym_return] = ACTIONS(750),
    [sym_next] = ACTIONS(750),
    [sym_break] = ACTIONS(750),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_inf] = ACTIONS(750),
    [sym_nan] = ACTIONS(750),
    [anon_sym_NA] = ACTIONS(750),
    [anon_sym_NA_integer_] = ACTIONS(750),
    [anon_sym_NA_real_] = ACTIONS(750),
    [anon_sym_NA_complex_] = ACTIONS(750),
    [anon_sym_NA_character_] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(752),
    [sym__semicolon] = ACTIONS(752),
    [sym__raw_string_literal] = ACTIONS(752),
    [sym__external_else] = ACTIONS(752),
    [sym__external_open_parenthesis] = ACTIONS(752),
    [sym__external_open_brace] = ACTIONS(752),
    [sym__external_close_brace] = ACTIONS(752),
    [sym__external_open_bracket] = ACTIONS(752),
    [sym__external_open_bracket2] = ACTIONS(752),
  },
  [346] = {
    [sym_identifier] = ACTIONS(716),
    [anon_sym_BSLASH] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_LT_DASH] = ACTIONS(714),
    [anon_sym_LT_LT_DASH] = ACTIONS(714),
    [anon_sym_COLON_EQ] = ACTIONS(714),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_DASH_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(716),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(716),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [aux_sym_binary_operator_token1] = ACTIONS(714),
    [anon_sym_PIPE_GT] = ACTIONS(714),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [sym__hex_literal] = ACTIONS(714),
    [sym__number_literal] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [sym_dots] = ACTIONS(716),
    [sym_dot_dot_i] = ACTIONS(716),
    [sym_return] = ACTIONS(716),
    [sym_next] = ACTIONS(716),
    [sym_break] = ACTIONS(716),
    [sym_true] = ACTIONS(716),
    [sym_false] = ACTIONS(716),
    [sym_null] = ACTIONS(716),
    [sym_inf] = ACTIONS(716),
    [sym_nan] = ACTIONS(716),
    [anon_sym_NA] = ACTIONS(716),
    [anon_sym_NA_integer_] = ACTIONS(716),
    [anon_sym_NA_real_] = ACTIONS(716),
    [anon_sym_NA_complex_] = ACTIONS(716),
    [anon_sym_NA_character_] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(714),
    [sym__semicolon] = ACTIONS(714),
    [sym__raw_string_literal] = ACTIONS(714),
    [sym__external_else] = ACTIONS(714),
    [sym__external_open_parenthesis] = ACTIONS(714),
    [sym__external_open_brace] = ACTIONS(714),
    [sym__external_close_brace] = ACTIONS(714),
    [sym__external_open_bracket] = ACTIONS(714),
    [sym__external_open_bracket2] = ACTIONS(714),
  },
  [347] = {
    [sym_identifier] = ACTIONS(754),
    [anon_sym_BSLASH] = ACTIONS(756),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(754),
    [anon_sym_while] = ACTIONS(754),
    [anon_sym_repeat] = ACTIONS(754),
    [anon_sym_QMARK] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_LT_DASH] = ACTIONS(756),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_COLON_EQ] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(754),
    [anon_sym_DASH_GT_GT] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(754),
    [anon_sym_AMP] = ACTIONS(754),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(756),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(756),
    [anon_sym_BANG_EQ] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(756),
    [anon_sym_STAR_STAR] = ACTIONS(756),
    [anon_sym_CARET] = ACTIONS(756),
    [aux_sym_binary_operator_token1] = ACTIONS(756),
    [anon_sym_PIPE_GT] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(756),
    [sym__hex_literal] = ACTIONS(756),
    [sym__number_literal] = ACTIONS(754),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(756),
    [sym_dots] = ACTIONS(754),
    [sym_dot_dot_i] = ACTIONS(754),
    [sym_return] = ACTIONS(754),
    [sym_next] = ACTIONS(754),
    [sym_break] = ACTIONS(754),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_inf] = ACTIONS(754),
    [sym_nan] = ACTIONS(754),
    [anon_sym_NA] = ACTIONS(754),
    [anon_sym_NA_integer_] = ACTIONS(754),
    [anon_sym_NA_real_] = ACTIONS(754),
    [anon_sym_NA_complex_] = ACTIONS(754),
    [anon_sym_NA_character_] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(756),
    [sym__semicolon] = ACTIONS(756),
    [sym__raw_string_literal] = ACTIONS(756),
    [sym__external_else] = ACTIONS(756),
    [sym__external_open_parenthesis] = ACTIONS(756),
    [sym__external_open_brace] = ACTIONS(756),
    [sym__external_close_brace] = ACTIONS(756),
    [sym__external_open_bracket] = ACTIONS(756),
    [sym__external_open_bracket2] = ACTIONS(756),
  },
  [348] = {
    [sym_identifier] = ACTIONS(758),
    [anon_sym_BSLASH] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_while] = ACTIONS(758),
    [anon_sym_repeat] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_LT_DASH] = ACTIONS(760),
    [anon_sym_LT_LT_DASH] = ACTIONS(760),
    [anon_sym_COLON_EQ] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(758),
    [anon_sym_DASH_GT_GT] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_PIPE_PIPE] = ACTIONS(760),
    [anon_sym_AMP_AMP] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(760),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_STAR_STAR] = ACTIONS(760),
    [anon_sym_CARET] = ACTIONS(760),
    [aux_sym_binary_operator_token1] = ACTIONS(760),
    [anon_sym_PIPE_GT] = ACTIONS(760),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_DOLLAR] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [sym__hex_literal] = ACTIONS(760),
    [sym__number_literal] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [sym_dots] = ACTIONS(758),
    [sym_dot_dot_i] = ACTIONS(758),
    [sym_return] = ACTIONS(758),
    [sym_next] = ACTIONS(758),
    [sym_break] = ACTIONS(758),
    [sym_true] = ACTIONS(758),
    [sym_false] = ACTIONS(758),
    [sym_null] = ACTIONS(758),
    [sym_inf] = ACTIONS(758),
    [sym_nan] = ACTIONS(758),
    [anon_sym_NA] = ACTIONS(758),
    [anon_sym_NA_integer_] = ACTIONS(758),
    [anon_sym_NA_real_] = ACTIONS(758),
    [anon_sym_NA_complex_] = ACTIONS(758),
    [anon_sym_NA_character_] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(760),
    [sym__semicolon] = ACTIONS(760),
    [sym__raw_string_literal] = ACTIONS(760),
    [sym__external_else] = ACTIONS(760),
    [sym__external_open_parenthesis] = ACTIONS(760),
    [sym__external_open_brace] = ACTIONS(760),
    [sym__external_close_brace] = ACTIONS(760),
    [sym__external_open_bracket] = ACTIONS(760),
    [sym__external_open_bracket2] = ACTIONS(760),
  },
  [349] = {
    [sym_identifier] = ACTIONS(762),
    [anon_sym_BSLASH] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_repeat] = ACTIONS(762),
    [anon_sym_QMARK] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_LT_DASH] = ACTIONS(764),
    [anon_sym_LT_LT_DASH] = ACTIONS(764),
    [anon_sym_COLON_EQ] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(762),
    [anon_sym_DASH_GT_GT] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(764),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(764),
    [aux_sym_binary_operator_token1] = ACTIONS(764),
    [anon_sym_PIPE_GT] = ACTIONS(764),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_DOLLAR] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [sym__hex_literal] = ACTIONS(764),
    [sym__number_literal] = ACTIONS(762),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(764),
    [sym_dots] = ACTIONS(762),
    [sym_dot_dot_i] = ACTIONS(762),
    [sym_return] = ACTIONS(762),
    [sym_next] = ACTIONS(762),
    [sym_break] = ACTIONS(762),
    [sym_true] = ACTIONS(762),
    [sym_false] = ACTIONS(762),
    [sym_null] = ACTIONS(762),
    [sym_inf] = ACTIONS(762),
    [sym_nan] = ACTIONS(762),
    [anon_sym_NA] = ACTIONS(762),
    [anon_sym_NA_integer_] = ACTIONS(762),
    [anon_sym_NA_real_] = ACTIONS(762),
    [anon_sym_NA_complex_] = ACTIONS(762),
    [anon_sym_NA_character_] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(764),
    [sym__semicolon] = ACTIONS(764),
    [sym__raw_string_literal] = ACTIONS(764),
    [sym__external_else] = ACTIONS(764),
    [sym__external_open_parenthesis] = ACTIONS(764),
    [sym__external_open_brace] = ACTIONS(764),
    [sym__external_close_brace] = ACTIONS(764),
    [sym__external_open_bracket] = ACTIONS(764),
    [sym__external_open_bracket2] = ACTIONS(764),
  },
  [350] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_COLON_EQ] = ACTIONS(707),
    [anon_sym_DASH_GT] = ACTIONS(709),
    [anon_sym_DASH_GT_GT] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(707),
    [anon_sym_EQ_EQ] = ACTIONS(707),
    [anon_sym_BANG_EQ] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_CARET] = ACTIONS(707),
    [aux_sym_binary_operator_token1] = ACTIONS(707),
    [anon_sym_PIPE_GT] = ACTIONS(707),
    [anon_sym_COLON] = ACTIONS(709),
    [anon_sym_DOLLAR] = ACTIONS(707),
    [anon_sym_AT] = ACTIONS(707),
    [sym__hex_literal] = ACTIONS(707),
    [sym__number_literal] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [sym_dots] = ACTIONS(709),
    [sym_dot_dot_i] = ACTIONS(709),
    [sym_return] = ACTIONS(709),
    [sym_next] = ACTIONS(709),
    [sym_break] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_inf] = ACTIONS(709),
    [sym_nan] = ACTIONS(709),
    [anon_sym_NA] = ACTIONS(709),
    [anon_sym_NA_integer_] = ACTIONS(709),
    [anon_sym_NA_real_] = ACTIONS(709),
    [anon_sym_NA_complex_] = ACTIONS(709),
    [anon_sym_NA_character_] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(707),
    [sym__semicolon] = ACTIONS(707),
    [sym__raw_string_literal] = ACTIONS(707),
    [sym__external_else] = ACTIONS(707),
    [sym__external_open_parenthesis] = ACTIONS(707),
    [sym__external_open_brace] = ACTIONS(707),
    [sym__external_close_brace] = ACTIONS(707),
    [sym__external_open_bracket] = ACTIONS(707),
    [sym__external_open_bracket2] = ACTIONS(707),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(752),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_BSLASH] = ACTIONS(752),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(750),
    [anon_sym_while] = ACTIONS(750),
    [anon_sym_repeat] = ACTIONS(750),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_LT_DASH] = ACTIONS(752),
    [anon_sym_LT_LT_DASH] = ACTIONS(752),
    [anon_sym_COLON_EQ] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(750),
    [anon_sym_DASH_GT_GT] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(750),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_PIPE_PIPE] = ACTIONS(752),
    [anon_sym_AMP_AMP] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [aux_sym_binary_operator_token1] = ACTIONS(752),
    [anon_sym_PIPE_GT] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(750),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [sym__hex_literal] = ACTIONS(752),
    [sym__number_literal] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_dots] = ACTIONS(750),
    [sym_dot_dot_i] = ACTIONS(750),
    [sym_return] = ACTIONS(750),
    [sym_next] = ACTIONS(750),
    [sym_break] = ACTIONS(750),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_inf] = ACTIONS(750),
    [sym_nan] = ACTIONS(750),
    [anon_sym_NA] = ACTIONS(750),
    [anon_sym_NA_integer_] = ACTIONS(750),
    [anon_sym_NA_real_] = ACTIONS(750),
    [anon_sym_NA_complex_] = ACTIONS(750),
    [anon_sym_NA_character_] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(752),
    [sym__semicolon] = ACTIONS(752),
    [sym__raw_string_literal] = ACTIONS(752),
    [sym__external_else] = ACTIONS(752),
    [sym__external_open_parenthesis] = ACTIONS(752),
    [sym__external_open_brace] = ACTIONS(752),
    [sym__external_open_bracket] = ACTIONS(752),
    [sym__external_open_bracket2] = ACTIONS(752),
  },
  [352] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_BSLASH] = ACTIONS(768),
    [anon_sym_function] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_repeat] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_LT_DASH] = ACTIONS(768),
    [anon_sym_LT_LT_DASH] = ACTIONS(768),
    [anon_sym_COLON_EQ] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(766),
    [anon_sym_DASH_GT_GT] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(768),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [aux_sym_binary_operator_token1] = ACTIONS(768),
    [anon_sym_PIPE_GT] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_DOLLAR] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [sym__hex_literal] = ACTIONS(768),
    [sym__number_literal] = ACTIONS(766),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(768),
    [sym_dots] = ACTIONS(766),
    [sym_dot_dot_i] = ACTIONS(766),
    [sym_return] = ACTIONS(766),
    [sym_next] = ACTIONS(766),
    [sym_break] = ACTIONS(766),
    [sym_true] = ACTIONS(766),
    [sym_false] = ACTIONS(766),
    [sym_null] = ACTIONS(766),
    [sym_inf] = ACTIONS(766),
    [sym_nan] = ACTIONS(766),
    [anon_sym_NA] = ACTIONS(766),
    [anon_sym_NA_integer_] = ACTIONS(766),
    [anon_sym_NA_real_] = ACTIONS(766),
    [anon_sym_NA_complex_] = ACTIONS(766),
    [anon_sym_NA_character_] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(768),
    [sym__semicolon] = ACTIONS(768),
    [sym__raw_string_literal] = ACTIONS(768),
    [sym__external_else] = ACTIONS(768),
    [sym__external_open_parenthesis] = ACTIONS(768),
    [sym__external_open_brace] = ACTIONS(768),
    [sym__external_close_brace] = ACTIONS(768),
    [sym__external_open_bracket] = ACTIONS(768),
    [sym__external_open_bracket2] = ACTIONS(768),
  },
  [353] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_BSLASH] = ACTIONS(772),
    [anon_sym_function] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_repeat] = ACTIONS(770),
    [anon_sym_QMARK] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_LT_DASH] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(772),
    [anon_sym_COLON_EQ] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(770),
    [anon_sym_DASH_GT_GT] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_PIPE_PIPE] = ACTIONS(772),
    [anon_sym_AMP_AMP] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(772),
    [anon_sym_BANG_EQ] = ACTIONS(772),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_STAR_STAR] = ACTIONS(772),
    [anon_sym_CARET] = ACTIONS(772),
    [aux_sym_binary_operator_token1] = ACTIONS(772),
    [anon_sym_PIPE_GT] = ACTIONS(772),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [sym__hex_literal] = ACTIONS(772),
    [sym__number_literal] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [sym_dots] = ACTIONS(770),
    [sym_dot_dot_i] = ACTIONS(770),
    [sym_return] = ACTIONS(770),
    [sym_next] = ACTIONS(770),
    [sym_break] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_null] = ACTIONS(770),
    [sym_inf] = ACTIONS(770),
    [sym_nan] = ACTIONS(770),
    [anon_sym_NA] = ACTIONS(770),
    [anon_sym_NA_integer_] = ACTIONS(770),
    [anon_sym_NA_real_] = ACTIONS(770),
    [anon_sym_NA_complex_] = ACTIONS(770),
    [anon_sym_NA_character_] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(772),
    [sym__semicolon] = ACTIONS(772),
    [sym__raw_string_literal] = ACTIONS(772),
    [sym__external_else] = ACTIONS(772),
    [sym__external_open_parenthesis] = ACTIONS(772),
    [sym__external_open_brace] = ACTIONS(772),
    [sym__external_close_brace] = ACTIONS(772),
    [sym__external_open_bracket] = ACTIONS(772),
    [sym__external_open_bracket2] = ACTIONS(772),
  },
  [354] = {
    [aux_sym_function_definition_repeat1] = STATE(354),
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_repeat] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(661),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [aux_sym_binary_operator_token1] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [sym__hex_literal] = ACTIONS(659),
    [sym__number_literal] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [sym_dots] = ACTIONS(661),
    [sym_dot_dot_i] = ACTIONS(661),
    [sym_return] = ACTIONS(661),
    [sym_next] = ACTIONS(661),
    [sym_break] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_inf] = ACTIONS(661),
    [sym_nan] = ACTIONS(661),
    [anon_sym_NA] = ACTIONS(661),
    [anon_sym_NA_integer_] = ACTIONS(661),
    [anon_sym_NA_real_] = ACTIONS(661),
    [anon_sym_NA_complex_] = ACTIONS(661),
    [anon_sym_NA_character_] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(774),
    [sym__semicolon] = ACTIONS(659),
    [sym__raw_string_literal] = ACTIONS(659),
    [sym__external_open_parenthesis] = ACTIONS(659),
    [sym__external_open_brace] = ACTIONS(659),
    [sym__external_open_bracket] = ACTIONS(659),
    [sym__external_open_bracket2] = ACTIONS(659),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(756),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_BSLASH] = ACTIONS(756),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(754),
    [anon_sym_while] = ACTIONS(754),
    [anon_sym_repeat] = ACTIONS(754),
    [anon_sym_QMARK] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_LT_DASH] = ACTIONS(756),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_COLON_EQ] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(754),
    [anon_sym_DASH_GT_GT] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(754),
    [anon_sym_AMP] = ACTIONS(754),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(756),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(756),
    [anon_sym_BANG_EQ] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(756),
    [anon_sym_STAR_STAR] = ACTIONS(756),
    [anon_sym_CARET] = ACTIONS(756),
    [aux_sym_binary_operator_token1] = ACTIONS(756),
    [anon_sym_PIPE_GT] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(756),
    [sym__hex_literal] = ACTIONS(756),
    [sym__number_literal] = ACTIONS(754),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(756),
    [sym_dots] = ACTIONS(754),
    [sym_dot_dot_i] = ACTIONS(754),
    [sym_return] = ACTIONS(754),
    [sym_next] = ACTIONS(754),
    [sym_break] = ACTIONS(754),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_inf] = ACTIONS(754),
    [sym_nan] = ACTIONS(754),
    [anon_sym_NA] = ACTIONS(754),
    [anon_sym_NA_integer_] = ACTIONS(754),
    [anon_sym_NA_real_] = ACTIONS(754),
    [anon_sym_NA_complex_] = ACTIONS(754),
    [anon_sym_NA_character_] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(756),
    [sym__semicolon] = ACTIONS(756),
    [sym__raw_string_literal] = ACTIONS(756),
    [sym__external_else] = ACTIONS(756),
    [sym__external_open_parenthesis] = ACTIONS(756),
    [sym__external_open_brace] = ACTIONS(756),
    [sym__external_open_bracket] = ACTIONS(756),
    [sym__external_open_bracket2] = ACTIONS(756),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(718),
    [anon_sym_BSLASH] = ACTIONS(720),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_repeat] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_DASH] = ACTIONS(720),
    [anon_sym_LT_LT_DASH] = ACTIONS(720),
    [anon_sym_COLON_EQ] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(718),
    [anon_sym_DASH_GT_GT] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_STAR_STAR] = ACTIONS(720),
    [anon_sym_CARET] = ACTIONS(720),
    [aux_sym_binary_operator_token1] = ACTIONS(720),
    [anon_sym_PIPE_GT] = ACTIONS(720),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [sym__hex_literal] = ACTIONS(720),
    [sym__number_literal] = ACTIONS(718),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(720),
    [sym_dots] = ACTIONS(718),
    [sym_dot_dot_i] = ACTIONS(718),
    [sym_return] = ACTIONS(718),
    [sym_next] = ACTIONS(718),
    [sym_break] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_inf] = ACTIONS(718),
    [sym_nan] = ACTIONS(718),
    [anon_sym_NA] = ACTIONS(718),
    [anon_sym_NA_integer_] = ACTIONS(718),
    [anon_sym_NA_real_] = ACTIONS(718),
    [anon_sym_NA_complex_] = ACTIONS(718),
    [anon_sym_NA_character_] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(720),
    [sym__semicolon] = ACTIONS(720),
    [sym__raw_string_literal] = ACTIONS(720),
    [sym__external_else] = ACTIONS(720),
    [sym__external_open_parenthesis] = ACTIONS(720),
    [sym__external_open_brace] = ACTIONS(720),
    [sym__external_open_bracket] = ACTIONS(720),
    [sym__external_open_bracket2] = ACTIONS(720),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_BSLASH] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_repeat] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_DASH] = ACTIONS(724),
    [anon_sym_LT_LT_DASH] = ACTIONS(724),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_DASH_GT_GT] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(724),
    [anon_sym_BANG_EQ] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_STAR_STAR] = ACTIONS(724),
    [anon_sym_CARET] = ACTIONS(724),
    [aux_sym_binary_operator_token1] = ACTIONS(724),
    [anon_sym_PIPE_GT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(724),
    [sym__hex_literal] = ACTIONS(724),
    [sym__number_literal] = ACTIONS(722),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_dots] = ACTIONS(722),
    [sym_dot_dot_i] = ACTIONS(722),
    [sym_return] = ACTIONS(722),
    [sym_next] = ACTIONS(722),
    [sym_break] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_null] = ACTIONS(722),
    [sym_inf] = ACTIONS(722),
    [sym_nan] = ACTIONS(722),
    [anon_sym_NA] = ACTIONS(722),
    [anon_sym_NA_integer_] = ACTIONS(722),
    [anon_sym_NA_real_] = ACTIONS(722),
    [anon_sym_NA_complex_] = ACTIONS(722),
    [anon_sym_NA_character_] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(724),
    [sym__semicolon] = ACTIONS(724),
    [sym__raw_string_literal] = ACTIONS(724),
    [sym__external_else] = ACTIONS(724),
    [sym__external_open_parenthesis] = ACTIONS(724),
    [sym__external_open_brace] = ACTIONS(724),
    [sym__external_open_bracket] = ACTIONS(724),
    [sym__external_open_bracket2] = ACTIONS(724),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_BSLASH] = ACTIONS(732),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_repeat] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_COLON_EQ] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_DASH_GT_GT] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_BANG_EQ] = ACTIONS(732),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_STAR_STAR] = ACTIONS(732),
    [anon_sym_CARET] = ACTIONS(732),
    [aux_sym_binary_operator_token1] = ACTIONS(732),
    [anon_sym_PIPE_GT] = ACTIONS(732),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [sym__hex_literal] = ACTIONS(732),
    [sym__number_literal] = ACTIONS(730),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [sym_dots] = ACTIONS(730),
    [sym_dot_dot_i] = ACTIONS(730),
    [sym_return] = ACTIONS(730),
    [sym_next] = ACTIONS(730),
    [sym_break] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_inf] = ACTIONS(730),
    [sym_nan] = ACTIONS(730),
    [anon_sym_NA] = ACTIONS(730),
    [anon_sym_NA_integer_] = ACTIONS(730),
    [anon_sym_NA_real_] = ACTIONS(730),
    [anon_sym_NA_complex_] = ACTIONS(730),
    [anon_sym_NA_character_] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(732),
    [sym__semicolon] = ACTIONS(732),
    [sym__raw_string_literal] = ACTIONS(732),
    [sym__external_else] = ACTIONS(732),
    [sym__external_open_parenthesis] = ACTIONS(732),
    [sym__external_open_brace] = ACTIONS(732),
    [sym__external_open_bracket] = ACTIONS(732),
    [sym__external_open_bracket2] = ACTIONS(732),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_identifier] = ACTIONS(758),
    [anon_sym_BSLASH] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_while] = ACTIONS(758),
    [anon_sym_repeat] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_LT_DASH] = ACTIONS(760),
    [anon_sym_LT_LT_DASH] = ACTIONS(760),
    [anon_sym_COLON_EQ] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(758),
    [anon_sym_DASH_GT_GT] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_PIPE_PIPE] = ACTIONS(760),
    [anon_sym_AMP_AMP] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(760),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_STAR_STAR] = ACTIONS(760),
    [anon_sym_CARET] = ACTIONS(760),
    [aux_sym_binary_operator_token1] = ACTIONS(760),
    [anon_sym_PIPE_GT] = ACTIONS(760),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_DOLLAR] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [sym__hex_literal] = ACTIONS(760),
    [sym__number_literal] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [sym_dots] = ACTIONS(758),
    [sym_dot_dot_i] = ACTIONS(758),
    [sym_return] = ACTIONS(758),
    [sym_next] = ACTIONS(758),
    [sym_break] = ACTIONS(758),
    [sym_true] = ACTIONS(758),
    [sym_false] = ACTIONS(758),
    [sym_null] = ACTIONS(758),
    [sym_inf] = ACTIONS(758),
    [sym_nan] = ACTIONS(758),
    [anon_sym_NA] = ACTIONS(758),
    [anon_sym_NA_integer_] = ACTIONS(758),
    [anon_sym_NA_real_] = ACTIONS(758),
    [anon_sym_NA_complex_] = ACTIONS(758),
    [anon_sym_NA_character_] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(760),
    [sym__semicolon] = ACTIONS(760),
    [sym__raw_string_literal] = ACTIONS(760),
    [sym__external_else] = ACTIONS(760),
    [sym__external_open_parenthesis] = ACTIONS(760),
    [sym__external_open_brace] = ACTIONS(760),
    [sym__external_open_bracket] = ACTIONS(760),
    [sym__external_open_bracket2] = ACTIONS(760),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_BSLASH] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_repeat] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_COLON_EQ] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(726),
    [anon_sym_DASH_GT_GT] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [anon_sym_STAR_STAR] = ACTIONS(728),
    [anon_sym_CARET] = ACTIONS(728),
    [aux_sym_binary_operator_token1] = ACTIONS(728),
    [anon_sym_PIPE_GT] = ACTIONS(728),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [anon_sym_AT] = ACTIONS(728),
    [sym__hex_literal] = ACTIONS(728),
    [sym__number_literal] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_dots] = ACTIONS(726),
    [sym_dot_dot_i] = ACTIONS(726),
    [sym_return] = ACTIONS(726),
    [sym_next] = ACTIONS(726),
    [sym_break] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_inf] = ACTIONS(726),
    [sym_nan] = ACTIONS(726),
    [anon_sym_NA] = ACTIONS(726),
    [anon_sym_NA_integer_] = ACTIONS(726),
    [anon_sym_NA_real_] = ACTIONS(726),
    [anon_sym_NA_complex_] = ACTIONS(726),
    [anon_sym_NA_character_] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(728),
    [sym__semicolon] = ACTIONS(728),
    [sym__raw_string_literal] = ACTIONS(728),
    [sym__external_else] = ACTIONS(728),
    [sym__external_open_parenthesis] = ACTIONS(728),
    [sym__external_open_brace] = ACTIONS(728),
    [sym__external_open_bracket] = ACTIONS(728),
    [sym__external_open_bracket2] = ACTIONS(728),
  },
  [361] = {
    [sym_identifier] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_COLON_EQ] = ACTIONS(734),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_DASH_GT_GT] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [aux_sym_binary_operator_token1] = ACTIONS(734),
    [anon_sym_PIPE_GT] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [sym__hex_literal] = ACTIONS(734),
    [sym__number_literal] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [sym_dots] = ACTIONS(736),
    [sym_dot_dot_i] = ACTIONS(736),
    [sym_return] = ACTIONS(736),
    [sym_next] = ACTIONS(736),
    [sym_break] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_null] = ACTIONS(736),
    [sym_inf] = ACTIONS(736),
    [sym_nan] = ACTIONS(736),
    [anon_sym_NA] = ACTIONS(736),
    [anon_sym_NA_integer_] = ACTIONS(736),
    [anon_sym_NA_real_] = ACTIONS(736),
    [anon_sym_NA_complex_] = ACTIONS(736),
    [anon_sym_NA_character_] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(734),
    [sym__semicolon] = ACTIONS(734),
    [sym__raw_string_literal] = ACTIONS(734),
    [sym__external_else] = ACTIONS(734),
    [sym__external_open_parenthesis] = ACTIONS(734),
    [sym__external_open_brace] = ACTIONS(734),
    [sym__external_close_brace] = ACTIONS(734),
    [sym__external_open_bracket] = ACTIONS(734),
    [sym__external_open_bracket2] = ACTIONS(734),
  },
  [362] = {
    [ts_builtin_sym_end] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_repeat] = ACTIONS(779),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_LT_DASH] = ACTIONS(777),
    [anon_sym_LT_LT_DASH] = ACTIONS(777),
    [anon_sym_COLON_EQ] = ACTIONS(777),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_DASH_GT_GT] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [aux_sym_binary_operator_token1] = ACTIONS(777),
    [anon_sym_PIPE_GT] = ACTIONS(777),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [sym__hex_literal] = ACTIONS(777),
    [sym__number_literal] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(777),
    [sym_dots] = ACTIONS(779),
    [sym_dot_dot_i] = ACTIONS(779),
    [sym_return] = ACTIONS(779),
    [sym_next] = ACTIONS(779),
    [sym_break] = ACTIONS(779),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [sym_inf] = ACTIONS(779),
    [sym_nan] = ACTIONS(779),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(777),
    [sym__semicolon] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(777),
    [sym__external_else] = ACTIONS(777),
    [sym__external_open_parenthesis] = ACTIONS(777),
    [sym__external_open_brace] = ACTIONS(777),
    [sym__external_open_bracket] = ACTIONS(777),
    [sym__external_open_bracket2] = ACTIONS(777),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(781),
    [sym_identifier] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_repeat] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_LT_DASH] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(781),
    [anon_sym_COLON_EQ] = ACTIONS(781),
    [anon_sym_DASH_GT] = ACTIONS(783),
    [anon_sym_DASH_GT_GT] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_STAR_STAR] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [aux_sym_binary_operator_token1] = ACTIONS(781),
    [anon_sym_PIPE_GT] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [sym__hex_literal] = ACTIONS(781),
    [sym__number_literal] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(781),
    [anon_sym_DQUOTE] = ACTIONS(781),
    [sym_dots] = ACTIONS(783),
    [sym_dot_dot_i] = ACTIONS(783),
    [sym_return] = ACTIONS(783),
    [sym_next] = ACTIONS(783),
    [sym_break] = ACTIONS(783),
    [sym_true] = ACTIONS(783),
    [sym_false] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [sym_inf] = ACTIONS(783),
    [sym_nan] = ACTIONS(783),
    [anon_sym_NA] = ACTIONS(783),
    [anon_sym_NA_integer_] = ACTIONS(783),
    [anon_sym_NA_real_] = ACTIONS(783),
    [anon_sym_NA_complex_] = ACTIONS(783),
    [anon_sym_NA_character_] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(781),
    [sym__semicolon] = ACTIONS(781),
    [sym__raw_string_literal] = ACTIONS(781),
    [sym__external_else] = ACTIONS(781),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_open_brace] = ACTIONS(781),
    [sym__external_open_bracket] = ACTIONS(781),
    [sym__external_open_bracket2] = ACTIONS(781),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(764),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_BSLASH] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_repeat] = ACTIONS(762),
    [anon_sym_QMARK] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_LT_DASH] = ACTIONS(764),
    [anon_sym_LT_LT_DASH] = ACTIONS(764),
    [anon_sym_COLON_EQ] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(762),
    [anon_sym_DASH_GT_GT] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(764),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(764),
    [aux_sym_binary_operator_token1] = ACTIONS(764),
    [anon_sym_PIPE_GT] = ACTIONS(764),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_DOLLAR] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [sym__hex_literal] = ACTIONS(764),
    [sym__number_literal] = ACTIONS(762),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(764),
    [sym_dots] = ACTIONS(762),
    [sym_dot_dot_i] = ACTIONS(762),
    [sym_return] = ACTIONS(762),
    [sym_next] = ACTIONS(762),
    [sym_break] = ACTIONS(762),
    [sym_true] = ACTIONS(762),
    [sym_false] = ACTIONS(762),
    [sym_null] = ACTIONS(762),
    [sym_inf] = ACTIONS(762),
    [sym_nan] = ACTIONS(762),
    [anon_sym_NA] = ACTIONS(762),
    [anon_sym_NA_integer_] = ACTIONS(762),
    [anon_sym_NA_real_] = ACTIONS(762),
    [anon_sym_NA_complex_] = ACTIONS(762),
    [anon_sym_NA_character_] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(764),
    [sym__semicolon] = ACTIONS(764),
    [sym__raw_string_literal] = ACTIONS(764),
    [sym__external_else] = ACTIONS(764),
    [sym__external_open_parenthesis] = ACTIONS(764),
    [sym__external_open_brace] = ACTIONS(764),
    [sym__external_open_bracket] = ACTIONS(764),
    [sym__external_open_bracket2] = ACTIONS(764),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(687),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_repeat] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_LT_DASH] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(689),
    [anon_sym_COLON_EQ] = ACTIONS(689),
    [anon_sym_DASH_GT] = ACTIONS(687),
    [anon_sym_DASH_GT_GT] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_STAR_STAR] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(689),
    [aux_sym_binary_operator_token1] = ACTIONS(689),
    [anon_sym_PIPE_GT] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [sym__hex_literal] = ACTIONS(689),
    [sym__number_literal] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_dots] = ACTIONS(687),
    [sym_dot_dot_i] = ACTIONS(687),
    [sym_return] = ACTIONS(687),
    [sym_next] = ACTIONS(687),
    [sym_break] = ACTIONS(687),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_inf] = ACTIONS(687),
    [sym_nan] = ACTIONS(687),
    [anon_sym_NA] = ACTIONS(687),
    [anon_sym_NA_integer_] = ACTIONS(687),
    [anon_sym_NA_real_] = ACTIONS(687),
    [anon_sym_NA_complex_] = ACTIONS(687),
    [anon_sym_NA_character_] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(689),
    [sym__semicolon] = ACTIONS(689),
    [sym__raw_string_literal] = ACTIONS(689),
    [sym__external_else] = ACTIONS(689),
    [sym__external_open_parenthesis] = ACTIONS(689),
    [sym__external_open_brace] = ACTIONS(689),
    [sym__external_open_bracket] = ACTIONS(689),
    [sym__external_open_bracket2] = ACTIONS(689),
  },
  [366] = {
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_identifier] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_while] = ACTIONS(691),
    [anon_sym_repeat] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_COLON_EQ] = ACTIONS(693),
    [anon_sym_DASH_GT] = ACTIONS(691),
    [anon_sym_DASH_GT_GT] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(691),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_LT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_EQ] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_CARET] = ACTIONS(693),
    [aux_sym_binary_operator_token1] = ACTIONS(693),
    [anon_sym_PIPE_GT] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [sym__hex_literal] = ACTIONS(693),
    [sym__number_literal] = ACTIONS(691),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [sym_dots] = ACTIONS(691),
    [sym_dot_dot_i] = ACTIONS(691),
    [sym_return] = ACTIONS(691),
    [sym_next] = ACTIONS(691),
    [sym_break] = ACTIONS(691),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_null] = ACTIONS(691),
    [sym_inf] = ACTIONS(691),
    [sym_nan] = ACTIONS(691),
    [anon_sym_NA] = ACTIONS(691),
    [anon_sym_NA_integer_] = ACTIONS(691),
    [anon_sym_NA_real_] = ACTIONS(691),
    [anon_sym_NA_complex_] = ACTIONS(691),
    [anon_sym_NA_character_] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(693),
    [sym__semicolon] = ACTIONS(693),
    [sym__raw_string_literal] = ACTIONS(693),
    [sym__external_else] = ACTIONS(693),
    [sym__external_open_parenthesis] = ACTIONS(693),
    [sym__external_open_brace] = ACTIONS(693),
    [sym__external_open_bracket] = ACTIONS(693),
    [sym__external_open_bracket2] = ACTIONS(693),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_if] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_repeat] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(697),
    [anon_sym_TILDE] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(695),
    [anon_sym_DASH_GT_GT] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_EQ] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_STAR_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(697),
    [aux_sym_binary_operator_token1] = ACTIONS(697),
    [anon_sym_PIPE_GT] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(697),
    [sym__hex_literal] = ACTIONS(697),
    [sym__number_literal] = ACTIONS(695),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [sym_dots] = ACTIONS(695),
    [sym_dot_dot_i] = ACTIONS(695),
    [sym_return] = ACTIONS(695),
    [sym_next] = ACTIONS(695),
    [sym_break] = ACTIONS(695),
    [sym_true] = ACTIONS(695),
    [sym_false] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [sym_inf] = ACTIONS(695),
    [sym_nan] = ACTIONS(695),
    [anon_sym_NA] = ACTIONS(695),
    [anon_sym_NA_integer_] = ACTIONS(695),
    [anon_sym_NA_real_] = ACTIONS(695),
    [anon_sym_NA_complex_] = ACTIONS(695),
    [anon_sym_NA_character_] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(697),
    [sym__semicolon] = ACTIONS(697),
    [sym__raw_string_literal] = ACTIONS(697),
    [sym__external_else] = ACTIONS(697),
    [sym__external_open_parenthesis] = ACTIONS(697),
    [sym__external_open_brace] = ACTIONS(697),
    [sym__external_open_bracket] = ACTIONS(697),
    [sym__external_open_bracket2] = ACTIONS(697),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(699),
    [anon_sym_while] = ACTIONS(699),
    [anon_sym_repeat] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(701),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [aux_sym_binary_operator_token1] = ACTIONS(701),
    [anon_sym_PIPE_GT] = ACTIONS(701),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [sym__hex_literal] = ACTIONS(701),
    [sym__number_literal] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [sym_dots] = ACTIONS(699),
    [sym_dot_dot_i] = ACTIONS(699),
    [sym_return] = ACTIONS(699),
    [sym_next] = ACTIONS(699),
    [sym_break] = ACTIONS(699),
    [sym_true] = ACTIONS(699),
    [sym_false] = ACTIONS(699),
    [sym_null] = ACTIONS(699),
    [sym_inf] = ACTIONS(699),
    [sym_nan] = ACTIONS(699),
    [anon_sym_NA] = ACTIONS(699),
    [anon_sym_NA_integer_] = ACTIONS(699),
    [anon_sym_NA_real_] = ACTIONS(699),
    [anon_sym_NA_complex_] = ACTIONS(699),
    [anon_sym_NA_character_] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(701),
    [sym__semicolon] = ACTIONS(701),
    [sym__raw_string_literal] = ACTIONS(701),
    [sym__external_else] = ACTIONS(701),
    [sym__external_open_parenthesis] = ACTIONS(701),
    [sym__external_open_brace] = ACTIONS(701),
    [sym__external_open_bracket] = ACTIONS(701),
    [sym__external_open_bracket2] = ACTIONS(701),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_repeat] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_LT_DASH] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(685),
    [anon_sym_COLON_EQ] = ACTIONS(685),
    [anon_sym_DASH_GT] = ACTIONS(683),
    [anon_sym_DASH_GT_GT] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(683),
    [anon_sym_PIPE_PIPE] = ACTIONS(685),
    [anon_sym_AMP_AMP] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_STAR_STAR] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [aux_sym_binary_operator_token1] = ACTIONS(685),
    [anon_sym_PIPE_GT] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [sym__hex_literal] = ACTIONS(685),
    [sym__number_literal] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [sym_dots] = ACTIONS(683),
    [sym_dot_dot_i] = ACTIONS(683),
    [sym_return] = ACTIONS(683),
    [sym_next] = ACTIONS(683),
    [sym_break] = ACTIONS(683),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [sym_inf] = ACTIONS(683),
    [sym_nan] = ACTIONS(683),
    [anon_sym_NA] = ACTIONS(683),
    [anon_sym_NA_integer_] = ACTIONS(683),
    [anon_sym_NA_real_] = ACTIONS(683),
    [anon_sym_NA_complex_] = ACTIONS(683),
    [anon_sym_NA_character_] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(685),
    [sym__semicolon] = ACTIONS(685),
    [sym__raw_string_literal] = ACTIONS(685),
    [sym__external_else] = ACTIONS(685),
    [sym__external_open_parenthesis] = ACTIONS(685),
    [sym__external_open_brace] = ACTIONS(685),
    [sym__external_open_bracket] = ACTIONS(685),
    [sym__external_open_bracket2] = ACTIONS(685),
  },
  [370] = {
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_BSLASH] = ACTIONS(768),
    [anon_sym_function] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_repeat] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_LT_DASH] = ACTIONS(768),
    [anon_sym_LT_LT_DASH] = ACTIONS(768),
    [anon_sym_COLON_EQ] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(766),
    [anon_sym_DASH_GT_GT] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(768),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [aux_sym_binary_operator_token1] = ACTIONS(768),
    [anon_sym_PIPE_GT] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_DOLLAR] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [sym__hex_literal] = ACTIONS(768),
    [sym__number_literal] = ACTIONS(766),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(768),
    [sym_dots] = ACTIONS(766),
    [sym_dot_dot_i] = ACTIONS(766),
    [sym_return] = ACTIONS(766),
    [sym_next] = ACTIONS(766),
    [sym_break] = ACTIONS(766),
    [sym_true] = ACTIONS(766),
    [sym_false] = ACTIONS(766),
    [sym_null] = ACTIONS(766),
    [sym_inf] = ACTIONS(766),
    [sym_nan] = ACTIONS(766),
    [anon_sym_NA] = ACTIONS(766),
    [anon_sym_NA_integer_] = ACTIONS(766),
    [anon_sym_NA_real_] = ACTIONS(766),
    [anon_sym_NA_complex_] = ACTIONS(766),
    [anon_sym_NA_character_] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(768),
    [sym__semicolon] = ACTIONS(768),
    [sym__raw_string_literal] = ACTIONS(768),
    [sym__external_else] = ACTIONS(768),
    [sym__external_open_parenthesis] = ACTIONS(768),
    [sym__external_open_brace] = ACTIONS(768),
    [sym__external_open_bracket] = ACTIONS(768),
    [sym__external_open_bracket2] = ACTIONS(768),
  },
  [371] = {
    [sym_identifier] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_repeat] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_LT_DASH] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(781),
    [anon_sym_COLON_EQ] = ACTIONS(781),
    [anon_sym_DASH_GT] = ACTIONS(783),
    [anon_sym_DASH_GT_GT] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_STAR_STAR] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [aux_sym_binary_operator_token1] = ACTIONS(781),
    [anon_sym_PIPE_GT] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [sym__hex_literal] = ACTIONS(781),
    [sym__number_literal] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(781),
    [anon_sym_DQUOTE] = ACTIONS(781),
    [sym_dots] = ACTIONS(783),
    [sym_dot_dot_i] = ACTIONS(783),
    [sym_return] = ACTIONS(783),
    [sym_next] = ACTIONS(783),
    [sym_break] = ACTIONS(783),
    [sym_true] = ACTIONS(783),
    [sym_false] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [sym_inf] = ACTIONS(783),
    [sym_nan] = ACTIONS(783),
    [anon_sym_NA] = ACTIONS(783),
    [anon_sym_NA_integer_] = ACTIONS(783),
    [anon_sym_NA_real_] = ACTIONS(783),
    [anon_sym_NA_complex_] = ACTIONS(783),
    [anon_sym_NA_character_] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(781),
    [sym__semicolon] = ACTIONS(781),
    [sym__raw_string_literal] = ACTIONS(781),
    [sym__external_else] = ACTIONS(781),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_open_brace] = ACTIONS(781),
    [sym__external_close_brace] = ACTIONS(781),
    [sym__external_open_bracket] = ACTIONS(781),
    [sym__external_open_bracket2] = ACTIONS(781),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(772),
    [sym_identifier] = ACTIONS(770),
    [anon_sym_BSLASH] = ACTIONS(772),
    [anon_sym_function] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_repeat] = ACTIONS(770),
    [anon_sym_QMARK] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_LT_DASH] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(772),
    [anon_sym_COLON_EQ] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(770),
    [anon_sym_DASH_GT_GT] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_PIPE_PIPE] = ACTIONS(772),
    [anon_sym_AMP_AMP] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(772),
    [anon_sym_BANG_EQ] = ACTIONS(772),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_STAR_STAR] = ACTIONS(772),
    [anon_sym_CARET] = ACTIONS(772),
    [aux_sym_binary_operator_token1] = ACTIONS(772),
    [anon_sym_PIPE_GT] = ACTIONS(772),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [sym__hex_literal] = ACTIONS(772),
    [sym__number_literal] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [sym_dots] = ACTIONS(770),
    [sym_dot_dot_i] = ACTIONS(770),
    [sym_return] = ACTIONS(770),
    [sym_next] = ACTIONS(770),
    [sym_break] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_null] = ACTIONS(770),
    [sym_inf] = ACTIONS(770),
    [sym_nan] = ACTIONS(770),
    [anon_sym_NA] = ACTIONS(770),
    [anon_sym_NA_integer_] = ACTIONS(770),
    [anon_sym_NA_real_] = ACTIONS(770),
    [anon_sym_NA_complex_] = ACTIONS(770),
    [anon_sym_NA_character_] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(772),
    [sym__semicolon] = ACTIONS(772),
    [sym__raw_string_literal] = ACTIONS(772),
    [sym__external_else] = ACTIONS(772),
    [sym__external_open_parenthesis] = ACTIONS(772),
    [sym__external_open_brace] = ACTIONS(772),
    [sym__external_open_bracket] = ACTIONS(772),
    [sym__external_open_bracket2] = ACTIONS(772),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(740),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_repeat] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_LT_DASH] = ACTIONS(740),
    [anon_sym_LT_LT_DASH] = ACTIONS(740),
    [anon_sym_COLON_EQ] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(738),
    [anon_sym_DASH_GT_GT] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [aux_sym_binary_operator_token1] = ACTIONS(740),
    [anon_sym_PIPE_GT] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [sym__hex_literal] = ACTIONS(740),
    [sym__number_literal] = ACTIONS(738),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_dots] = ACTIONS(738),
    [sym_dot_dot_i] = ACTIONS(738),
    [sym_return] = ACTIONS(738),
    [sym_next] = ACTIONS(738),
    [sym_break] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_null] = ACTIONS(738),
    [sym_inf] = ACTIONS(738),
    [sym_nan] = ACTIONS(738),
    [anon_sym_NA] = ACTIONS(738),
    [anon_sym_NA_integer_] = ACTIONS(738),
    [anon_sym_NA_real_] = ACTIONS(738),
    [anon_sym_NA_complex_] = ACTIONS(738),
    [anon_sym_NA_character_] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(740),
    [sym__semicolon] = ACTIONS(740),
    [sym__raw_string_literal] = ACTIONS(740),
    [sym__external_else] = ACTIONS(740),
    [sym__external_open_parenthesis] = ACTIONS(740),
    [sym__external_open_brace] = ACTIONS(740),
    [sym__external_open_bracket] = ACTIONS(740),
    [sym__external_open_bracket2] = ACTIONS(740),
  },
  [374] = {
    [ts_builtin_sym_end] = ACTIONS(744),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_repeat] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_DASH] = ACTIONS(744),
    [anon_sym_LT_LT_DASH] = ACTIONS(744),
    [anon_sym_COLON_EQ] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(742),
    [anon_sym_DASH_GT_GT] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(744),
    [anon_sym_AMP_AMP] = ACTIONS(744),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(744),
    [anon_sym_STAR_STAR] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(744),
    [aux_sym_binary_operator_token1] = ACTIONS(744),
    [anon_sym_PIPE_GT] = ACTIONS(744),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(744),
    [sym__hex_literal] = ACTIONS(744),
    [sym__number_literal] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(744),
    [sym_dots] = ACTIONS(742),
    [sym_dot_dot_i] = ACTIONS(742),
    [sym_return] = ACTIONS(742),
    [sym_next] = ACTIONS(742),
    [sym_break] = ACTIONS(742),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_inf] = ACTIONS(742),
    [sym_nan] = ACTIONS(742),
    [anon_sym_NA] = ACTIONS(742),
    [anon_sym_NA_integer_] = ACTIONS(742),
    [anon_sym_NA_real_] = ACTIONS(742),
    [anon_sym_NA_complex_] = ACTIONS(742),
    [anon_sym_NA_character_] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(744),
    [sym__semicolon] = ACTIONS(744),
    [sym__raw_string_literal] = ACTIONS(744),
    [sym__external_else] = ACTIONS(744),
    [sym__external_open_parenthesis] = ACTIONS(744),
    [sym__external_open_brace] = ACTIONS(744),
    [sym__external_open_bracket] = ACTIONS(744),
    [sym__external_open_bracket2] = ACTIONS(744),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(748),
    [sym_identifier] = ACTIONS(746),
    [anon_sym_BSLASH] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_while] = ACTIONS(746),
    [anon_sym_repeat] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_LT_DASH] = ACTIONS(748),
    [anon_sym_LT_LT_DASH] = ACTIONS(748),
    [anon_sym_COLON_EQ] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(746),
    [anon_sym_DASH_GT_GT] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(748),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_STAR_STAR] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(748),
    [aux_sym_binary_operator_token1] = ACTIONS(748),
    [anon_sym_PIPE_GT] = ACTIONS(748),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [sym__hex_literal] = ACTIONS(748),
    [sym__number_literal] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [sym_dots] = ACTIONS(746),
    [sym_dot_dot_i] = ACTIONS(746),
    [sym_return] = ACTIONS(746),
    [sym_next] = ACTIONS(746),
    [sym_break] = ACTIONS(746),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_null] = ACTIONS(746),
    [sym_inf] = ACTIONS(746),
    [sym_nan] = ACTIONS(746),
    [anon_sym_NA] = ACTIONS(746),
    [anon_sym_NA_integer_] = ACTIONS(746),
    [anon_sym_NA_real_] = ACTIONS(746),
    [anon_sym_NA_complex_] = ACTIONS(746),
    [anon_sym_NA_character_] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(748),
    [sym__semicolon] = ACTIONS(748),
    [sym__raw_string_literal] = ACTIONS(748),
    [sym__external_else] = ACTIONS(748),
    [sym__external_open_parenthesis] = ACTIONS(748),
    [sym__external_open_brace] = ACTIONS(748),
    [sym__external_open_bracket] = ACTIONS(748),
    [sym__external_open_bracket2] = ACTIONS(748),
  },
  [376] = {
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_repeat] = ACTIONS(779),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_LT_DASH] = ACTIONS(777),
    [anon_sym_LT_LT_DASH] = ACTIONS(777),
    [anon_sym_COLON_EQ] = ACTIONS(777),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_DASH_GT_GT] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [aux_sym_binary_operator_token1] = ACTIONS(777),
    [anon_sym_PIPE_GT] = ACTIONS(777),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [sym__hex_literal] = ACTIONS(777),
    [sym__number_literal] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(777),
    [sym_dots] = ACTIONS(779),
    [sym_dot_dot_i] = ACTIONS(779),
    [sym_return] = ACTIONS(779),
    [sym_next] = ACTIONS(779),
    [sym_break] = ACTIONS(779),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [sym_inf] = ACTIONS(779),
    [sym_nan] = ACTIONS(779),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(777),
    [sym__semicolon] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(777),
    [sym__external_else] = ACTIONS(777),
    [sym__external_open_parenthesis] = ACTIONS(777),
    [sym__external_open_brace] = ACTIONS(777),
    [sym__external_close_brace] = ACTIONS(777),
    [sym__external_open_bracket] = ACTIONS(777),
    [sym__external_open_bracket2] = ACTIONS(777),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_BSLASH] = ACTIONS(732),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_repeat] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_COLON_EQ] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_DASH_GT_GT] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_BANG_EQ] = ACTIONS(732),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_STAR_STAR] = ACTIONS(732),
    [anon_sym_CARET] = ACTIONS(732),
    [aux_sym_binary_operator_token1] = ACTIONS(732),
    [anon_sym_PIPE_GT] = ACTIONS(732),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [sym__hex_literal] = ACTIONS(732),
    [sym__number_literal] = ACTIONS(730),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [sym_dots] = ACTIONS(730),
    [sym_dot_dot_i] = ACTIONS(730),
    [sym_return] = ACTIONS(730),
    [sym_next] = ACTIONS(730),
    [sym_break] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_inf] = ACTIONS(730),
    [sym_nan] = ACTIONS(730),
    [anon_sym_NA] = ACTIONS(730),
    [anon_sym_NA_integer_] = ACTIONS(730),
    [anon_sym_NA_real_] = ACTIONS(730),
    [anon_sym_NA_complex_] = ACTIONS(730),
    [anon_sym_NA_character_] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(732),
    [sym__semicolon] = ACTIONS(732),
    [sym__raw_string_literal] = ACTIONS(732),
    [sym__external_open_parenthesis] = ACTIONS(732),
    [sym__external_open_brace] = ACTIONS(732),
    [sym__external_open_bracket] = ACTIONS(732),
    [sym__external_open_bracket2] = ACTIONS(732),
  },
  [378] = {
    [ts_builtin_sym_end] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_repeat] = ACTIONS(779),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_LT_DASH] = ACTIONS(777),
    [anon_sym_LT_LT_DASH] = ACTIONS(777),
    [anon_sym_COLON_EQ] = ACTIONS(777),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_DASH_GT_GT] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [aux_sym_binary_operator_token1] = ACTIONS(777),
    [anon_sym_PIPE_GT] = ACTIONS(777),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [sym__hex_literal] = ACTIONS(777),
    [sym__number_literal] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(777),
    [sym_dots] = ACTIONS(779),
    [sym_dot_dot_i] = ACTIONS(779),
    [sym_return] = ACTIONS(779),
    [sym_next] = ACTIONS(779),
    [sym_break] = ACTIONS(779),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [sym_inf] = ACTIONS(779),
    [sym_nan] = ACTIONS(779),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(777),
    [sym__semicolon] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(777),
    [sym__external_open_parenthesis] = ACTIONS(777),
    [sym__external_open_brace] = ACTIONS(777),
    [sym__external_open_bracket] = ACTIONS(777),
    [sym__external_open_bracket2] = ACTIONS(777),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(748),
    [sym_identifier] = ACTIONS(746),
    [anon_sym_BSLASH] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_while] = ACTIONS(746),
    [anon_sym_repeat] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_LT_DASH] = ACTIONS(748),
    [anon_sym_LT_LT_DASH] = ACTIONS(748),
    [anon_sym_COLON_EQ] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(746),
    [anon_sym_DASH_GT_GT] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(748),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_STAR_STAR] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(748),
    [aux_sym_binary_operator_token1] = ACTIONS(748),
    [anon_sym_PIPE_GT] = ACTIONS(748),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [sym__hex_literal] = ACTIONS(748),
    [sym__number_literal] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [sym_dots] = ACTIONS(746),
    [sym_dot_dot_i] = ACTIONS(746),
    [sym_return] = ACTIONS(746),
    [sym_next] = ACTIONS(746),
    [sym_break] = ACTIONS(746),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_null] = ACTIONS(746),
    [sym_inf] = ACTIONS(746),
    [sym_nan] = ACTIONS(746),
    [anon_sym_NA] = ACTIONS(746),
    [anon_sym_NA_integer_] = ACTIONS(746),
    [anon_sym_NA_real_] = ACTIONS(746),
    [anon_sym_NA_complex_] = ACTIONS(746),
    [anon_sym_NA_character_] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(748),
    [sym__semicolon] = ACTIONS(748),
    [sym__raw_string_literal] = ACTIONS(748),
    [sym__external_open_parenthesis] = ACTIONS(748),
    [sym__external_open_brace] = ACTIONS(748),
    [sym__external_open_bracket] = ACTIONS(748),
    [sym__external_open_bracket2] = ACTIONS(748),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(703),
    [sym_identifier] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_repeat] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_LT_DASH] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(703),
    [anon_sym_COLON_EQ] = ACTIONS(703),
    [anon_sym_DASH_GT] = ACTIONS(705),
    [anon_sym_DASH_GT_GT] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_CARET] = ACTIONS(703),
    [aux_sym_binary_operator_token1] = ACTIONS(703),
    [anon_sym_PIPE_GT] = ACTIONS(703),
    [anon_sym_COLON] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(703),
    [sym__hex_literal] = ACTIONS(703),
    [sym__number_literal] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(703),
    [sym_dots] = ACTIONS(705),
    [sym_dot_dot_i] = ACTIONS(705),
    [sym_return] = ACTIONS(705),
    [sym_next] = ACTIONS(705),
    [sym_break] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [sym_inf] = ACTIONS(705),
    [sym_nan] = ACTIONS(705),
    [anon_sym_NA] = ACTIONS(705),
    [anon_sym_NA_integer_] = ACTIONS(705),
    [anon_sym_NA_real_] = ACTIONS(705),
    [anon_sym_NA_complex_] = ACTIONS(705),
    [anon_sym_NA_character_] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(703),
    [sym__semicolon] = ACTIONS(703),
    [sym__raw_string_literal] = ACTIONS(703),
    [sym__external_open_parenthesis] = ACTIONS(703),
    [sym__external_open_brace] = ACTIONS(703),
    [sym__external_open_bracket] = ACTIONS(703),
    [sym__external_open_bracket2] = ACTIONS(703),
  },
  [381] = {
    [ts_builtin_sym_end] = ACTIONS(752),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_BSLASH] = ACTIONS(752),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(750),
    [anon_sym_while] = ACTIONS(750),
    [anon_sym_repeat] = ACTIONS(750),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_LT_DASH] = ACTIONS(752),
    [anon_sym_LT_LT_DASH] = ACTIONS(752),
    [anon_sym_COLON_EQ] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(750),
    [anon_sym_DASH_GT_GT] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(750),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_PIPE_PIPE] = ACTIONS(752),
    [anon_sym_AMP_AMP] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [aux_sym_binary_operator_token1] = ACTIONS(752),
    [anon_sym_PIPE_GT] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(750),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [sym__hex_literal] = ACTIONS(752),
    [sym__number_literal] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_dots] = ACTIONS(750),
    [sym_dot_dot_i] = ACTIONS(750),
    [sym_return] = ACTIONS(750),
    [sym_next] = ACTIONS(750),
    [sym_break] = ACTIONS(750),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_inf] = ACTIONS(750),
    [sym_nan] = ACTIONS(750),
    [anon_sym_NA] = ACTIONS(750),
    [anon_sym_NA_integer_] = ACTIONS(750),
    [anon_sym_NA_real_] = ACTIONS(750),
    [anon_sym_NA_complex_] = ACTIONS(750),
    [anon_sym_NA_character_] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(752),
    [sym__semicolon] = ACTIONS(752),
    [sym__raw_string_literal] = ACTIONS(752),
    [sym__external_open_parenthesis] = ACTIONS(752),
    [sym__external_open_brace] = ACTIONS(752),
    [sym__external_open_bracket] = ACTIONS(752),
    [sym__external_open_bracket2] = ACTIONS(752),
  },
  [382] = {
    [ts_builtin_sym_end] = ACTIONS(714),
    [sym_identifier] = ACTIONS(716),
    [anon_sym_BSLASH] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_LT_DASH] = ACTIONS(714),
    [anon_sym_LT_LT_DASH] = ACTIONS(714),
    [anon_sym_COLON_EQ] = ACTIONS(714),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_DASH_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(716),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(716),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [aux_sym_binary_operator_token1] = ACTIONS(714),
    [anon_sym_PIPE_GT] = ACTIONS(714),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [sym__hex_literal] = ACTIONS(714),
    [sym__number_literal] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [sym_dots] = ACTIONS(716),
    [sym_dot_dot_i] = ACTIONS(716),
    [sym_return] = ACTIONS(716),
    [sym_next] = ACTIONS(716),
    [sym_break] = ACTIONS(716),
    [sym_true] = ACTIONS(716),
    [sym_false] = ACTIONS(716),
    [sym_null] = ACTIONS(716),
    [sym_inf] = ACTIONS(716),
    [sym_nan] = ACTIONS(716),
    [anon_sym_NA] = ACTIONS(716),
    [anon_sym_NA_integer_] = ACTIONS(716),
    [anon_sym_NA_real_] = ACTIONS(716),
    [anon_sym_NA_complex_] = ACTIONS(716),
    [anon_sym_NA_character_] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(714),
    [sym__semicolon] = ACTIONS(714),
    [sym__raw_string_literal] = ACTIONS(714),
    [sym__external_open_parenthesis] = ACTIONS(714),
    [sym__external_open_brace] = ACTIONS(714),
    [sym__external_open_bracket] = ACTIONS(714),
    [sym__external_open_bracket2] = ACTIONS(714),
  },
  [383] = {
    [ts_builtin_sym_end] = ACTIONS(756),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_BSLASH] = ACTIONS(756),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(754),
    [anon_sym_while] = ACTIONS(754),
    [anon_sym_repeat] = ACTIONS(754),
    [anon_sym_QMARK] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_LT_DASH] = ACTIONS(756),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_COLON_EQ] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(754),
    [anon_sym_DASH_GT_GT] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(754),
    [anon_sym_AMP] = ACTIONS(754),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(756),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(756),
    [anon_sym_BANG_EQ] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(756),
    [anon_sym_STAR_STAR] = ACTIONS(756),
    [anon_sym_CARET] = ACTIONS(756),
    [aux_sym_binary_operator_token1] = ACTIONS(756),
    [anon_sym_PIPE_GT] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(756),
    [sym__hex_literal] = ACTIONS(756),
    [sym__number_literal] = ACTIONS(754),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(756),
    [sym_dots] = ACTIONS(754),
    [sym_dot_dot_i] = ACTIONS(754),
    [sym_return] = ACTIONS(754),
    [sym_next] = ACTIONS(754),
    [sym_break] = ACTIONS(754),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_inf] = ACTIONS(754),
    [sym_nan] = ACTIONS(754),
    [anon_sym_NA] = ACTIONS(754),
    [anon_sym_NA_integer_] = ACTIONS(754),
    [anon_sym_NA_real_] = ACTIONS(754),
    [anon_sym_NA_complex_] = ACTIONS(754),
    [anon_sym_NA_character_] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(756),
    [sym__semicolon] = ACTIONS(756),
    [sym__raw_string_literal] = ACTIONS(756),
    [sym__external_open_parenthesis] = ACTIONS(756),
    [sym__external_open_brace] = ACTIONS(756),
    [sym__external_open_bracket] = ACTIONS(756),
    [sym__external_open_bracket2] = ACTIONS(756),
  },
  [384] = {
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_BSLASH] = ACTIONS(768),
    [anon_sym_function] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_repeat] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_LT_DASH] = ACTIONS(768),
    [anon_sym_LT_LT_DASH] = ACTIONS(768),
    [anon_sym_COLON_EQ] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(766),
    [anon_sym_DASH_GT_GT] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(768),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [aux_sym_binary_operator_token1] = ACTIONS(768),
    [anon_sym_PIPE_GT] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_DOLLAR] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [sym__hex_literal] = ACTIONS(768),
    [sym__number_literal] = ACTIONS(766),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(768),
    [sym_dots] = ACTIONS(766),
    [sym_dot_dot_i] = ACTIONS(766),
    [sym_return] = ACTIONS(766),
    [sym_next] = ACTIONS(766),
    [sym_break] = ACTIONS(766),
    [sym_true] = ACTIONS(766),
    [sym_false] = ACTIONS(766),
    [sym_null] = ACTIONS(766),
    [sym_inf] = ACTIONS(766),
    [sym_nan] = ACTIONS(766),
    [anon_sym_NA] = ACTIONS(766),
    [anon_sym_NA_integer_] = ACTIONS(766),
    [anon_sym_NA_real_] = ACTIONS(766),
    [anon_sym_NA_complex_] = ACTIONS(766),
    [anon_sym_NA_character_] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(768),
    [sym__semicolon] = ACTIONS(768),
    [sym__raw_string_literal] = ACTIONS(768),
    [sym__external_open_parenthesis] = ACTIONS(768),
    [sym__external_open_brace] = ACTIONS(768),
    [sym__external_open_bracket] = ACTIONS(768),
    [sym__external_open_bracket2] = ACTIONS(768),
  },
  [385] = {
    [sym_identifier] = ACTIONS(762),
    [anon_sym_BSLASH] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_repeat] = ACTIONS(762),
    [anon_sym_QMARK] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_LT_DASH] = ACTIONS(764),
    [anon_sym_LT_LT_DASH] = ACTIONS(764),
    [anon_sym_COLON_EQ] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(762),
    [anon_sym_DASH_GT_GT] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(764),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(764),
    [aux_sym_binary_operator_token1] = ACTIONS(764),
    [anon_sym_PIPE_GT] = ACTIONS(764),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_DOLLAR] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [sym__hex_literal] = ACTIONS(764),
    [sym__number_literal] = ACTIONS(762),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(764),
    [sym_dots] = ACTIONS(762),
    [sym_dot_dot_i] = ACTIONS(762),
    [sym_return] = ACTIONS(762),
    [sym_next] = ACTIONS(762),
    [sym_break] = ACTIONS(762),
    [sym_true] = ACTIONS(762),
    [sym_false] = ACTIONS(762),
    [sym_null] = ACTIONS(762),
    [sym_inf] = ACTIONS(762),
    [sym_nan] = ACTIONS(762),
    [anon_sym_NA] = ACTIONS(762),
    [anon_sym_NA_integer_] = ACTIONS(762),
    [anon_sym_NA_real_] = ACTIONS(762),
    [anon_sym_NA_complex_] = ACTIONS(762),
    [anon_sym_NA_character_] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(764),
    [sym__semicolon] = ACTIONS(764),
    [sym__raw_string_literal] = ACTIONS(764),
    [sym__external_open_parenthesis] = ACTIONS(764),
    [sym__external_open_brace] = ACTIONS(764),
    [sym__external_close_brace] = ACTIONS(764),
    [sym__external_open_bracket] = ACTIONS(764),
    [sym__external_open_bracket2] = ACTIONS(764),
  },
  [386] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1687),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(821),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_if] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_repeat] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(697),
    [anon_sym_TILDE] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(695),
    [anon_sym_DASH_GT_GT] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_EQ] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_STAR_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(697),
    [aux_sym_binary_operator_token1] = ACTIONS(697),
    [anon_sym_PIPE_GT] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(697),
    [sym__hex_literal] = ACTIONS(697),
    [sym__number_literal] = ACTIONS(695),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [sym_dots] = ACTIONS(695),
    [sym_dot_dot_i] = ACTIONS(695),
    [sym_return] = ACTIONS(695),
    [sym_next] = ACTIONS(695),
    [sym_break] = ACTIONS(695),
    [sym_true] = ACTIONS(695),
    [sym_false] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [sym_inf] = ACTIONS(695),
    [sym_nan] = ACTIONS(695),
    [anon_sym_NA] = ACTIONS(695),
    [anon_sym_NA_integer_] = ACTIONS(695),
    [anon_sym_NA_real_] = ACTIONS(695),
    [anon_sym_NA_complex_] = ACTIONS(695),
    [anon_sym_NA_character_] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(697),
    [sym__semicolon] = ACTIONS(697),
    [sym__raw_string_literal] = ACTIONS(697),
    [sym__external_open_parenthesis] = ACTIONS(697),
    [sym__external_open_brace] = ACTIONS(697),
    [sym__external_open_bracket] = ACTIONS(697),
    [sym__external_open_bracket2] = ACTIONS(697),
  },
  [388] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_COLON_EQ] = ACTIONS(707),
    [anon_sym_DASH_GT] = ACTIONS(709),
    [anon_sym_DASH_GT_GT] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(707),
    [anon_sym_EQ_EQ] = ACTIONS(707),
    [anon_sym_BANG_EQ] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_CARET] = ACTIONS(707),
    [aux_sym_binary_operator_token1] = ACTIONS(707),
    [anon_sym_PIPE_GT] = ACTIONS(707),
    [anon_sym_COLON] = ACTIONS(709),
    [anon_sym_DOLLAR] = ACTIONS(707),
    [anon_sym_AT] = ACTIONS(707),
    [sym__hex_literal] = ACTIONS(707),
    [sym__number_literal] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [sym_dots] = ACTIONS(709),
    [sym_dot_dot_i] = ACTIONS(709),
    [sym_return] = ACTIONS(709),
    [sym_next] = ACTIONS(709),
    [sym_break] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_inf] = ACTIONS(709),
    [sym_nan] = ACTIONS(709),
    [anon_sym_NA] = ACTIONS(709),
    [anon_sym_NA_integer_] = ACTIONS(709),
    [anon_sym_NA_real_] = ACTIONS(709),
    [anon_sym_NA_complex_] = ACTIONS(709),
    [anon_sym_NA_character_] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(707),
    [sym__semicolon] = ACTIONS(707),
    [sym__raw_string_literal] = ACTIONS(707),
    [sym__external_open_parenthesis] = ACTIONS(707),
    [sym__external_open_brace] = ACTIONS(707),
    [sym__external_close_brace] = ACTIONS(707),
    [sym__external_open_bracket] = ACTIONS(707),
    [sym__external_open_bracket2] = ACTIONS(707),
  },
  [389] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(397),
    [aux_sym_braced_expression_repeat1] = STATE(398),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(823),
  },
  [390] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1753),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(825),
  },
  [391] = {
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_identifier] = ACTIONS(758),
    [anon_sym_BSLASH] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_while] = ACTIONS(758),
    [anon_sym_repeat] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_LT_DASH] = ACTIONS(760),
    [anon_sym_LT_LT_DASH] = ACTIONS(760),
    [anon_sym_COLON_EQ] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(758),
    [anon_sym_DASH_GT_GT] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_PIPE_PIPE] = ACTIONS(760),
    [anon_sym_AMP_AMP] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(760),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_STAR_STAR] = ACTIONS(760),
    [anon_sym_CARET] = ACTIONS(760),
    [aux_sym_binary_operator_token1] = ACTIONS(760),
    [anon_sym_PIPE_GT] = ACTIONS(760),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_DOLLAR] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [sym__hex_literal] = ACTIONS(760),
    [sym__number_literal] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [sym_dots] = ACTIONS(758),
    [sym_dot_dot_i] = ACTIONS(758),
    [sym_return] = ACTIONS(758),
    [sym_next] = ACTIONS(758),
    [sym_break] = ACTIONS(758),
    [sym_true] = ACTIONS(758),
    [sym_false] = ACTIONS(758),
    [sym_null] = ACTIONS(758),
    [sym_inf] = ACTIONS(758),
    [sym_nan] = ACTIONS(758),
    [anon_sym_NA] = ACTIONS(758),
    [anon_sym_NA_integer_] = ACTIONS(758),
    [anon_sym_NA_real_] = ACTIONS(758),
    [anon_sym_NA_complex_] = ACTIONS(758),
    [anon_sym_NA_character_] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(760),
    [sym__semicolon] = ACTIONS(760),
    [sym__raw_string_literal] = ACTIONS(760),
    [sym__external_open_parenthesis] = ACTIONS(760),
    [sym__external_open_brace] = ACTIONS(760),
    [sym__external_open_bracket] = ACTIONS(760),
    [sym__external_open_bracket2] = ACTIONS(760),
  },
  [392] = {
    [ts_builtin_sym_end] = ACTIONS(764),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_BSLASH] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_repeat] = ACTIONS(762),
    [anon_sym_QMARK] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_LT_DASH] = ACTIONS(764),
    [anon_sym_LT_LT_DASH] = ACTIONS(764),
    [anon_sym_COLON_EQ] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(762),
    [anon_sym_DASH_GT_GT] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(764),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(764),
    [aux_sym_binary_operator_token1] = ACTIONS(764),
    [anon_sym_PIPE_GT] = ACTIONS(764),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_DOLLAR] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [sym__hex_literal] = ACTIONS(764),
    [sym__number_literal] = ACTIONS(762),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(764),
    [sym_dots] = ACTIONS(762),
    [sym_dot_dot_i] = ACTIONS(762),
    [sym_return] = ACTIONS(762),
    [sym_next] = ACTIONS(762),
    [sym_break] = ACTIONS(762),
    [sym_true] = ACTIONS(762),
    [sym_false] = ACTIONS(762),
    [sym_null] = ACTIONS(762),
    [sym_inf] = ACTIONS(762),
    [sym_nan] = ACTIONS(762),
    [anon_sym_NA] = ACTIONS(762),
    [anon_sym_NA_integer_] = ACTIONS(762),
    [anon_sym_NA_real_] = ACTIONS(762),
    [anon_sym_NA_complex_] = ACTIONS(762),
    [anon_sym_NA_character_] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(764),
    [sym__semicolon] = ACTIONS(764),
    [sym__raw_string_literal] = ACTIONS(764),
    [sym__external_open_parenthesis] = ACTIONS(764),
    [sym__external_open_brace] = ACTIONS(764),
    [sym__external_open_bracket] = ACTIONS(764),
    [sym__external_open_bracket2] = ACTIONS(764),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(707),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_COLON_EQ] = ACTIONS(707),
    [anon_sym_DASH_GT] = ACTIONS(709),
    [anon_sym_DASH_GT_GT] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(707),
    [anon_sym_EQ_EQ] = ACTIONS(707),
    [anon_sym_BANG_EQ] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_CARET] = ACTIONS(707),
    [aux_sym_binary_operator_token1] = ACTIONS(707),
    [anon_sym_PIPE_GT] = ACTIONS(707),
    [anon_sym_COLON] = ACTIONS(709),
    [anon_sym_DOLLAR] = ACTIONS(707),
    [anon_sym_AT] = ACTIONS(707),
    [sym__hex_literal] = ACTIONS(707),
    [sym__number_literal] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [sym_dots] = ACTIONS(709),
    [sym_dot_dot_i] = ACTIONS(709),
    [sym_return] = ACTIONS(709),
    [sym_next] = ACTIONS(709),
    [sym_break] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_inf] = ACTIONS(709),
    [sym_nan] = ACTIONS(709),
    [anon_sym_NA] = ACTIONS(709),
    [anon_sym_NA_integer_] = ACTIONS(709),
    [anon_sym_NA_real_] = ACTIONS(709),
    [anon_sym_NA_complex_] = ACTIONS(709),
    [anon_sym_NA_character_] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(707),
    [sym__semicolon] = ACTIONS(707),
    [sym__raw_string_literal] = ACTIONS(707),
    [sym__external_open_parenthesis] = ACTIONS(707),
    [sym__external_open_brace] = ACTIONS(707),
    [sym__external_open_bracket] = ACTIONS(707),
    [sym__external_open_bracket2] = ACTIONS(707),
  },
  [394] = {
    [sym_identifier] = ACTIONS(726),
    [anon_sym_BSLASH] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_repeat] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_COLON_EQ] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(726),
    [anon_sym_DASH_GT_GT] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [anon_sym_STAR_STAR] = ACTIONS(728),
    [anon_sym_CARET] = ACTIONS(728),
    [aux_sym_binary_operator_token1] = ACTIONS(728),
    [anon_sym_PIPE_GT] = ACTIONS(728),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [anon_sym_AT] = ACTIONS(728),
    [sym__hex_literal] = ACTIONS(728),
    [sym__number_literal] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_dots] = ACTIONS(726),
    [sym_dot_dot_i] = ACTIONS(726),
    [sym_return] = ACTIONS(726),
    [sym_next] = ACTIONS(726),
    [sym_break] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_inf] = ACTIONS(726),
    [sym_nan] = ACTIONS(726),
    [anon_sym_NA] = ACTIONS(726),
    [anon_sym_NA_integer_] = ACTIONS(726),
    [anon_sym_NA_real_] = ACTIONS(726),
    [anon_sym_NA_complex_] = ACTIONS(726),
    [anon_sym_NA_character_] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(728),
    [sym__semicolon] = ACTIONS(728),
    [sym__raw_string_literal] = ACTIONS(728),
    [sym__external_open_parenthesis] = ACTIONS(728),
    [sym__external_open_brace] = ACTIONS(728),
    [sym__external_close_brace] = ACTIONS(728),
    [sym__external_open_bracket] = ACTIONS(728),
    [sym__external_open_bracket2] = ACTIONS(728),
  },
  [395] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(699),
    [anon_sym_while] = ACTIONS(699),
    [anon_sym_repeat] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(701),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [aux_sym_binary_operator_token1] = ACTIONS(701),
    [anon_sym_PIPE_GT] = ACTIONS(701),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [sym__hex_literal] = ACTIONS(701),
    [sym__number_literal] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [sym_dots] = ACTIONS(699),
    [sym_dot_dot_i] = ACTIONS(699),
    [sym_return] = ACTIONS(699),
    [sym_next] = ACTIONS(699),
    [sym_break] = ACTIONS(699),
    [sym_true] = ACTIONS(699),
    [sym_false] = ACTIONS(699),
    [sym_null] = ACTIONS(699),
    [sym_inf] = ACTIONS(699),
    [sym_nan] = ACTIONS(699),
    [anon_sym_NA] = ACTIONS(699),
    [anon_sym_NA_integer_] = ACTIONS(699),
    [anon_sym_NA_real_] = ACTIONS(699),
    [anon_sym_NA_complex_] = ACTIONS(699),
    [anon_sym_NA_character_] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(701),
    [sym__semicolon] = ACTIONS(701),
    [sym__raw_string_literal] = ACTIONS(701),
    [sym__external_open_parenthesis] = ACTIONS(701),
    [sym__external_open_brace] = ACTIONS(701),
    [sym__external_open_bracket] = ACTIONS(701),
    [sym__external_open_bracket2] = ACTIONS(701),
  },
  [396] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_repeat] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_LT_DASH] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(685),
    [anon_sym_COLON_EQ] = ACTIONS(685),
    [anon_sym_DASH_GT] = ACTIONS(683),
    [anon_sym_DASH_GT_GT] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(683),
    [anon_sym_PIPE_PIPE] = ACTIONS(685),
    [anon_sym_AMP_AMP] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_STAR_STAR] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [aux_sym_binary_operator_token1] = ACTIONS(685),
    [anon_sym_PIPE_GT] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [sym__hex_literal] = ACTIONS(685),
    [sym__number_literal] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [sym_dots] = ACTIONS(683),
    [sym_dot_dot_i] = ACTIONS(683),
    [sym_return] = ACTIONS(683),
    [sym_next] = ACTIONS(683),
    [sym_break] = ACTIONS(683),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [sym_inf] = ACTIONS(683),
    [sym_nan] = ACTIONS(683),
    [anon_sym_NA] = ACTIONS(683),
    [anon_sym_NA_integer_] = ACTIONS(683),
    [anon_sym_NA_real_] = ACTIONS(683),
    [anon_sym_NA_complex_] = ACTIONS(683),
    [anon_sym_NA_character_] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(685),
    [sym__semicolon] = ACTIONS(685),
    [sym__raw_string_literal] = ACTIONS(685),
    [sym__external_open_parenthesis] = ACTIONS(685),
    [sym__external_open_brace] = ACTIONS(685),
    [sym__external_open_bracket] = ACTIONS(685),
    [sym__external_open_bracket2] = ACTIONS(685),
  },
  [397] = {
    [ts_builtin_sym_end] = ACTIONS(772),
    [sym_identifier] = ACTIONS(770),
    [anon_sym_BSLASH] = ACTIONS(772),
    [anon_sym_function] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_repeat] = ACTIONS(770),
    [anon_sym_QMARK] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_LT_DASH] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(772),
    [anon_sym_COLON_EQ] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(770),
    [anon_sym_DASH_GT_GT] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_PIPE_PIPE] = ACTIONS(772),
    [anon_sym_AMP_AMP] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(772),
    [anon_sym_BANG_EQ] = ACTIONS(772),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_STAR_STAR] = ACTIONS(772),
    [anon_sym_CARET] = ACTIONS(772),
    [aux_sym_binary_operator_token1] = ACTIONS(772),
    [anon_sym_PIPE_GT] = ACTIONS(772),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [sym__hex_literal] = ACTIONS(772),
    [sym__number_literal] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [sym_dots] = ACTIONS(770),
    [sym_dot_dot_i] = ACTIONS(770),
    [sym_return] = ACTIONS(770),
    [sym_next] = ACTIONS(770),
    [sym_break] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_null] = ACTIONS(770),
    [sym_inf] = ACTIONS(770),
    [sym_nan] = ACTIONS(770),
    [anon_sym_NA] = ACTIONS(770),
    [anon_sym_NA_integer_] = ACTIONS(770),
    [anon_sym_NA_real_] = ACTIONS(770),
    [anon_sym_NA_complex_] = ACTIONS(770),
    [anon_sym_NA_character_] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(772),
    [sym__semicolon] = ACTIONS(772),
    [sym__raw_string_literal] = ACTIONS(772),
    [sym__external_open_parenthesis] = ACTIONS(772),
    [sym__external_open_brace] = ACTIONS(772),
    [sym__external_open_bracket] = ACTIONS(772),
    [sym__external_open_bracket2] = ACTIONS(772),
  },
  [398] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(396),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(827),
  },
  [399] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1708),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(829),
  },
  [400] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1682),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(831),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(781),
    [sym_identifier] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_repeat] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_LT_DASH] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(781),
    [anon_sym_COLON_EQ] = ACTIONS(781),
    [anon_sym_DASH_GT] = ACTIONS(783),
    [anon_sym_DASH_GT_GT] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_STAR_STAR] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [aux_sym_binary_operator_token1] = ACTIONS(781),
    [anon_sym_PIPE_GT] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [sym__hex_literal] = ACTIONS(781),
    [sym__number_literal] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(781),
    [anon_sym_DQUOTE] = ACTIONS(781),
    [sym_dots] = ACTIONS(783),
    [sym_dot_dot_i] = ACTIONS(783),
    [sym_return] = ACTIONS(783),
    [sym_next] = ACTIONS(783),
    [sym_break] = ACTIONS(783),
    [sym_true] = ACTIONS(783),
    [sym_false] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [sym_inf] = ACTIONS(783),
    [sym_nan] = ACTIONS(783),
    [anon_sym_NA] = ACTIONS(783),
    [anon_sym_NA_integer_] = ACTIONS(783),
    [anon_sym_NA_real_] = ACTIONS(783),
    [anon_sym_NA_complex_] = ACTIONS(783),
    [anon_sym_NA_character_] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(781),
    [sym__semicolon] = ACTIONS(781),
    [sym__raw_string_literal] = ACTIONS(781),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_open_brace] = ACTIONS(781),
    [sym__external_open_bracket] = ACTIONS(781),
    [sym__external_open_bracket2] = ACTIONS(781),
  },
  [402] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1710),
    [aux_sym_braced_expression_repeat1] = STATE(390),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(833),
  },
  [403] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(327),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(835),
  },
  [404] = {
    [sym_identifier] = ACTIONS(750),
    [anon_sym_BSLASH] = ACTIONS(752),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(750),
    [anon_sym_while] = ACTIONS(750),
    [anon_sym_repeat] = ACTIONS(750),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_LT_DASH] = ACTIONS(752),
    [anon_sym_LT_LT_DASH] = ACTIONS(752),
    [anon_sym_COLON_EQ] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(750),
    [anon_sym_DASH_GT_GT] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(750),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_PIPE_PIPE] = ACTIONS(752),
    [anon_sym_AMP_AMP] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [aux_sym_binary_operator_token1] = ACTIONS(752),
    [anon_sym_PIPE_GT] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(750),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [sym__hex_literal] = ACTIONS(752),
    [sym__number_literal] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_dots] = ACTIONS(750),
    [sym_dot_dot_i] = ACTIONS(750),
    [sym_return] = ACTIONS(750),
    [sym_next] = ACTIONS(750),
    [sym_break] = ACTIONS(750),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_inf] = ACTIONS(750),
    [sym_nan] = ACTIONS(750),
    [anon_sym_NA] = ACTIONS(750),
    [anon_sym_NA_integer_] = ACTIONS(750),
    [anon_sym_NA_real_] = ACTIONS(750),
    [anon_sym_NA_complex_] = ACTIONS(750),
    [anon_sym_NA_character_] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(752),
    [sym__semicolon] = ACTIONS(752),
    [sym__raw_string_literal] = ACTIONS(752),
    [sym__external_open_parenthesis] = ACTIONS(752),
    [sym__external_open_brace] = ACTIONS(752),
    [sym__external_close_brace] = ACTIONS(752),
    [sym__external_open_bracket] = ACTIONS(752),
    [sym__external_open_bracket2] = ACTIONS(752),
  },
  [405] = {
    [sym_identifier] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_repeat] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_LT_DASH] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(781),
    [anon_sym_COLON_EQ] = ACTIONS(781),
    [anon_sym_DASH_GT] = ACTIONS(783),
    [anon_sym_DASH_GT_GT] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_STAR_STAR] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [aux_sym_binary_operator_token1] = ACTIONS(781),
    [anon_sym_PIPE_GT] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [sym__hex_literal] = ACTIONS(781),
    [sym__number_literal] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(781),
    [anon_sym_DQUOTE] = ACTIONS(781),
    [sym_dots] = ACTIONS(783),
    [sym_dot_dot_i] = ACTIONS(783),
    [sym_return] = ACTIONS(783),
    [sym_next] = ACTIONS(783),
    [sym_break] = ACTIONS(783),
    [sym_true] = ACTIONS(783),
    [sym_false] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [sym_inf] = ACTIONS(783),
    [sym_nan] = ACTIONS(783),
    [anon_sym_NA] = ACTIONS(783),
    [anon_sym_NA_integer_] = ACTIONS(783),
    [anon_sym_NA_real_] = ACTIONS(783),
    [anon_sym_NA_complex_] = ACTIONS(783),
    [anon_sym_NA_character_] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(781),
    [sym__semicolon] = ACTIONS(781),
    [sym__raw_string_literal] = ACTIONS(781),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_open_brace] = ACTIONS(781),
    [sym__external_close_brace] = ACTIONS(781),
    [sym__external_open_bracket] = ACTIONS(781),
    [sym__external_open_bracket2] = ACTIONS(781),
  },
  [406] = {
    [sym_identifier] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_COLON_EQ] = ACTIONS(734),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_DASH_GT_GT] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [aux_sym_binary_operator_token1] = ACTIONS(734),
    [anon_sym_PIPE_GT] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [sym__hex_literal] = ACTIONS(734),
    [sym__number_literal] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [sym_dots] = ACTIONS(736),
    [sym_dot_dot_i] = ACTIONS(736),
    [sym_return] = ACTIONS(736),
    [sym_next] = ACTIONS(736),
    [sym_break] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_null] = ACTIONS(736),
    [sym_inf] = ACTIONS(736),
    [sym_nan] = ACTIONS(736),
    [anon_sym_NA] = ACTIONS(736),
    [anon_sym_NA_integer_] = ACTIONS(736),
    [anon_sym_NA_real_] = ACTIONS(736),
    [anon_sym_NA_complex_] = ACTIONS(736),
    [anon_sym_NA_character_] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(734),
    [sym__semicolon] = ACTIONS(734),
    [sym__raw_string_literal] = ACTIONS(734),
    [sym__external_open_parenthesis] = ACTIONS(734),
    [sym__external_open_brace] = ACTIONS(734),
    [sym__external_close_brace] = ACTIONS(734),
    [sym__external_open_bracket] = ACTIONS(734),
    [sym__external_open_bracket2] = ACTIONS(734),
  },
  [407] = {
    [sym_identifier] = ACTIONS(716),
    [anon_sym_BSLASH] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_LT_DASH] = ACTIONS(714),
    [anon_sym_LT_LT_DASH] = ACTIONS(714),
    [anon_sym_COLON_EQ] = ACTIONS(714),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_DASH_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(716),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(716),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [aux_sym_binary_operator_token1] = ACTIONS(714),
    [anon_sym_PIPE_GT] = ACTIONS(714),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [sym__hex_literal] = ACTIONS(714),
    [sym__number_literal] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [sym_dots] = ACTIONS(716),
    [sym_dot_dot_i] = ACTIONS(716),
    [sym_return] = ACTIONS(716),
    [sym_next] = ACTIONS(716),
    [sym_break] = ACTIONS(716),
    [sym_true] = ACTIONS(716),
    [sym_false] = ACTIONS(716),
    [sym_null] = ACTIONS(716),
    [sym_inf] = ACTIONS(716),
    [sym_nan] = ACTIONS(716),
    [anon_sym_NA] = ACTIONS(716),
    [anon_sym_NA_integer_] = ACTIONS(716),
    [anon_sym_NA_real_] = ACTIONS(716),
    [anon_sym_NA_complex_] = ACTIONS(716),
    [anon_sym_NA_character_] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(714),
    [sym__semicolon] = ACTIONS(714),
    [sym__raw_string_literal] = ACTIONS(714),
    [sym__external_open_parenthesis] = ACTIONS(714),
    [sym__external_open_brace] = ACTIONS(714),
    [sym__external_close_brace] = ACTIONS(714),
    [sym__external_open_bracket] = ACTIONS(714),
    [sym__external_open_bracket2] = ACTIONS(714),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_BSLASH] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_repeat] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_COLON_EQ] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(726),
    [anon_sym_DASH_GT_GT] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [anon_sym_STAR_STAR] = ACTIONS(728),
    [anon_sym_CARET] = ACTIONS(728),
    [aux_sym_binary_operator_token1] = ACTIONS(728),
    [anon_sym_PIPE_GT] = ACTIONS(728),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [anon_sym_AT] = ACTIONS(728),
    [sym__hex_literal] = ACTIONS(728),
    [sym__number_literal] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_dots] = ACTIONS(726),
    [sym_dot_dot_i] = ACTIONS(726),
    [sym_return] = ACTIONS(726),
    [sym_next] = ACTIONS(726),
    [sym_break] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_inf] = ACTIONS(726),
    [sym_nan] = ACTIONS(726),
    [anon_sym_NA] = ACTIONS(726),
    [anon_sym_NA_integer_] = ACTIONS(726),
    [anon_sym_NA_real_] = ACTIONS(726),
    [anon_sym_NA_complex_] = ACTIONS(726),
    [anon_sym_NA_character_] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(728),
    [sym__semicolon] = ACTIONS(728),
    [sym__raw_string_literal] = ACTIONS(728),
    [sym__external_open_parenthesis] = ACTIONS(728),
    [sym__external_open_brace] = ACTIONS(728),
    [sym__external_open_bracket] = ACTIONS(728),
    [sym__external_open_bracket2] = ACTIONS(728),
  },
  [409] = {
    [sym_identifier] = ACTIONS(754),
    [anon_sym_BSLASH] = ACTIONS(756),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(754),
    [anon_sym_while] = ACTIONS(754),
    [anon_sym_repeat] = ACTIONS(754),
    [anon_sym_QMARK] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_LT_DASH] = ACTIONS(756),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_COLON_EQ] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(754),
    [anon_sym_DASH_GT_GT] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(754),
    [anon_sym_AMP] = ACTIONS(754),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(756),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(756),
    [anon_sym_BANG_EQ] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(756),
    [anon_sym_STAR_STAR] = ACTIONS(756),
    [anon_sym_CARET] = ACTIONS(756),
    [aux_sym_binary_operator_token1] = ACTIONS(756),
    [anon_sym_PIPE_GT] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(756),
    [sym__hex_literal] = ACTIONS(756),
    [sym__number_literal] = ACTIONS(754),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(756),
    [sym_dots] = ACTIONS(754),
    [sym_dot_dot_i] = ACTIONS(754),
    [sym_return] = ACTIONS(754),
    [sym_next] = ACTIONS(754),
    [sym_break] = ACTIONS(754),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_inf] = ACTIONS(754),
    [sym_nan] = ACTIONS(754),
    [anon_sym_NA] = ACTIONS(754),
    [anon_sym_NA_integer_] = ACTIONS(754),
    [anon_sym_NA_real_] = ACTIONS(754),
    [anon_sym_NA_complex_] = ACTIONS(754),
    [anon_sym_NA_character_] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(756),
    [sym__semicolon] = ACTIONS(756),
    [sym__raw_string_literal] = ACTIONS(756),
    [sym__external_open_parenthesis] = ACTIONS(756),
    [sym__external_open_brace] = ACTIONS(756),
    [sym__external_close_brace] = ACTIONS(756),
    [sym__external_open_bracket] = ACTIONS(756),
    [sym__external_open_bracket2] = ACTIONS(756),
  },
  [410] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_BSLASH] = ACTIONS(720),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_repeat] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_DASH] = ACTIONS(720),
    [anon_sym_LT_LT_DASH] = ACTIONS(720),
    [anon_sym_COLON_EQ] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(718),
    [anon_sym_DASH_GT_GT] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_STAR_STAR] = ACTIONS(720),
    [anon_sym_CARET] = ACTIONS(720),
    [aux_sym_binary_operator_token1] = ACTIONS(720),
    [anon_sym_PIPE_GT] = ACTIONS(720),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [sym__hex_literal] = ACTIONS(720),
    [sym__number_literal] = ACTIONS(718),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(720),
    [sym_dots] = ACTIONS(718),
    [sym_dot_dot_i] = ACTIONS(718),
    [sym_return] = ACTIONS(718),
    [sym_next] = ACTIONS(718),
    [sym_break] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_inf] = ACTIONS(718),
    [sym_nan] = ACTIONS(718),
    [anon_sym_NA] = ACTIONS(718),
    [anon_sym_NA_integer_] = ACTIONS(718),
    [anon_sym_NA_real_] = ACTIONS(718),
    [anon_sym_NA_complex_] = ACTIONS(718),
    [anon_sym_NA_character_] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(720),
    [sym__semicolon] = ACTIONS(720),
    [sym__raw_string_literal] = ACTIONS(720),
    [sym__external_open_parenthesis] = ACTIONS(720),
    [sym__external_open_brace] = ACTIONS(720),
    [sym__external_close_brace] = ACTIONS(720),
    [sym__external_open_bracket] = ACTIONS(720),
    [sym__external_open_bracket2] = ACTIONS(720),
  },
  [411] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_BSLASH] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_repeat] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_DASH] = ACTIONS(724),
    [anon_sym_LT_LT_DASH] = ACTIONS(724),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_DASH_GT_GT] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(724),
    [anon_sym_BANG_EQ] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_STAR_STAR] = ACTIONS(724),
    [anon_sym_CARET] = ACTIONS(724),
    [aux_sym_binary_operator_token1] = ACTIONS(724),
    [anon_sym_PIPE_GT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(724),
    [sym__hex_literal] = ACTIONS(724),
    [sym__number_literal] = ACTIONS(722),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_dots] = ACTIONS(722),
    [sym_dot_dot_i] = ACTIONS(722),
    [sym_return] = ACTIONS(722),
    [sym_next] = ACTIONS(722),
    [sym_break] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_null] = ACTIONS(722),
    [sym_inf] = ACTIONS(722),
    [sym_nan] = ACTIONS(722),
    [anon_sym_NA] = ACTIONS(722),
    [anon_sym_NA_integer_] = ACTIONS(722),
    [anon_sym_NA_real_] = ACTIONS(722),
    [anon_sym_NA_complex_] = ACTIONS(722),
    [anon_sym_NA_character_] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(724),
    [sym__semicolon] = ACTIONS(724),
    [sym__raw_string_literal] = ACTIONS(724),
    [sym__external_open_parenthesis] = ACTIONS(724),
    [sym__external_open_brace] = ACTIONS(724),
    [sym__external_close_brace] = ACTIONS(724),
    [sym__external_open_bracket] = ACTIONS(724),
    [sym__external_open_bracket2] = ACTIONS(724),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(744),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_repeat] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_DASH] = ACTIONS(744),
    [anon_sym_LT_LT_DASH] = ACTIONS(744),
    [anon_sym_COLON_EQ] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(742),
    [anon_sym_DASH_GT_GT] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(744),
    [anon_sym_AMP_AMP] = ACTIONS(744),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(744),
    [anon_sym_STAR_STAR] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(744),
    [aux_sym_binary_operator_token1] = ACTIONS(744),
    [anon_sym_PIPE_GT] = ACTIONS(744),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(744),
    [sym__hex_literal] = ACTIONS(744),
    [sym__number_literal] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(744),
    [sym_dots] = ACTIONS(742),
    [sym_dot_dot_i] = ACTIONS(742),
    [sym_return] = ACTIONS(742),
    [sym_next] = ACTIONS(742),
    [sym_break] = ACTIONS(742),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_inf] = ACTIONS(742),
    [sym_nan] = ACTIONS(742),
    [anon_sym_NA] = ACTIONS(742),
    [anon_sym_NA_integer_] = ACTIONS(742),
    [anon_sym_NA_real_] = ACTIONS(742),
    [anon_sym_NA_complex_] = ACTIONS(742),
    [anon_sym_NA_character_] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(744),
    [sym__semicolon] = ACTIONS(744),
    [sym__raw_string_literal] = ACTIONS(744),
    [sym__external_open_parenthesis] = ACTIONS(744),
    [sym__external_open_brace] = ACTIONS(744),
    [sym__external_open_bracket] = ACTIONS(744),
    [sym__external_open_bracket2] = ACTIONS(744),
  },
  [413] = {
    [sym_identifier] = ACTIONS(730),
    [anon_sym_BSLASH] = ACTIONS(732),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_repeat] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_COLON_EQ] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_DASH_GT_GT] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_BANG_EQ] = ACTIONS(732),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_STAR_STAR] = ACTIONS(732),
    [anon_sym_CARET] = ACTIONS(732),
    [aux_sym_binary_operator_token1] = ACTIONS(732),
    [anon_sym_PIPE_GT] = ACTIONS(732),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [sym__hex_literal] = ACTIONS(732),
    [sym__number_literal] = ACTIONS(730),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [sym_dots] = ACTIONS(730),
    [sym_dot_dot_i] = ACTIONS(730),
    [sym_return] = ACTIONS(730),
    [sym_next] = ACTIONS(730),
    [sym_break] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_inf] = ACTIONS(730),
    [sym_nan] = ACTIONS(730),
    [anon_sym_NA] = ACTIONS(730),
    [anon_sym_NA_integer_] = ACTIONS(730),
    [anon_sym_NA_real_] = ACTIONS(730),
    [anon_sym_NA_complex_] = ACTIONS(730),
    [anon_sym_NA_character_] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(732),
    [sym__semicolon] = ACTIONS(732),
    [sym__raw_string_literal] = ACTIONS(732),
    [sym__external_open_parenthesis] = ACTIONS(732),
    [sym__external_open_brace] = ACTIONS(732),
    [sym__external_close_brace] = ACTIONS(732),
    [sym__external_open_bracket] = ACTIONS(732),
    [sym__external_open_bracket2] = ACTIONS(732),
  },
  [414] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(416),
    [aux_sym_braced_expression_repeat1] = STATE(433),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(837),
  },
  [415] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_BSLASH] = ACTIONS(768),
    [anon_sym_function] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_repeat] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_LT_DASH] = ACTIONS(768),
    [anon_sym_LT_LT_DASH] = ACTIONS(768),
    [anon_sym_COLON_EQ] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(766),
    [anon_sym_DASH_GT_GT] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(768),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [aux_sym_binary_operator_token1] = ACTIONS(768),
    [anon_sym_PIPE_GT] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_DOLLAR] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [sym__hex_literal] = ACTIONS(768),
    [sym__number_literal] = ACTIONS(766),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(768),
    [sym_dots] = ACTIONS(766),
    [sym_dot_dot_i] = ACTIONS(766),
    [sym_return] = ACTIONS(766),
    [sym_next] = ACTIONS(766),
    [sym_break] = ACTIONS(766),
    [sym_true] = ACTIONS(766),
    [sym_false] = ACTIONS(766),
    [sym_null] = ACTIONS(766),
    [sym_inf] = ACTIONS(766),
    [sym_nan] = ACTIONS(766),
    [anon_sym_NA] = ACTIONS(766),
    [anon_sym_NA_integer_] = ACTIONS(766),
    [anon_sym_NA_real_] = ACTIONS(766),
    [anon_sym_NA_complex_] = ACTIONS(766),
    [anon_sym_NA_character_] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(768),
    [sym__semicolon] = ACTIONS(768),
    [sym__raw_string_literal] = ACTIONS(768),
    [sym__external_open_parenthesis] = ACTIONS(768),
    [sym__external_open_brace] = ACTIONS(768),
    [sym__external_close_brace] = ACTIONS(768),
    [sym__external_open_bracket] = ACTIONS(768),
    [sym__external_open_bracket2] = ACTIONS(768),
  },
  [416] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_BSLASH] = ACTIONS(772),
    [anon_sym_function] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_repeat] = ACTIONS(770),
    [anon_sym_QMARK] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_LT_DASH] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(772),
    [anon_sym_COLON_EQ] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(770),
    [anon_sym_DASH_GT_GT] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_PIPE_PIPE] = ACTIONS(772),
    [anon_sym_AMP_AMP] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(772),
    [anon_sym_BANG_EQ] = ACTIONS(772),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_STAR_STAR] = ACTIONS(772),
    [anon_sym_CARET] = ACTIONS(772),
    [aux_sym_binary_operator_token1] = ACTIONS(772),
    [anon_sym_PIPE_GT] = ACTIONS(772),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [sym__hex_literal] = ACTIONS(772),
    [sym__number_literal] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [sym_dots] = ACTIONS(770),
    [sym_dot_dot_i] = ACTIONS(770),
    [sym_return] = ACTIONS(770),
    [sym_next] = ACTIONS(770),
    [sym_break] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_null] = ACTIONS(770),
    [sym_inf] = ACTIONS(770),
    [sym_nan] = ACTIONS(770),
    [anon_sym_NA] = ACTIONS(770),
    [anon_sym_NA_integer_] = ACTIONS(770),
    [anon_sym_NA_real_] = ACTIONS(770),
    [anon_sym_NA_complex_] = ACTIONS(770),
    [anon_sym_NA_character_] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(772),
    [sym__semicolon] = ACTIONS(772),
    [sym__raw_string_literal] = ACTIONS(772),
    [sym__external_open_parenthesis] = ACTIONS(772),
    [sym__external_open_brace] = ACTIONS(772),
    [sym__external_close_brace] = ACTIONS(772),
    [sym__external_open_bracket] = ACTIONS(772),
    [sym__external_open_bracket2] = ACTIONS(772),
  },
  [417] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1746),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(839),
  },
  [418] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1730),
    [aux_sym_braced_expression_repeat1] = STATE(417),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(841),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(718),
    [anon_sym_BSLASH] = ACTIONS(720),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_repeat] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_DASH] = ACTIONS(720),
    [anon_sym_LT_LT_DASH] = ACTIONS(720),
    [anon_sym_COLON_EQ] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(718),
    [anon_sym_DASH_GT_GT] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_STAR_STAR] = ACTIONS(720),
    [anon_sym_CARET] = ACTIONS(720),
    [aux_sym_binary_operator_token1] = ACTIONS(720),
    [anon_sym_PIPE_GT] = ACTIONS(720),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [sym__hex_literal] = ACTIONS(720),
    [sym__number_literal] = ACTIONS(718),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(720),
    [sym_dots] = ACTIONS(718),
    [sym_dot_dot_i] = ACTIONS(718),
    [sym_return] = ACTIONS(718),
    [sym_next] = ACTIONS(718),
    [sym_break] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_inf] = ACTIONS(718),
    [sym_nan] = ACTIONS(718),
    [anon_sym_NA] = ACTIONS(718),
    [anon_sym_NA_integer_] = ACTIONS(718),
    [anon_sym_NA_real_] = ACTIONS(718),
    [anon_sym_NA_complex_] = ACTIONS(718),
    [anon_sym_NA_character_] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(720),
    [sym__semicolon] = ACTIONS(720),
    [sym__raw_string_literal] = ACTIONS(720),
    [sym__external_open_parenthesis] = ACTIONS(720),
    [sym__external_open_brace] = ACTIONS(720),
    [sym__external_open_bracket] = ACTIONS(720),
    [sym__external_open_bracket2] = ACTIONS(720),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(740),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_repeat] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_LT_DASH] = ACTIONS(740),
    [anon_sym_LT_LT_DASH] = ACTIONS(740),
    [anon_sym_COLON_EQ] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(738),
    [anon_sym_DASH_GT_GT] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [aux_sym_binary_operator_token1] = ACTIONS(740),
    [anon_sym_PIPE_GT] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [sym__hex_literal] = ACTIONS(740),
    [sym__number_literal] = ACTIONS(738),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_dots] = ACTIONS(738),
    [sym_dot_dot_i] = ACTIONS(738),
    [sym_return] = ACTIONS(738),
    [sym_next] = ACTIONS(738),
    [sym_break] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_null] = ACTIONS(738),
    [sym_inf] = ACTIONS(738),
    [sym_nan] = ACTIONS(738),
    [anon_sym_NA] = ACTIONS(738),
    [anon_sym_NA_integer_] = ACTIONS(738),
    [anon_sym_NA_real_] = ACTIONS(738),
    [anon_sym_NA_complex_] = ACTIONS(738),
    [anon_sym_NA_character_] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(740),
    [sym__semicolon] = ACTIONS(740),
    [sym__raw_string_literal] = ACTIONS(740),
    [sym__external_open_parenthesis] = ACTIONS(740),
    [sym__external_open_brace] = ACTIONS(740),
    [sym__external_open_bracket] = ACTIONS(740),
    [sym__external_open_bracket2] = ACTIONS(740),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_BSLASH] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_repeat] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_DASH] = ACTIONS(724),
    [anon_sym_LT_LT_DASH] = ACTIONS(724),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_DASH_GT_GT] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(724),
    [anon_sym_BANG_EQ] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_STAR_STAR] = ACTIONS(724),
    [anon_sym_CARET] = ACTIONS(724),
    [aux_sym_binary_operator_token1] = ACTIONS(724),
    [anon_sym_PIPE_GT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(724),
    [sym__hex_literal] = ACTIONS(724),
    [sym__number_literal] = ACTIONS(722),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_dots] = ACTIONS(722),
    [sym_dot_dot_i] = ACTIONS(722),
    [sym_return] = ACTIONS(722),
    [sym_next] = ACTIONS(722),
    [sym_break] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_null] = ACTIONS(722),
    [sym_inf] = ACTIONS(722),
    [sym_nan] = ACTIONS(722),
    [anon_sym_NA] = ACTIONS(722),
    [anon_sym_NA_integer_] = ACTIONS(722),
    [anon_sym_NA_real_] = ACTIONS(722),
    [anon_sym_NA_complex_] = ACTIONS(722),
    [anon_sym_NA_character_] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(724),
    [sym__semicolon] = ACTIONS(724),
    [sym__raw_string_literal] = ACTIONS(724),
    [sym__external_open_parenthesis] = ACTIONS(724),
    [sym__external_open_brace] = ACTIONS(724),
    [sym__external_open_bracket] = ACTIONS(724),
    [sym__external_open_bracket2] = ACTIONS(724),
  },
  [422] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1736),
    [aux_sym_braced_expression_repeat1] = STATE(439),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(843),
  },
  [423] = {
    [sym_identifier] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(687),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_repeat] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_LT_DASH] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(689),
    [anon_sym_COLON_EQ] = ACTIONS(689),
    [anon_sym_DASH_GT] = ACTIONS(687),
    [anon_sym_DASH_GT_GT] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_STAR_STAR] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(689),
    [aux_sym_binary_operator_token1] = ACTIONS(689),
    [anon_sym_PIPE_GT] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [sym__hex_literal] = ACTIONS(689),
    [sym__number_literal] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_dots] = ACTIONS(687),
    [sym_dot_dot_i] = ACTIONS(687),
    [sym_return] = ACTIONS(687),
    [sym_next] = ACTIONS(687),
    [sym_break] = ACTIONS(687),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_inf] = ACTIONS(687),
    [sym_nan] = ACTIONS(687),
    [anon_sym_NA] = ACTIONS(687),
    [anon_sym_NA_integer_] = ACTIONS(687),
    [anon_sym_NA_real_] = ACTIONS(687),
    [anon_sym_NA_complex_] = ACTIONS(687),
    [anon_sym_NA_character_] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(689),
    [sym__semicolon] = ACTIONS(689),
    [sym__raw_string_literal] = ACTIONS(689),
    [sym__external_open_parenthesis] = ACTIONS(689),
    [sym__external_open_brace] = ACTIONS(689),
    [sym__external_close_brace] = ACTIONS(689),
    [sym__external_open_bracket] = ACTIONS(689),
    [sym__external_open_bracket2] = ACTIONS(689),
  },
  [424] = {
    [sym_identifier] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_while] = ACTIONS(691),
    [anon_sym_repeat] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_COLON_EQ] = ACTIONS(693),
    [anon_sym_DASH_GT] = ACTIONS(691),
    [anon_sym_DASH_GT_GT] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(691),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_LT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_EQ] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_CARET] = ACTIONS(693),
    [aux_sym_binary_operator_token1] = ACTIONS(693),
    [anon_sym_PIPE_GT] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [sym__hex_literal] = ACTIONS(693),
    [sym__number_literal] = ACTIONS(691),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [sym_dots] = ACTIONS(691),
    [sym_dot_dot_i] = ACTIONS(691),
    [sym_return] = ACTIONS(691),
    [sym_next] = ACTIONS(691),
    [sym_break] = ACTIONS(691),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_null] = ACTIONS(691),
    [sym_inf] = ACTIONS(691),
    [sym_nan] = ACTIONS(691),
    [anon_sym_NA] = ACTIONS(691),
    [anon_sym_NA_integer_] = ACTIONS(691),
    [anon_sym_NA_real_] = ACTIONS(691),
    [anon_sym_NA_complex_] = ACTIONS(691),
    [anon_sym_NA_character_] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(693),
    [sym__semicolon] = ACTIONS(693),
    [sym__raw_string_literal] = ACTIONS(693),
    [sym__external_open_parenthesis] = ACTIONS(693),
    [sym__external_open_brace] = ACTIONS(693),
    [sym__external_close_brace] = ACTIONS(693),
    [sym__external_open_bracket] = ACTIONS(693),
    [sym__external_open_bracket2] = ACTIONS(693),
  },
  [425] = {
    [sym_identifier] = ACTIONS(758),
    [anon_sym_BSLASH] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_while] = ACTIONS(758),
    [anon_sym_repeat] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_LT_DASH] = ACTIONS(760),
    [anon_sym_LT_LT_DASH] = ACTIONS(760),
    [anon_sym_COLON_EQ] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(758),
    [anon_sym_DASH_GT_GT] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_PIPE_PIPE] = ACTIONS(760),
    [anon_sym_AMP_AMP] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(760),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_STAR_STAR] = ACTIONS(760),
    [anon_sym_CARET] = ACTIONS(760),
    [aux_sym_binary_operator_token1] = ACTIONS(760),
    [anon_sym_PIPE_GT] = ACTIONS(760),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_DOLLAR] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [sym__hex_literal] = ACTIONS(760),
    [sym__number_literal] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [sym_dots] = ACTIONS(758),
    [sym_dot_dot_i] = ACTIONS(758),
    [sym_return] = ACTIONS(758),
    [sym_next] = ACTIONS(758),
    [sym_break] = ACTIONS(758),
    [sym_true] = ACTIONS(758),
    [sym_false] = ACTIONS(758),
    [sym_null] = ACTIONS(758),
    [sym_inf] = ACTIONS(758),
    [sym_nan] = ACTIONS(758),
    [anon_sym_NA] = ACTIONS(758),
    [anon_sym_NA_integer_] = ACTIONS(758),
    [anon_sym_NA_real_] = ACTIONS(758),
    [anon_sym_NA_complex_] = ACTIONS(758),
    [anon_sym_NA_character_] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(760),
    [sym__semicolon] = ACTIONS(760),
    [sym__raw_string_literal] = ACTIONS(760),
    [sym__external_open_parenthesis] = ACTIONS(760),
    [sym__external_open_brace] = ACTIONS(760),
    [sym__external_close_brace] = ACTIONS(760),
    [sym__external_open_bracket] = ACTIONS(760),
    [sym__external_open_bracket2] = ACTIONS(760),
  },
  [426] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(372),
    [aux_sym_braced_expression_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(845),
  },
  [427] = {
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_repeat] = ACTIONS(779),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_LT_DASH] = ACTIONS(777),
    [anon_sym_LT_LT_DASH] = ACTIONS(777),
    [anon_sym_COLON_EQ] = ACTIONS(777),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_DASH_GT_GT] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [aux_sym_binary_operator_token1] = ACTIONS(777),
    [anon_sym_PIPE_GT] = ACTIONS(777),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [sym__hex_literal] = ACTIONS(777),
    [sym__number_literal] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(777),
    [sym_dots] = ACTIONS(779),
    [sym_dot_dot_i] = ACTIONS(779),
    [sym_return] = ACTIONS(779),
    [sym_next] = ACTIONS(779),
    [sym_break] = ACTIONS(779),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [sym_inf] = ACTIONS(779),
    [sym_nan] = ACTIONS(779),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(777),
    [sym__semicolon] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(777),
    [sym__external_open_parenthesis] = ACTIONS(777),
    [sym__external_open_brace] = ACTIONS(777),
    [sym__external_close_brace] = ACTIONS(777),
    [sym__external_open_bracket] = ACTIONS(777),
    [sym__external_open_bracket2] = ACTIONS(777),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(734),
    [sym_identifier] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_COLON_EQ] = ACTIONS(734),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_DASH_GT_GT] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [aux_sym_binary_operator_token1] = ACTIONS(734),
    [anon_sym_PIPE_GT] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [sym__hex_literal] = ACTIONS(734),
    [sym__number_literal] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [sym_dots] = ACTIONS(736),
    [sym_dot_dot_i] = ACTIONS(736),
    [sym_return] = ACTIONS(736),
    [sym_next] = ACTIONS(736),
    [sym_break] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_null] = ACTIONS(736),
    [sym_inf] = ACTIONS(736),
    [sym_nan] = ACTIONS(736),
    [anon_sym_NA] = ACTIONS(736),
    [anon_sym_NA_integer_] = ACTIONS(736),
    [anon_sym_NA_real_] = ACTIONS(736),
    [anon_sym_NA_complex_] = ACTIONS(736),
    [anon_sym_NA_character_] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(734),
    [sym__semicolon] = ACTIONS(734),
    [sym__raw_string_literal] = ACTIONS(734),
    [sym__external_open_parenthesis] = ACTIONS(734),
    [sym__external_open_brace] = ACTIONS(734),
    [sym__external_open_bracket] = ACTIONS(734),
    [sym__external_open_bracket2] = ACTIONS(734),
  },
  [429] = {
    [sym_identifier] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_if] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_repeat] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(697),
    [anon_sym_TILDE] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(695),
    [anon_sym_DASH_GT_GT] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_EQ] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_STAR_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(697),
    [aux_sym_binary_operator_token1] = ACTIONS(697),
    [anon_sym_PIPE_GT] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(697),
    [sym__hex_literal] = ACTIONS(697),
    [sym__number_literal] = ACTIONS(695),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [sym_dots] = ACTIONS(695),
    [sym_dot_dot_i] = ACTIONS(695),
    [sym_return] = ACTIONS(695),
    [sym_next] = ACTIONS(695),
    [sym_break] = ACTIONS(695),
    [sym_true] = ACTIONS(695),
    [sym_false] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [sym_inf] = ACTIONS(695),
    [sym_nan] = ACTIONS(695),
    [anon_sym_NA] = ACTIONS(695),
    [anon_sym_NA_integer_] = ACTIONS(695),
    [anon_sym_NA_real_] = ACTIONS(695),
    [anon_sym_NA_complex_] = ACTIONS(695),
    [anon_sym_NA_character_] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(697),
    [sym__semicolon] = ACTIONS(697),
    [sym__raw_string_literal] = ACTIONS(697),
    [sym__external_open_parenthesis] = ACTIONS(697),
    [sym__external_open_brace] = ACTIONS(697),
    [sym__external_close_brace] = ACTIONS(697),
    [sym__external_open_bracket] = ACTIONS(697),
    [sym__external_open_bracket2] = ACTIONS(697),
  },
  [430] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1684),
    [aux_sym_braced_expression_repeat1] = STATE(386),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(847),
  },
  [431] = {
    [sym_identifier] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(699),
    [anon_sym_while] = ACTIONS(699),
    [anon_sym_repeat] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(701),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [aux_sym_binary_operator_token1] = ACTIONS(701),
    [anon_sym_PIPE_GT] = ACTIONS(701),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [sym__hex_literal] = ACTIONS(701),
    [sym__number_literal] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [sym_dots] = ACTIONS(699),
    [sym_dot_dot_i] = ACTIONS(699),
    [sym_return] = ACTIONS(699),
    [sym_next] = ACTIONS(699),
    [sym_break] = ACTIONS(699),
    [sym_true] = ACTIONS(699),
    [sym_false] = ACTIONS(699),
    [sym_null] = ACTIONS(699),
    [sym_inf] = ACTIONS(699),
    [sym_nan] = ACTIONS(699),
    [anon_sym_NA] = ACTIONS(699),
    [anon_sym_NA_integer_] = ACTIONS(699),
    [anon_sym_NA_real_] = ACTIONS(699),
    [anon_sym_NA_complex_] = ACTIONS(699),
    [anon_sym_NA_character_] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(701),
    [sym__semicolon] = ACTIONS(701),
    [sym__raw_string_literal] = ACTIONS(701),
    [sym__external_open_parenthesis] = ACTIONS(701),
    [sym__external_open_brace] = ACTIONS(701),
    [sym__external_close_brace] = ACTIONS(701),
    [sym__external_open_bracket] = ACTIONS(701),
    [sym__external_open_bracket2] = ACTIONS(701),
  },
  [432] = {
    [sym_identifier] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_repeat] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_LT_DASH] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(685),
    [anon_sym_COLON_EQ] = ACTIONS(685),
    [anon_sym_DASH_GT] = ACTIONS(683),
    [anon_sym_DASH_GT_GT] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(683),
    [anon_sym_PIPE_PIPE] = ACTIONS(685),
    [anon_sym_AMP_AMP] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_STAR_STAR] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [aux_sym_binary_operator_token1] = ACTIONS(685),
    [anon_sym_PIPE_GT] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [sym__hex_literal] = ACTIONS(685),
    [sym__number_literal] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [sym_dots] = ACTIONS(683),
    [sym_dot_dot_i] = ACTIONS(683),
    [sym_return] = ACTIONS(683),
    [sym_next] = ACTIONS(683),
    [sym_break] = ACTIONS(683),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [sym_inf] = ACTIONS(683),
    [sym_nan] = ACTIONS(683),
    [anon_sym_NA] = ACTIONS(683),
    [anon_sym_NA_integer_] = ACTIONS(683),
    [anon_sym_NA_real_] = ACTIONS(683),
    [anon_sym_NA_complex_] = ACTIONS(683),
    [anon_sym_NA_character_] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(685),
    [sym__semicolon] = ACTIONS(685),
    [sym__raw_string_literal] = ACTIONS(685),
    [sym__external_open_parenthesis] = ACTIONS(685),
    [sym__external_open_brace] = ACTIONS(685),
    [sym__external_close_brace] = ACTIONS(685),
    [sym__external_open_bracket] = ACTIONS(685),
    [sym__external_open_bracket2] = ACTIONS(685),
  },
  [433] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(432),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(849),
  },
  [434] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(353),
    [aux_sym_braced_expression_repeat1] = STATE(403),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(851),
  },
  [435] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(740),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_repeat] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_LT_DASH] = ACTIONS(740),
    [anon_sym_LT_LT_DASH] = ACTIONS(740),
    [anon_sym_COLON_EQ] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(738),
    [anon_sym_DASH_GT_GT] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [aux_sym_binary_operator_token1] = ACTIONS(740),
    [anon_sym_PIPE_GT] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [sym__hex_literal] = ACTIONS(740),
    [sym__number_literal] = ACTIONS(738),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_dots] = ACTIONS(738),
    [sym_dot_dot_i] = ACTIONS(738),
    [sym_return] = ACTIONS(738),
    [sym_next] = ACTIONS(738),
    [sym_break] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_null] = ACTIONS(738),
    [sym_inf] = ACTIONS(738),
    [sym_nan] = ACTIONS(738),
    [anon_sym_NA] = ACTIONS(738),
    [anon_sym_NA_integer_] = ACTIONS(738),
    [anon_sym_NA_real_] = ACTIONS(738),
    [anon_sym_NA_complex_] = ACTIONS(738),
    [anon_sym_NA_character_] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(740),
    [sym__semicolon] = ACTIONS(740),
    [sym__raw_string_literal] = ACTIONS(740),
    [sym__external_open_parenthesis] = ACTIONS(740),
    [sym__external_open_brace] = ACTIONS(740),
    [sym__external_close_brace] = ACTIONS(740),
    [sym__external_open_bracket] = ACTIONS(740),
    [sym__external_open_bracket2] = ACTIONS(740),
  },
  [436] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_repeat] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_DASH] = ACTIONS(744),
    [anon_sym_LT_LT_DASH] = ACTIONS(744),
    [anon_sym_COLON_EQ] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(742),
    [anon_sym_DASH_GT_GT] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(744),
    [anon_sym_AMP_AMP] = ACTIONS(744),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(744),
    [anon_sym_STAR_STAR] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(744),
    [aux_sym_binary_operator_token1] = ACTIONS(744),
    [anon_sym_PIPE_GT] = ACTIONS(744),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(744),
    [sym__hex_literal] = ACTIONS(744),
    [sym__number_literal] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(744),
    [sym_dots] = ACTIONS(742),
    [sym_dot_dot_i] = ACTIONS(742),
    [sym_return] = ACTIONS(742),
    [sym_next] = ACTIONS(742),
    [sym_break] = ACTIONS(742),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_inf] = ACTIONS(742),
    [sym_nan] = ACTIONS(742),
    [anon_sym_NA] = ACTIONS(742),
    [anon_sym_NA_integer_] = ACTIONS(742),
    [anon_sym_NA_real_] = ACTIONS(742),
    [anon_sym_NA_complex_] = ACTIONS(742),
    [anon_sym_NA_character_] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(744),
    [sym__semicolon] = ACTIONS(744),
    [sym__raw_string_literal] = ACTIONS(744),
    [sym__external_open_parenthesis] = ACTIONS(744),
    [sym__external_open_brace] = ACTIONS(744),
    [sym__external_close_brace] = ACTIONS(744),
    [sym__external_open_bracket] = ACTIONS(744),
    [sym__external_open_bracket2] = ACTIONS(744),
  },
  [437] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1635),
    [aux_sym_braced_expression_repeat1] = STATE(399),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(853),
  },
  [438] = {
    [sym_identifier] = ACTIONS(746),
    [anon_sym_BSLASH] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_while] = ACTIONS(746),
    [anon_sym_repeat] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_LT_DASH] = ACTIONS(748),
    [anon_sym_LT_LT_DASH] = ACTIONS(748),
    [anon_sym_COLON_EQ] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(746),
    [anon_sym_DASH_GT_GT] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(748),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_STAR_STAR] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(748),
    [aux_sym_binary_operator_token1] = ACTIONS(748),
    [anon_sym_PIPE_GT] = ACTIONS(748),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [sym__hex_literal] = ACTIONS(748),
    [sym__number_literal] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [sym_dots] = ACTIONS(746),
    [sym_dot_dot_i] = ACTIONS(746),
    [sym_return] = ACTIONS(746),
    [sym_next] = ACTIONS(746),
    [sym_break] = ACTIONS(746),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_null] = ACTIONS(746),
    [sym_inf] = ACTIONS(746),
    [sym_nan] = ACTIONS(746),
    [anon_sym_NA] = ACTIONS(746),
    [anon_sym_NA_integer_] = ACTIONS(746),
    [anon_sym_NA_real_] = ACTIONS(746),
    [anon_sym_NA_complex_] = ACTIONS(746),
    [anon_sym_NA_character_] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(748),
    [sym__semicolon] = ACTIONS(748),
    [sym__raw_string_literal] = ACTIONS(748),
    [sym__external_open_parenthesis] = ACTIONS(748),
    [sym__external_open_brace] = ACTIONS(748),
    [sym__external_close_brace] = ACTIONS(748),
    [sym__external_open_bracket] = ACTIONS(748),
    [sym__external_open_bracket2] = ACTIONS(748),
  },
  [439] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1744),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(855),
  },
  [440] = {
    [sym_identifier] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_repeat] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_LT_DASH] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(703),
    [anon_sym_COLON_EQ] = ACTIONS(703),
    [anon_sym_DASH_GT] = ACTIONS(705),
    [anon_sym_DASH_GT_GT] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_CARET] = ACTIONS(703),
    [aux_sym_binary_operator_token1] = ACTIONS(703),
    [anon_sym_PIPE_GT] = ACTIONS(703),
    [anon_sym_COLON] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(703),
    [sym__hex_literal] = ACTIONS(703),
    [sym__number_literal] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(703),
    [sym_dots] = ACTIONS(705),
    [sym_dot_dot_i] = ACTIONS(705),
    [sym_return] = ACTIONS(705),
    [sym_next] = ACTIONS(705),
    [sym_break] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [sym_inf] = ACTIONS(705),
    [sym_nan] = ACTIONS(705),
    [anon_sym_NA] = ACTIONS(705),
    [anon_sym_NA_integer_] = ACTIONS(705),
    [anon_sym_NA_real_] = ACTIONS(705),
    [anon_sym_NA_complex_] = ACTIONS(705),
    [anon_sym_NA_character_] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(703),
    [sym__semicolon] = ACTIONS(703),
    [sym__raw_string_literal] = ACTIONS(703),
    [sym__external_open_parenthesis] = ACTIONS(703),
    [sym__external_open_brace] = ACTIONS(703),
    [sym__external_close_brace] = ACTIONS(703),
    [sym__external_open_bracket] = ACTIONS(703),
    [sym__external_open_bracket2] = ACTIONS(703),
  },
  [441] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(1701),
    [aux_sym_braced_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(857),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(687),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_repeat] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_LT_DASH] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(689),
    [anon_sym_COLON_EQ] = ACTIONS(689),
    [anon_sym_DASH_GT] = ACTIONS(687),
    [anon_sym_DASH_GT_GT] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_STAR_STAR] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(689),
    [aux_sym_binary_operator_token1] = ACTIONS(689),
    [anon_sym_PIPE_GT] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [sym__hex_literal] = ACTIONS(689),
    [sym__number_literal] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_dots] = ACTIONS(687),
    [sym_dot_dot_i] = ACTIONS(687),
    [sym_return] = ACTIONS(687),
    [sym_next] = ACTIONS(687),
    [sym_break] = ACTIONS(687),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_inf] = ACTIONS(687),
    [sym_nan] = ACTIONS(687),
    [anon_sym_NA] = ACTIONS(687),
    [anon_sym_NA_integer_] = ACTIONS(687),
    [anon_sym_NA_real_] = ACTIONS(687),
    [anon_sym_NA_complex_] = ACTIONS(687),
    [anon_sym_NA_character_] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(689),
    [sym__semicolon] = ACTIONS(689),
    [sym__raw_string_literal] = ACTIONS(689),
    [sym__external_open_parenthesis] = ACTIONS(689),
    [sym__external_open_brace] = ACTIONS(689),
    [sym__external_open_bracket] = ACTIONS(689),
    [sym__external_open_bracket2] = ACTIONS(689),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_identifier] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_while] = ACTIONS(691),
    [anon_sym_repeat] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_COLON_EQ] = ACTIONS(693),
    [anon_sym_DASH_GT] = ACTIONS(691),
    [anon_sym_DASH_GT_GT] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(691),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_LT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_EQ] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_CARET] = ACTIONS(693),
    [aux_sym_binary_operator_token1] = ACTIONS(693),
    [anon_sym_PIPE_GT] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [sym__hex_literal] = ACTIONS(693),
    [sym__number_literal] = ACTIONS(691),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [sym_dots] = ACTIONS(691),
    [sym_dot_dot_i] = ACTIONS(691),
    [sym_return] = ACTIONS(691),
    [sym_next] = ACTIONS(691),
    [sym_break] = ACTIONS(691),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_null] = ACTIONS(691),
    [sym_inf] = ACTIONS(691),
    [sym_nan] = ACTIONS(691),
    [anon_sym_NA] = ACTIONS(691),
    [anon_sym_NA_integer_] = ACTIONS(691),
    [anon_sym_NA_real_] = ACTIONS(691),
    [anon_sym_NA_complex_] = ACTIONS(691),
    [anon_sym_NA_character_] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(693),
    [sym__semicolon] = ACTIONS(693),
    [sym__raw_string_literal] = ACTIONS(693),
    [sym__external_open_parenthesis] = ACTIONS(693),
    [sym__external_open_brace] = ACTIONS(693),
    [sym__external_open_bracket] = ACTIONS(693),
    [sym__external_open_bracket2] = ACTIONS(693),
  },
  [444] = {
    [sym_function_definition] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_repeat_statement] = STATE(187),
    [sym_braced_expression] = STATE(187),
    [sym_parenthesized_expression] = STATE(187),
    [sym_call] = STATE(187),
    [sym_subset] = STATE(187),
    [sym_subset2] = STATE(187),
    [sym_unary_operator] = STATE(187),
    [sym_binary_operator] = STATE(187),
    [sym_extract_operator] = STATE(187),
    [sym_namespace_operator] = STATE(187),
    [sym_integer] = STATE(187),
    [sym_complex] = STATE(187),
    [sym_float] = STATE(187),
    [sym__float_literal] = STATE(315),
    [sym_string] = STATE(314),
    [sym__single_quoted_string] = STATE(316),
    [sym__double_quoted_string] = STATE(317),
    [sym_na] = STATE(187),
    [sym__expression] = STATE(187),
    [sym__open_parenthesis] = STATE(1117),
    [sym__open_brace] = STATE(414),
    [sym__close_brace] = STATE(369),
    [aux_sym_braced_expression_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_dots] = ACTIONS(785),
    [sym_dot_dot_i] = ACTIONS(785),
    [sym_return] = ACTIONS(811),
    [sym_next] = ACTIONS(811),
    [sym_break] = ACTIONS(811),
    [sym_true] = ACTIONS(811),
    [sym_false] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [sym_inf] = ACTIONS(811),
    [sym_nan] = ACTIONS(811),
    [anon_sym_NA] = ACTIONS(813),
    [anon_sym_NA_integer_] = ACTIONS(813),
    [anon_sym_NA_real_] = ACTIONS(813),
    [anon_sym_NA_complex_] = ACTIONS(813),
    [anon_sym_NA_character_] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__semicolon] = ACTIONS(815),
    [sym__raw_string_literal] = ACTIONS(477),
    [sym__external_open_parenthesis] = ACTIONS(817),
    [sym__external_open_brace] = ACTIONS(819),
    [sym__external_close_brace] = ACTIONS(859),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_BSLASH,
    ACTIONS(867), 1,
      anon_sym_function,
    ACTIONS(870), 1,
      anon_sym_if,
    ACTIONS(873), 1,
      anon_sym_for,
    ACTIONS(876), 1,
      anon_sym_while,
    ACTIONS(879), 1,
      anon_sym_repeat,
    ACTIONS(882), 1,
      anon_sym_QMARK,
    ACTIONS(885), 1,
      anon_sym_TILDE,
    ACTIONS(888), 1,
      anon_sym_BANG,
    ACTIONS(894), 1,
      sym__hex_literal,
    ACTIONS(897), 1,
      sym__number_literal,
    ACTIONS(900), 1,
      anon_sym_SQUOTE,
    ACTIONS(903), 1,
      anon_sym_DQUOTE,
    ACTIONS(915), 1,
      sym__raw_string_literal,
    ACTIONS(918), 1,
      sym__external_open_parenthesis,
    ACTIONS(921), 1,
      sym__external_open_brace,
    ACTIONS(924), 1,
      sym__external_close_brace,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(445), 1,
      aux_sym_braced_expression_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(912), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(861), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(909), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(906), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(187), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(926), 1,
      ts_builtin_sym_end,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(448), 1,
      aux_sym_program_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(958), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(954), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [254] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(964), 1,
      ts_builtin_sym_end,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(446), 1,
      aux_sym_program_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(966), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(954), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [381] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 1,
      ts_builtin_sym_end,
    ACTIONS(973), 1,
      anon_sym_BSLASH,
    ACTIONS(976), 1,
      anon_sym_function,
    ACTIONS(979), 1,
      anon_sym_if,
    ACTIONS(982), 1,
      anon_sym_for,
    ACTIONS(985), 1,
      anon_sym_while,
    ACTIONS(988), 1,
      anon_sym_repeat,
    ACTIONS(991), 1,
      anon_sym_QMARK,
    ACTIONS(994), 1,
      anon_sym_TILDE,
    ACTIONS(997), 1,
      anon_sym_BANG,
    ACTIONS(1003), 1,
      sym__hex_literal,
    ACTIONS(1006), 1,
      sym__number_literal,
    ACTIONS(1009), 1,
      anon_sym_SQUOTE,
    ACTIONS(1012), 1,
      anon_sym_DQUOTE,
    ACTIONS(1024), 1,
      sym__raw_string_literal,
    ACTIONS(1027), 1,
      sym__external_open_parenthesis,
    ACTIONS(1030), 1,
      sym__external_open_brace,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(448), 1,
      aux_sym_program_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(1000), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1021), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(970), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1018), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1015), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [508] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    STATE(2039), 1,
      sym__argument_value,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1035), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(409), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1361), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [632] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    STATE(2042), 1,
      sym__argument_value,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1035), 2,
      sym__external_close_bracket,
      sym_comma,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(523), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1575), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [756] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    STATE(2033), 1,
      sym__argument_value,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1035), 2,
      sym__external_close_bracket2,
      sym_comma,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(455), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1552), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [880] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1041), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(231), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1003] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1047), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(706), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1045), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(197), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1126] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1051), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(832), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1049), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(198), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1249] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1053), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(149), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1372] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1057), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(484), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1055), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(150), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1495] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1061), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(984), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1059), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(199), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1618] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1065), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(985), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1063), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(200), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1741] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1067), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(151), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1864] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1071), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(986), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1069), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(201), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1987] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1073), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(152), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2110] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1075), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(153), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2233] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1079), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(993), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1077), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(130), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2356] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1081), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(154), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2479] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1085), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1000), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1083), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(202), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2602] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1087), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(155), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2725] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1091), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1008), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1089), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(203), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2848] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1093), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(156), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2971] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1097), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1014), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1095), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(204), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1099), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(157), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3217] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1101), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(158), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3340] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1103), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(159), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3463] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1105), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(160), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3586] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1107), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(161), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3709] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1111), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1016), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1109), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(205), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3832] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1113), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(162), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3955] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1115), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(221), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4078] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1117), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(163), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4201] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1149), 1,
      sym__newline,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(491), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1145), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(2), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4324] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1157), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(498), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1155), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(222), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4447] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1161), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(634), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1159), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(183), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4570] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1165), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(636), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1163), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(184), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4693] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1169), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(486), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1167), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(188), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4816] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1171), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(164), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4939] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1175), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(487), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1173), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(166), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5062] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1177), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(206), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5185] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1179), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(167), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5308] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1183), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(494), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1181), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(168), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5431] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1187), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(477), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1185), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(207), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5554] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1191), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(495), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1189), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(169), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5677] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1193), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(5), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5800] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1197), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(499), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1195), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(171), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5923] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1201), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(507), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1199), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(3), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6046] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1203), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(172), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6169] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1205), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(173), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6292] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1209), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(502), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1207), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(174), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6415] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1213), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(503), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1211), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(175), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6538] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1215), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(223), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6661] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1217), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(176), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6784] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1221), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(506), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1219), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(177), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6907] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1225), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(594), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1223), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(224), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7030] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1227), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(178), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7153] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1229), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(179), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7276] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1233), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(508), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1231), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(180), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7399] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1237), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(631), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1235), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(225), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7522] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1239), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(181), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7645] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1241), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(4), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7768] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1243), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(182), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7891] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1247), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(452), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1245), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(226), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8014] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1251), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(516), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1249), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1434), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8137] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1255), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(517), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1253), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1437), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8260] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1259), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(518), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1257), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1443), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8383] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1263), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(519), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1261), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1447), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8506] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1267), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(520), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1265), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1529), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8629] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1271), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(535), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1269), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1392), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8752] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1273), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1393), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8875] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1275), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1394), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8998] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1277), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1396), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1279), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1397), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9244] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1281), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1398), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9367] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1285), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(537), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1283), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1400), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1289), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(538), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1287), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1401), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9613] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1293), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(539), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1291), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1403), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9736] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1297), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(540), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1295), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1404), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9859] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1301), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(541), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1299), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1405), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9982] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1305), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(542), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1303), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1406), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10105] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1309), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(543), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1307), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1407), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10228] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1313), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(544), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1311), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1408), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10351] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1317), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(545), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1315), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1409), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10474] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1321), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(546), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1319), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1411), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10597] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1325), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(547), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1323), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1414), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10720] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1329), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(548), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1327), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1418), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10843] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1333), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(549), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1331), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1419), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10966] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1337), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(644), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1335), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(185), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11089] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1339), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1439), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11212] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1343), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(550), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1341), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1441), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11335] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1345), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1455), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11458] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1347), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1456), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11581] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1349), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1459), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11704] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1351), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1460), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11827] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1353), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1462), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11950] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1355), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1464), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12073] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1357), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1465), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12196] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1359), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1468), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12319] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1361), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1470), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12442] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1363), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1479), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12565] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1365), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1481), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12688] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1367), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1483), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12811] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1369), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1484), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12934] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1371), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1492), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13057] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1375), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(552), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1373), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1496), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13180] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1377), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1519), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13303] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1381), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(556), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1379), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1520), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13426] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1385), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(557), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1383), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1533), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13549] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1389), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(560), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1387), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1365), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13672] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1391), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1388), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13795] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1393), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1391), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13918] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1397), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(562), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1395), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1413), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14041] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1401), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(563), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1399), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1416), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14164] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1403), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1357), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14287] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1407), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(565), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1405), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1363), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14410] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1409), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1372), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14533] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1411), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1376), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14656] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1415), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(566), 1,
      aux_sym_function_definition_repeat1,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1413), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1377), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14779] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1417), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1389), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14902] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_BSLASH,
    ACTIONS(497), 1,
      anon_sym_function,
    ACTIONS(499), 1,
      anon_sym_if,
    ACTIONS(501), 1,
      anon_sym_for,
    ACTIONS(503), 1,
      anon_sym_while,
    ACTIONS(505), 1,
      anon_sym_repeat,
    ACTIONS(507), 1,
      anon_sym_QMARK,
    ACTIONS(509), 1,
      anon_sym_TILDE,
    ACTIONS(511), 1,
      anon_sym_BANG,
    ACTIONS(515), 1,
      sym__hex_literal,
    ACTIONS(517), 1,
      sym__number_literal,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(533), 1,
      sym__external_open_parenthesis,
    ACTIONS(535), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(418), 1,
      sym__open_brace,
    STATE(1064), 1,
      sym__open_parenthesis,
    STATE(1608), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1626), 1,
      sym__float_literal,
    STATE(1629), 1,
      sym__single_quoted_string,
    ACTIONS(513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1037), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(527), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1419), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1390), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15025] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1423), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(573), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1421), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1535), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15148] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1427), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(574), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1425), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1572), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15271] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1431), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(575), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1429), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1334), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15394] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1435), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(576), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1433), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1364), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15517] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1439), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(577), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1437), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1369), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15640] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1443), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(592), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1441), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1421), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15763] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1445), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1424), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15886] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1447), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1426), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16009] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1449), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1427), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16132] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1451), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1428), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16255] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1453), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1430), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16378] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1457), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(595), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1455), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1432), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16501] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1461), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(596), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1459), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1435), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16624] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1465), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(597), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1463), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1436), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16747] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1469), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(598), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1467), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1440), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16870] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1473), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(599), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1471), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1442), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16993] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1477), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(600), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1475), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1444), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17116] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1481), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(601), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1479), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1446), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17239] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1485), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(602), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1483), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1467), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17362] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1489), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(603), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1487), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1526), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17485] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1493), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(604), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1491), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1532), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17608] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1497), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(605), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1495), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1537), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17731] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1501), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(606), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1499), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1541), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17854] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1505), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(607), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1503), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1545), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17977] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1507), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(189), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18100] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1509), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1573), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18223] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1513), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(608), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1511), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1466), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18346] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1515), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(227), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18469] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1517), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1336), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18592] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1519), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1337), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18715] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1521), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1338), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18838] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1523), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1339), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18961] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1525), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1340), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19084] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1527), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1341), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19207] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1529), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1342), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19330] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1531), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1343), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19453] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1533), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1344), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19576] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1535), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1346), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19699] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1537), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1347), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19822] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1539), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1348), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19945] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1541), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1349), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20068] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1543), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1356), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20191] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1547), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(610), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1545), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1358), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20314] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1549), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1366), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20437] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1553), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(614), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1551), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1367), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20560] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1557), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(615), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1555), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1368), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20683] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1561), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(618), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1559), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1370), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20806] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1563), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1373), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20929] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1565), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1374), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21052] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1569), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(620), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1567), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1378), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21175] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1573), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(621), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1571), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1379), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21298] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1575), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1380), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21421] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1579), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(623), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1577), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1381), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21544] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1581), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1382), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21667] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1583), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1383), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21790] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1587), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(624), 1,
      aux_sym_function_definition_repeat1,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1585), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1384), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21913] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1589), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1385), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22036] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_BSLASH,
    ACTIONS(429), 1,
      anon_sym_function,
    ACTIONS(431), 1,
      anon_sym_if,
    ACTIONS(433), 1,
      anon_sym_for,
    ACTIONS(435), 1,
      anon_sym_while,
    ACTIONS(437), 1,
      anon_sym_repeat,
    ACTIONS(439), 1,
      anon_sym_QMARK,
    ACTIONS(441), 1,
      anon_sym_TILDE,
    ACTIONS(443), 1,
      anon_sym_BANG,
    ACTIONS(447), 1,
      sym__hex_literal,
    ACTIONS(449), 1,
      sym__number_literal,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(465), 1,
      sym__external_open_parenthesis,
    ACTIONS(467), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(422), 1,
      sym__open_brace,
    STATE(1069), 1,
      sym__open_parenthesis,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1607), 1,
      sym_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1610), 1,
      sym__float_literal,
    STATE(1632), 1,
      sym__double_quoted_string,
    ACTIONS(445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1039), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1591), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1387), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22159] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1595), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(661), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1593), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(186), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22282] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1599), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(637), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1597), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(119), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22405] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1603), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(639), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1601), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(122), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22528] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1607), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(640), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1605), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(123), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22651] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1611), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(641), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1609), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(124), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22774] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1615), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(642), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1613), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(125), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22897] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1617), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(228), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23020] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1621), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(643), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1619), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(229), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23143] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1625), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(645), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1623), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(230), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23266] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1627), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(190), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23389] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1631), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(665), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1629), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(126), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23512] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1633), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(191), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23635] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1635), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(127), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23758] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1639), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(660), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1637), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(232), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23881] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1641), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(128), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24004] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1643), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(74), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24127] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1645), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(19), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24250] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1647), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(20), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24373] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1649), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(233), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24496] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1651), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(192), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24619] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1653), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(234), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24742] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1657), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(663), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1655), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(235), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24865] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1661), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(672), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1659), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(21), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24988] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1665), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(674), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1663), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(23), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25111] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1669), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(675), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1667), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(24), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25234] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1673), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(677), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1671), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(25), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25357] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(678), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1675), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(26), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25480] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1681), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(680), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1679), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(27), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25603] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1685), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(681), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1683), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(28), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25726] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1689), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(683), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1687), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(29), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25849] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(684), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1691), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(30), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25972] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1697), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(686), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1695), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(31), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26095] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1701), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(687), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1699), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(32), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26218] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1705), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(689), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1703), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(33), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26341] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1707), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(208), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26464] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1709), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(236), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26587] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1711), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(193), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26710] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1713), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(209), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26833] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1715), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(237), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26956] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1717), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(210), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27079] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1719), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(34), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27202] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1723), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(693), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1721), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(35), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27325] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1727), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(679), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1725), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1438), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27448] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1731), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(682), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1729), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1449), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27571] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1735), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(685), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1733), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1458), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27694] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1739), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(688), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1737), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1463), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27817] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1743), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(690), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1741), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1469), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27940] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1745), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(36), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28063] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1747), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(37), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28186] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1749), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(38), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28309] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1751), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(39), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28432] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1755), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(707), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1753), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1500), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28555] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1757), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(40), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28678] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1759), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(41), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28801] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1761), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1503), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28924] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1763), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(42), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29047] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1765), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(43), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29170] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1767), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1507), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29293] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1769), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(44), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29416] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1771), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(45), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29539] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1773), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1508), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29662] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1775), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(46), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29785] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1777), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(47), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29908] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1779), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1510), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30031] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1781), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(48), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30154] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1783), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1512), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30277] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1787), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(719), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1785), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1530), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30400] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1791), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(721), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1789), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1534), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30523] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1793), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(49), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30646] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1797), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(709), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1795), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(50), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30769] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1801), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(724), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1799), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1362), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30892] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1805), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(726), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1803), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1375), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31015] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1809), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(728), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1807), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1386), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31138] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1813), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(752), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1811), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1395), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31261] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1817), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(790), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1815), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1420), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31384] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1821), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(791), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1819), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1422), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31507] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1825), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(792), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1823), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1423), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31630] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1829), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(795), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1827), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1425), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31753] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1833), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(798), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1831), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1429), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31876] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1837), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(801), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1835), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1431), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31999] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1841), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(802), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1839), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1433), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32122] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1843), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(211), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32245] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1845), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1516), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32368] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1849), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(819), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1847), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1527), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32491] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1851), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(51), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32614] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1855), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(713), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1853), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(52), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32737] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1859), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(714), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1857), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(53), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32860] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1863), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(717), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1861), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(54), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32983] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1865), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(55), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33106] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1867), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(56), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33229] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1871), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(720), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1869), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(57), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33352] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1875), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(722), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1873), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(58), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33475] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1877), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(59), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33598] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1881), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(725), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1879), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(60), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33721] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1883), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1539), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33844] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1885), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(61), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33967] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1887), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1542), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34090] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1889), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(62), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34213] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(1893), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(727), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1891), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(63), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34336] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1895), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1543), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34459] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1897), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(64), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34582] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1899), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1547), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34705] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1901), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(65), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34828] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1903), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1548), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34951] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1939), 1,
      sym__newline,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(735), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1935), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1194), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35074] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1949), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(736), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1947), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1195), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1953), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(737), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1951), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1263), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35320] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1957), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(738), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1955), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1268), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35443] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1961), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(739), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1959), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1281), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35566] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1965), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(753), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1963), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1275), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35689] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1967), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1282), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35812] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1969), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1283), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35935] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1971), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1284), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36058] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1973), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1285), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36181] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1975), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1286), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36304] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1979), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(755), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1977), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1287), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36427] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1983), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(757), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1981), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1289), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36550] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1987), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(758), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1985), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1295), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36673] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1991), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(759), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1989), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1296), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36796] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1995), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(760), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1993), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1297), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36919] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(1999), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(761), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1997), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1298), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37042] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2003), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(762), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2001), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1299), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37165] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2007), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(763), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2005), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1300), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37288] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2011), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(764), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2009), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1302), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37411] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2015), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(765), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2013), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1316), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37534] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2019), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(766), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2017), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1322), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37657] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2023), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(767), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2021), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1176), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2025), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1550), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37903] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2027), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1202), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38026] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2031), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(768), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2029), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1210), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38149] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2033), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1215), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38272] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2035), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1217), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38395] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2037), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1250), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38518] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2039), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1251), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38641] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2041), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1252), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38764] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2043), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1253), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38887] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2045), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1333), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39010] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2047), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1255), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39133] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2049), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1256), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39256] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2051), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1257), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39379] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2053), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1258), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39502] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2055), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1259), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39625] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2057), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1260), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2059), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1261), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39871] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2063), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(770), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2061), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1262), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39994] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2065), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1264), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40117] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2069), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(774), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2067), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1265), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40240] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2073), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(775), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2071), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1266), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40363] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2077), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(778), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2075), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1267), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40486] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2079), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1269), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40609] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2081), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1270), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40732] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2085), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(780), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2083), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1271), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40855] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2089), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(781), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2087), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1272), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40978] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2091), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1273), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41101] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2095), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(783), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2093), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1274), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41224] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2097), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1276), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41347] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2099), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1277), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41470] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2103), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(784), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2101), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1278), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41593] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2105), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1279), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41716] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2107), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1280), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41839] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2139), 1,
      sym__newline,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(794), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2135), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(66), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41962] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2147), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(796), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2145), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(67), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42085] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2151), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(797), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2149), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(68), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42208] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2155), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(799), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2153), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(69), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42331] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2159), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(800), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2157), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(70), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42454] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2161), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1553), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42577] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2163), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1554), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42700] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2165), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1557), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42823] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2169), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(815), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2167), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(71), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42946] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2171), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(72), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43069] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2173), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1558), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43192] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2175), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(73), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43315] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2177), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(129), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43438] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2179), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1559), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43561] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2181), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(75), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43684] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2183), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(76), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43807] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2185), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1561), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43930] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2187), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1563), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44053] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2191), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(817), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2189), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(77), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44176] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2195), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(820), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2193), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(79), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44299] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2199), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(822), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2197), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(80), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44422] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2203), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(823), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2201), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(81), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44545] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2207), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(824), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2205), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(82), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44668] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2211), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(825), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2209), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(83), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44791] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2215), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(826), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2213), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(84), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44914] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2219), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(827), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2217), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(85), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45037] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2223), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(828), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2221), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(86), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45160] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2227), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(829), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2225), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(87), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45283] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2231), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(830), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2229), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(88), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45406] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2235), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(831), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2233), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(89), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45529] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2237), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(90), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45652] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2241), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(833), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2239), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(91), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45775] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2243), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(92), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45898] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2245), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(93), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46021] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2247), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1570), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46144] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2249), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(94), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46267] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2253), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(835), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2251), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1571), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46390] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2255), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(95), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46513] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2257), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(96), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46636] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2259), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(97), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46759] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2261), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(98), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46882] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2263), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(99), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47005] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2265), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(100), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47128] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2267), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(101), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47251] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2269), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(102), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47374] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2271), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(103), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47497] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2273), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(104), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47620] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2275), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(212), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47743] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2277), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(105), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47866] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2281), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(839), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2279), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(106), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47989] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2283), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1574), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48112] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2287), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(841), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2285), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1360), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48235] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2291), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(842), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2289), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1335), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48358] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2295), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(853), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2293), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1345), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48481] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2297), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(107), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48604] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2301), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(847), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2299), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(108), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48727] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2303), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1350), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48850] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2305), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1351), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48973] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2309), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(848), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2307), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(109), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49096] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2313), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(851), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2311), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(110), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49219] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2317), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(858), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2315), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1352), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49342] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2321), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(860), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2319), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1353), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49465] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2323), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(111), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49588] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2325), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(112), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49711] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2329), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(855), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2327), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(113), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49834] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2333), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(856), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2331), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(114), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49957] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2335), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(115), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50080] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2339), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(859), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2337), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(116), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50203] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2341), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1354), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50326] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2345), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(886), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2343), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1355), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50449] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2347), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(117), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50572] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2349), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(118), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50695] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2353), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(862), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2351), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(18), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50818] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2355), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1410), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50941] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2357), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(120), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51064] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2359), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1412), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51187] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(2363), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(974), 1,
      aux_sym_function_definition_repeat1,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2361), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1448), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51310] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2365), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(121), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51433] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2401), 1,
      sym__newline,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(869), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2397), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1290), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51556] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2411), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(870), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2409), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1291), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51679] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2415), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(871), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2413), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1292), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51802] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2419), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(872), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2417), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1293), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2423), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(873), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2421), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1294), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52048] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2427), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(887), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2425), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1301), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52171] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2429), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1303), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52294] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2431), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1304), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52417] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2433), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1305), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52540] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2435), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1306), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52663] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2437), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1307), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52786] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2441), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(889), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2439), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1308), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52909] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2445), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(891), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2443), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1310), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53032] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2449), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(892), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2447), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1311), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53155] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2453), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(893), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2451), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1312), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53278] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2457), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(894), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2455), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1313), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53401] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2461), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(895), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2459), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1314), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53524] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2465), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(896), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2463), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1315), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53647] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2469), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(897), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2467), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1317), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53770] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2473), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(898), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2471), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1318), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53893] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2477), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(899), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2475), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1319), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54016] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2481), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(900), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2479), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1320), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54139] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2485), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(901), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2483), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1321), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54262] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2487), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1450), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54385] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2489), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1323), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54508] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2493), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(902), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2491), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1324), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54631] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2495), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1325), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54754] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2497), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1326), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54877] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2499), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1327), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55000] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2501), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1328), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2503), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1329), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55246] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2505), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1330), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55369] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2507), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1331), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55492] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2509), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1332), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55615] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2511), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1254), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55738] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2513), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1167), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55861] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2515), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1168), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55984] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2517), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1169), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56107] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2519), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1170), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56230] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2521), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1171), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56353] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2525), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(904), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2523), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1172), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56476] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2527), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1173), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56599] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2531), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(908), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2529), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1174), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56722] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2535), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(909), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2533), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1175), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56845] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2539), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(912), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2537), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1177), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56968] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2541), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1178), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57091] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2543), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1179), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57214] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2547), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(914), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2545), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1180), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57337] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2551), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(915), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2549), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1181), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57460] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2553), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1182), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57583] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2557), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(917), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2555), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1183), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57706] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2559), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1184), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57829] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2561), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1185), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57952] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2565), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(918), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2563), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1186), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58075] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2567), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1187), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58198] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2569), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1188), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58321] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2605), 1,
      sym__newline,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(925), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2601), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1189), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58444] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2615), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(926), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2613), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1190), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58567] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2619), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(927), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2617), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1191), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58690] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2623), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(928), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2621), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1192), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58813] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2627), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(929), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2625), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1193), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58936] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2631), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(942), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2629), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1196), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59059] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2633), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1197), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59182] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2635), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1198), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59305] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2637), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1199), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59428] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2639), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1200), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59551] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2641), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1201), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59674] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2645), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(944), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2643), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1166), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59797] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2649), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(946), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2647), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1204), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59920] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2653), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(947), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2651), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1205), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60043] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2657), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(948), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2655), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1206), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60166] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2661), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(949), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2659), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1207), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60289] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2665), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(950), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2663), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1208), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60412] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2669), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(951), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2667), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1209), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60535] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2673), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(952), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2671), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1211), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60658] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2677), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(953), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2675), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1212), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60781] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2681), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(954), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2679), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1213), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60904] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2685), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(955), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2683), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1214), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61027] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2689), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(956), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2687), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1216), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61150] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2691), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1218), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61273] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2695), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(957), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2693), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1219), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61396] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2697), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1220), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61519] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2699), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1221), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61642] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2701), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1222), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61765] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2703), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1223), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61888] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2705), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1224), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62011] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2707), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1225), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62134] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2709), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1226), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62257] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2711), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1227), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62380] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2713), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1228), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62503] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2715), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1229), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62626] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2717), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1230), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62749] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2719), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1231), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62872] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2721), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1232), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62995] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2723), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1233), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63118] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2727), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(959), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2725), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1234), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63241] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2729), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1235), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63364] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2733), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(963), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2731), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1236), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63487] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2737), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(964), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2735), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1237), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63610] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2741), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(967), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2739), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1238), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63733] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2743), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1239), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63856] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2745), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1240), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63979] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2749), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(969), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2747), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1241), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64102] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2753), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(970), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2751), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1242), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64225] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2755), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1243), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64348] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2759), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(972), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2757), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1244), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64471] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2761), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1245), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64594] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2763), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1246), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64717] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2767), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(973), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2765), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1247), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64840] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2769), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1248), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64963] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2771), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1249), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65086] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2773), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1451), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65209] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2777), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(976), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2775), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1158), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65332] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2779), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1159), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65455] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2783), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(980), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2781), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1139), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65578] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2787), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(992), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2785), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(238), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65701] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2791), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(994), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2789), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(239), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65824] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2793), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1161), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65947] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2797), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(999), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2795), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(240), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66070] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2801), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1001), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2799), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(241), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66193] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2805), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1007), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2803), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(242), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66316] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2807), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(213), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66439] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2809), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(214), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66562] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2811), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(215), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66685] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2815), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(455), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2813), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(131), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66808] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2819), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(989), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2817), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(6), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66931] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2821), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(7), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67054] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2825), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(991), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2823), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(8), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67177] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2827), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(9), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67300] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2829), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(132), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67423] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2831), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(216), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67546] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2833), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(133), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67669] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2837), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(996), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2835), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1146), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67792] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2839), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1149), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67915] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2843), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(998), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2841), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1150), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68038] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2845), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1155), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68161] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2847), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(134), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68284] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2849), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(217), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68407] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2851), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(135), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68530] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2855), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(1003), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2853), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1162), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68653] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2857), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1163), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68776] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2861), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(1005), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2859), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68899] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2863), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1140), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69022] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(2867), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(591), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2865), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(170), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69145] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(1117), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2869), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(136), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2871), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(218), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69391] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(2875), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(659), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2873), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(194), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69514] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2879), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(1011), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2877), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1151), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69637] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2881), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1152), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69760] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    ACTIONS(2885), 1,
      sym__newline,
    STATE(430), 1,
      sym__open_brace,
    STATE(1013), 1,
      aux_sym_function_definition_repeat1,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2883), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1153), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69883] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1907), 1,
      anon_sym_BSLASH,
    ACTIONS(1909), 1,
      anon_sym_function,
    ACTIONS(1911), 1,
      anon_sym_if,
    ACTIONS(1913), 1,
      anon_sym_for,
    ACTIONS(1915), 1,
      anon_sym_while,
    ACTIONS(1917), 1,
      anon_sym_repeat,
    ACTIONS(1919), 1,
      anon_sym_QMARK,
    ACTIONS(1921), 1,
      anon_sym_TILDE,
    ACTIONS(1923), 1,
      anon_sym_BANG,
    ACTIONS(1927), 1,
      sym__hex_literal,
    ACTIONS(1929), 1,
      sym__number_literal,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(1943), 1,
      sym__external_open_parenthesis,
    ACTIONS(1945), 1,
      sym__external_open_brace,
    STATE(430), 1,
      sym__open_brace,
    STATE(1079), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      sym_string,
    STATE(1599), 1,
      sym__float_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1905), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1937), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2887), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1154), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70006] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2889), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(219), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70129] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(2893), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(662), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2891), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(195), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70252] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(1043), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(1051), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2895), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(220), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70375] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2899), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(459), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2897), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(137), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70498] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2903), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1019), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2901), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(15), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70621] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2905), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(16), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70744] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    ACTIONS(2909), 1,
      sym__newline,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1021), 1,
      aux_sym_function_definition_repeat1,
    STATE(1084), 1,
      sym__open_parenthesis,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2907), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(17), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70867] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_SQUOTE,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2111), 1,
      anon_sym_BSLASH,
    ACTIONS(2113), 1,
      anon_sym_function,
    ACTIONS(2115), 1,
      anon_sym_if,
    ACTIONS(2117), 1,
      anon_sym_for,
    ACTIONS(2119), 1,
      anon_sym_while,
    ACTIONS(2121), 1,
      anon_sym_repeat,
    ACTIONS(2123), 1,
      anon_sym_QMARK,
    ACTIONS(2125), 1,
      anon_sym_TILDE,
    ACTIONS(2127), 1,
      anon_sym_BANG,
    ACTIONS(2131), 1,
      sym__hex_literal,
    ACTIONS(2133), 1,
      sym__number_literal,
    ACTIONS(2141), 1,
      sym__external_open_parenthesis,
    ACTIONS(2143), 1,
      sym__external_open_brace,
    STATE(290), 1,
      sym_string,
    STATE(291), 1,
      sym__float_literal,
    STATE(292), 1,
      sym__single_quoted_string,
    STATE(293), 1,
      sym__double_quoted_string,
    STATE(434), 1,
      sym__open_brace,
    STATE(1084), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2109), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2137), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2911), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(10), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70990] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2915), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(461), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2913), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(243), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71113] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2919), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(462), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2917), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(138), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71236] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2923), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(464), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2921), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(139), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71359] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2927), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(466), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2925), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(140), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71482] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2931), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(1027), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2929), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1156), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71605] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2933), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1157), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71728] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    ACTIONS(2937), 1,
      sym__newline,
    STATE(437), 1,
      sym__open_brace,
    STATE(1029), 1,
      aux_sym_function_definition_repeat1,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2935), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1160), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71851] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2369), 1,
      anon_sym_BSLASH,
    ACTIONS(2371), 1,
      anon_sym_function,
    ACTIONS(2373), 1,
      anon_sym_if,
    ACTIONS(2375), 1,
      anon_sym_for,
    ACTIONS(2377), 1,
      anon_sym_while,
    ACTIONS(2379), 1,
      anon_sym_repeat,
    ACTIONS(2381), 1,
      anon_sym_QMARK,
    ACTIONS(2383), 1,
      anon_sym_TILDE,
    ACTIONS(2385), 1,
      anon_sym_BANG,
    ACTIONS(2389), 1,
      sym__hex_literal,
    ACTIONS(2391), 1,
      sym__number_literal,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(2405), 1,
      sym__external_open_parenthesis,
    ACTIONS(2407), 1,
      sym__external_open_brace,
    STATE(437), 1,
      sym__open_brace,
    STATE(1089), 1,
      sym__open_parenthesis,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1577), 1,
      sym_string,
    STATE(1578), 1,
      sym__float_literal,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2387), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2399), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2939), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1164), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71974] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2943), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(468), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2941), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(141), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72097] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2947), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(470), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2945), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(142), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72220] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2951), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(471), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2949), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(143), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72343] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2955), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(472), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2953), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(144), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72466] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2959), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(1035), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2957), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1141), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72589] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2961), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1142), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72712] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    ACTIONS(2965), 1,
      sym__newline,
    STATE(441), 1,
      sym__open_brace,
    STATE(1037), 1,
      aux_sym_function_definition_repeat1,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2963), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1143), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72835] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(2573), 1,
      anon_sym_BSLASH,
    ACTIONS(2575), 1,
      anon_sym_function,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_for,
    ACTIONS(2581), 1,
      anon_sym_while,
    ACTIONS(2583), 1,
      anon_sym_repeat,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_TILDE,
    ACTIONS(2589), 1,
      anon_sym_BANG,
    ACTIONS(2593), 1,
      sym__hex_literal,
    ACTIONS(2595), 1,
      sym__number_literal,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(2609), 1,
      sym__external_open_parenthesis,
    ACTIONS(2611), 1,
      sym__external_open_brace,
    STATE(441), 1,
      sym__open_brace,
    STATE(1094), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      sym_string,
    STATE(1593), 1,
      sym__float_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(2591), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2571), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(2603), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2967), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1144), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72958] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2971), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(473), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2969), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(145), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73081] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2975), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(474), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2973), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(146), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73204] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2979), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(476), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2977), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(147), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73327] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_SQUOTE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      sym__raw_string_literal,
    ACTIONS(787), 1,
      anon_sym_BSLASH,
    ACTIONS(789), 1,
      anon_sym_function,
    ACTIONS(791), 1,
      anon_sym_if,
    ACTIONS(793), 1,
      anon_sym_for,
    ACTIONS(795), 1,
      anon_sym_while,
    ACTIONS(797), 1,
      anon_sym_repeat,
    ACTIONS(799), 1,
      anon_sym_QMARK,
    ACTIONS(801), 1,
      anon_sym_TILDE,
    ACTIONS(803), 1,
      anon_sym_BANG,
    ACTIONS(807), 1,
      sym__hex_literal,
    ACTIONS(809), 1,
      sym__number_literal,
    ACTIONS(817), 1,
      sym__external_open_parenthesis,
    ACTIONS(819), 1,
      sym__external_open_brace,
    ACTIONS(2983), 1,
      sym__newline,
    STATE(314), 1,
      sym_string,
    STATE(315), 1,
      sym__float_literal,
    STATE(316), 1,
      sym__single_quoted_string,
    STATE(317), 1,
      sym__double_quoted_string,
    STATE(414), 1,
      sym__open_brace,
    STATE(478), 1,
      aux_sym_function_definition_repeat1,
    STATE(1117), 1,
      sym__open_parenthesis,
    ACTIONS(805), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(813), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2981), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(148), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(2987), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1043), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2985), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(11), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73573] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2989), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(12), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73696] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    ACTIONS(2993), 1,
      sym__newline,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1045), 1,
      aux_sym_function_definition_repeat1,
    STATE(1074), 1,
      sym__open_parenthesis,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2991), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(13), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_SQUOTE,
    ACTIONS(355), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      sym__raw_string_literal,
    ACTIONS(1043), 1,
      sym__newline,
    ACTIONS(1121), 1,
      anon_sym_BSLASH,
    ACTIONS(1123), 1,
      anon_sym_function,
    ACTIONS(1125), 1,
      anon_sym_if,
    ACTIONS(1127), 1,
      anon_sym_for,
    ACTIONS(1129), 1,
      anon_sym_while,
    ACTIONS(1131), 1,
      anon_sym_repeat,
    ACTIONS(1133), 1,
      anon_sym_QMARK,
    ACTIONS(1135), 1,
      anon_sym_TILDE,
    ACTIONS(1137), 1,
      anon_sym_BANG,
    ACTIONS(1141), 1,
      sym__hex_literal,
    ACTIONS(1143), 1,
      sym__number_literal,
    ACTIONS(1151), 1,
      sym__external_open_parenthesis,
    ACTIONS(1153), 1,
      sym__external_open_brace,
    STATE(286), 1,
      sym_string,
    STATE(287), 1,
      sym__float_literal,
    STATE(288), 1,
      sym__single_quoted_string,
    STATE(289), 1,
      sym__double_quoted_string,
    STATE(426), 1,
      sym__open_brace,
    STATE(1074), 1,
      sym__open_parenthesis,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1139), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1119), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(1147), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2995), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(14), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73942] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_SQUOTE,
    ACTIONS(483), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      sym__raw_string_literal,
    ACTIONS(930), 1,
      anon_sym_BSLASH,
    ACTIONS(932), 1,
      anon_sym_function,
    ACTIONS(934), 1,
      anon_sym_if,
    ACTIONS(936), 1,
      anon_sym_for,
    ACTIONS(938), 1,
      anon_sym_while,
    ACTIONS(940), 1,
      anon_sym_repeat,
    ACTIONS(942), 1,
      anon_sym_QMARK,
    ACTIONS(944), 1,
      anon_sym_TILDE,
    ACTIONS(946), 1,
      anon_sym_BANG,
    ACTIONS(950), 1,
      sym__hex_literal,
    ACTIONS(952), 1,
      sym__number_literal,
    ACTIONS(960), 1,
      sym__external_open_parenthesis,
    ACTIONS(962), 1,
      sym__external_open_brace,
    ACTIONS(2999), 1,
      sym__newline,
    STATE(304), 1,
      sym__float_literal,
    STATE(308), 1,
      sym__single_quoted_string,
    STATE(309), 1,
      sym__double_quoted_string,
    STATE(323), 1,
      sym_string,
    STATE(389), 1,
      sym__open_brace,
    STATE(664), 1,
      aux_sym_function_definition_repeat1,
    STATE(1051), 1,
      sym__open_parenthesis,
    ACTIONS(948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(956), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2997), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(196), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74065] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3001), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1461), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74182] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3003), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1536), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74299] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3005), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1415), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74416] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3007), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1402), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74533] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3009), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1359), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74650] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3011), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1417), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74767] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3013), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1371), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74884] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3015), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1399), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75001] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3017), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1445), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75118] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3019), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1452), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75235] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3021), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1453), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75352] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3023), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1454), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75469] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3025), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1457), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75586] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3027), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1472), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75703] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3029), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1473), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75820] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3031), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1474), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75937] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3033), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1475), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76054] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3035), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1476), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76171] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3037), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1477), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76288] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3039), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1478), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76405] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3041), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1480), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76522] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3043), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1482), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76639] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3045), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1485), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76756] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3047), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1486), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76873] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3049), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1487), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76990] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3051), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1488), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77107] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3053), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1489), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77224] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3055), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1490), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77341] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3057), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1491), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77458] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3059), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1493), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77575] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3061), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1494), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77692] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3063), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1495), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77809] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3065), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1497), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77926] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3067), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1498), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78043] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3069), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1499), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78160] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3071), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1501), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78277] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3073), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1502), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78394] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3075), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1504), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78511] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3077), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1505), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78628] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3079), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1506), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78745] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3081), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1509), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78862] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3083), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1511), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78979] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3085), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1513), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79096] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3087), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1514), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79213] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3089), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1515), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79330] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3091), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1517), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79447] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3093), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1518), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79564] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3095), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1521), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79681] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3097), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1522), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79798] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3099), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1523), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79915] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3101), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1524), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80032] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3103), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1525), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80149] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3105), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1528), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80266] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3107), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1531), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80383] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3109), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1538), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80500] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3111), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1540), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80617] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3113), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1544), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80734] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3115), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1546), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80851] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3117), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1549), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80968] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3119), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1551), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81085] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3121), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1555), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81202] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3123), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1556), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81319] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3125), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1560), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81436] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3127), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1562), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81553] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3129), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1564), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81670] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3131), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1565), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81787] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3133), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1566), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81904] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3135), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1567), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82021] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3137), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1568), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82138] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3139), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1569), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82255] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(381), 1,
      anon_sym_BSLASH,
    ACTIONS(383), 1,
      anon_sym_function,
    ACTIONS(385), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_for,
    ACTIONS(389), 1,
      anon_sym_while,
    ACTIONS(391), 1,
      anon_sym_repeat,
    ACTIONS(393), 1,
      anon_sym_QMARK,
    ACTIONS(395), 1,
      anon_sym_TILDE,
    ACTIONS(397), 1,
      anon_sym_BANG,
    ACTIONS(401), 1,
      sym__hex_literal,
    ACTIONS(403), 1,
      sym__number_literal,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(419), 1,
      sym__external_open_parenthesis,
    ACTIONS(423), 1,
      sym__external_open_brace,
    STATE(402), 1,
      sym__open_brace,
    STATE(1056), 1,
      sym__open_parenthesis,
    STATE(1619), 1,
      sym_string,
    STATE(1620), 1,
      sym__float_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    ACTIONS(399), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(413), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3141), 8,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
    STATE(1471), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82372] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(3145), 1,
      sym__newline,
    STATE(1123), 1,
      aux_sym_function_definition_repeat1,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1688), 1,
      sym_string,
    ACTIONS(3143), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82444] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(3149), 1,
      sym__newline,
    STATE(1120), 1,
      aux_sym_function_definition_repeat1,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1703), 1,
      sym_string,
    ACTIONS(3147), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82516] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    ACTIONS(3153), 1,
      sym__newline,
    STATE(1138), 1,
      aux_sym_function_definition_repeat1,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1646), 1,
      sym_string,
    ACTIONS(3151), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82588] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(3157), 1,
      sym__newline,
    STATE(1122), 1,
      aux_sym_function_definition_repeat1,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1638), 1,
      sym_string,
    ACTIONS(3155), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82660] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    ACTIONS(3161), 1,
      sym__newline,
    STATE(1134), 1,
      aux_sym_function_definition_repeat1,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1658), 1,
      sym_string,
    ACTIONS(3159), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82732] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    ACTIONS(3165), 1,
      sym__newline,
    STATE(1133), 1,
      aux_sym_function_definition_repeat1,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1643), 1,
      sym_string,
    ACTIONS(3163), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82804] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(3169), 1,
      sym__newline,
    STATE(1147), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1629), 1,
      sym__single_quoted_string,
    STATE(1722), 1,
      sym_string,
    ACTIONS(3167), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82875] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    ACTIONS(3173), 1,
      sym__newline,
    STATE(1124), 1,
      aux_sym_function_definition_repeat1,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1629), 1,
      sym__single_quoted_string,
    STATE(1720), 1,
      sym_string,
    ACTIONS(3171), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [82946] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(3177), 1,
      sym__newline,
    STATE(1128), 1,
      aux_sym_function_definition_repeat1,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    STATE(1731), 1,
      sym_string,
    ACTIONS(3175), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83017] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(3181), 1,
      sym__newline,
    STATE(1129), 1,
      aux_sym_function_definition_repeat1,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1632), 1,
      sym__double_quoted_string,
    STATE(1765), 1,
      sym_string,
    ACTIONS(3179), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(371), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(369), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83088] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    ACTIONS(3185), 1,
      sym__newline,
    STATE(1145), 1,
      aux_sym_function_definition_repeat1,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    STATE(1770), 1,
      sym_string,
    ACTIONS(3183), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83159] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    ACTIONS(3189), 1,
      sym__newline,
    STATE(1148), 1,
      aux_sym_function_definition_repeat1,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1632), 1,
      sym__double_quoted_string,
    STATE(1712), 1,
      sym_string,
    ACTIONS(3187), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(347), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_SQUOTE,
    ACTIONS(2395), 1,
      anon_sym_DQUOTE,
    ACTIONS(2403), 1,
      sym__raw_string_literal,
    STATE(1576), 1,
      sym__double_quoted_string,
    STATE(1579), 1,
      sym__single_quoted_string,
    STATE(1637), 1,
      sym_string,
    ACTIONS(3191), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83296] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_SQUOTE,
    ACTIONS(2599), 1,
      anon_sym_DQUOTE,
    ACTIONS(2607), 1,
      sym__raw_string_literal,
    STATE(1594), 1,
      sym__single_quoted_string,
    STATE(1595), 1,
      sym__double_quoted_string,
    STATE(1690), 1,
      sym_string,
    ACTIONS(3193), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83362] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_SQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__raw_string_literal,
    STATE(1602), 1,
      sym__single_quoted_string,
    STATE(1603), 1,
      sym__double_quoted_string,
    STATE(1641), 1,
      sym_string,
    ACTIONS(3195), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3197), 1,
      sym__newline,
    STATE(1133), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 29,
      sym__raw_string_literal,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [83483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      sym__newline,
    STATE(1134), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 29,
      sym__raw_string_literal,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [83538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_SQUOTE,
    ACTIONS(407), 1,
      anon_sym_DQUOTE,
    ACTIONS(417), 1,
      sym__raw_string_literal,
    STATE(1624), 1,
      sym__single_quoted_string,
    STATE(1625), 1,
      sym__double_quoted_string,
    STATE(1755), 1,
      sym_string,
    ACTIONS(3203), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83603] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_SQUOTE,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      sym__raw_string_literal,
    STATE(1604), 1,
      sym__single_quoted_string,
    STATE(1632), 1,
      sym__double_quoted_string,
    STATE(1715), 1,
      sym_string,
    ACTIONS(3205), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      sym__raw_string_literal,
    STATE(1611), 1,
      sym__double_quoted_string,
    STATE(1629), 1,
      sym__single_quoted_string,
    STATE(1758), 1,
      sym_string,
    ACTIONS(3207), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(491), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(489), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [83733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 1,
      sym__newline,
    STATE(1138), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 29,
      sym__raw_string_literal,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [83788] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3250), 1,
      sym__external_else,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(846), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [83896] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3296), 1,
      sym__external_else,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(622), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84004] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3304), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(961), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84112] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3306), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(965), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84220] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3308), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(966), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84328] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3310), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(971), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3312), 1,
      sym__newline,
    STATE(1145), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 28,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [84490] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3353), 1,
      sym__external_else,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(554), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      sym__newline,
    STATE(1147), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 28,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [84652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      sym__newline,
    STATE(1148), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(661), 12,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
    ACTIONS(659), 28,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_comma,
  [84706] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3367), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(558), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84814] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3369), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(559), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [84922] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3371), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(772), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85030] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3373), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(776), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85138] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3375), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(777), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85246] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3377), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(782), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85354] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3379), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(564), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85462] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3381), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(906), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85570] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3383), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(910), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85678] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3385), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(837), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85786] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3387), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(845), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85894] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3389), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(911), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86002] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    ACTIONS(3391), 1,
      sym__external_else,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(861), 1,
      sym__else,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86110] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3393), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(612), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(7), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86218] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3395), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(616), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(69), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86326] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    ACTIONS(3397), 1,
      sym__external_else,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(916), 1,
      sym__else,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(63), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86434] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    ACTIONS(3399), 1,
      sym__external_else,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(617), 1,
      sym__else,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(57), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86542] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [86643] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 17,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [86718] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [86789] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [86862] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [86933] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(167), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87036] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(171), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87139] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(175), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87242] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(179), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87345] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(183), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87448] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [87519] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(187), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87622] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(191), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87725] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(195), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87828] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(199), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87931] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(203), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88034] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(207), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88137] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(211), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88240] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(215), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88343] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(219), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88446] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(145), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88549] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(223), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88652] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(227), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(233), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(237), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [88961] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 9,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [89056] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 11,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [89143] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [89214] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(233), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89317] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(237), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(241), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89523] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(245), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89626] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(147), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89729] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 9,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [89824] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 11,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [89911] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [89982] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(155), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90085] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90188] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [90283] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 16,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [90362] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90465] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [90562] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [90653] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 11,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [90740] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(159), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90843] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [90926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 17,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [91001] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [91072] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [91145] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [91246] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [91317] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(155), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91523] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(159), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91626] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [91727] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91830] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [91925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 16,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [92004] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92107] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [92204] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [92295] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 11,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [92382] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [92465] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 17,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [92540] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [92611] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [92684] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [92755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(167), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(171), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92961] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(175), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93064] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(179), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93167] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(183), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93270] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(187), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93373] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(191), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93476] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(195), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93579] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(199), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93682] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(203), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93785] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(207), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93888] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(211), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93991] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(215), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(219), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(145), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94300] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(223), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94403] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    ACTIONS(3260), 1,
      anon_sym_TILDE,
    ACTIONS(3262), 1,
      anon_sym_PLUS,
    ACTIONS(3264), 1,
      anon_sym_DASH,
    ACTIONS(3268), 1,
      anon_sym_DASH_GT,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 1,
      anon_sym_AMP,
    ACTIONS(3276), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3278), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    ACTIONS(3286), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      sym__external_open_parenthesis,
    ACTIONS(3300), 1,
      sym__external_open_bracket,
    ACTIONS(3302), 1,
      sym__external_open_bracket2,
    STATE(249), 1,
      sym__open_bracket2,
    STATE(281), 1,
      sym__open_parenthesis,
    STATE(282), 1,
      sym__open_bracket,
    STATE(1698), 1,
      sym_call_arguments,
    STATE(1699), 1,
      sym_subset_arguments,
    STATE(1700), 1,
      sym_subset2_arguments,
    ACTIONS(3280), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3288), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3290), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3294), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3266), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(227), 4,
      sym__external_else,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3282), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94506] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [94601] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [94680] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94783] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [94880] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [94963] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [95050] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [95133] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [95208] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [95279] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [95352] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [95423] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(167), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95526] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(171), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95629] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [95724] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(175), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95827] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(179), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95930] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(183), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96033] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(187), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96136] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [96223] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(191), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96326] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(195), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96429] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(199), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96532] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(203), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96635] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(207), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96738] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(211), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96841] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(241), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96944] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(215), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97047] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(219), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97150] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(145), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97253] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(223), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97356] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(227), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97459] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [97530] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(245), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97633] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(147), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97736] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [97831] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [97918] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [97989] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [98090] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98193] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [98288] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(233), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98391] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(237), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98494] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 9,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [98589] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 11,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [98676] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [98747] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [98826] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_DASH_GT,
    ACTIONS(3224), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3220), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98929] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_TILDE,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [99026] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [99117] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [99204] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [99287] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(241), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99390] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [99465] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(245), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99568] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(147), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99671] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 9,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [99766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 11,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [99853] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [99924] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [100025] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100128] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [100223] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 16,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [100302] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(151), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100405] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [100502] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [100593] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 11,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [100680] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [100751] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [100834] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 17,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [100909] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [100980] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [101053] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [101124] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [101197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(155), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101300] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(159), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101403] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [101504] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101607] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [101702] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 16,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [101781] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3325), 1,
      anon_sym_DASH_GT,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3323), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(163), 4,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101884] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_TILDE,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3329), 1,
      anon_sym_PIPE,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [101981] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3331), 1,
      anon_sym_AMP,
    ACTIONS(3335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [102072] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3341), 1,
      anon_sym_STAR,
    ACTIONS(3343), 1,
      anon_sym_SLASH,
    ACTIONS(3349), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      sym__external_open_parenthesis,
    ACTIONS(3357), 1,
      sym__external_open_bracket,
    ACTIONS(3359), 1,
      sym__external_open_bracket2,
    STATE(278), 1,
      sym__open_parenthesis,
    STATE(279), 1,
      sym__open_bracket,
    STATE(280), 1,
      sym__open_bracket2,
    STATE(1693), 1,
      sym_call_arguments,
    STATE(1695), 1,
      sym_subset_arguments,
    STATE(1696), 1,
      sym_subset2_arguments,
    ACTIONS(3337), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3345), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3347), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3351), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3339), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 11,
      sym__external_else,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [102159] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_PLUS,
    ACTIONS(3218), 1,
      anon_sym_DASH,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_STAR,
    ACTIONS(3240), 1,
      anon_sym_SLASH,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(3252), 1,
      sym__external_open_parenthesis,
    ACTIONS(3254), 1,
      sym__external_open_bracket,
    ACTIONS(3256), 1,
      sym__external_open_bracket2,
    STATE(272), 1,
      sym__open_parenthesis,
    STATE(273), 1,
      sym__open_bracket,
    STATE(274), 1,
      sym__open_bracket2,
    STATE(1672), 1,
      sym_call_arguments,
    STATE(1674), 1,
      sym_subset_arguments,
    STATE(1681), 1,
      sym_subset2_arguments,
    ACTIONS(3234), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3242), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3244), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3248), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3236), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [102250] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 8,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [102344] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(183), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102446] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 6,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [102546] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102648] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [102742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [102820] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102922] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [103018] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [103108] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [103194] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 14,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [103276] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(187), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103378] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 16,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [103452] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [103522] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [103594] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [103664] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(191), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103766] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(195), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103868] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(199), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103970] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(203), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104072] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(207), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104174] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(211), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104276] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(167), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104378] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(207), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104480] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(171), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104582] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3535), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(395), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104688] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(179), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104790] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3537), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104894] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [104988] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(211), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105090] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 10,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [105176] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(187), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105278] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(175), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105380] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(179), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105482] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(183), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105584] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [105654] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(187), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105756] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3539), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(480), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105862] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(215), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105964] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(191), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106066] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(195), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106168] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [106246] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(219), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106348] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(145), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(199), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106552] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(203), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106654] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(207), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106756] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(211), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(215), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106960] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(219), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107062] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(145), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107164] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(223), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107266] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107368] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(227), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107470] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(191), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107572] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(223), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107674] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(227), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107776] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(195), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107878] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(241), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(245), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108082] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(147), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108184] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [108280] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 8,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [108374] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 10,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [108460] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [108530] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3541), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(638), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108636] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 6,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [108736] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108838] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3543), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(501), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [109038] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [109116] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109218] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [109314] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [109404] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [109490] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 14,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [109572] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(215), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109674] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 16,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [109748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(219), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109850] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(199), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109952] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [110022] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3545), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(493), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [110128] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(203), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [110230] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3547), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(479), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [110336] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [110408] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [110478] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [110568] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(241), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [110670] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [110756] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [110838] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(245), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [110940] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [111014] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(147), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [111116] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 8,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [111210] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 10,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [111296] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [111366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [111436] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [111508] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 6,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [111608] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [111678] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(233), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [111780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [111882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 8,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [111976] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(237), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112078] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(233), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112180] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(155), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112282] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 15,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [112360] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(159), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112462] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112564] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 8,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [112658] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(153), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 7,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [112754] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3549), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [112858] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 9,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [112948] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 10,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [113034] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(145), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113136] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(237), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113238] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(223), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113340] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(227), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113442] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3551), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    STATE(1740), 1,
      sym__close_parenthesis,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113548] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3553), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(821), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113654] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3555), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(836), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113760] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 6,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [113860] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [113962] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3557), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(838), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [114068] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(235), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [114162] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [114256] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [114334] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3559), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(854), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [114440] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [114542] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(237), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [114628] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [114724] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [114814] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(159), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [114916] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 10,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [115002] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [115088] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [115158] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 14,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [115240] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3561), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(431), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115346] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(485), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115452] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3565), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(488), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115558] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(492), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115664] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3569), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(500), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115770] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3571), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    STATE(1739), 1,
      sym__close_parenthesis,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115876] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3573), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(551), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [115982] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3575), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(553), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116088] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 16,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [116162] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3577), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(555), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116268] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [116338] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3579), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(561), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116444] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [116516] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [116586] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3581), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    STATE(1780), 1,
      sym__close_parenthesis,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116692] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3583), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(609), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116798] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3585), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(611), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [116904] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3587), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(613), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117010] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3589), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(619), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117116] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3591), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(368), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117222] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3593), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(694), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117328] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(167), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117430] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3595), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(710), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117536] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3597), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(712), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117642] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3599), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(718), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(171), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117850] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3601), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1686), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [117956] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3603), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(769), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118062] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3605), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(771), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118168] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(241), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118270] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3607), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(773), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118376] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3609), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(779), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118482] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(245), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118584] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3611), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(331), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118690] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3613), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(834), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118796] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3615), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(840), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [118902] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(147), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119004] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(149), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [119098] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3617), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(844), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119204] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(147), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [119290] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3619), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(852), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119396] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(149), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(147), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [119466] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3621), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1707), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119572] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3623), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(903), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119678] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3625), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(905), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119784] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(155), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119886] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3627), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(907), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [119992] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3629), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(913), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120098] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(175), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120200] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(179), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120302] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3631), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1680), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120408] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3633), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(958), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120514] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(960), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120620] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3637), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(962), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120726] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3639), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(968), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [120832] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 14,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [120914] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(159), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121016] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3641), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(975), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121122] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(235), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(237), 18,
      sym__external_close_bracket,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [121192] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(151), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [121292] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3643), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(977), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121398] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 16,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [121472] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(183), 3,
      sym__external_close_bracket,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121574] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121676] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(233), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121778] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3645), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(509), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [121884] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [121954] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3647), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(988), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122060] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [122160] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3649), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(990), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122266] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(151), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [122338] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122440] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [122534] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3651), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(995), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122640] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(153), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(151), 18,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [122710] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3653), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(997), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122816] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [122894] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(163), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [122996] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3655), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1002), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [123102] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(165), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [123198] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3657), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1004), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [123304] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3659), 1,
      anon_sym_QMARK,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3537), 2,
      sym__external_close_bracket2,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [123408] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [123498] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(163), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [123584] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3661), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1010), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [123690] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3663), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1012), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [123796] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(163), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [123878] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [123952] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [124022] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3665), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1018), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124128] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(163), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [124200] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1020), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(165), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(163), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [124376] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3669), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1026), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124482] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3671), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1028), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124588] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3673), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1034), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124694] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3675), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1036), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124800] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3677), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1042), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [124906] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    ACTIONS(3533), 1,
      anon_sym_QMARK,
    ACTIONS(3679), 1,
      sym__external_close_parenthesis,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1044), 1,
      sym__close_parenthesis,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125012] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(167), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125114] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(171), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125216] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(237), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125318] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PLUS,
    ACTIONS(3403), 1,
      anon_sym_DASH,
    ACTIONS(3405), 1,
      anon_sym_PIPE,
    ACTIONS(3407), 1,
      anon_sym_AMP,
    ACTIONS(3409), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3411), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_STAR,
    ACTIONS(3419), 1,
      anon_sym_SLASH,
    ACTIONS(3425), 1,
      anon_sym_COLON,
    ACTIONS(3429), 1,
      sym__external_open_parenthesis,
    ACTIONS(3431), 1,
      sym__external_open_bracket,
    ACTIONS(3433), 1,
      sym__external_open_bracket2,
    ACTIONS(3479), 1,
      anon_sym_EQ,
    ACTIONS(3481), 1,
      anon_sym_TILDE,
    ACTIONS(3483), 1,
      anon_sym_DASH_GT,
    ACTIONS(3485), 1,
      anon_sym_DASH_GT_GT,
    STATE(266), 1,
      sym__open_parenthesis,
    STATE(267), 1,
      sym__open_bracket,
    STATE(268), 1,
      sym__open_bracket2,
    STATE(1718), 1,
      sym_subset_arguments,
    STATE(1732), 1,
      sym_subset2_arguments,
    STATE(1764), 1,
      sym_call_arguments,
    ACTIONS(3413), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3421), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3423), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3427), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(155), 3,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3487), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3415), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_TILDE,
    ACTIONS(3439), 1,
      anon_sym_PLUS,
    ACTIONS(3441), 1,
      anon_sym_DASH,
    ACTIONS(3445), 1,
      anon_sym_DASH_GT,
    ACTIONS(3447), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3461), 1,
      anon_sym_STAR,
    ACTIONS(3463), 1,
      anon_sym_SLASH,
    ACTIONS(3469), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym__external_open_parenthesis,
    ACTIONS(3475), 1,
      sym__external_open_bracket,
    ACTIONS(3477), 1,
      sym__external_open_bracket2,
    STATE(255), 1,
      sym__open_parenthesis,
    STATE(256), 1,
      sym__open_bracket,
    STATE(257), 1,
      sym__open_bracket2,
    STATE(1735), 1,
      sym_call_arguments,
    STATE(1737), 1,
      sym_subset_arguments,
    STATE(1738), 1,
      sym_subset2_arguments,
    ACTIONS(3457), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3465), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3467), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3471), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(175), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(3443), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3459), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125522] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_EQ,
    ACTIONS(3491), 1,
      anon_sym_TILDE,
    ACTIONS(3493), 1,
      anon_sym_PLUS,
    ACTIONS(3495), 1,
      anon_sym_DASH,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    ACTIONS(3501), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3515), 1,
      anon_sym_STAR,
    ACTIONS(3517), 1,
      anon_sym_SLASH,
    ACTIONS(3523), 1,
      anon_sym_COLON,
    ACTIONS(3527), 1,
      sym__external_open_parenthesis,
    ACTIONS(3529), 1,
      sym__external_open_bracket,
    ACTIONS(3531), 1,
      sym__external_open_bracket2,
    ACTIONS(3681), 1,
      anon_sym_QMARK,
    STATE(248), 1,
      sym__open_parenthesis,
    STATE(265), 1,
      sym__open_bracket2,
    STATE(283), 1,
      sym__open_bracket,
    STATE(1711), 1,
      sym_subset_arguments,
    STATE(1726), 1,
      sym_subset2_arguments,
    STATE(1761), 1,
      sym_call_arguments,
    ACTIONS(3511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3519), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(3521), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(3525), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(3537), 2,
      sym__external_close_bracket,
      sym_comma,
    ACTIONS(3497), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(3513), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [125626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [125671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3685), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [125720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_L,
    ACTIONS(3689), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [125769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [125814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [125863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [125908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [125953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [125998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 15,
      sym__newline,
      sym__semicolon,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(341), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
  [126088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3697), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [126407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 1,
      anon_sym_L,
    ACTIONS(3701), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [126456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_L,
    ACTIONS(3705), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [126730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [126998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3709), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3713), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 1,
      sym__newline,
    STATE(1609), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(659), 12,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(661), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
  [127186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3718), 1,
      anon_sym_L,
    ACTIONS(3720), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(645), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(649), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3724), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(609), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_L,
    ACTIONS(3728), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [127902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_L,
    ACTIONS(3732), 1,
      anon_sym_i,
    ACTIONS(617), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(615), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [127950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3709), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3713), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [128094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3724), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(641), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [128188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(623), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [128232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(605), 26,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [128276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(637), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [128320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [128965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [129997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3738), 13,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3736), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
  [130814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 13,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3740), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
  [130900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [130986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 13,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3744), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
  [131029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [131965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(772), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(777), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(768), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [132973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(728), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(685), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(734), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(724), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(732), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(781), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(720), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [133983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(689), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(693), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(740), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(744), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(748), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(697), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(752), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(714), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(756), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(703), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_close_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(701), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(760), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(764), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(707), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_EQ,
    ACTIONS(609), 8,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(607), 25,
      sym__external_open_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      sym__external_close_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [134701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 1,
      sym__external_close_parenthesis,
    STATE(1694), 1,
      sym__close_parenthesis,
    STATE(1877), 1,
      sym_parameter,
    STATE(2029), 1,
      sym__parameter_name,
    STATE(2036), 1,
      sym__parameter_without_default,
    STATE(2044), 1,
      sym__parameter_with_default,
    ACTIONS(3748), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [134728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2029), 1,
      sym__parameter_name,
    STATE(2034), 1,
      sym_parameter,
    STATE(2036), 1,
      sym__parameter_without_default,
    STATE(2044), 1,
      sym__parameter_with_default,
    ACTIONS(3748), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [134749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      sym__newline,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    STATE(868), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1788), 1,
      aux_sym_function_definition_repeat1,
  [134768] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(888), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(489), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3758), 1,
      sym__newline,
    STATE(515), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1791), 1,
      aux_sym_function_definition_repeat1,
  [134825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(536), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3760), 1,
      sym__newline,
    STATE(483), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1789), 1,
      aux_sym_function_definition_repeat1,
  [134863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(456), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3762), 1,
      sym__newline,
    STATE(793), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1799), 1,
      aux_sym_function_definition_repeat1,
  [134901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3764), 1,
      sym__newline,
    STATE(924), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1796), 1,
      aux_sym_function_definition_repeat1,
  [134920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(943), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3766), 1,
      sym__newline,
    STATE(572), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1800), 1,
      aux_sym_function_definition_repeat1,
  [134958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3768), 1,
      sym__newline,
    STATE(635), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1801), 1,
      aux_sym_function_definition_repeat1,
  [134977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(816), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [134996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(593), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [135015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(666), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [135034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3770), 1,
      sym__newline,
    STATE(734), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1805), 1,
      aux_sym_function_definition_repeat1,
  [135053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3772), 1,
      sym__newline,
    STATE(987), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1793), 1,
      aux_sym_function_definition_repeat1,
  [135072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3774), 1,
      sym__newline,
    STATE(676), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(1806), 1,
      aux_sym_function_definition_repeat1,
  [135091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(754), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [135110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym__external_open_parenthesis,
    ACTIONS(3756), 1,
      sym__newline,
    STATE(708), 1,
      sym_parameters,
    STATE(1785), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [135129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3776), 1,
      sym__external_close_parenthesis,
    STATE(1663), 1,
      sym__close_parenthesis,
    STATE(1881), 1,
      aux_sym_call_arguments_repeat1,
  [135145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3778), 1,
      sym__external_close_bracket2,
    STATE(1777), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3780), 1,
      sym__external_close_bracket,
    STATE(1659), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3782), 1,
      sym__external_close_bracket,
    STATE(1774), 1,
      sym__close_bracket,
    STATE(1928), 1,
      aux_sym_call_arguments_repeat1,
  [135193] = 4,
    ACTIONS(3784), 1,
      anon_sym_SQUOTE,
    ACTIONS(3788), 1,
      sym_comment,
    STATE(1821), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135207] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_SQUOTE,
    STATE(1816), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135221] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3792), 1,
      anon_sym_DQUOTE,
    STATE(1817), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135235] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_DQUOTE,
    STATE(1827), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__newline,
    ACTIONS(3800), 1,
      sym__external_open_parenthesis,
    STATE(1858), 1,
      aux_sym_function_definition_repeat1,
    STATE(2003), 1,
      sym__open_parenthesis,
  [135265] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135279] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3806), 1,
      sym__external_close_bracket,
    STATE(1676), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3808), 1,
      sym__external_close_bracket2,
    STATE(382), 1,
      sym__close_bracket2,
    STATE(1907), 1,
      aux_sym_call_arguments_repeat1,
  [135325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3810), 1,
      sym__external_close_bracket2,
    STATE(1729), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135341] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3814), 1,
      sym__external_close_parenthesis,
    STATE(1644), 1,
      sym__close_parenthesis,
    STATE(1826), 1,
      aux_sym_call_arguments_repeat1,
  [135371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3816), 1,
      sym__external_close_parenthesis,
    STATE(1645), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3818), 1,
      sym__external_close_bracket,
    STATE(364), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3820), 1,
      sym__external_close_bracket2,
    STATE(1669), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3822), 1,
      sym__external_close_parenthesis,
    STATE(1665), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135435] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3824), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3826), 1,
      sym__external_close_bracket2,
    STATE(335), 1,
      sym__close_bracket2,
    STATE(1829), 1,
      aux_sym_call_arguments_repeat1,
  [135465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3828), 1,
      sym__external_close_bracket2,
    STATE(333), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3830), 1,
      sym__external_close_bracket2,
    STATE(1776), 1,
      sym__close_bracket2,
    STATE(1931), 1,
      aux_sym_call_arguments_repeat1,
  [135497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3832), 1,
      sym__external_close_bracket2,
    STATE(355), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135513] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3834), 1,
      anon_sym_SQUOTE,
    STATE(1835), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135527] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_DQUOTE,
    STATE(1836), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3838), 1,
      sym__external_close_parenthesis,
    STATE(379), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135557] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135571] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3842), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3844), 1,
      sym__external_close_bracket,
    STATE(1754), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3846), 1,
      sym__external_close_bracket,
    STATE(1775), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3848), 1,
      sym__external_close_parenthesis,
    STATE(1723), 1,
      sym__close_parenthesis,
    STATE(1847), 1,
      aux_sym_call_arguments_repeat1,
  [135633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3850), 1,
      sym__external_close_parenthesis,
    STATE(1724), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135649] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3852), 1,
      anon_sym_SQUOTE,
    STATE(1958), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3854), 1,
      sym__external_close_parenthesis,
    STATE(342), 1,
      sym__close_parenthesis,
    STATE(1845), 1,
      aux_sym_call_arguments_repeat1,
  [135679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3856), 1,
      sym__external_close_parenthesis,
    STATE(343), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135695] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_SQUOTE,
    STATE(1868), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3860), 1,
      sym__external_close_parenthesis,
    STATE(348), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3862), 1,
      sym__external_close_bracket,
    STATE(380), 1,
      sym__close_bracket,
    STATE(1889), 1,
      aux_sym_call_arguments_repeat1,
  [135741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3864), 1,
      sym__external_close_parenthesis,
    STATE(1743), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135757] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_DQUOTE,
    STATE(1876), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3868), 1,
      sym__external_close_bracket2,
    STATE(1661), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3870), 1,
      sym__external_close_bracket2,
    STATE(1671), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135803] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3872), 1,
      anon_sym_SQUOTE,
    STATE(1855), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135817] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_DQUOTE,
    STATE(1856), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3876), 1,
      sym__external_close_bracket,
    STATE(1725), 1,
      sym__close_bracket,
    STATE(1904), 1,
      aux_sym_call_arguments_repeat1,
  [135847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3878), 1,
      sym__external_close_bracket,
    STATE(1727), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135863] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135877] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3882), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3884), 1,
      sym__external_close_bracket2,
    STATE(383), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [135907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(3886), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2024), 1,
      sym__open_parenthesis,
  [135923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3888), 1,
      sym__external_close_bracket,
    STATE(1655), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [135939] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3890), 1,
      anon_sym_SQUOTE,
    STATE(1872), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [135953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3892), 1,
      sym__external_close_parenthesis,
    STATE(1647), 1,
      sym__close_parenthesis,
    STATE(1865), 1,
      aux_sym_call_arguments_repeat1,
  [135969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3894), 1,
      sym__external_close_parenthesis,
    STATE(1648), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [135985] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_DQUOTE,
    STATE(1875), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [135999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3898), 1,
      sym__newline,
    ACTIONS(3900), 1,
      sym__external_open_parenthesis,
    STATE(1053), 1,
      sym__open_parenthesis,
    STATE(1891), 1,
      aux_sym_function_definition_repeat1,
  [136015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3902), 1,
      sym__external_close_parenthesis,
    STATE(1654), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3904), 1,
      sym__external_close_bracket,
    STATE(404), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3906), 1,
      sym__external_close_bracket2,
    STATE(407), 1,
      sym__close_bracket2,
    STATE(1905), 1,
      aux_sym_call_arguments_repeat1,
  [136063] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3908), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136077] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3910), 1,
      anon_sym_SQUOTE,
    STATE(1873), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136091] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_DQUOTE,
    STATE(1874), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3914), 1,
      sym__external_close_bracket,
    STATE(1653), 1,
      sym__close_bracket,
    STATE(1903), 1,
      aux_sym_call_arguments_repeat1,
  [136121] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3916), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136135] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3918), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136149] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3920), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136163] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3922), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136177] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3924), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 1,
      sym_comma,
    ACTIONS(3928), 1,
      sym__external_close_parenthesis,
    STATE(1692), 1,
      sym__close_parenthesis,
    STATE(1947), 1,
      aux_sym_parameters_repeat1,
  [136207] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3930), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3932), 1,
      sym__external_close_parenthesis,
    STATE(1664), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136237] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3934), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3936), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3939), 1,
      sym__external_close_parenthesis,
    STATE(1709), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3941), 1,
      sym__external_close_bracket2,
    STATE(1656), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136283] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_DQUOTE,
    STATE(1878), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3945), 1,
      sym__external_close_bracket2,
    STATE(1660), 1,
      sym__close_bracket2,
    STATE(1825), 1,
      aux_sym_call_arguments_repeat1,
  [136313] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3949), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3952), 1,
      sym__external_close_parenthesis,
    STATE(1759), 1,
      sym__close_parenthesis,
    STATE(1894), 1,
      aux_sym_call_arguments_repeat1,
  [136343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3954), 1,
      sym__external_close_parenthesis,
    STATE(1766), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136359] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_SQUOTE,
    STATE(1897), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3958), 1,
      sym__external_close_bracket,
    STATE(392), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136389] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_DQUOTE,
    STATE(1898), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(3962), 1,
      sym__external_open_parenthesis,
    STATE(1050), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [136419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3964), 1,
      sym__external_close_bracket2,
    STATE(1728), 1,
      sym__close_bracket2,
    STATE(1929), 1,
      aux_sym_call_arguments_repeat1,
  [136435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3966), 1,
      sym__external_close_bracket,
    STATE(385), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3968), 1,
      sym__external_close_parenthesis,
    STATE(1741), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3970), 1,
      sym__external_close_parenthesis,
    STATE(412), 1,
      sym__close_parenthesis,
    STATE(1933), 1,
      aux_sym_call_arguments_repeat1,
  [136483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3972), 1,
      sym__external_close_bracket2,
    STATE(409), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136499] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3974), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136513] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(3976), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3978), 1,
      sym__external_close_bracket,
    STATE(440), 1,
      sym__close_bracket,
    STATE(1893), 1,
      aux_sym_call_arguments_repeat1,
  [136543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(3980), 1,
      sym__external_open_parenthesis,
    STATE(1049), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [136559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3982), 1,
      sym__external_close_bracket,
    STATE(1649), 1,
      sym__close_bracket,
    STATE(1859), 1,
      aux_sym_call_arguments_repeat1,
  [136575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3984), 1,
      sym__external_close_parenthesis,
    STATE(1771), 1,
      sym__close_parenthesis,
    STATE(1912), 1,
      aux_sym_call_arguments_repeat1,
  [136591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3986), 1,
      sym__external_close_bracket,
    STATE(1668), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3988), 1,
      sym__external_close_bracket,
    STATE(1745), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3990), 1,
      sym__external_close_bracket2,
    STATE(388), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3992), 1,
      sym__external_close_parenthesis,
    STATE(436), 1,
      sym__close_parenthesis,
    STATE(1934), 1,
      aux_sym_call_arguments_repeat1,
  [136655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(3994), 1,
      sym__external_close_bracket2,
    STATE(393), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(3996), 1,
      sym__external_close_parenthesis,
    STATE(1772), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(3998), 1,
      sym__external_close_bracket,
    STATE(1778), 1,
      sym__close_bracket,
    STATE(1837), 1,
      aux_sym_call_arguments_repeat1,
  [136703] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_SQUOTE,
    STATE(1924), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136717] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DQUOTE,
    STATE(2000), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [136731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4004), 1,
      sym__external_close_parenthesis,
    STATE(1781), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      sym__newline,
    ACTIONS(4008), 1,
      sym__external_open_parenthesis,
    STATE(1052), 1,
      sym__open_parenthesis,
    STATE(1900), 1,
      aux_sym_function_definition_repeat1,
  [136763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4010), 1,
      sym__external_close_bracket,
    STATE(1650), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4012), 1,
      sym__external_close_bracket,
    STATE(344), 1,
      sym__close_bracket,
    STATE(1955), 1,
      aux_sym_call_arguments_repeat1,
  [136795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4014), 1,
      sym__external_close_bracket2,
    STATE(1651), 1,
      sym__close_bracket2,
    STATE(1882), 1,
      aux_sym_call_arguments_repeat1,
  [136811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4016), 1,
      sym__external_close_bracket,
    STATE(345), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4018), 1,
      sym__external_close_bracket2,
    STATE(346), 1,
      sym__close_bracket2,
    STATE(1960), 1,
      aux_sym_call_arguments_repeat1,
  [136843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4020), 1,
      sym__external_close_bracket2,
    STATE(1652), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4022), 1,
      sym__external_close_bracket2,
    STATE(347), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4024), 1,
      sym__external_close_parenthesis,
    STATE(438), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [136891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4026), 1,
      sym__external_close_bracket,
    STATE(1748), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [136907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4028), 1,
      sym__external_close_bracket,
    STATE(1666), 1,
      sym__close_bracket,
    STATE(1818), 1,
      aux_sym_call_arguments_repeat1,
  [136923] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [136937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4032), 1,
      sym__external_close_bracket2,
    STATE(1763), 1,
      sym__close_bracket2,
    STATE(1926), 1,
      aux_sym_call_arguments_repeat1,
  [136953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4034), 1,
      sym__external_close_bracket2,
    STATE(1756), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4036), 1,
      sym__external_close_bracket2,
    STATE(1678), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [136985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4038), 1,
      sym__external_close_bracket,
    STATE(1782), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [137001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4040), 1,
      sym__external_close_bracket2,
    STATE(1749), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [137017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      sym__newline,
    ACTIONS(4044), 1,
      sym__external_open_parenthesis,
    STATE(1057), 1,
      sym__open_parenthesis,
    STATE(1932), 1,
      aux_sym_function_definition_repeat1,
  [137033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4046), 1,
      sym__external_close_bracket2,
    STATE(1783), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [137049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4048), 1,
      sym__external_open_parenthesis,
    STATE(1058), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4050), 1,
      sym__external_close_parenthesis,
    STATE(391), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [137081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4052), 1,
      sym__external_close_parenthesis,
    STATE(425), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [137097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4054), 1,
      sym__external_close_bracket,
    STATE(1667), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [137113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 1,
      sym__newline,
    ACTIONS(4058), 1,
      sym__external_open_parenthesis,
    STATE(1060), 1,
      sym__open_parenthesis,
    STATE(1938), 1,
      aux_sym_function_definition_repeat1,
  [137129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4060), 1,
      sym__external_close_bracket,
    STATE(332), 1,
      sym__close_bracket,
    STATE(1824), 1,
      aux_sym_call_arguments_repeat1,
  [137145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4062), 1,
      sym__external_open_parenthesis,
    STATE(1061), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4064), 1,
      sym__external_close_bracket2,
    STATE(1670), 1,
      sym__close_bracket2,
    STATE(1927), 1,
      aux_sym_call_arguments_repeat1,
  [137177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4066), 1,
      sym__newline,
    ACTIONS(4068), 1,
      sym__external_open_parenthesis,
    STATE(1065), 1,
      sym__open_parenthesis,
    STATE(1942), 1,
      aux_sym_function_definition_repeat1,
  [137193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4070), 1,
      sym__external_close_parenthesis,
    STATE(374), 1,
      sym__close_parenthesis,
    STATE(1951), 1,
      aux_sym_call_arguments_repeat1,
  [137209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4072), 1,
      sym__external_open_parenthesis,
    STATE(1066), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4074), 1,
      sym__external_close_bracket2,
    STATE(1757), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [137241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 1,
      sym__newline,
    ACTIONS(4078), 1,
      sym__external_open_parenthesis,
    STATE(1070), 1,
      sym__open_parenthesis,
    STATE(1946), 1,
      aux_sym_function_definition_repeat1,
  [137257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4080), 1,
      sym__external_close_parenthesis,
    STATE(375), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [137273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4082), 1,
      sym__external_open_parenthesis,
    STATE(1071), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 1,
      sym_comma,
    ACTIONS(4084), 1,
      sym__external_close_parenthesis,
    STATE(1697), 1,
      sym__close_parenthesis,
    STATE(2002), 1,
      aux_sym_parameters_repeat1,
  [137305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4086), 1,
      sym__newline,
    ACTIONS(4088), 1,
      sym__external_open_parenthesis,
    STATE(1075), 1,
      sym__open_parenthesis,
    STATE(1949), 1,
      aux_sym_function_definition_repeat1,
  [137321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4090), 1,
      sym__external_open_parenthesis,
    STATE(1076), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      sym__newline,
    ACTIONS(4094), 1,
      sym__external_open_parenthesis,
    STATE(1080), 1,
      sym__open_parenthesis,
    STATE(1952), 1,
      aux_sym_function_definition_repeat1,
  [137353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym_comma,
    ACTIONS(4096), 1,
      sym__external_close_parenthesis,
    STATE(359), 1,
      sym__close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [137369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4098), 1,
      sym__external_open_parenthesis,
    STATE(1081), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4100), 1,
      sym__external_close_bracket,
    STATE(351), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [137401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4102), 1,
      sym__newline,
    ACTIONS(4104), 1,
      sym__external_open_parenthesis,
    STATE(1085), 1,
      sym__open_parenthesis,
    STATE(1956), 1,
      aux_sym_function_definition_repeat1,
  [137417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4106), 1,
      sym__external_close_bracket,
    STATE(349), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [137433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4108), 1,
      sym__external_open_parenthesis,
    STATE(1086), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 1,
      sym__newline,
    ACTIONS(4112), 1,
      sym__external_open_parenthesis,
    STATE(1090), 1,
      sym__open_parenthesis,
    STATE(1959), 1,
      aux_sym_function_definition_repeat1,
  [137465] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4114), 1,
      anon_sym_SQUOTE,
    STATE(1880), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(3786), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [137479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4116), 1,
      sym__external_open_parenthesis,
    STATE(1091), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      sym_comma,
    ACTIONS(4118), 1,
      sym__external_close_bracket2,
    STATE(350), 1,
      sym__close_bracket2,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [137511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4120), 1,
      sym__newline,
    ACTIONS(4122), 1,
      sym__external_open_parenthesis,
    STATE(1095), 1,
      sym__open_parenthesis,
    STATE(1962), 1,
      aux_sym_function_definition_repeat1,
  [137527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4124), 1,
      sym__external_open_parenthesis,
    STATE(1096), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4126), 1,
      sym__newline,
    ACTIONS(4128), 1,
      sym__external_open_parenthesis,
    STATE(1099), 1,
      sym__open_parenthesis,
    STATE(1965), 1,
      aux_sym_function_definition_repeat1,
  [137559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      sym_comma,
    ACTIONS(4130), 1,
      sym__external_close_bracket,
    STATE(381), 1,
      sym__close_bracket,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [137575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4132), 1,
      sym__external_open_parenthesis,
    STATE(1100), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4134), 1,
      sym__newline,
    ACTIONS(4136), 1,
      sym__external_open_parenthesis,
    STATE(1101), 1,
      sym__open_parenthesis,
    STATE(1967), 1,
      aux_sym_function_definition_repeat1,
  [137607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4138), 1,
      sym__external_open_parenthesis,
    STATE(1102), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 1,
      sym__newline,
    ACTIONS(4142), 1,
      sym__external_open_parenthesis,
    STATE(1103), 1,
      sym__open_parenthesis,
    STATE(1969), 1,
      aux_sym_function_definition_repeat1,
  [137639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4144), 1,
      sym__external_open_parenthesis,
    STATE(1104), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4146), 1,
      sym__newline,
    ACTIONS(4148), 1,
      sym__external_open_parenthesis,
    STATE(1105), 1,
      sym__open_parenthesis,
    STATE(1971), 1,
      aux_sym_function_definition_repeat1,
  [137671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4150), 1,
      sym__external_open_parenthesis,
    STATE(1106), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__newline,
    ACTIONS(4154), 1,
      sym__external_open_parenthesis,
    STATE(1107), 1,
      sym__open_parenthesis,
    STATE(1973), 1,
      aux_sym_function_definition_repeat1,
  [137703] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4156), 1,
      sym__external_open_parenthesis,
    STATE(1108), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4158), 1,
      sym__newline,
    ACTIONS(4160), 1,
      sym__external_open_parenthesis,
    STATE(1109), 1,
      sym__open_parenthesis,
    STATE(1975), 1,
      aux_sym_function_definition_repeat1,
  [137735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4162), 1,
      sym__external_open_parenthesis,
    STATE(1110), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4164), 1,
      sym__newline,
    ACTIONS(4166), 1,
      sym__external_open_parenthesis,
    STATE(1111), 1,
      sym__open_parenthesis,
    STATE(1977), 1,
      aux_sym_function_definition_repeat1,
  [137767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4168), 1,
      sym__external_open_parenthesis,
    STATE(1112), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4170), 1,
      sym__newline,
    ACTIONS(4172), 1,
      sym__external_open_parenthesis,
    STATE(1113), 1,
      sym__open_parenthesis,
    STATE(1979), 1,
      aux_sym_function_definition_repeat1,
  [137799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4174), 1,
      sym__external_open_parenthesis,
    STATE(1114), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__newline,
    ACTIONS(4178), 1,
      sym__external_open_parenthesis,
    STATE(1115), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      aux_sym_function_definition_repeat1,
  [137831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      sym__newline,
    ACTIONS(4182), 1,
      sym__external_open_parenthesis,
    STATE(1983), 1,
      aux_sym_function_definition_repeat1,
    STATE(2008), 1,
      sym__open_parenthesis,
  [137847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4184), 1,
      sym__external_open_parenthesis,
    STATE(1116), 1,
      sym__open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [137863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4186), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2009), 1,
      sym__open_parenthesis,
  [137879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 1,
      sym__newline,
    ACTIONS(4190), 1,
      sym__external_open_parenthesis,
    STATE(1985), 1,
      aux_sym_function_definition_repeat1,
    STATE(2010), 1,
      sym__open_parenthesis,
  [137895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4192), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2011), 1,
      sym__open_parenthesis,
  [137911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4194), 1,
      sym__newline,
    ACTIONS(4196), 1,
      sym__external_open_parenthesis,
    STATE(1987), 1,
      aux_sym_function_definition_repeat1,
    STATE(2012), 1,
      sym__open_parenthesis,
  [137927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4198), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2013), 1,
      sym__open_parenthesis,
  [137943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4200), 1,
      sym__newline,
    ACTIONS(4202), 1,
      sym__external_open_parenthesis,
    STATE(1989), 1,
      aux_sym_function_definition_repeat1,
    STATE(2015), 1,
      sym__open_parenthesis,
  [137959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4204), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2016), 1,
      sym__open_parenthesis,
  [137975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4206), 1,
      sym__newline,
    ACTIONS(4208), 1,
      sym__external_open_parenthesis,
    STATE(1991), 1,
      aux_sym_function_definition_repeat1,
    STATE(2018), 1,
      sym__open_parenthesis,
  [137991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4210), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2019), 1,
      sym__open_parenthesis,
  [138007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 1,
      sym__newline,
    ACTIONS(4214), 1,
      sym__external_open_parenthesis,
    STATE(1993), 1,
      aux_sym_function_definition_repeat1,
    STATE(2020), 1,
      sym__open_parenthesis,
  [138023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4216), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2021), 1,
      sym__open_parenthesis,
  [138039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 1,
      sym__newline,
    ACTIONS(4220), 1,
      sym__external_open_parenthesis,
    STATE(1995), 1,
      aux_sym_function_definition_repeat1,
    STATE(2022), 1,
      sym__open_parenthesis,
  [138055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4222), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2023), 1,
      sym__open_parenthesis,
  [138071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 1,
      sym__newline,
    ACTIONS(4226), 1,
      sym__external_open_parenthesis,
    STATE(1997), 1,
      aux_sym_function_definition_repeat1,
    STATE(2025), 1,
      sym__open_parenthesis,
  [138087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4228), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2026), 1,
      sym__open_parenthesis,
  [138103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      sym__newline,
    ACTIONS(4232), 1,
      sym__external_open_parenthesis,
    STATE(1999), 1,
      aux_sym_function_definition_repeat1,
    STATE(2027), 1,
      sym__open_parenthesis,
  [138119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym__newline,
    ACTIONS(4234), 1,
      sym__external_open_parenthesis,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
    STATE(2028), 1,
      sym__open_parenthesis,
  [138135] = 4,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_DQUOTE,
    STATE(1885), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(3794), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [138149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      sym__external_open_parenthesis,
    ACTIONS(4238), 1,
      sym__newline,
    STATE(2001), 1,
      aux_sym_function_definition_repeat1,
  [138162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4241), 1,
      sym_comma,
    ACTIONS(4244), 1,
      sym__external_close_parenthesis,
    STATE(2002), 1,
      aux_sym_parameters_repeat1,
  [138175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      sym_comma,
    ACTIONS(4251), 1,
      sym__external_close_parenthesis,
    STATE(2004), 1,
      aux_sym_call_arguments_repeat1,
  [138197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      sym__external_close_bracket2,
    ACTIONS(4253), 1,
      sym_comma,
    STATE(2005), 1,
      aux_sym_call_arguments_repeat1,
  [138210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4256), 3,
      sym__external_close_parenthesis,
      anon_sym_EQ,
      sym_comma,
  [138219] = 3,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4258), 1,
      anon_sym_DQUOTE,
    ACTIONS(4260), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [138230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4266), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138284] = 3,
    ACTIONS(3788), 1,
      sym_comment,
    ACTIONS(4274), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [138295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4278), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      sym__external_close_bracket,
    ACTIONS(4282), 1,
      sym_comma,
    STATE(2017), 1,
      aux_sym_call_arguments_repeat1,
  [138326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4291), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4295), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4297), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4301), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4303), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4305), 3,
      sym_dots,
      sym_dot_dot_i,
      sym_identifier,
  [138425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4307), 1,
      anon_sym_EQ,
    ACTIONS(4309), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4313), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4315), 2,
      sym__external_close_bracket,
      sym_comma,
  [138460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4317), 2,
      sym__external_close_bracket2,
      sym_comma,
  [138468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4313), 2,
      sym__external_close_bracket2,
      sym_comma,
  [138484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4321), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 2,
      sym__external_close_bracket2,
      sym_comma,
  [138508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4317), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4315), 2,
      sym__external_close_bracket2,
      sym_comma,
  [138524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 2,
      sym__external_close_bracket,
      sym_comma,
  [138532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4317), 2,
      sym__external_close_bracket,
      sym_comma,
  [138540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 2,
      sym__external_close_bracket,
      sym_comma,
  [138548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4325), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4313), 2,
      sym__external_close_bracket,
      sym_comma,
  [138564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4315), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [138572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 2,
      sym__external_close_bracket2,
      sym_comma,
  [138580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4327), 1,
      anon_sym_in,
  [138587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_in,
  [138594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4331), 1,
      anon_sym_in,
  [138601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4333), 1,
      anon_sym_in,
  [138608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4335), 1,
      anon_sym_in,
  [138615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4337), 1,
      ts_builtin_sym_end,
  [138622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_EQ,
  [138629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_in,
  [138636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_in,
  [138643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_in,
  [138650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_in,
  [138657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_EQ,
  [138664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 1,
      anon_sym_in,
  [138671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_in,
  [138678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_in,
  [138685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 1,
      anon_sym_in,
  [138692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 1,
      anon_sym_in,
  [138699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4361), 1,
      anon_sym_in,
  [138706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_in,
  [138713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_in,
  [138720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_in,
  [138727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_in,
  [138734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_in,
  [138741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_EQ,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(445)] = 0,
  [SMALL_STATE(446)] = 127,
  [SMALL_STATE(447)] = 254,
  [SMALL_STATE(448)] = 381,
  [SMALL_STATE(449)] = 508,
  [SMALL_STATE(450)] = 632,
  [SMALL_STATE(451)] = 756,
  [SMALL_STATE(452)] = 880,
  [SMALL_STATE(453)] = 1003,
  [SMALL_STATE(454)] = 1126,
  [SMALL_STATE(455)] = 1249,
  [SMALL_STATE(456)] = 1372,
  [SMALL_STATE(457)] = 1495,
  [SMALL_STATE(458)] = 1618,
  [SMALL_STATE(459)] = 1741,
  [SMALL_STATE(460)] = 1864,
  [SMALL_STATE(461)] = 1987,
  [SMALL_STATE(462)] = 2110,
  [SMALL_STATE(463)] = 2233,
  [SMALL_STATE(464)] = 2356,
  [SMALL_STATE(465)] = 2479,
  [SMALL_STATE(466)] = 2602,
  [SMALL_STATE(467)] = 2725,
  [SMALL_STATE(468)] = 2848,
  [SMALL_STATE(469)] = 2971,
  [SMALL_STATE(470)] = 3094,
  [SMALL_STATE(471)] = 3217,
  [SMALL_STATE(472)] = 3340,
  [SMALL_STATE(473)] = 3463,
  [SMALL_STATE(474)] = 3586,
  [SMALL_STATE(475)] = 3709,
  [SMALL_STATE(476)] = 3832,
  [SMALL_STATE(477)] = 3955,
  [SMALL_STATE(478)] = 4078,
  [SMALL_STATE(479)] = 4201,
  [SMALL_STATE(480)] = 4324,
  [SMALL_STATE(481)] = 4447,
  [SMALL_STATE(482)] = 4570,
  [SMALL_STATE(483)] = 4693,
  [SMALL_STATE(484)] = 4816,
  [SMALL_STATE(485)] = 4939,
  [SMALL_STATE(486)] = 5062,
  [SMALL_STATE(487)] = 5185,
  [SMALL_STATE(488)] = 5308,
  [SMALL_STATE(489)] = 5431,
  [SMALL_STATE(490)] = 5554,
  [SMALL_STATE(491)] = 5677,
  [SMALL_STATE(492)] = 5800,
  [SMALL_STATE(493)] = 5923,
  [SMALL_STATE(494)] = 6046,
  [SMALL_STATE(495)] = 6169,
  [SMALL_STATE(496)] = 6292,
  [SMALL_STATE(497)] = 6415,
  [SMALL_STATE(498)] = 6538,
  [SMALL_STATE(499)] = 6661,
  [SMALL_STATE(500)] = 6784,
  [SMALL_STATE(501)] = 6907,
  [SMALL_STATE(502)] = 7030,
  [SMALL_STATE(503)] = 7153,
  [SMALL_STATE(504)] = 7276,
  [SMALL_STATE(505)] = 7399,
  [SMALL_STATE(506)] = 7522,
  [SMALL_STATE(507)] = 7645,
  [SMALL_STATE(508)] = 7768,
  [SMALL_STATE(509)] = 7891,
  [SMALL_STATE(510)] = 8014,
  [SMALL_STATE(511)] = 8137,
  [SMALL_STATE(512)] = 8260,
  [SMALL_STATE(513)] = 8383,
  [SMALL_STATE(514)] = 8506,
  [SMALL_STATE(515)] = 8629,
  [SMALL_STATE(516)] = 8752,
  [SMALL_STATE(517)] = 8875,
  [SMALL_STATE(518)] = 8998,
  [SMALL_STATE(519)] = 9121,
  [SMALL_STATE(520)] = 9244,
  [SMALL_STATE(521)] = 9367,
  [SMALL_STATE(522)] = 9490,
  [SMALL_STATE(523)] = 9613,
  [SMALL_STATE(524)] = 9736,
  [SMALL_STATE(525)] = 9859,
  [SMALL_STATE(526)] = 9982,
  [SMALL_STATE(527)] = 10105,
  [SMALL_STATE(528)] = 10228,
  [SMALL_STATE(529)] = 10351,
  [SMALL_STATE(530)] = 10474,
  [SMALL_STATE(531)] = 10597,
  [SMALL_STATE(532)] = 10720,
  [SMALL_STATE(533)] = 10843,
  [SMALL_STATE(534)] = 10966,
  [SMALL_STATE(535)] = 11089,
  [SMALL_STATE(536)] = 11212,
  [SMALL_STATE(537)] = 11335,
  [SMALL_STATE(538)] = 11458,
  [SMALL_STATE(539)] = 11581,
  [SMALL_STATE(540)] = 11704,
  [SMALL_STATE(541)] = 11827,
  [SMALL_STATE(542)] = 11950,
  [SMALL_STATE(543)] = 12073,
  [SMALL_STATE(544)] = 12196,
  [SMALL_STATE(545)] = 12319,
  [SMALL_STATE(546)] = 12442,
  [SMALL_STATE(547)] = 12565,
  [SMALL_STATE(548)] = 12688,
  [SMALL_STATE(549)] = 12811,
  [SMALL_STATE(550)] = 12934,
  [SMALL_STATE(551)] = 13057,
  [SMALL_STATE(552)] = 13180,
  [SMALL_STATE(553)] = 13303,
  [SMALL_STATE(554)] = 13426,
  [SMALL_STATE(555)] = 13549,
  [SMALL_STATE(556)] = 13672,
  [SMALL_STATE(557)] = 13795,
  [SMALL_STATE(558)] = 13918,
  [SMALL_STATE(559)] = 14041,
  [SMALL_STATE(560)] = 14164,
  [SMALL_STATE(561)] = 14287,
  [SMALL_STATE(562)] = 14410,
  [SMALL_STATE(563)] = 14533,
  [SMALL_STATE(564)] = 14656,
  [SMALL_STATE(565)] = 14779,
  [SMALL_STATE(566)] = 14902,
  [SMALL_STATE(567)] = 15025,
  [SMALL_STATE(568)] = 15148,
  [SMALL_STATE(569)] = 15271,
  [SMALL_STATE(570)] = 15394,
  [SMALL_STATE(571)] = 15517,
  [SMALL_STATE(572)] = 15640,
  [SMALL_STATE(573)] = 15763,
  [SMALL_STATE(574)] = 15886,
  [SMALL_STATE(575)] = 16009,
  [SMALL_STATE(576)] = 16132,
  [SMALL_STATE(577)] = 16255,
  [SMALL_STATE(578)] = 16378,
  [SMALL_STATE(579)] = 16501,
  [SMALL_STATE(580)] = 16624,
  [SMALL_STATE(581)] = 16747,
  [SMALL_STATE(582)] = 16870,
  [SMALL_STATE(583)] = 16993,
  [SMALL_STATE(584)] = 17116,
  [SMALL_STATE(585)] = 17239,
  [SMALL_STATE(586)] = 17362,
  [SMALL_STATE(587)] = 17485,
  [SMALL_STATE(588)] = 17608,
  [SMALL_STATE(589)] = 17731,
  [SMALL_STATE(590)] = 17854,
  [SMALL_STATE(591)] = 17977,
  [SMALL_STATE(592)] = 18100,
  [SMALL_STATE(593)] = 18223,
  [SMALL_STATE(594)] = 18346,
  [SMALL_STATE(595)] = 18469,
  [SMALL_STATE(596)] = 18592,
  [SMALL_STATE(597)] = 18715,
  [SMALL_STATE(598)] = 18838,
  [SMALL_STATE(599)] = 18961,
  [SMALL_STATE(600)] = 19084,
  [SMALL_STATE(601)] = 19207,
  [SMALL_STATE(602)] = 19330,
  [SMALL_STATE(603)] = 19453,
  [SMALL_STATE(604)] = 19576,
  [SMALL_STATE(605)] = 19699,
  [SMALL_STATE(606)] = 19822,
  [SMALL_STATE(607)] = 19945,
  [SMALL_STATE(608)] = 20068,
  [SMALL_STATE(609)] = 20191,
  [SMALL_STATE(610)] = 20314,
  [SMALL_STATE(611)] = 20437,
  [SMALL_STATE(612)] = 20560,
  [SMALL_STATE(613)] = 20683,
  [SMALL_STATE(614)] = 20806,
  [SMALL_STATE(615)] = 20929,
  [SMALL_STATE(616)] = 21052,
  [SMALL_STATE(617)] = 21175,
  [SMALL_STATE(618)] = 21298,
  [SMALL_STATE(619)] = 21421,
  [SMALL_STATE(620)] = 21544,
  [SMALL_STATE(621)] = 21667,
  [SMALL_STATE(622)] = 21790,
  [SMALL_STATE(623)] = 21913,
  [SMALL_STATE(624)] = 22036,
  [SMALL_STATE(625)] = 22159,
  [SMALL_STATE(626)] = 22282,
  [SMALL_STATE(627)] = 22405,
  [SMALL_STATE(628)] = 22528,
  [SMALL_STATE(629)] = 22651,
  [SMALL_STATE(630)] = 22774,
  [SMALL_STATE(631)] = 22897,
  [SMALL_STATE(632)] = 23020,
  [SMALL_STATE(633)] = 23143,
  [SMALL_STATE(634)] = 23266,
  [SMALL_STATE(635)] = 23389,
  [SMALL_STATE(636)] = 23512,
  [SMALL_STATE(637)] = 23635,
  [SMALL_STATE(638)] = 23758,
  [SMALL_STATE(639)] = 23881,
  [SMALL_STATE(640)] = 24004,
  [SMALL_STATE(641)] = 24127,
  [SMALL_STATE(642)] = 24250,
  [SMALL_STATE(643)] = 24373,
  [SMALL_STATE(644)] = 24496,
  [SMALL_STATE(645)] = 24619,
  [SMALL_STATE(646)] = 24742,
  [SMALL_STATE(647)] = 24865,
  [SMALL_STATE(648)] = 24988,
  [SMALL_STATE(649)] = 25111,
  [SMALL_STATE(650)] = 25234,
  [SMALL_STATE(651)] = 25357,
  [SMALL_STATE(652)] = 25480,
  [SMALL_STATE(653)] = 25603,
  [SMALL_STATE(654)] = 25726,
  [SMALL_STATE(655)] = 25849,
  [SMALL_STATE(656)] = 25972,
  [SMALL_STATE(657)] = 26095,
  [SMALL_STATE(658)] = 26218,
  [SMALL_STATE(659)] = 26341,
  [SMALL_STATE(660)] = 26464,
  [SMALL_STATE(661)] = 26587,
  [SMALL_STATE(662)] = 26710,
  [SMALL_STATE(663)] = 26833,
  [SMALL_STATE(664)] = 26956,
  [SMALL_STATE(665)] = 27079,
  [SMALL_STATE(666)] = 27202,
  [SMALL_STATE(667)] = 27325,
  [SMALL_STATE(668)] = 27448,
  [SMALL_STATE(669)] = 27571,
  [SMALL_STATE(670)] = 27694,
  [SMALL_STATE(671)] = 27817,
  [SMALL_STATE(672)] = 27940,
  [SMALL_STATE(673)] = 28063,
  [SMALL_STATE(674)] = 28186,
  [SMALL_STATE(675)] = 28309,
  [SMALL_STATE(676)] = 28432,
  [SMALL_STATE(677)] = 28555,
  [SMALL_STATE(678)] = 28678,
  [SMALL_STATE(679)] = 28801,
  [SMALL_STATE(680)] = 28924,
  [SMALL_STATE(681)] = 29047,
  [SMALL_STATE(682)] = 29170,
  [SMALL_STATE(683)] = 29293,
  [SMALL_STATE(684)] = 29416,
  [SMALL_STATE(685)] = 29539,
  [SMALL_STATE(686)] = 29662,
  [SMALL_STATE(687)] = 29785,
  [SMALL_STATE(688)] = 29908,
  [SMALL_STATE(689)] = 30031,
  [SMALL_STATE(690)] = 30154,
  [SMALL_STATE(691)] = 30277,
  [SMALL_STATE(692)] = 30400,
  [SMALL_STATE(693)] = 30523,
  [SMALL_STATE(694)] = 30646,
  [SMALL_STATE(695)] = 30769,
  [SMALL_STATE(696)] = 30892,
  [SMALL_STATE(697)] = 31015,
  [SMALL_STATE(698)] = 31138,
  [SMALL_STATE(699)] = 31261,
  [SMALL_STATE(700)] = 31384,
  [SMALL_STATE(701)] = 31507,
  [SMALL_STATE(702)] = 31630,
  [SMALL_STATE(703)] = 31753,
  [SMALL_STATE(704)] = 31876,
  [SMALL_STATE(705)] = 31999,
  [SMALL_STATE(706)] = 32122,
  [SMALL_STATE(707)] = 32245,
  [SMALL_STATE(708)] = 32368,
  [SMALL_STATE(709)] = 32491,
  [SMALL_STATE(710)] = 32614,
  [SMALL_STATE(711)] = 32737,
  [SMALL_STATE(712)] = 32860,
  [SMALL_STATE(713)] = 32983,
  [SMALL_STATE(714)] = 33106,
  [SMALL_STATE(715)] = 33229,
  [SMALL_STATE(716)] = 33352,
  [SMALL_STATE(717)] = 33475,
  [SMALL_STATE(718)] = 33598,
  [SMALL_STATE(719)] = 33721,
  [SMALL_STATE(720)] = 33844,
  [SMALL_STATE(721)] = 33967,
  [SMALL_STATE(722)] = 34090,
  [SMALL_STATE(723)] = 34213,
  [SMALL_STATE(724)] = 34336,
  [SMALL_STATE(725)] = 34459,
  [SMALL_STATE(726)] = 34582,
  [SMALL_STATE(727)] = 34705,
  [SMALL_STATE(728)] = 34828,
  [SMALL_STATE(729)] = 34951,
  [SMALL_STATE(730)] = 35074,
  [SMALL_STATE(731)] = 35197,
  [SMALL_STATE(732)] = 35320,
  [SMALL_STATE(733)] = 35443,
  [SMALL_STATE(734)] = 35566,
  [SMALL_STATE(735)] = 35689,
  [SMALL_STATE(736)] = 35812,
  [SMALL_STATE(737)] = 35935,
  [SMALL_STATE(738)] = 36058,
  [SMALL_STATE(739)] = 36181,
  [SMALL_STATE(740)] = 36304,
  [SMALL_STATE(741)] = 36427,
  [SMALL_STATE(742)] = 36550,
  [SMALL_STATE(743)] = 36673,
  [SMALL_STATE(744)] = 36796,
  [SMALL_STATE(745)] = 36919,
  [SMALL_STATE(746)] = 37042,
  [SMALL_STATE(747)] = 37165,
  [SMALL_STATE(748)] = 37288,
  [SMALL_STATE(749)] = 37411,
  [SMALL_STATE(750)] = 37534,
  [SMALL_STATE(751)] = 37657,
  [SMALL_STATE(752)] = 37780,
  [SMALL_STATE(753)] = 37903,
  [SMALL_STATE(754)] = 38026,
  [SMALL_STATE(755)] = 38149,
  [SMALL_STATE(756)] = 38272,
  [SMALL_STATE(757)] = 38395,
  [SMALL_STATE(758)] = 38518,
  [SMALL_STATE(759)] = 38641,
  [SMALL_STATE(760)] = 38764,
  [SMALL_STATE(761)] = 38887,
  [SMALL_STATE(762)] = 39010,
  [SMALL_STATE(763)] = 39133,
  [SMALL_STATE(764)] = 39256,
  [SMALL_STATE(765)] = 39379,
  [SMALL_STATE(766)] = 39502,
  [SMALL_STATE(767)] = 39625,
  [SMALL_STATE(768)] = 39748,
  [SMALL_STATE(769)] = 39871,
  [SMALL_STATE(770)] = 39994,
  [SMALL_STATE(771)] = 40117,
  [SMALL_STATE(772)] = 40240,
  [SMALL_STATE(773)] = 40363,
  [SMALL_STATE(774)] = 40486,
  [SMALL_STATE(775)] = 40609,
  [SMALL_STATE(776)] = 40732,
  [SMALL_STATE(777)] = 40855,
  [SMALL_STATE(778)] = 40978,
  [SMALL_STATE(779)] = 41101,
  [SMALL_STATE(780)] = 41224,
  [SMALL_STATE(781)] = 41347,
  [SMALL_STATE(782)] = 41470,
  [SMALL_STATE(783)] = 41593,
  [SMALL_STATE(784)] = 41716,
  [SMALL_STATE(785)] = 41839,
  [SMALL_STATE(786)] = 41962,
  [SMALL_STATE(787)] = 42085,
  [SMALL_STATE(788)] = 42208,
  [SMALL_STATE(789)] = 42331,
  [SMALL_STATE(790)] = 42454,
  [SMALL_STATE(791)] = 42577,
  [SMALL_STATE(792)] = 42700,
  [SMALL_STATE(793)] = 42823,
  [SMALL_STATE(794)] = 42946,
  [SMALL_STATE(795)] = 43069,
  [SMALL_STATE(796)] = 43192,
  [SMALL_STATE(797)] = 43315,
  [SMALL_STATE(798)] = 43438,
  [SMALL_STATE(799)] = 43561,
  [SMALL_STATE(800)] = 43684,
  [SMALL_STATE(801)] = 43807,
  [SMALL_STATE(802)] = 43930,
  [SMALL_STATE(803)] = 44053,
  [SMALL_STATE(804)] = 44176,
  [SMALL_STATE(805)] = 44299,
  [SMALL_STATE(806)] = 44422,
  [SMALL_STATE(807)] = 44545,
  [SMALL_STATE(808)] = 44668,
  [SMALL_STATE(809)] = 44791,
  [SMALL_STATE(810)] = 44914,
  [SMALL_STATE(811)] = 45037,
  [SMALL_STATE(812)] = 45160,
  [SMALL_STATE(813)] = 45283,
  [SMALL_STATE(814)] = 45406,
  [SMALL_STATE(815)] = 45529,
  [SMALL_STATE(816)] = 45652,
  [SMALL_STATE(817)] = 45775,
  [SMALL_STATE(818)] = 45898,
  [SMALL_STATE(819)] = 46021,
  [SMALL_STATE(820)] = 46144,
  [SMALL_STATE(821)] = 46267,
  [SMALL_STATE(822)] = 46390,
  [SMALL_STATE(823)] = 46513,
  [SMALL_STATE(824)] = 46636,
  [SMALL_STATE(825)] = 46759,
  [SMALL_STATE(826)] = 46882,
  [SMALL_STATE(827)] = 47005,
  [SMALL_STATE(828)] = 47128,
  [SMALL_STATE(829)] = 47251,
  [SMALL_STATE(830)] = 47374,
  [SMALL_STATE(831)] = 47497,
  [SMALL_STATE(832)] = 47620,
  [SMALL_STATE(833)] = 47743,
  [SMALL_STATE(834)] = 47866,
  [SMALL_STATE(835)] = 47989,
  [SMALL_STATE(836)] = 48112,
  [SMALL_STATE(837)] = 48235,
  [SMALL_STATE(838)] = 48358,
  [SMALL_STATE(839)] = 48481,
  [SMALL_STATE(840)] = 48604,
  [SMALL_STATE(841)] = 48727,
  [SMALL_STATE(842)] = 48850,
  [SMALL_STATE(843)] = 48973,
  [SMALL_STATE(844)] = 49096,
  [SMALL_STATE(845)] = 49219,
  [SMALL_STATE(846)] = 49342,
  [SMALL_STATE(847)] = 49465,
  [SMALL_STATE(848)] = 49588,
  [SMALL_STATE(849)] = 49711,
  [SMALL_STATE(850)] = 49834,
  [SMALL_STATE(851)] = 49957,
  [SMALL_STATE(852)] = 50080,
  [SMALL_STATE(853)] = 50203,
  [SMALL_STATE(854)] = 50326,
  [SMALL_STATE(855)] = 50449,
  [SMALL_STATE(856)] = 50572,
  [SMALL_STATE(857)] = 50695,
  [SMALL_STATE(858)] = 50818,
  [SMALL_STATE(859)] = 50941,
  [SMALL_STATE(860)] = 51064,
  [SMALL_STATE(861)] = 51187,
  [SMALL_STATE(862)] = 51310,
  [SMALL_STATE(863)] = 51433,
  [SMALL_STATE(864)] = 51556,
  [SMALL_STATE(865)] = 51679,
  [SMALL_STATE(866)] = 51802,
  [SMALL_STATE(867)] = 51925,
  [SMALL_STATE(868)] = 52048,
  [SMALL_STATE(869)] = 52171,
  [SMALL_STATE(870)] = 52294,
  [SMALL_STATE(871)] = 52417,
  [SMALL_STATE(872)] = 52540,
  [SMALL_STATE(873)] = 52663,
  [SMALL_STATE(874)] = 52786,
  [SMALL_STATE(875)] = 52909,
  [SMALL_STATE(876)] = 53032,
  [SMALL_STATE(877)] = 53155,
  [SMALL_STATE(878)] = 53278,
  [SMALL_STATE(879)] = 53401,
  [SMALL_STATE(880)] = 53524,
  [SMALL_STATE(881)] = 53647,
  [SMALL_STATE(882)] = 53770,
  [SMALL_STATE(883)] = 53893,
  [SMALL_STATE(884)] = 54016,
  [SMALL_STATE(885)] = 54139,
  [SMALL_STATE(886)] = 54262,
  [SMALL_STATE(887)] = 54385,
  [SMALL_STATE(888)] = 54508,
  [SMALL_STATE(889)] = 54631,
  [SMALL_STATE(890)] = 54754,
  [SMALL_STATE(891)] = 54877,
  [SMALL_STATE(892)] = 55000,
  [SMALL_STATE(893)] = 55123,
  [SMALL_STATE(894)] = 55246,
  [SMALL_STATE(895)] = 55369,
  [SMALL_STATE(896)] = 55492,
  [SMALL_STATE(897)] = 55615,
  [SMALL_STATE(898)] = 55738,
  [SMALL_STATE(899)] = 55861,
  [SMALL_STATE(900)] = 55984,
  [SMALL_STATE(901)] = 56107,
  [SMALL_STATE(902)] = 56230,
  [SMALL_STATE(903)] = 56353,
  [SMALL_STATE(904)] = 56476,
  [SMALL_STATE(905)] = 56599,
  [SMALL_STATE(906)] = 56722,
  [SMALL_STATE(907)] = 56845,
  [SMALL_STATE(908)] = 56968,
  [SMALL_STATE(909)] = 57091,
  [SMALL_STATE(910)] = 57214,
  [SMALL_STATE(911)] = 57337,
  [SMALL_STATE(912)] = 57460,
  [SMALL_STATE(913)] = 57583,
  [SMALL_STATE(914)] = 57706,
  [SMALL_STATE(915)] = 57829,
  [SMALL_STATE(916)] = 57952,
  [SMALL_STATE(917)] = 58075,
  [SMALL_STATE(918)] = 58198,
  [SMALL_STATE(919)] = 58321,
  [SMALL_STATE(920)] = 58444,
  [SMALL_STATE(921)] = 58567,
  [SMALL_STATE(922)] = 58690,
  [SMALL_STATE(923)] = 58813,
  [SMALL_STATE(924)] = 58936,
  [SMALL_STATE(925)] = 59059,
  [SMALL_STATE(926)] = 59182,
  [SMALL_STATE(927)] = 59305,
  [SMALL_STATE(928)] = 59428,
  [SMALL_STATE(929)] = 59551,
  [SMALL_STATE(930)] = 59674,
  [SMALL_STATE(931)] = 59797,
  [SMALL_STATE(932)] = 59920,
  [SMALL_STATE(933)] = 60043,
  [SMALL_STATE(934)] = 60166,
  [SMALL_STATE(935)] = 60289,
  [SMALL_STATE(936)] = 60412,
  [SMALL_STATE(937)] = 60535,
  [SMALL_STATE(938)] = 60658,
  [SMALL_STATE(939)] = 60781,
  [SMALL_STATE(940)] = 60904,
  [SMALL_STATE(941)] = 61027,
  [SMALL_STATE(942)] = 61150,
  [SMALL_STATE(943)] = 61273,
  [SMALL_STATE(944)] = 61396,
  [SMALL_STATE(945)] = 61519,
  [SMALL_STATE(946)] = 61642,
  [SMALL_STATE(947)] = 61765,
  [SMALL_STATE(948)] = 61888,
  [SMALL_STATE(949)] = 62011,
  [SMALL_STATE(950)] = 62134,
  [SMALL_STATE(951)] = 62257,
  [SMALL_STATE(952)] = 62380,
  [SMALL_STATE(953)] = 62503,
  [SMALL_STATE(954)] = 62626,
  [SMALL_STATE(955)] = 62749,
  [SMALL_STATE(956)] = 62872,
  [SMALL_STATE(957)] = 62995,
  [SMALL_STATE(958)] = 63118,
  [SMALL_STATE(959)] = 63241,
  [SMALL_STATE(960)] = 63364,
  [SMALL_STATE(961)] = 63487,
  [SMALL_STATE(962)] = 63610,
  [SMALL_STATE(963)] = 63733,
  [SMALL_STATE(964)] = 63856,
  [SMALL_STATE(965)] = 63979,
  [SMALL_STATE(966)] = 64102,
  [SMALL_STATE(967)] = 64225,
  [SMALL_STATE(968)] = 64348,
  [SMALL_STATE(969)] = 64471,
  [SMALL_STATE(970)] = 64594,
  [SMALL_STATE(971)] = 64717,
  [SMALL_STATE(972)] = 64840,
  [SMALL_STATE(973)] = 64963,
  [SMALL_STATE(974)] = 65086,
  [SMALL_STATE(975)] = 65209,
  [SMALL_STATE(976)] = 65332,
  [SMALL_STATE(977)] = 65455,
  [SMALL_STATE(978)] = 65578,
  [SMALL_STATE(979)] = 65701,
  [SMALL_STATE(980)] = 65824,
  [SMALL_STATE(981)] = 65947,
  [SMALL_STATE(982)] = 66070,
  [SMALL_STATE(983)] = 66193,
  [SMALL_STATE(984)] = 66316,
  [SMALL_STATE(985)] = 66439,
  [SMALL_STATE(986)] = 66562,
  [SMALL_STATE(987)] = 66685,
  [SMALL_STATE(988)] = 66808,
  [SMALL_STATE(989)] = 66931,
  [SMALL_STATE(990)] = 67054,
  [SMALL_STATE(991)] = 67177,
  [SMALL_STATE(992)] = 67300,
  [SMALL_STATE(993)] = 67423,
  [SMALL_STATE(994)] = 67546,
  [SMALL_STATE(995)] = 67669,
  [SMALL_STATE(996)] = 67792,
  [SMALL_STATE(997)] = 67915,
  [SMALL_STATE(998)] = 68038,
  [SMALL_STATE(999)] = 68161,
  [SMALL_STATE(1000)] = 68284,
  [SMALL_STATE(1001)] = 68407,
  [SMALL_STATE(1002)] = 68530,
  [SMALL_STATE(1003)] = 68653,
  [SMALL_STATE(1004)] = 68776,
  [SMALL_STATE(1005)] = 68899,
  [SMALL_STATE(1006)] = 69022,
  [SMALL_STATE(1007)] = 69145,
  [SMALL_STATE(1008)] = 69268,
  [SMALL_STATE(1009)] = 69391,
  [SMALL_STATE(1010)] = 69514,
  [SMALL_STATE(1011)] = 69637,
  [SMALL_STATE(1012)] = 69760,
  [SMALL_STATE(1013)] = 69883,
  [SMALL_STATE(1014)] = 70006,
  [SMALL_STATE(1015)] = 70129,
  [SMALL_STATE(1016)] = 70252,
  [SMALL_STATE(1017)] = 70375,
  [SMALL_STATE(1018)] = 70498,
  [SMALL_STATE(1019)] = 70621,
  [SMALL_STATE(1020)] = 70744,
  [SMALL_STATE(1021)] = 70867,
  [SMALL_STATE(1022)] = 70990,
  [SMALL_STATE(1023)] = 71113,
  [SMALL_STATE(1024)] = 71236,
  [SMALL_STATE(1025)] = 71359,
  [SMALL_STATE(1026)] = 71482,
  [SMALL_STATE(1027)] = 71605,
  [SMALL_STATE(1028)] = 71728,
  [SMALL_STATE(1029)] = 71851,
  [SMALL_STATE(1030)] = 71974,
  [SMALL_STATE(1031)] = 72097,
  [SMALL_STATE(1032)] = 72220,
  [SMALL_STATE(1033)] = 72343,
  [SMALL_STATE(1034)] = 72466,
  [SMALL_STATE(1035)] = 72589,
  [SMALL_STATE(1036)] = 72712,
  [SMALL_STATE(1037)] = 72835,
  [SMALL_STATE(1038)] = 72958,
  [SMALL_STATE(1039)] = 73081,
  [SMALL_STATE(1040)] = 73204,
  [SMALL_STATE(1041)] = 73327,
  [SMALL_STATE(1042)] = 73450,
  [SMALL_STATE(1043)] = 73573,
  [SMALL_STATE(1044)] = 73696,
  [SMALL_STATE(1045)] = 73819,
  [SMALL_STATE(1046)] = 73942,
  [SMALL_STATE(1047)] = 74065,
  [SMALL_STATE(1048)] = 74182,
  [SMALL_STATE(1049)] = 74299,
  [SMALL_STATE(1050)] = 74416,
  [SMALL_STATE(1051)] = 74533,
  [SMALL_STATE(1052)] = 74650,
  [SMALL_STATE(1053)] = 74767,
  [SMALL_STATE(1054)] = 74884,
  [SMALL_STATE(1055)] = 75001,
  [SMALL_STATE(1056)] = 75118,
  [SMALL_STATE(1057)] = 75235,
  [SMALL_STATE(1058)] = 75352,
  [SMALL_STATE(1059)] = 75469,
  [SMALL_STATE(1060)] = 75586,
  [SMALL_STATE(1061)] = 75703,
  [SMALL_STATE(1062)] = 75820,
  [SMALL_STATE(1063)] = 75937,
  [SMALL_STATE(1064)] = 76054,
  [SMALL_STATE(1065)] = 76171,
  [SMALL_STATE(1066)] = 76288,
  [SMALL_STATE(1067)] = 76405,
  [SMALL_STATE(1068)] = 76522,
  [SMALL_STATE(1069)] = 76639,
  [SMALL_STATE(1070)] = 76756,
  [SMALL_STATE(1071)] = 76873,
  [SMALL_STATE(1072)] = 76990,
  [SMALL_STATE(1073)] = 77107,
  [SMALL_STATE(1074)] = 77224,
  [SMALL_STATE(1075)] = 77341,
  [SMALL_STATE(1076)] = 77458,
  [SMALL_STATE(1077)] = 77575,
  [SMALL_STATE(1078)] = 77692,
  [SMALL_STATE(1079)] = 77809,
  [SMALL_STATE(1080)] = 77926,
  [SMALL_STATE(1081)] = 78043,
  [SMALL_STATE(1082)] = 78160,
  [SMALL_STATE(1083)] = 78277,
  [SMALL_STATE(1084)] = 78394,
  [SMALL_STATE(1085)] = 78511,
  [SMALL_STATE(1086)] = 78628,
  [SMALL_STATE(1087)] = 78745,
  [SMALL_STATE(1088)] = 78862,
  [SMALL_STATE(1089)] = 78979,
  [SMALL_STATE(1090)] = 79096,
  [SMALL_STATE(1091)] = 79213,
  [SMALL_STATE(1092)] = 79330,
  [SMALL_STATE(1093)] = 79447,
  [SMALL_STATE(1094)] = 79564,
  [SMALL_STATE(1095)] = 79681,
  [SMALL_STATE(1096)] = 79798,
  [SMALL_STATE(1097)] = 79915,
  [SMALL_STATE(1098)] = 80032,
  [SMALL_STATE(1099)] = 80149,
  [SMALL_STATE(1100)] = 80266,
  [SMALL_STATE(1101)] = 80383,
  [SMALL_STATE(1102)] = 80500,
  [SMALL_STATE(1103)] = 80617,
  [SMALL_STATE(1104)] = 80734,
  [SMALL_STATE(1105)] = 80851,
  [SMALL_STATE(1106)] = 80968,
  [SMALL_STATE(1107)] = 81085,
  [SMALL_STATE(1108)] = 81202,
  [SMALL_STATE(1109)] = 81319,
  [SMALL_STATE(1110)] = 81436,
  [SMALL_STATE(1111)] = 81553,
  [SMALL_STATE(1112)] = 81670,
  [SMALL_STATE(1113)] = 81787,
  [SMALL_STATE(1114)] = 81904,
  [SMALL_STATE(1115)] = 82021,
  [SMALL_STATE(1116)] = 82138,
  [SMALL_STATE(1117)] = 82255,
  [SMALL_STATE(1118)] = 82372,
  [SMALL_STATE(1119)] = 82444,
  [SMALL_STATE(1120)] = 82516,
  [SMALL_STATE(1121)] = 82588,
  [SMALL_STATE(1122)] = 82660,
  [SMALL_STATE(1123)] = 82732,
  [SMALL_STATE(1124)] = 82804,
  [SMALL_STATE(1125)] = 82875,
  [SMALL_STATE(1126)] = 82946,
  [SMALL_STATE(1127)] = 83017,
  [SMALL_STATE(1128)] = 83088,
  [SMALL_STATE(1129)] = 83159,
  [SMALL_STATE(1130)] = 83230,
  [SMALL_STATE(1131)] = 83296,
  [SMALL_STATE(1132)] = 83362,
  [SMALL_STATE(1133)] = 83428,
  [SMALL_STATE(1134)] = 83483,
  [SMALL_STATE(1135)] = 83538,
  [SMALL_STATE(1136)] = 83603,
  [SMALL_STATE(1137)] = 83668,
  [SMALL_STATE(1138)] = 83733,
  [SMALL_STATE(1139)] = 83788,
  [SMALL_STATE(1140)] = 83896,
  [SMALL_STATE(1141)] = 84004,
  [SMALL_STATE(1142)] = 84112,
  [SMALL_STATE(1143)] = 84220,
  [SMALL_STATE(1144)] = 84328,
  [SMALL_STATE(1145)] = 84436,
  [SMALL_STATE(1146)] = 84490,
  [SMALL_STATE(1147)] = 84598,
  [SMALL_STATE(1148)] = 84652,
  [SMALL_STATE(1149)] = 84706,
  [SMALL_STATE(1150)] = 84814,
  [SMALL_STATE(1151)] = 84922,
  [SMALL_STATE(1152)] = 85030,
  [SMALL_STATE(1153)] = 85138,
  [SMALL_STATE(1154)] = 85246,
  [SMALL_STATE(1155)] = 85354,
  [SMALL_STATE(1156)] = 85462,
  [SMALL_STATE(1157)] = 85570,
  [SMALL_STATE(1158)] = 85678,
  [SMALL_STATE(1159)] = 85786,
  [SMALL_STATE(1160)] = 85894,
  [SMALL_STATE(1161)] = 86002,
  [SMALL_STATE(1162)] = 86110,
  [SMALL_STATE(1163)] = 86218,
  [SMALL_STATE(1164)] = 86326,
  [SMALL_STATE(1165)] = 86434,
  [SMALL_STATE(1166)] = 86542,
  [SMALL_STATE(1167)] = 86643,
  [SMALL_STATE(1168)] = 86718,
  [SMALL_STATE(1169)] = 86789,
  [SMALL_STATE(1170)] = 86862,
  [SMALL_STATE(1171)] = 86933,
  [SMALL_STATE(1172)] = 87036,
  [SMALL_STATE(1173)] = 87139,
  [SMALL_STATE(1174)] = 87242,
  [SMALL_STATE(1175)] = 87345,
  [SMALL_STATE(1176)] = 87448,
  [SMALL_STATE(1177)] = 87519,
  [SMALL_STATE(1178)] = 87622,
  [SMALL_STATE(1179)] = 87725,
  [SMALL_STATE(1180)] = 87828,
  [SMALL_STATE(1181)] = 87931,
  [SMALL_STATE(1182)] = 88034,
  [SMALL_STATE(1183)] = 88137,
  [SMALL_STATE(1184)] = 88240,
  [SMALL_STATE(1185)] = 88343,
  [SMALL_STATE(1186)] = 88446,
  [SMALL_STATE(1187)] = 88549,
  [SMALL_STATE(1188)] = 88652,
  [SMALL_STATE(1189)] = 88755,
  [SMALL_STATE(1190)] = 88858,
  [SMALL_STATE(1191)] = 88961,
  [SMALL_STATE(1192)] = 89056,
  [SMALL_STATE(1193)] = 89143,
  [SMALL_STATE(1194)] = 89214,
  [SMALL_STATE(1195)] = 89317,
  [SMALL_STATE(1196)] = 89420,
  [SMALL_STATE(1197)] = 89523,
  [SMALL_STATE(1198)] = 89626,
  [SMALL_STATE(1199)] = 89729,
  [SMALL_STATE(1200)] = 89824,
  [SMALL_STATE(1201)] = 89911,
  [SMALL_STATE(1202)] = 89982,
  [SMALL_STATE(1203)] = 90085,
  [SMALL_STATE(1204)] = 90188,
  [SMALL_STATE(1205)] = 90283,
  [SMALL_STATE(1206)] = 90362,
  [SMALL_STATE(1207)] = 90465,
  [SMALL_STATE(1208)] = 90562,
  [SMALL_STATE(1209)] = 90653,
  [SMALL_STATE(1210)] = 90740,
  [SMALL_STATE(1211)] = 90843,
  [SMALL_STATE(1212)] = 90926,
  [SMALL_STATE(1213)] = 91001,
  [SMALL_STATE(1214)] = 91072,
  [SMALL_STATE(1215)] = 91145,
  [SMALL_STATE(1216)] = 91246,
  [SMALL_STATE(1217)] = 91317,
  [SMALL_STATE(1218)] = 91420,
  [SMALL_STATE(1219)] = 91523,
  [SMALL_STATE(1220)] = 91626,
  [SMALL_STATE(1221)] = 91727,
  [SMALL_STATE(1222)] = 91830,
  [SMALL_STATE(1223)] = 91925,
  [SMALL_STATE(1224)] = 92004,
  [SMALL_STATE(1225)] = 92107,
  [SMALL_STATE(1226)] = 92204,
  [SMALL_STATE(1227)] = 92295,
  [SMALL_STATE(1228)] = 92382,
  [SMALL_STATE(1229)] = 92465,
  [SMALL_STATE(1230)] = 92540,
  [SMALL_STATE(1231)] = 92611,
  [SMALL_STATE(1232)] = 92684,
  [SMALL_STATE(1233)] = 92755,
  [SMALL_STATE(1234)] = 92858,
  [SMALL_STATE(1235)] = 92961,
  [SMALL_STATE(1236)] = 93064,
  [SMALL_STATE(1237)] = 93167,
  [SMALL_STATE(1238)] = 93270,
  [SMALL_STATE(1239)] = 93373,
  [SMALL_STATE(1240)] = 93476,
  [SMALL_STATE(1241)] = 93579,
  [SMALL_STATE(1242)] = 93682,
  [SMALL_STATE(1243)] = 93785,
  [SMALL_STATE(1244)] = 93888,
  [SMALL_STATE(1245)] = 93991,
  [SMALL_STATE(1246)] = 94094,
  [SMALL_STATE(1247)] = 94197,
  [SMALL_STATE(1248)] = 94300,
  [SMALL_STATE(1249)] = 94403,
  [SMALL_STATE(1250)] = 94506,
  [SMALL_STATE(1251)] = 94601,
  [SMALL_STATE(1252)] = 94680,
  [SMALL_STATE(1253)] = 94783,
  [SMALL_STATE(1254)] = 94880,
  [SMALL_STATE(1255)] = 94963,
  [SMALL_STATE(1256)] = 95050,
  [SMALL_STATE(1257)] = 95133,
  [SMALL_STATE(1258)] = 95208,
  [SMALL_STATE(1259)] = 95279,
  [SMALL_STATE(1260)] = 95352,
  [SMALL_STATE(1261)] = 95423,
  [SMALL_STATE(1262)] = 95526,
  [SMALL_STATE(1263)] = 95629,
  [SMALL_STATE(1264)] = 95724,
  [SMALL_STATE(1265)] = 95827,
  [SMALL_STATE(1266)] = 95930,
  [SMALL_STATE(1267)] = 96033,
  [SMALL_STATE(1268)] = 96136,
  [SMALL_STATE(1269)] = 96223,
  [SMALL_STATE(1270)] = 96326,
  [SMALL_STATE(1271)] = 96429,
  [SMALL_STATE(1272)] = 96532,
  [SMALL_STATE(1273)] = 96635,
  [SMALL_STATE(1274)] = 96738,
  [SMALL_STATE(1275)] = 96841,
  [SMALL_STATE(1276)] = 96944,
  [SMALL_STATE(1277)] = 97047,
  [SMALL_STATE(1278)] = 97150,
  [SMALL_STATE(1279)] = 97253,
  [SMALL_STATE(1280)] = 97356,
  [SMALL_STATE(1281)] = 97459,
  [SMALL_STATE(1282)] = 97530,
  [SMALL_STATE(1283)] = 97633,
  [SMALL_STATE(1284)] = 97736,
  [SMALL_STATE(1285)] = 97831,
  [SMALL_STATE(1286)] = 97918,
  [SMALL_STATE(1287)] = 97989,
  [SMALL_STATE(1288)] = 98090,
  [SMALL_STATE(1289)] = 98193,
  [SMALL_STATE(1290)] = 98288,
  [SMALL_STATE(1291)] = 98391,
  [SMALL_STATE(1292)] = 98494,
  [SMALL_STATE(1293)] = 98589,
  [SMALL_STATE(1294)] = 98676,
  [SMALL_STATE(1295)] = 98747,
  [SMALL_STATE(1296)] = 98826,
  [SMALL_STATE(1297)] = 98929,
  [SMALL_STATE(1298)] = 99026,
  [SMALL_STATE(1299)] = 99117,
  [SMALL_STATE(1300)] = 99204,
  [SMALL_STATE(1301)] = 99287,
  [SMALL_STATE(1302)] = 99390,
  [SMALL_STATE(1303)] = 99465,
  [SMALL_STATE(1304)] = 99568,
  [SMALL_STATE(1305)] = 99671,
  [SMALL_STATE(1306)] = 99766,
  [SMALL_STATE(1307)] = 99853,
  [SMALL_STATE(1308)] = 99924,
  [SMALL_STATE(1309)] = 100025,
  [SMALL_STATE(1310)] = 100128,
  [SMALL_STATE(1311)] = 100223,
  [SMALL_STATE(1312)] = 100302,
  [SMALL_STATE(1313)] = 100405,
  [SMALL_STATE(1314)] = 100502,
  [SMALL_STATE(1315)] = 100593,
  [SMALL_STATE(1316)] = 100680,
  [SMALL_STATE(1317)] = 100751,
  [SMALL_STATE(1318)] = 100834,
  [SMALL_STATE(1319)] = 100909,
  [SMALL_STATE(1320)] = 100980,
  [SMALL_STATE(1321)] = 101053,
  [SMALL_STATE(1322)] = 101124,
  [SMALL_STATE(1323)] = 101197,
  [SMALL_STATE(1324)] = 101300,
  [SMALL_STATE(1325)] = 101403,
  [SMALL_STATE(1326)] = 101504,
  [SMALL_STATE(1327)] = 101607,
  [SMALL_STATE(1328)] = 101702,
  [SMALL_STATE(1329)] = 101781,
  [SMALL_STATE(1330)] = 101884,
  [SMALL_STATE(1331)] = 101981,
  [SMALL_STATE(1332)] = 102072,
  [SMALL_STATE(1333)] = 102159,
  [SMALL_STATE(1334)] = 102250,
  [SMALL_STATE(1335)] = 102344,
  [SMALL_STATE(1336)] = 102446,
  [SMALL_STATE(1337)] = 102546,
  [SMALL_STATE(1338)] = 102648,
  [SMALL_STATE(1339)] = 102742,
  [SMALL_STATE(1340)] = 102820,
  [SMALL_STATE(1341)] = 102922,
  [SMALL_STATE(1342)] = 103018,
  [SMALL_STATE(1343)] = 103108,
  [SMALL_STATE(1344)] = 103194,
  [SMALL_STATE(1345)] = 103276,
  [SMALL_STATE(1346)] = 103378,
  [SMALL_STATE(1347)] = 103452,
  [SMALL_STATE(1348)] = 103522,
  [SMALL_STATE(1349)] = 103594,
  [SMALL_STATE(1350)] = 103664,
  [SMALL_STATE(1351)] = 103766,
  [SMALL_STATE(1352)] = 103868,
  [SMALL_STATE(1353)] = 103970,
  [SMALL_STATE(1354)] = 104072,
  [SMALL_STATE(1355)] = 104174,
  [SMALL_STATE(1356)] = 104276,
  [SMALL_STATE(1357)] = 104378,
  [SMALL_STATE(1358)] = 104480,
  [SMALL_STATE(1359)] = 104582,
  [SMALL_STATE(1360)] = 104688,
  [SMALL_STATE(1361)] = 104790,
  [SMALL_STATE(1362)] = 104894,
  [SMALL_STATE(1363)] = 104988,
  [SMALL_STATE(1364)] = 105090,
  [SMALL_STATE(1365)] = 105176,
  [SMALL_STATE(1366)] = 105278,
  [SMALL_STATE(1367)] = 105380,
  [SMALL_STATE(1368)] = 105482,
  [SMALL_STATE(1369)] = 105584,
  [SMALL_STATE(1370)] = 105654,
  [SMALL_STATE(1371)] = 105756,
  [SMALL_STATE(1372)] = 105862,
  [SMALL_STATE(1373)] = 105964,
  [SMALL_STATE(1374)] = 106066,
  [SMALL_STATE(1375)] = 106168,
  [SMALL_STATE(1376)] = 106246,
  [SMALL_STATE(1377)] = 106348,
  [SMALL_STATE(1378)] = 106450,
  [SMALL_STATE(1379)] = 106552,
  [SMALL_STATE(1380)] = 106654,
  [SMALL_STATE(1381)] = 106756,
  [SMALL_STATE(1382)] = 106858,
  [SMALL_STATE(1383)] = 106960,
  [SMALL_STATE(1384)] = 107062,
  [SMALL_STATE(1385)] = 107164,
  [SMALL_STATE(1386)] = 107266,
  [SMALL_STATE(1387)] = 107368,
  [SMALL_STATE(1388)] = 107470,
  [SMALL_STATE(1389)] = 107572,
  [SMALL_STATE(1390)] = 107674,
  [SMALL_STATE(1391)] = 107776,
  [SMALL_STATE(1392)] = 107878,
  [SMALL_STATE(1393)] = 107980,
  [SMALL_STATE(1394)] = 108082,
  [SMALL_STATE(1395)] = 108184,
  [SMALL_STATE(1396)] = 108280,
  [SMALL_STATE(1397)] = 108374,
  [SMALL_STATE(1398)] = 108460,
  [SMALL_STATE(1399)] = 108530,
  [SMALL_STATE(1400)] = 108636,
  [SMALL_STATE(1401)] = 108736,
  [SMALL_STATE(1402)] = 108838,
  [SMALL_STATE(1403)] = 108944,
  [SMALL_STATE(1404)] = 109038,
  [SMALL_STATE(1405)] = 109116,
  [SMALL_STATE(1406)] = 109218,
  [SMALL_STATE(1407)] = 109314,
  [SMALL_STATE(1408)] = 109404,
  [SMALL_STATE(1409)] = 109490,
  [SMALL_STATE(1410)] = 109572,
  [SMALL_STATE(1411)] = 109674,
  [SMALL_STATE(1412)] = 109748,
  [SMALL_STATE(1413)] = 109850,
  [SMALL_STATE(1414)] = 109952,
  [SMALL_STATE(1415)] = 110022,
  [SMALL_STATE(1416)] = 110128,
  [SMALL_STATE(1417)] = 110230,
  [SMALL_STATE(1418)] = 110336,
  [SMALL_STATE(1419)] = 110408,
  [SMALL_STATE(1420)] = 110478,
  [SMALL_STATE(1421)] = 110568,
  [SMALL_STATE(1422)] = 110670,
  [SMALL_STATE(1423)] = 110756,
  [SMALL_STATE(1424)] = 110838,
  [SMALL_STATE(1425)] = 110940,
  [SMALL_STATE(1426)] = 111014,
  [SMALL_STATE(1427)] = 111116,
  [SMALL_STATE(1428)] = 111210,
  [SMALL_STATE(1429)] = 111296,
  [SMALL_STATE(1430)] = 111366,
  [SMALL_STATE(1431)] = 111436,
  [SMALL_STATE(1432)] = 111508,
  [SMALL_STATE(1433)] = 111608,
  [SMALL_STATE(1434)] = 111678,
  [SMALL_STATE(1435)] = 111780,
  [SMALL_STATE(1436)] = 111882,
  [SMALL_STATE(1437)] = 111976,
  [SMALL_STATE(1438)] = 112078,
  [SMALL_STATE(1439)] = 112180,
  [SMALL_STATE(1440)] = 112282,
  [SMALL_STATE(1441)] = 112360,
  [SMALL_STATE(1442)] = 112462,
  [SMALL_STATE(1443)] = 112564,
  [SMALL_STATE(1444)] = 112658,
  [SMALL_STATE(1445)] = 112754,
  [SMALL_STATE(1446)] = 112858,
  [SMALL_STATE(1447)] = 112948,
  [SMALL_STATE(1448)] = 113034,
  [SMALL_STATE(1449)] = 113136,
  [SMALL_STATE(1450)] = 113238,
  [SMALL_STATE(1451)] = 113340,
  [SMALL_STATE(1452)] = 113442,
  [SMALL_STATE(1453)] = 113548,
  [SMALL_STATE(1454)] = 113654,
  [SMALL_STATE(1455)] = 113760,
  [SMALL_STATE(1456)] = 113860,
  [SMALL_STATE(1457)] = 113962,
  [SMALL_STATE(1458)] = 114068,
  [SMALL_STATE(1459)] = 114162,
  [SMALL_STATE(1460)] = 114256,
  [SMALL_STATE(1461)] = 114334,
  [SMALL_STATE(1462)] = 114440,
  [SMALL_STATE(1463)] = 114542,
  [SMALL_STATE(1464)] = 114628,
  [SMALL_STATE(1465)] = 114724,
  [SMALL_STATE(1466)] = 114814,
  [SMALL_STATE(1467)] = 114916,
  [SMALL_STATE(1468)] = 115002,
  [SMALL_STATE(1469)] = 115088,
  [SMALL_STATE(1470)] = 115158,
  [SMALL_STATE(1471)] = 115240,
  [SMALL_STATE(1472)] = 115346,
  [SMALL_STATE(1473)] = 115452,
  [SMALL_STATE(1474)] = 115558,
  [SMALL_STATE(1475)] = 115664,
  [SMALL_STATE(1476)] = 115770,
  [SMALL_STATE(1477)] = 115876,
  [SMALL_STATE(1478)] = 115982,
  [SMALL_STATE(1479)] = 116088,
  [SMALL_STATE(1480)] = 116162,
  [SMALL_STATE(1481)] = 116268,
  [SMALL_STATE(1482)] = 116338,
  [SMALL_STATE(1483)] = 116444,
  [SMALL_STATE(1484)] = 116516,
  [SMALL_STATE(1485)] = 116586,
  [SMALL_STATE(1486)] = 116692,
  [SMALL_STATE(1487)] = 116798,
  [SMALL_STATE(1488)] = 116904,
  [SMALL_STATE(1489)] = 117010,
  [SMALL_STATE(1490)] = 117116,
  [SMALL_STATE(1491)] = 117222,
  [SMALL_STATE(1492)] = 117328,
  [SMALL_STATE(1493)] = 117430,
  [SMALL_STATE(1494)] = 117536,
  [SMALL_STATE(1495)] = 117642,
  [SMALL_STATE(1496)] = 117748,
  [SMALL_STATE(1497)] = 117850,
  [SMALL_STATE(1498)] = 117956,
  [SMALL_STATE(1499)] = 118062,
  [SMALL_STATE(1500)] = 118168,
  [SMALL_STATE(1501)] = 118270,
  [SMALL_STATE(1502)] = 118376,
  [SMALL_STATE(1503)] = 118482,
  [SMALL_STATE(1504)] = 118584,
  [SMALL_STATE(1505)] = 118690,
  [SMALL_STATE(1506)] = 118796,
  [SMALL_STATE(1507)] = 118902,
  [SMALL_STATE(1508)] = 119004,
  [SMALL_STATE(1509)] = 119098,
  [SMALL_STATE(1510)] = 119204,
  [SMALL_STATE(1511)] = 119290,
  [SMALL_STATE(1512)] = 119396,
  [SMALL_STATE(1513)] = 119466,
  [SMALL_STATE(1514)] = 119572,
  [SMALL_STATE(1515)] = 119678,
  [SMALL_STATE(1516)] = 119784,
  [SMALL_STATE(1517)] = 119886,
  [SMALL_STATE(1518)] = 119992,
  [SMALL_STATE(1519)] = 120098,
  [SMALL_STATE(1520)] = 120200,
  [SMALL_STATE(1521)] = 120302,
  [SMALL_STATE(1522)] = 120408,
  [SMALL_STATE(1523)] = 120514,
  [SMALL_STATE(1524)] = 120620,
  [SMALL_STATE(1525)] = 120726,
  [SMALL_STATE(1526)] = 120832,
  [SMALL_STATE(1527)] = 120914,
  [SMALL_STATE(1528)] = 121016,
  [SMALL_STATE(1529)] = 121122,
  [SMALL_STATE(1530)] = 121192,
  [SMALL_STATE(1531)] = 121292,
  [SMALL_STATE(1532)] = 121398,
  [SMALL_STATE(1533)] = 121472,
  [SMALL_STATE(1534)] = 121574,
  [SMALL_STATE(1535)] = 121676,
  [SMALL_STATE(1536)] = 121778,
  [SMALL_STATE(1537)] = 121884,
  [SMALL_STATE(1538)] = 121954,
  [SMALL_STATE(1539)] = 122060,
  [SMALL_STATE(1540)] = 122160,
  [SMALL_STATE(1541)] = 122266,
  [SMALL_STATE(1542)] = 122338,
  [SMALL_STATE(1543)] = 122440,
  [SMALL_STATE(1544)] = 122534,
  [SMALL_STATE(1545)] = 122640,
  [SMALL_STATE(1546)] = 122710,
  [SMALL_STATE(1547)] = 122816,
  [SMALL_STATE(1548)] = 122894,
  [SMALL_STATE(1549)] = 122996,
  [SMALL_STATE(1550)] = 123102,
  [SMALL_STATE(1551)] = 123198,
  [SMALL_STATE(1552)] = 123304,
  [SMALL_STATE(1553)] = 123408,
  [SMALL_STATE(1554)] = 123498,
  [SMALL_STATE(1555)] = 123584,
  [SMALL_STATE(1556)] = 123690,
  [SMALL_STATE(1557)] = 123796,
  [SMALL_STATE(1558)] = 123878,
  [SMALL_STATE(1559)] = 123952,
  [SMALL_STATE(1560)] = 124022,
  [SMALL_STATE(1561)] = 124128,
  [SMALL_STATE(1562)] = 124200,
  [SMALL_STATE(1563)] = 124306,
  [SMALL_STATE(1564)] = 124376,
  [SMALL_STATE(1565)] = 124482,
  [SMALL_STATE(1566)] = 124588,
  [SMALL_STATE(1567)] = 124694,
  [SMALL_STATE(1568)] = 124800,
  [SMALL_STATE(1569)] = 124906,
  [SMALL_STATE(1570)] = 125012,
  [SMALL_STATE(1571)] = 125114,
  [SMALL_STATE(1572)] = 125216,
  [SMALL_STATE(1573)] = 125318,
  [SMALL_STATE(1574)] = 125420,
  [SMALL_STATE(1575)] = 125522,
  [SMALL_STATE(1576)] = 125626,
  [SMALL_STATE(1577)] = 125671,
  [SMALL_STATE(1578)] = 125720,
  [SMALL_STATE(1579)] = 125769,
  [SMALL_STATE(1580)] = 125814,
  [SMALL_STATE(1581)] = 125863,
  [SMALL_STATE(1582)] = 125908,
  [SMALL_STATE(1583)] = 125953,
  [SMALL_STATE(1584)] = 125998,
  [SMALL_STATE(1585)] = 126043,
  [SMALL_STATE(1586)] = 126088,
  [SMALL_STATE(1587)] = 126133,
  [SMALL_STATE(1588)] = 126178,
  [SMALL_STATE(1589)] = 126223,
  [SMALL_STATE(1590)] = 126268,
  [SMALL_STATE(1591)] = 126313,
  [SMALL_STATE(1592)] = 126358,
  [SMALL_STATE(1593)] = 126407,
  [SMALL_STATE(1594)] = 126456,
  [SMALL_STATE(1595)] = 126501,
  [SMALL_STATE(1596)] = 126546,
  [SMALL_STATE(1597)] = 126591,
  [SMALL_STATE(1598)] = 126636,
  [SMALL_STATE(1599)] = 126681,
  [SMALL_STATE(1600)] = 126730,
  [SMALL_STATE(1601)] = 126775,
  [SMALL_STATE(1602)] = 126820,
  [SMALL_STATE(1603)] = 126865,
  [SMALL_STATE(1604)] = 126910,
  [SMALL_STATE(1605)] = 126954,
  [SMALL_STATE(1606)] = 126998,
  [SMALL_STATE(1607)] = 127042,
  [SMALL_STATE(1608)] = 127090,
  [SMALL_STATE(1609)] = 127138,
  [SMALL_STATE(1610)] = 127186,
  [SMALL_STATE(1611)] = 127234,
  [SMALL_STATE(1612)] = 127278,
  [SMALL_STATE(1613)] = 127322,
  [SMALL_STATE(1614)] = 127366,
  [SMALL_STATE(1615)] = 127410,
  [SMALL_STATE(1616)] = 127454,
  [SMALL_STATE(1617)] = 127498,
  [SMALL_STATE(1618)] = 127542,
  [SMALL_STATE(1619)] = 127586,
  [SMALL_STATE(1620)] = 127634,
  [SMALL_STATE(1621)] = 127682,
  [SMALL_STATE(1622)] = 127726,
  [SMALL_STATE(1623)] = 127770,
  [SMALL_STATE(1624)] = 127814,
  [SMALL_STATE(1625)] = 127858,
  [SMALL_STATE(1626)] = 127902,
  [SMALL_STATE(1627)] = 127950,
  [SMALL_STATE(1628)] = 128000,
  [SMALL_STATE(1629)] = 128050,
  [SMALL_STATE(1630)] = 128094,
  [SMALL_STATE(1631)] = 128144,
  [SMALL_STATE(1632)] = 128188,
  [SMALL_STATE(1633)] = 128232,
  [SMALL_STATE(1634)] = 128276,
  [SMALL_STATE(1635)] = 128320,
  [SMALL_STATE(1636)] = 128363,
  [SMALL_STATE(1637)] = 128406,
  [SMALL_STATE(1638)] = 128449,
  [SMALL_STATE(1639)] = 128492,
  [SMALL_STATE(1640)] = 128535,
  [SMALL_STATE(1641)] = 128578,
  [SMALL_STATE(1642)] = 128621,
  [SMALL_STATE(1643)] = 128664,
  [SMALL_STATE(1644)] = 128707,
  [SMALL_STATE(1645)] = 128750,
  [SMALL_STATE(1646)] = 128793,
  [SMALL_STATE(1647)] = 128836,
  [SMALL_STATE(1648)] = 128879,
  [SMALL_STATE(1649)] = 128922,
  [SMALL_STATE(1650)] = 128965,
  [SMALL_STATE(1651)] = 129008,
  [SMALL_STATE(1652)] = 129051,
  [SMALL_STATE(1653)] = 129094,
  [SMALL_STATE(1654)] = 129137,
  [SMALL_STATE(1655)] = 129180,
  [SMALL_STATE(1656)] = 129223,
  [SMALL_STATE(1657)] = 129266,
  [SMALL_STATE(1658)] = 129309,
  [SMALL_STATE(1659)] = 129352,
  [SMALL_STATE(1660)] = 129395,
  [SMALL_STATE(1661)] = 129438,
  [SMALL_STATE(1662)] = 129481,
  [SMALL_STATE(1663)] = 129524,
  [SMALL_STATE(1664)] = 129567,
  [SMALL_STATE(1665)] = 129610,
  [SMALL_STATE(1666)] = 129653,
  [SMALL_STATE(1667)] = 129696,
  [SMALL_STATE(1668)] = 129739,
  [SMALL_STATE(1669)] = 129782,
  [SMALL_STATE(1670)] = 129825,
  [SMALL_STATE(1671)] = 129868,
  [SMALL_STATE(1672)] = 129911,
  [SMALL_STATE(1673)] = 129954,
  [SMALL_STATE(1674)] = 129997,
  [SMALL_STATE(1675)] = 130040,
  [SMALL_STATE(1676)] = 130083,
  [SMALL_STATE(1677)] = 130126,
  [SMALL_STATE(1678)] = 130169,
  [SMALL_STATE(1679)] = 130212,
  [SMALL_STATE(1680)] = 130255,
  [SMALL_STATE(1681)] = 130298,
  [SMALL_STATE(1682)] = 130341,
  [SMALL_STATE(1683)] = 130384,
  [SMALL_STATE(1684)] = 130427,
  [SMALL_STATE(1685)] = 130470,
  [SMALL_STATE(1686)] = 130513,
  [SMALL_STATE(1687)] = 130556,
  [SMALL_STATE(1688)] = 130599,
  [SMALL_STATE(1689)] = 130642,
  [SMALL_STATE(1690)] = 130685,
  [SMALL_STATE(1691)] = 130728,
  [SMALL_STATE(1692)] = 130771,
  [SMALL_STATE(1693)] = 130814,
  [SMALL_STATE(1694)] = 130857,
  [SMALL_STATE(1695)] = 130900,
  [SMALL_STATE(1696)] = 130943,
  [SMALL_STATE(1697)] = 130986,
  [SMALL_STATE(1698)] = 131029,
  [SMALL_STATE(1699)] = 131072,
  [SMALL_STATE(1700)] = 131115,
  [SMALL_STATE(1701)] = 131158,
  [SMALL_STATE(1702)] = 131201,
  [SMALL_STATE(1703)] = 131244,
  [SMALL_STATE(1704)] = 131287,
  [SMALL_STATE(1705)] = 131330,
  [SMALL_STATE(1706)] = 131373,
  [SMALL_STATE(1707)] = 131416,
  [SMALL_STATE(1708)] = 131459,
  [SMALL_STATE(1709)] = 131502,
  [SMALL_STATE(1710)] = 131545,
  [SMALL_STATE(1711)] = 131587,
  [SMALL_STATE(1712)] = 131629,
  [SMALL_STATE(1713)] = 131671,
  [SMALL_STATE(1714)] = 131713,
  [SMALL_STATE(1715)] = 131755,
  [SMALL_STATE(1716)] = 131797,
  [SMALL_STATE(1717)] = 131839,
  [SMALL_STATE(1718)] = 131881,
  [SMALL_STATE(1719)] = 131923,
  [SMALL_STATE(1720)] = 131965,
  [SMALL_STATE(1721)] = 132007,
  [SMALL_STATE(1722)] = 132049,
  [SMALL_STATE(1723)] = 132091,
  [SMALL_STATE(1724)] = 132133,
  [SMALL_STATE(1725)] = 132175,
  [SMALL_STATE(1726)] = 132217,
  [SMALL_STATE(1727)] = 132259,
  [SMALL_STATE(1728)] = 132301,
  [SMALL_STATE(1729)] = 132343,
  [SMALL_STATE(1730)] = 132385,
  [SMALL_STATE(1731)] = 132427,
  [SMALL_STATE(1732)] = 132469,
  [SMALL_STATE(1733)] = 132511,
  [SMALL_STATE(1734)] = 132553,
  [SMALL_STATE(1735)] = 132595,
  [SMALL_STATE(1736)] = 132637,
  [SMALL_STATE(1737)] = 132679,
  [SMALL_STATE(1738)] = 132721,
  [SMALL_STATE(1739)] = 132763,
  [SMALL_STATE(1740)] = 132805,
  [SMALL_STATE(1741)] = 132847,
  [SMALL_STATE(1742)] = 132889,
  [SMALL_STATE(1743)] = 132931,
  [SMALL_STATE(1744)] = 132973,
  [SMALL_STATE(1745)] = 133015,
  [SMALL_STATE(1746)] = 133057,
  [SMALL_STATE(1747)] = 133099,
  [SMALL_STATE(1748)] = 133141,
  [SMALL_STATE(1749)] = 133183,
  [SMALL_STATE(1750)] = 133225,
  [SMALL_STATE(1751)] = 133267,
  [SMALL_STATE(1752)] = 133309,
  [SMALL_STATE(1753)] = 133353,
  [SMALL_STATE(1754)] = 133395,
  [SMALL_STATE(1755)] = 133437,
  [SMALL_STATE(1756)] = 133479,
  [SMALL_STATE(1757)] = 133521,
  [SMALL_STATE(1758)] = 133563,
  [SMALL_STATE(1759)] = 133605,
  [SMALL_STATE(1760)] = 133647,
  [SMALL_STATE(1761)] = 133689,
  [SMALL_STATE(1762)] = 133731,
  [SMALL_STATE(1763)] = 133773,
  [SMALL_STATE(1764)] = 133815,
  [SMALL_STATE(1765)] = 133857,
  [SMALL_STATE(1766)] = 133899,
  [SMALL_STATE(1767)] = 133941,
  [SMALL_STATE(1768)] = 133983,
  [SMALL_STATE(1769)] = 134025,
  [SMALL_STATE(1770)] = 134067,
  [SMALL_STATE(1771)] = 134109,
  [SMALL_STATE(1772)] = 134151,
  [SMALL_STATE(1773)] = 134193,
  [SMALL_STATE(1774)] = 134235,
  [SMALL_STATE(1775)] = 134277,
  [SMALL_STATE(1776)] = 134319,
  [SMALL_STATE(1777)] = 134361,
  [SMALL_STATE(1778)] = 134403,
  [SMALL_STATE(1779)] = 134445,
  [SMALL_STATE(1780)] = 134489,
  [SMALL_STATE(1781)] = 134531,
  [SMALL_STATE(1782)] = 134573,
  [SMALL_STATE(1783)] = 134615,
  [SMALL_STATE(1784)] = 134657,
  [SMALL_STATE(1785)] = 134701,
  [SMALL_STATE(1786)] = 134728,
  [SMALL_STATE(1787)] = 134749,
  [SMALL_STATE(1788)] = 134768,
  [SMALL_STATE(1789)] = 134787,
  [SMALL_STATE(1790)] = 134806,
  [SMALL_STATE(1791)] = 134825,
  [SMALL_STATE(1792)] = 134844,
  [SMALL_STATE(1793)] = 134863,
  [SMALL_STATE(1794)] = 134882,
  [SMALL_STATE(1795)] = 134901,
  [SMALL_STATE(1796)] = 134920,
  [SMALL_STATE(1797)] = 134939,
  [SMALL_STATE(1798)] = 134958,
  [SMALL_STATE(1799)] = 134977,
  [SMALL_STATE(1800)] = 134996,
  [SMALL_STATE(1801)] = 135015,
  [SMALL_STATE(1802)] = 135034,
  [SMALL_STATE(1803)] = 135053,
  [SMALL_STATE(1804)] = 135072,
  [SMALL_STATE(1805)] = 135091,
  [SMALL_STATE(1806)] = 135110,
  [SMALL_STATE(1807)] = 135129,
  [SMALL_STATE(1808)] = 135145,
  [SMALL_STATE(1809)] = 135161,
  [SMALL_STATE(1810)] = 135177,
  [SMALL_STATE(1811)] = 135193,
  [SMALL_STATE(1812)] = 135207,
  [SMALL_STATE(1813)] = 135221,
  [SMALL_STATE(1814)] = 135235,
  [SMALL_STATE(1815)] = 135249,
  [SMALL_STATE(1816)] = 135265,
  [SMALL_STATE(1817)] = 135279,
  [SMALL_STATE(1818)] = 135293,
  [SMALL_STATE(1819)] = 135309,
  [SMALL_STATE(1820)] = 135325,
  [SMALL_STATE(1821)] = 135341,
  [SMALL_STATE(1822)] = 135355,
  [SMALL_STATE(1823)] = 135371,
  [SMALL_STATE(1824)] = 135387,
  [SMALL_STATE(1825)] = 135403,
  [SMALL_STATE(1826)] = 135419,
  [SMALL_STATE(1827)] = 135435,
  [SMALL_STATE(1828)] = 135449,
  [SMALL_STATE(1829)] = 135465,
  [SMALL_STATE(1830)] = 135481,
  [SMALL_STATE(1831)] = 135497,
  [SMALL_STATE(1832)] = 135513,
  [SMALL_STATE(1833)] = 135527,
  [SMALL_STATE(1834)] = 135541,
  [SMALL_STATE(1835)] = 135557,
  [SMALL_STATE(1836)] = 135571,
  [SMALL_STATE(1837)] = 135585,
  [SMALL_STATE(1838)] = 135601,
  [SMALL_STATE(1839)] = 135617,
  [SMALL_STATE(1840)] = 135633,
  [SMALL_STATE(1841)] = 135649,
  [SMALL_STATE(1842)] = 135663,
  [SMALL_STATE(1843)] = 135679,
  [SMALL_STATE(1844)] = 135695,
  [SMALL_STATE(1845)] = 135709,
  [SMALL_STATE(1846)] = 135725,
  [SMALL_STATE(1847)] = 135741,
  [SMALL_STATE(1848)] = 135757,
  [SMALL_STATE(1849)] = 135771,
  [SMALL_STATE(1850)] = 135787,
  [SMALL_STATE(1851)] = 135803,
  [SMALL_STATE(1852)] = 135817,
  [SMALL_STATE(1853)] = 135831,
  [SMALL_STATE(1854)] = 135847,
  [SMALL_STATE(1855)] = 135863,
  [SMALL_STATE(1856)] = 135877,
  [SMALL_STATE(1857)] = 135891,
  [SMALL_STATE(1858)] = 135907,
  [SMALL_STATE(1859)] = 135923,
  [SMALL_STATE(1860)] = 135939,
  [SMALL_STATE(1861)] = 135953,
  [SMALL_STATE(1862)] = 135969,
  [SMALL_STATE(1863)] = 135985,
  [SMALL_STATE(1864)] = 135999,
  [SMALL_STATE(1865)] = 136015,
  [SMALL_STATE(1866)] = 136031,
  [SMALL_STATE(1867)] = 136047,
  [SMALL_STATE(1868)] = 136063,
  [SMALL_STATE(1869)] = 136077,
  [SMALL_STATE(1870)] = 136091,
  [SMALL_STATE(1871)] = 136105,
  [SMALL_STATE(1872)] = 136121,
  [SMALL_STATE(1873)] = 136135,
  [SMALL_STATE(1874)] = 136149,
  [SMALL_STATE(1875)] = 136163,
  [SMALL_STATE(1876)] = 136177,
  [SMALL_STATE(1877)] = 136191,
  [SMALL_STATE(1878)] = 136207,
  [SMALL_STATE(1879)] = 136221,
  [SMALL_STATE(1880)] = 136237,
  [SMALL_STATE(1881)] = 136251,
  [SMALL_STATE(1882)] = 136267,
  [SMALL_STATE(1883)] = 136283,
  [SMALL_STATE(1884)] = 136297,
  [SMALL_STATE(1885)] = 136313,
  [SMALL_STATE(1886)] = 136327,
  [SMALL_STATE(1887)] = 136343,
  [SMALL_STATE(1888)] = 136359,
  [SMALL_STATE(1889)] = 136373,
  [SMALL_STATE(1890)] = 136389,
  [SMALL_STATE(1891)] = 136403,
  [SMALL_STATE(1892)] = 136419,
  [SMALL_STATE(1893)] = 136435,
  [SMALL_STATE(1894)] = 136451,
  [SMALL_STATE(1895)] = 136467,
  [SMALL_STATE(1896)] = 136483,
  [SMALL_STATE(1897)] = 136499,
  [SMALL_STATE(1898)] = 136513,
  [SMALL_STATE(1899)] = 136527,
  [SMALL_STATE(1900)] = 136543,
  [SMALL_STATE(1901)] = 136559,
  [SMALL_STATE(1902)] = 136575,
  [SMALL_STATE(1903)] = 136591,
  [SMALL_STATE(1904)] = 136607,
  [SMALL_STATE(1905)] = 136623,
  [SMALL_STATE(1906)] = 136639,
  [SMALL_STATE(1907)] = 136655,
  [SMALL_STATE(1908)] = 136671,
  [SMALL_STATE(1909)] = 136687,
  [SMALL_STATE(1910)] = 136703,
  [SMALL_STATE(1911)] = 136717,
  [SMALL_STATE(1912)] = 136731,
  [SMALL_STATE(1913)] = 136747,
  [SMALL_STATE(1914)] = 136763,
  [SMALL_STATE(1915)] = 136779,
  [SMALL_STATE(1916)] = 136795,
  [SMALL_STATE(1917)] = 136811,
  [SMALL_STATE(1918)] = 136827,
  [SMALL_STATE(1919)] = 136843,
  [SMALL_STATE(1920)] = 136859,
  [SMALL_STATE(1921)] = 136875,
  [SMALL_STATE(1922)] = 136891,
  [SMALL_STATE(1923)] = 136907,
  [SMALL_STATE(1924)] = 136923,
  [SMALL_STATE(1925)] = 136937,
  [SMALL_STATE(1926)] = 136953,
  [SMALL_STATE(1927)] = 136969,
  [SMALL_STATE(1928)] = 136985,
  [SMALL_STATE(1929)] = 137001,
  [SMALL_STATE(1930)] = 137017,
  [SMALL_STATE(1931)] = 137033,
  [SMALL_STATE(1932)] = 137049,
  [SMALL_STATE(1933)] = 137065,
  [SMALL_STATE(1934)] = 137081,
  [SMALL_STATE(1935)] = 137097,
  [SMALL_STATE(1936)] = 137113,
  [SMALL_STATE(1937)] = 137129,
  [SMALL_STATE(1938)] = 137145,
  [SMALL_STATE(1939)] = 137161,
  [SMALL_STATE(1940)] = 137177,
  [SMALL_STATE(1941)] = 137193,
  [SMALL_STATE(1942)] = 137209,
  [SMALL_STATE(1943)] = 137225,
  [SMALL_STATE(1944)] = 137241,
  [SMALL_STATE(1945)] = 137257,
  [SMALL_STATE(1946)] = 137273,
  [SMALL_STATE(1947)] = 137289,
  [SMALL_STATE(1948)] = 137305,
  [SMALL_STATE(1949)] = 137321,
  [SMALL_STATE(1950)] = 137337,
  [SMALL_STATE(1951)] = 137353,
  [SMALL_STATE(1952)] = 137369,
  [SMALL_STATE(1953)] = 137385,
  [SMALL_STATE(1954)] = 137401,
  [SMALL_STATE(1955)] = 137417,
  [SMALL_STATE(1956)] = 137433,
  [SMALL_STATE(1957)] = 137449,
  [SMALL_STATE(1958)] = 137465,
  [SMALL_STATE(1959)] = 137479,
  [SMALL_STATE(1960)] = 137495,
  [SMALL_STATE(1961)] = 137511,
  [SMALL_STATE(1962)] = 137527,
  [SMALL_STATE(1963)] = 137543,
  [SMALL_STATE(1964)] = 137559,
  [SMALL_STATE(1965)] = 137575,
  [SMALL_STATE(1966)] = 137591,
  [SMALL_STATE(1967)] = 137607,
  [SMALL_STATE(1968)] = 137623,
  [SMALL_STATE(1969)] = 137639,
  [SMALL_STATE(1970)] = 137655,
  [SMALL_STATE(1971)] = 137671,
  [SMALL_STATE(1972)] = 137687,
  [SMALL_STATE(1973)] = 137703,
  [SMALL_STATE(1974)] = 137719,
  [SMALL_STATE(1975)] = 137735,
  [SMALL_STATE(1976)] = 137751,
  [SMALL_STATE(1977)] = 137767,
  [SMALL_STATE(1978)] = 137783,
  [SMALL_STATE(1979)] = 137799,
  [SMALL_STATE(1980)] = 137815,
  [SMALL_STATE(1981)] = 137831,
  [SMALL_STATE(1982)] = 137847,
  [SMALL_STATE(1983)] = 137863,
  [SMALL_STATE(1984)] = 137879,
  [SMALL_STATE(1985)] = 137895,
  [SMALL_STATE(1986)] = 137911,
  [SMALL_STATE(1987)] = 137927,
  [SMALL_STATE(1988)] = 137943,
  [SMALL_STATE(1989)] = 137959,
  [SMALL_STATE(1990)] = 137975,
  [SMALL_STATE(1991)] = 137991,
  [SMALL_STATE(1992)] = 138007,
  [SMALL_STATE(1993)] = 138023,
  [SMALL_STATE(1994)] = 138039,
  [SMALL_STATE(1995)] = 138055,
  [SMALL_STATE(1996)] = 138071,
  [SMALL_STATE(1997)] = 138087,
  [SMALL_STATE(1998)] = 138103,
  [SMALL_STATE(1999)] = 138119,
  [SMALL_STATE(2000)] = 138135,
  [SMALL_STATE(2001)] = 138149,
  [SMALL_STATE(2002)] = 138162,
  [SMALL_STATE(2003)] = 138175,
  [SMALL_STATE(2004)] = 138184,
  [SMALL_STATE(2005)] = 138197,
  [SMALL_STATE(2006)] = 138210,
  [SMALL_STATE(2007)] = 138219,
  [SMALL_STATE(2008)] = 138230,
  [SMALL_STATE(2009)] = 138239,
  [SMALL_STATE(2010)] = 138248,
  [SMALL_STATE(2011)] = 138257,
  [SMALL_STATE(2012)] = 138266,
  [SMALL_STATE(2013)] = 138275,
  [SMALL_STATE(2014)] = 138284,
  [SMALL_STATE(2015)] = 138295,
  [SMALL_STATE(2016)] = 138304,
  [SMALL_STATE(2017)] = 138313,
  [SMALL_STATE(2018)] = 138326,
  [SMALL_STATE(2019)] = 138335,
  [SMALL_STATE(2020)] = 138344,
  [SMALL_STATE(2021)] = 138353,
  [SMALL_STATE(2022)] = 138362,
  [SMALL_STATE(2023)] = 138371,
  [SMALL_STATE(2024)] = 138380,
  [SMALL_STATE(2025)] = 138389,
  [SMALL_STATE(2026)] = 138398,
  [SMALL_STATE(2027)] = 138407,
  [SMALL_STATE(2028)] = 138416,
  [SMALL_STATE(2029)] = 138425,
  [SMALL_STATE(2030)] = 138436,
  [SMALL_STATE(2031)] = 138444,
  [SMALL_STATE(2032)] = 138452,
  [SMALL_STATE(2033)] = 138460,
  [SMALL_STATE(2034)] = 138468,
  [SMALL_STATE(2035)] = 138476,
  [SMALL_STATE(2036)] = 138484,
  [SMALL_STATE(2037)] = 138492,
  [SMALL_STATE(2038)] = 138500,
  [SMALL_STATE(2039)] = 138508,
  [SMALL_STATE(2040)] = 138516,
  [SMALL_STATE(2041)] = 138524,
  [SMALL_STATE(2042)] = 138532,
  [SMALL_STATE(2043)] = 138540,
  [SMALL_STATE(2044)] = 138548,
  [SMALL_STATE(2045)] = 138556,
  [SMALL_STATE(2046)] = 138564,
  [SMALL_STATE(2047)] = 138572,
  [SMALL_STATE(2048)] = 138580,
  [SMALL_STATE(2049)] = 138587,
  [SMALL_STATE(2050)] = 138594,
  [SMALL_STATE(2051)] = 138601,
  [SMALL_STATE(2052)] = 138608,
  [SMALL_STATE(2053)] = 138615,
  [SMALL_STATE(2054)] = 138622,
  [SMALL_STATE(2055)] = 138629,
  [SMALL_STATE(2056)] = 138636,
  [SMALL_STATE(2057)] = 138643,
  [SMALL_STATE(2058)] = 138650,
  [SMALL_STATE(2059)] = 138657,
  [SMALL_STATE(2060)] = 138664,
  [SMALL_STATE(2061)] = 138671,
  [SMALL_STATE(2062)] = 138678,
  [SMALL_STATE(2063)] = 138685,
  [SMALL_STATE(2064)] = 138692,
  [SMALL_STATE(2065)] = 138699,
  [SMALL_STATE(2066)] = 138706,
  [SMALL_STATE(2067)] = 138713,
  [SMALL_STATE(2068)] = 138720,
  [SMALL_STATE(2069)] = 138727,
  [SMALL_STATE(2070)] = 138734,
  [SMALL_STATE(2071)] = 138741,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 35),
  [9] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 35),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 40),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 40),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 44),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 44),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 39),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 39),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 54),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 54),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 3, 0, 13),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 3, 0, 13),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 15),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 15),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 22),
  [157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 22),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 24),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 24),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 4, 0, 25),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 4, 0, 25),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 34),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 34),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 36),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 36),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 41),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 41),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 42),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 42),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 43),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 43),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 45),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 45),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 7, 0, 46),
  [193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 7, 0, 46),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 47),
  [197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 47),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 48),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 48),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 49),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 49),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 50),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 50),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 51),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 51),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 52),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 52),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 53),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 53),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 55),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 55),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 10, 0, 56),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 10, 0, 56),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 2, 0, 2),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 2, 0, 2),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 3),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 3),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 8),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 8),
  [243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 12),
  [245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 12),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 7),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 7),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 5),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 5),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 2, 0, 5),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 2, 0, 5),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 2, 0, 5),
  [491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 2, 0, 5),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1, 0, 0),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1, 0, 0),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 1),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 1),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 2, 0, 4),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 2, 0, 4),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 2, 0, 4),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 2, 0, 4),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 3, 0, 14),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 3, 0, 14),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 3, 0, 14),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 3, 0, 14),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(307),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 1, 0, 0),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(318),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 3, 0, 20),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 3, 0, 20),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 2, 0, 4),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 2, 0, 4),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 2, 0, 4),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 2, 0, 4),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 2, 0, 4),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 2, 0, 4),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 19),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 19),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 3, 0, 27),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 3, 0, 27),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 4, 0, 37),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 4, 0, 37),
  [711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 3, 0, 27),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 3, 0, 27),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 2, 0, 0),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 2, 0, 0),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_na, 1, 0, 0),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_na, 1, 0, 0),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 6),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 6),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 3, 0, 15),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 3, 0, 15),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 4, 0, 25),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 4, 0, 25),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 3, 0, 27),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 3, 0, 27),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 3, 0, 28),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 3, 0, 28),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 3, 0, 28),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 3, 0, 28),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 3, 0, 28),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 3, 0, 28),
  [758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 4, 0, 37),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 4, 0, 37),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 4, 0, 37),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 4, 0, 37),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2, 2, 0, 6),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2, 2, 0, 6),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 2, 0, 4),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 2, 0, 4),
  [774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 2, 0, 6),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 2, 0, 6),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 15),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 15),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(314),
  [864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1803),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1803),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1966),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1984),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1936),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(978),
  [882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(979),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(981),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(982),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(983),
  [894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(315),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(315),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1844),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1848),
  [906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(187),
  [909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(394),
  [912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1585),
  [915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(313),
  [918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(1117),
  [921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21), SHIFT_REPEAT(414),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 21),
  [926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(323),
  [973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1792),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1792),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1913),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1815),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1864),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1006),
  [991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(625),
  [1003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1841),
  [1012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1883),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [1018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(408),
  [1021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [1024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(305),
  [1027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1051),
  [1030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(389),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 2, 0, 9),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [3033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [3197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1133),
  [3200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1134),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1145),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1147),
  [3364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1148),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [3407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [3505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_value, 1, 0, 18),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_default, 3, 0, 33),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [3715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1609),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [3734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_name_string_or_identifier_or_null, 1, 0, 0),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 23),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 23),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 4),
  [3742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 4),
  [3744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 31),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 31),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [3934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0),
  [3936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(2014),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0),
  [3949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(2007),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [4238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2001),
  [4241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 32), SHIFT_REPEAT(1786),
  [4244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 32),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [4248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 29), SHIFT_REPEAT(310),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 29),
  [4253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 29), SHIFT_REPEAT(324),
  [4256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 9),
  [4258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [4262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [4274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [4276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [4282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 29), SHIFT_REPEAT(312),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_without_default, 1, 0, 11),
  [4311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_unnamed, 1, 0, 17),
  [4313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 17),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 16),
  [4317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 3, 0, 38),
  [4319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 30),
  [4321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 11),
  [4323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 26),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 10),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [4337] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__start = 0,
  ts_external_token__newline = 1,
  ts_external_token__semicolon = 2,
  ts_external_token__raw_string_literal = 3,
  ts_external_token__external_else = 4,
  ts_external_token__external_open_parenthesis = 5,
  ts_external_token__external_close_parenthesis = 6,
  ts_external_token__external_open_brace = 7,
  ts_external_token__external_close_brace = 8,
  ts_external_token__external_open_bracket = 9,
  ts_external_token__external_close_bracket = 10,
  ts_external_token__external_open_bracket2 = 11,
  ts_external_token__external_close_bracket2 = 12,
  ts_external_token__error_sentinel = 13,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__start] = sym__start,
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__semicolon] = sym__semicolon,
  [ts_external_token__raw_string_literal] = sym__raw_string_literal,
  [ts_external_token__external_else] = sym__external_else,
  [ts_external_token__external_open_parenthesis] = sym__external_open_parenthesis,
  [ts_external_token__external_close_parenthesis] = sym__external_close_parenthesis,
  [ts_external_token__external_open_brace] = sym__external_open_brace,
  [ts_external_token__external_close_brace] = sym__external_close_brace,
  [ts_external_token__external_open_bracket] = sym__external_open_bracket,
  [ts_external_token__external_close_bracket] = sym__external_close_bracket,
  [ts_external_token__external_open_bracket2] = sym__external_open_bracket2,
  [ts_external_token__external_close_bracket2] = sym__external_close_bracket2,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[36][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__start] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__start] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [7] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [8] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [9] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [12] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [13] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [14] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [17] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [18] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [20] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [21] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [22] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [23] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [24] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [25] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [26] = {
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [27] = {
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [28] = {
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [29] = {
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [30] = {
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [31] = {
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [32] = {
    [ts_external_token__external_close_parenthesis] = true,
  },
  [33] = {
    [ts_external_token__newline] = true,
    [ts_external_token__external_open_parenthesis] = true,
  },
  [34] = {
    [ts_external_token__external_close_bracket2] = true,
  },
  [35] = {
    [ts_external_token__external_close_bracket] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_r_external_scanner_create(void);
void tree_sitter_r_external_scanner_destroy(void *);
bool tree_sitter_r_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_r_external_scanner_serialize(void *, char *);
void tree_sitter_r_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_r(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_r_external_scanner_create,
      tree_sitter_r_external_scanner_destroy,
      tree_sitter_r_external_scanner_scan,
      tree_sitter_r_external_scanner_serialize,
      tree_sitter_r_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
